# <img align="right" src="https://github.com/avelino/awesome-go/raw/master/tmpl/assets/logo.png" alt="awesome-go" title="awesome-go" /> Awesome Go

[Awesome]: https://cdn.jsdelivr.net/gh/yinggaozhen/awesome-go-cn@1.4.1/docs/awesome.svg "star > 2000"
[Green]: https://cdn.jsdelivr.net/gh/yinggaozhen/awesome-go-cn@1.1/docs/Green.svg "最近一周有更新"
[Yellow]: https://cdn.jsdelivr.net/gh/yinggaozhen/awesome-go-cn@1.1/docs/Yellow.svg "最近一年没有更新"
[CN]: https://cdn.jsdelivr.net/gh/yinggaozhen/awesome-go-cn@1.1/docs/Cn.svg "包含中文文档"
[Archived]: https://cdn.jsdelivr.net/gh/yinggaozhen/awesome-go-cn@1.2.1/docs/archived.svg "项目已归档"
[GoDoc]: https://cdn.jsdelivr.net/gh/yinggaozhen/awesome-go-cn@1.3.0/docs/DOC.svg "godoc文档地址"

**此项目是 [awesome-go](https://awesome-go.com/) 中文版，最后一次同步时间 : 2021-08-20 07:14:17(每隔1天同步一次)**

[![chinese](https://cdn.jsdelivr.net/gh/yinggaozhen/awesome-go-cn@1.3.0/docs/english.svg)](README_EN.md) [![Build Status](https://travis-ci.org/avelino/awesome-go.svg?branch=master)](https://travis-ci.org/avelino/awesome-go) [![Awesome](https://cdn.rawgit.com/sindresorhus/awesome/d7305f38d29fed78fa85652e3a63e154dd8e8829/media/badge.svg)](https://github.com/sindresorhus/awesome) [![Slack Widget](https://img.shields.io/badge/join-us%20on%20slack-gray.svg?longCache=true&logo=slack&colorB=red)](http://gophers.slack.com/messages/awesome) [![Netlify Status](https://api.netlify.com/api/v1/badges/83a6dcbe-0da6-433e-b586-f68109286bd5/deploy-status)](https://app.netlify.com/sites/awesome-go/deploys)

[![patreon avelino](https://c5.patreon.com/external/logo/become_a_patron_button@2x.png)](https://www.patreon.com/avelinosource) 为Awesome Go打赏~

精选了一系列很棒的Go框架、库和软件。灵感来自于[awesome-python](https://github.com/vinta/awesome-python)。

**小图标说明** :


小图标 | 说明  
:-:|-
![awesome][Awesome] | star > 2000
![最近一个周有更新][Green] | 最近一周有更新。可以基本判断当前库处于积极维护状态。
![最近一年未更新][Yellow] | 最近一年没有更新。反应了此库的维护积极性不高，使用时需谨慎。
![归档项目][Archived] | 此项目已归档，不再更新，使用时需谨慎。
![此项目有中文文档][CN] | 此项目有中文文档。
![godoc文档][GoDoc] | godoc文档地址。

### 说明

[中文](README.md)  | [English](README_EN.md) 
 

<a href="https://www.producthunt.com/posts/awesome-go?utm_source=badge-featured&utm_medium=badge&utm_souce=badge-awesome-go" target="_blank"><img src="https://api.producthunt.com/widgets/embed-image/v1/featured.svg?post_id=291535&theme=light" alt="awesome-go - Curated list awesome Go frameworks, libraries and software | Product Hunt" style="width: 250px; height: 54px;" width="250" height="54" /></a>

你可以快速浏览贡献者名单[contribution guidelines](https://github.com/avelino/awesome-go/blob/master/CONTRIBUTING.md). 感谢所有为此项目付出的同学[contributors](https://github.com/avelino/awesome-go/graphs/contributors); 你真棒!
> [![Digital Ocean](https://avelino.run/sponsors/do_logo_horizontal_blue-210.png)](https://m.do.co/c/bd3b723c0a36?utm_medium=opensource&utm_source=awesome-go)
如果您在看到一个包或项目不再维护或不适合，请往awesome-go提交[Pull Request](https://github.com/avelino/awesome-go/pulls)，本项目每隔一天与英文文档同步。感谢!
**We have no monthly cost**_, but we have employees **working hard** to maintain the Awesome Go, with money raised we can repay the effort of each person involved! All billing and distribution will be open to the entire community._

A curated list of awesome Go frameworks, libraries and software. Inspired by [awesome-python](https://github.com/vinta/awesome-python).

### 贡献

Please take a quick gander at the [contribution guidelines](https://github.com/avelino/awesome-go/blob/master/CONTRIBUTING.md) first. Thanks to all [contributors](https://github.com/avelino/awesome-go/graphs/contributors); you rock!

#### *如果您在这里看到一个包或项目不再维护或不适合，请提交一个pull request来改进此文件。谢谢你！!*

### 内容

- [Awesome Go](#awesome-go)
    - [音频和音乐](#音频和音乐)
    - [身份验证和OAuth](#身份验证和oauth)
    - [Bot建设](#bot建设)
    - [构建自动化](#构建自动化)
    - [命令行](#命令行)
    - [配置](#配置)
    - [持续集成](#持续集成)
    - [CSS预处理器](#css预处理器)
    - [数据结构](#数据结构)
    - [数据库](#数据库)
    - [数据库驱动程序](#数据库驱动程序)
    - [日期和时间](#日期和时间)
    - [分布式系统](#分布式系统)
    - [动态域名](#动态域名)
    - [电子邮件](#电子邮件)
    - [可嵌入的脚本语言](#可嵌入的脚本语言)
    - [错误处理](#错误处理)
    - [文件处理](#文件处理)
    - [金融](#金融)
    - [表单](#表单)
    - [方法](#方法)
    - [游戏开发](#游戏开发)
    - [代码生成与泛型](#代码生成与泛型)
    - [地理](#地理)
    - [Go 编译器](#go-编译器)
    - [Goroutines](#goroutines)
    - [GUI](#gui)
    - [硬件](#硬件)
    - [图片](#图片)
    - [物联网](#物联网)
    - [作业调度器](#作业调度器)
    - [JSON](#json)
    - [日志记录](#日志记录)
    - [机器学习](#机器学习)
    - [消息](#消息)
    - [微软办公软件](#微软办公软件)
        - [Microsoft Excel](#microsoft-excel)
    - [杂项](#杂项)
        - [依赖注入](#依赖注入)
        - [项目布局](#项目布局)
        - [字符串](#字符串)
        - [未分类的](#未分类的)
    - [自然语言处理](#自然语言处理)
    - [网络](#网络)
        - [HTTP客户端](#http客户端)
    - [OpenGL](#opengl)
    - [ORM](#orm)
    - [包管理](#包管理)
    - [性能](#性能)
    - [查询语言](#查询语言)
    - [嵌入的资源](#嵌入的资源)
    - [科学与数据分析](#科学与数据分析)
    - [安全](#安全)
    - [序列化](#序列化)
    - [服务器应用程序](#服务器应用程序)
    - [流处理](#流处理)
    - [模板引擎](#模板引擎)
    - [测试](#测试)
    - [文本处理](#文本处理)
    - [Third-party APIs](#third-party-apis)
    - [公用事业公司](#公用事业公司)
    - [UUID](#uuid)
    - [验证](#验证)
    - [版本控制](#版本控制)
    - [视频](#视频)
    - [Web框架](#web框架)
        - [中间件](#中间件)
            - [仿真中间件](#仿真中间件)
            - [用于创建HTTP中间件的库](#用于创建http中间件的库)
        - [路由器](#路由器)
    - [WebAssembly](#webassembly)
    - [Windows](#windows)
    - [XML](#xml)

- [工具](#工具)
    - [代码分析](#代码分析)
    - [编辑器插件](#编辑器插件)
    - [Go 生成工具](#go-生成工具)
    - [Go 工具](#go-工具)
    - [软件包](#软件包)
        - [DevOps 工具](#devops-工具)
        - [其他软件](#其他软件)

- [资源](#资源)
    - [基准](#基准)
    - [会议](#会议)
    - [E-Books](#e-books)
    - [Gophers](#gophers)
    - [聚会](#聚会)
    - [风格指南](#风格指南)
    - [Twitter](#twitter)
    - [网站](#网站)
        - [教程](#教程)

## 音频和音乐

*用于操作音频的库。 (翻译出错了? 试试 [英文版](README_EN.md#audio-and-music) 吧~)*

* [Oto](https://github.com/hajimehoshi/oto) **star:844** 多平台的 low-level 声音播放库。   [![godoc][GoDoc]](https://godoc.org/github.com/hajimehoshi/oto)
* [PortAudio](https://github.com/gordonklaus/portaudio) **star:462** 基于 Go 的PortAudio audio I/O库。   [![godoc][GoDoc]](https://godoc.org/github.com/gordonklaus/portaudio)
* [music-theory](https://github.com/go-music-theory/music-theory) **star:352** 基于 Go 的音乐理论模型。   [![最近一年没有更新][Yellow]](https://github.com/go-music-theory/music-theory)   [![godoc][GoDoc]](https://godoc.org/github.com/go-music-theory/music-theory)
* [waveform](https://github.com/mdlayher/waveform) **star:342** 通过音频流生成波形图像的包。   [![最近一年没有更新][Yellow]](https://github.com/mdlayher/waveform)   [![godoc][GoDoc]](https://godoc.org/github.com/mdlayher/waveform)   [![归档项目][Archived]](https://github.com/mdlayher/waveform)
* [portmidi](https://github.com/rakyll/portmidi) **star:262** PortMidi的 Go 语言实现接口.   [![godoc][GoDoc]](https://godoc.org/github.com/rakyll/portmidi)
* [id3v2](https://github.com/bogem/id3v2) **star:189** ID3解码和编码库为Go。   [![godoc][GoDoc]](https://godoc.org/github.com/bogem/id3v2)
* [flac](https://github.com/mewkiz/flac) **star:160** 原生 Go FLAC编码器/解码器，支持FLAC流。   [![godoc][GoDoc]](https://godoc.org/github.com/mewkiz/flac)
* [malgo](https://github.com/gen2brain/malgo) **star:151** 迷你音频库。
* [GoAudio](https://github.com/DylanMeeus/GoAudio) **star:143** 本地Go音频处理库。   [![godoc][GoDoc]](https://godoc.org/github.com/DylanMeeus/GoAudio)
* [mix](https://github.com/go-mix/mix) **star:142** 基于序列的 Go 原生音乐混音器。   [![最近一年没有更新][Yellow]](https://github.com/go-mix/mix)   [![godoc][GoDoc]](https://godoc.org/github.com/go-mix/mix)
* [gaad](https://github.com/Comcast/gaad) **star:86** 原生 Go AAC位流解析器。   [![godoc][GoDoc]](https://godoc.org/github.com/Comcast/gaad)
* [minimp3](https://github.com/tosone/minimp3) **star:58** 轻量级MP3解码器库。
* [vorbis](https://github.com/mccoyst/vorbis) **star:28** “原生” Go Vorbis解码器(使用CGO，但没有依赖关系)。   [![最近一年没有更新][Yellow]](https://github.com/mccoyst/vorbis)   [![godoc][GoDoc]](https://godoc.org/github.com/mccoyst/vorbis)
* [gosamplerate](https://github.com/dh1tw/gosamplerate) **star:11** libsamplerate 的 Go 语言实现接口。   [![最近一年没有更新][Yellow]](https://github.com/dh1tw/gosamplerate)   [![godoc][GoDoc]](https://godoc.org/github.com/dh1tw/gosamplerate)

## 身份验证和OAuth

*用于实现验证方案的库。 (翻译出错了? 试试 [英文版](README_EN.md#authentication-and-oauth) 吧~)*

* [casbin](https://github.com/casbin/casbin) **star:10045** 支持ACL、RBAC、ABAC等访问控制模型的授权库。   [![star > 2000][Awesome]](https://github.com/casbin/casbin)   [![最近一周有更新][Green]](https://github.com/casbin/casbin)   [![godoc][GoDoc]](https://godoc.org/github.com/casbin/casbin)
* [oauth2](https://github.com/golang/oauth2) **star:3769** goauth2的继任者。通用OAuth 2.0包，附带JWT、谷歌api、计算引擎和应用程序引擎支持。   [![star > 2000][Awesome]](https://github.com/golang/oauth2)   [![最近一周有更新][Green]](https://github.com/golang/oauth2)   [![godoc][GoDoc]](https://godoc.org/github.com/golang/oauth2)
* [goth](https://github.com/markbates/goth) **star:3297** 提供了 OAuth 和 OAuth2 的简单清晰易用的方法。可开箱即用处理多个提供程序。   [![star > 2000][Awesome]](https://github.com/markbates/goth)   [![godoc][GoDoc]](https://godoc.org/github.com/markbates/goth)
* [authboss](https://github.com/volatiletech/authboss) **star:2810** web模块化认证系统。它试图删除尽可能多的模板文件和硬编码，以便每次新建一个新的web项目时，您都可以插入、配置并开始构建您的应用程序，而不必每次都构建一个身份验证系统。   [![star > 2000][Awesome]](https://github.com/volatiletech/authboss)   [![godoc][GoDoc]](https://godoc.org/github.com/volatiletech/authboss)
* [go-jose](https://github.com/square/go-jose) **star:1811** 相当完整地实现了JOSE工作组的JSON Web令牌、JSON Web签名和JSON Web加密规范。
* [loginsrv](https://github.com/tarent/loginsrv) **star:1803** JWT登录微服务带有可插拔的后端服务，如OAuth2 (Github)、htpasswd、osiam。   [![godoc][GoDoc]](https://godoc.org/github.com/tarent/loginsrv)
* [go-oauth2-server](https://github.com/RichardKnop/go-oauth2-server) **star:1794** 用 Golang 编写的独立且符合规范的OAuth2服务器。   [![godoc][GoDoc]](https://godoc.org/github.com/RichardKnop/go-oauth2-server)
* [osin](https://github.com/openshift/osin) **star:1686** OAuth2服务器库。   [![godoc][GoDoc]](https://godoc.org/github.com/openshift/osin)
* [gologin](https://github.com/dghubble/gologin) **star:1426** 用于使用OAuth1和OAuth2身份验证提供者登录的可链处理程序。   [![godoc][GoDoc]](https://godoc.org/github.com/dghubble/gologin)
* [gorbac](https://github.com/mikespook/gorbac) **star:1208** 轻量级的基于角色的访问控制(RBAC)实现。   [![godoc][GoDoc]](https://godoc.org/github.com/mikespook/gorbac)
* [scs](https://github.com/alexedwards/scs) **star:916** HTTP服务器的会话管理器。   [![最近一周有更新][Green]](https://github.com/alexedwards/scs)   [![godoc][GoDoc]](https://godoc.org/github.com/alexedwards/scs)
* [paseto](https://github.com/o1egl/paseto) **star:531** 平台无关的安全令牌(PASETO)。   [![最近一年没有更新][Yellow]](https://github.com/o1egl/paseto)   [![godoc][GoDoc]](https://godoc.org/github.com/o1egl/paseto)
* [permissions2](https://github.com/xyproto/permissions2) **star:432** 用于跟踪用户、登录状态和权限的库。依赖于cookie安全和bcrypt。   [![godoc][GoDoc]](https://godoc.org/github.com/xyproto/permissions2)
* [go-guardian](https://github.com/shaj13/go-guardian) **star:298** Go-Guardian是一个golang库，它提供了一种简单、干净和习惯的方式来创建强大的现代API和web身份验证，支持LDAP、Basic、承载令牌和基于证书的身份验证。   [![godoc][GoDoc]](https://godoc.org/github.com/shaj13/go-guardian)
* [jwt](https://github.com/cristalhq/jwt) **star:284** 安全、简单、快速的JSON Web令牌。   [![godoc][GoDoc]](https://godoc.org/github.com/cristalhq/jwt)
* [jwt](https://github.com/pascaldekloe/jwt) **star:262** 轻量级JSON Web令牌库。   [![godoc][GoDoc]](https://godoc.org/github.com/pascaldekloe/jwt)
* [jeff](https://github.com/abraithwaite/jeff) **star:231** 简单、灵活、安全和惯用的web会话管理，具有可配置化的后端。   [![godoc][GoDoc]](https://godoc.org/github.com/abraithwaite/jeff)
* [httpauth](https://github.com/goji/httpauth) **star:208** HTTP身份验证中间件。   [![最近一年没有更新][Yellow]](https://github.com/goji/httpauth)   [![godoc][GoDoc]](https://godoc.org/github.com/goji/httpauth)
* [jwt-auth](https://github.com/adam-hanna/jwt-auth) **star:207** JWT中间件，可用于Golang http服务器，提供了许多配置选项。   [![godoc][GoDoc]](https://godoc.org/github.com/adam-hanna/jwt-auth)
* [branca](https://github.com/hako/branca) **star:154** 基于 Go 实现Branca令牌。   [![最近一年没有更新][Yellow]](https://github.com/hako/branca)   [![godoc][GoDoc]](https://godoc.org/github.com/hako/branca)
* [sessionup](https://github.com/swithek/sessionup) **star:113** 简单但有效的HTTP会话管理和标识包。   [![godoc][GoDoc]](https://godoc.org/github.com/swithek/sessionup)
* [session](https://github.com/icza/session) **star:105** web服务器会话管理(包括支持谷歌应用程序引擎 - GAE)。   [![godoc][GoDoc]](https://godoc.org/github.com/icza/session)
* [otpgen](https://github.com/grijul/otpgen) **star:93** 库生成TOTP/HOTP代码。   [![godoc][GoDoc]](https://godoc.org/github.com/grijul/otpgen)
* [sjwt](https://github.com/brianvoe/sjwt) **star:92** 简单的jwt生成器和解析器。   [![最近一年没有更新][Yellow]](https://github.com/brianvoe/sjwt)   [![godoc][GoDoc]](https://godoc.org/github.com/brianvoe/sjwt)
* [jwt](https://github.com/robbert229/jwt) **star:91** 简单易用的JSON Web令牌实现(JWT)。   [![godoc][GoDoc]](https://godoc.org/github.com/robbert229/jwt)
* [rbac](https://github.com/zpatrick/rbac) **star:81** 最小的RBAC包。   [![最近一年没有更新][Yellow]](https://github.com/zpatrick/rbac)   [![godoc][GoDoc]](https://godoc.org/github.com/zpatrick/rbac)
* [sessions](https://github.com/adam-hanna/sessions) **star:60** 非常简单，高性能，可深度定制的会话服务，主要用于的 go http 服务器。   [![最近一年没有更新][Yellow]](https://github.com/adam-hanna/sessions)   [![godoc][GoDoc]](https://godoc.org/github.com/adam-hanna/sessions)
* [securecookie](https://github.com/chmike/securecookie) **star:53** 高效安全的cookie编码/解码。   [![godoc][GoDoc]](https://godoc.org/github.com/chmike/securecookie)
* [go-email-normalizer](https://github.com/dimuska139/go-email-normalizer) **star:25** Golang库，用于提供电子邮件地址的规范表示。   [![godoc][GoDoc]](https://godoc.org/github.com/dimuska139/go-email-normalizer)
* [otpgo](https://github.com/jltorresm/otpgo) **star:22** 基于时间的一次性密码(TOTP)和基于hmac的一次性密码(HOTP)库用于Go。   [![godoc][GoDoc]](https://godoc.org/github.com/jltorresm/otpgo)
* [scope](https://github.com/SonicRoshan/scope) **star:14** 在Go中轻松管理OAuth2范围。   [![godoc][GoDoc]](https://godoc.org/github.com/SonicRoshan/scope)
* [sessiongate-go](https://github.com/f0rmiga/sessiongate-go) **star:9** 使用SessionGate Redis模块进行会话管理。   [![最近一年没有更新][Yellow]](https://github.com/f0rmiga/sessiongate-go)   [![godoc][GoDoc]](https://godoc.org/github.com/f0rmiga/sessiongate-go)
* [cookiestxt](https://github.com/mengzhuo/cookiestxt) **star:7** 提供cookie .txt文件格式的解析器。   [![godoc][GoDoc]](https://godoc.org/github.com/mengzhuo/cookiestxt)

## Bot建设

*用于构建和使用机器人的库。 (翻译出错了? 试试 [英文版](README_EN.md#bot-building) 吧~)*

* [olivia](https://github.com/olivia-ai/olivia) **star:3016** 用人工神经网络建造的聊天机器人。   [![star > 2000][Awesome]](https://github.com/olivia-ai/olivia)   [![最近一周有更新][Green]](https://github.com/olivia-ai/olivia)   [![godoc][GoDoc]](https://godoc.org/github.com/olivia-ai/olivia)
* [telegram-bot-api](https://github.com/Syfaro/telegram-bot-api) **star:3002** 简单轻量级的Telegram bot客户端。   [![star > 2000][Awesome]](https://github.com/Syfaro/telegram-bot-api)   [![最近一周有更新][Green]](https://github.com/Syfaro/telegram-bot-api)   [![godoc][GoDoc]](https://godoc.org/github.com/Syfaro/telegram-bot-api)
* [telebot](https://github.com/tucnak/telebot) **star:2047** 用Go编写的Telegram bot框架。   [![star > 2000][Awesome]](https://github.com/tucnak/telebot)   [![最近一周有更新][Green]](https://github.com/tucnak/telebot)   [![godoc][GoDoc]](https://godoc.org/github.com/tucnak/telebot)
* [Kelp](https://github.com/stellar/kelp) **star:729** 官方交易和做市机器人为[Stellar](https://www.stellar.org/) DEX。开箱即用的作品，用 Golang 编写，兼容集中交易和定制交易策略。   [![godoc][GoDoc]](https://godoc.org/github.com/stellar/kelp)
* [go-chat-bot](https://github.com/go-chat-bot/bot) **star:694** 用 Go 编写的IRC, Slack和电报机器人。   [![godoc][GoDoc]](https://godoc.org/github.com/go-chat-bot/bot)
* [go-joe](https://joe-bot.net)  一个通用的机器人库的灵感来自于Hubot。
* [Golang CryptoTrading Bot](https://github.com/saniales/golang-crypto-trading-bot) **star:582** 基于控制台的，用于加密货币交易所的的交易机器人。   [![godoc][GoDoc]](https://godoc.org/github.com/saniales/golang-crypto-trading-bot)
* [slacker](https://github.com/shomali11/slacker) **star:550** 可简单创建Slack机器人的框架。   [![godoc][GoDoc]](https://godoc.org/github.com/shomali11/slacker)
* [tbot](https://github.com/yanzay/tbot) **star:315** 带有类似于net/http API的Telegram bot服务器。   [![godoc][GoDoc]](https://godoc.org/github.com/yanzay/tbot)
* [go-sarah](https://github.com/oklahomer/go-sarah) **star:198** 此框架提供了聊天机器人相关的服务，包括LINE、Slack、Gitter等。   [![godoc][GoDoc]](https://godoc.org/github.com/oklahomer/go-sarah)
* [go-twitch-irc](https://github.com/gempir/go-twitch-irc) **star:181** Libary为twitch编写机器人程序。电视聊天   [![godoc][GoDoc]](https://godoc.org/github.com/gempir/go-twitch-irc)
* [Tenyks](https://github.com/kyleterry/tenyks) **star:170** 面向服务的IRC bot，使用Redis和JSON进行消息传递。   [![最近一年没有更新][Yellow]](https://github.com/kyleterry/tenyks)   [![godoc][GoDoc]](https://godoc.org/github.com/kyleterry/tenyks)
* [hanu](https://github.com/sbstjn/hanu) **star:135** 用于编写Slack机器人的框架。   [![godoc][GoDoc]](https://godoc.org/github.com/sbstjn/hanu)
* [go-tgbot](https://github.com/olebedev/go-tgbot) **star:106** 由swagger文件、基于会话的路由器和中间件生成的纯Golang Telegram Bot API包装器。   [![最近一年没有更新][Yellow]](https://github.com/olebedev/go-tgbot)   [![godoc][GoDoc]](https://godoc.org/github.com/olebedev/go-tgbot)
* [margelet](https://github.com/zhulik/margelet) **star:63** 构建电报机器人的框架。   [![最近一年没有更新][Yellow]](https://github.com/zhulik/margelet)   [![godoc][GoDoc]](https://godoc.org/github.com/zhulik/margelet)
* [slack-bot](https://github.com/innogames/slack-bot) **star:52** 为懒惰的开发者准备好使用Slack Bot:自定义命令，Jenkins, Jira, Bitbucket, Github…   [![最近一周有更新][Green]](https://github.com/innogames/slack-bot)   [![godoc][GoDoc]](https://godoc.org/github.com/innogames/slack-bot)
* [ephemeral-roles](https://github.com/ewohltman/ephemeral-roles) **star:49** 用于管理基于语音通道成员存在的临时角色的不和机器人。   [![godoc][GoDoc]](https://godoc.org/github.com/ewohltman/ephemeral-roles)
* [slackscot](https://github.com/alexandre-normand/slackscot) **star:46** 另一个构建Slack机器人的框架。   [![godoc][GoDoc]](https://godoc.org/github.com/alexandre-normand/slackscot)
* [govkbot](https://github.com/nikepan/govkbot) **star:36** 简单的Go [VK](https://vk.com) bot库。   [![godoc][GoDoc]](https://godoc.org/github.com/nikepan/govkbot)
* [echotron](https://github.com/NicoNex/echotron) **star:18** 纯golang编写的电报机器人库。   [![最近一周有更新][Green]](https://github.com/NicoNex/echotron)   [![godoc][GoDoc]](https://godoc.org/github.com/NicoNex/echotron)
* [micha](https://github.com/onrik/micha) **star:17** 基于 GO 实现的Telegram 机器人API库。   [![godoc][GoDoc]](https://godoc.org/github.com/onrik/micha)

## 构建自动化

*帮助构建自动化的库和工具。 (翻译出错了? 试试 [英文版](README_EN.md#build-automation) 吧~)*

* [realize](https://github.com/tockins/realize) **star:4075** Go 语言构建系统，可以监控文件变化并重新加载。运行，构建，监控文件并支持自定义路径。   [![star > 2000][Awesome]](https://github.com/tockins/realize)   [![godoc][GoDoc]](https://godoc.org/github.com/tockins/realize)
* [Task](https://github.com/go-task/task) **star:3739** 简单的“Go”的选择。   [![star > 2000][Awesome]](https://github.com/go-task/task)   [![godoc][GoDoc]](https://godoc.org/github.com/go-task/task)
* [mmake](https://github.com/tj/mmake) **star:1577** 现代 Make 工具   [![最近一年没有更新][Yellow]](https://github.com/tj/mmake)   [![godoc][GoDoc]](https://godoc.org/github.com/tj/mmake)
* [goyek](https://github.com/goyek/goyek) **star:245** 在Go中创建构建管道。   [![godoc][GoDoc]](https://godoc.org/github.com/goyek/goyek)
* [taskctl](https://github.com/taskctl/taskctl) **star:121** 并发任务跑。   [![godoc][GoDoc]](https://godoc.org/github.com/taskctl/taskctl)
* [1build](https://github.com/gopinath-langote/1build) **star:96** 命令行工具，以无摩擦地管理项目特定的命令。   [![godoc][GoDoc]](https://godoc.org/github.com/gopinath-langote/1build)
* [gaper](https://github.com/maxcnunes/gaper) **star:48** 当Go项目崩溃或一些人看到文件更改时，构建并重新启动该项目。   [![最近一年没有更新][Yellow]](https://github.com/maxcnunes/gaper)   [![godoc][GoDoc]](https://godoc.org/github.com/maxcnunes/gaper)
* [gilbert](https://go-gilbert.github.io)  一个为 Go 项目而生的构建系统和任务运行器。
* [anko](https://github.com/GuilhermeCaruso/anko) **star:17** 适用于多种编程语言的简单应用程序监视程序。   [![godoc][GoDoc]](https://godoc.org/github.com/GuilhermeCaruso/anko)

## 命令行

### 标准CLI

*用于构建标准或基本命令行应用程序的库。 (翻译出错了? 试试 [英文版](README_EN.md#standard-cli) 吧~)*

* [cobra](https://github.com/spf13/cobra) **star:22808** 现代Go CLI命令行交互工具。   [![star > 2000][Awesome]](https://github.com/spf13/cobra)   [![最近一周有更新][Green]](https://github.com/spf13/cobra)   [![godoc][GoDoc]](https://godoc.org/github.com/spf13/cobra)
* [urfave/cli](https://github.com/urfave/cli) **star:16387** 可让你简单、快速和愉快的构建命令行应用(之前是codegangsta/cli)。   [![star > 2000][Awesome]](https://github.com/urfave/cli)   [![最近一周有更新][Green]](https://github.com/urfave/cli)   [![godoc][GoDoc]](https://godoc.org/github.com/urfave/cli)
* [elvish](https://github.com/elves/elvish) **star:4416** 一种表达性编程语言和通用的交互外壳。   [![star > 2000][Awesome]](https://github.com/elves/elvish)   [![最近一周有更新][Green]](https://github.com/elves/elvish)   [![godoc][GoDoc]](https://godoc.org/github.com/elves/elvish)
* [kingpin](https://github.com/alecthomas/kingpin) **star:3105** 支持子命令的命令行和标志解析器。   [![star > 2000][Awesome]](https://github.com/alecthomas/kingpin)   [![godoc][GoDoc]](https://godoc.org/github.com/alecthomas/kingpin)
* [Dnote](https://github.com/dnote/dnote) **star:2130** 一个简单的命令行笔记本与多设备同步。   [![star > 2000][Awesome]](https://github.com/dnote/dnote)   [![最近一周有更新][Green]](https://github.com/dnote/dnote)   [![godoc][GoDoc]](https://godoc.org/github.com/dnote/dnote)
* [go-flags](https://github.com/jessevdk/go-flags) **star:2003**  Go 命令行选项解析器。   [![star > 2000][Awesome]](https://github.com/jessevdk/go-flags)   [![godoc][GoDoc]](https://godoc.org/github.com/jessevdk/go-flags)
* [pflag](https://github.com/spf13/pflag) **star:1525** 基于POSIX/GNU-style --flags实现的包，主要用于替换Go的falg包。   [![godoc][GoDoc]](https://godoc.org/github.com/spf13/pflag)
* [mitchellh/cli](https://github.com/mitchellh/cli) **star:1375** 用于实现命令行接口的Go库。   [![最近一周有更新][Green]](https://github.com/mitchellh/cli)   [![godoc][GoDoc]](https://godoc.org/github.com/mitchellh/cli)
* [go-arg](https://github.com/alexflint/go-arg) **star:1239** 基于结构的参数解析。   [![godoc][GoDoc]](https://godoc.org/github.com/alexflint/go-arg)
* [liner](https://github.com/peterh/liner) **star:811** 类似readline-like的命令行接口库。   [![godoc][GoDoc]](https://godoc.org/github.com/peterh/liner)
* [complete](https://github.com/posener/complete) **star:784** 使用 Go 语言编写的 bash 命令补全工具以及 Go 命令补全工具.   [![godoc][GoDoc]](https://godoc.org/github.com/posener/complete)
* [mow.cli](https://github.com/jawher/mow.cli) **star:748** 用于构建具有复杂标志和参数解析和验证的CLI应用程序。   [![godoc][GoDoc]](https://godoc.org/github.com/jawher/mow.cli)
* [flaggy](https://github.com/integrii/flaggy) **star:728** 一个健壮的、易用的标志包，具有出色的子命令支持。   [![godoc][GoDoc]](https://godoc.org/github.com/integrii/flaggy)
* [ops](https://github.com/nanovms/ops) **star:672** Unikernel 构建器/协调器。   [![最近一周有更新][Green]](https://github.com/nanovms/ops)   [![godoc][GoDoc]](https://godoc.org/github.com/nanovms/ops)
* [cli](https://github.com/mkideal/cli) **star:599** 基于golang结构标签，功能丰富易于使用的命令行包。   [![godoc][GoDoc]](https://godoc.org/github.com/mkideal/cli)
* [argparse](https://github.com/akamensky/argparse) **star:353** 命令行参数分析器，灵感来自Python的argparse模块。   [![最近一周有更新][Green]](https://github.com/akamensky/argparse)   [![godoc][GoDoc]](https://godoc.org/github.com/akamensky/argparse)
* [commandeer](https://github.com/jaffee/commandeer) **star:148** 开发友好的CLI应用程序。   [![godoc][GoDoc]](https://godoc.org/github.com/jaffee/commandeer)
* [wmenu](https://github.com/dixonwille/wmenu) **star:140** 为cli程序提供了简单上手的菜单，可提示用户作出选择。   [![最近一年没有更新][Yellow]](https://github.com/dixonwille/wmenu)   [![godoc][GoDoc]](https://godoc.org/github.com/dixonwille/wmenu)
* [sflags](https://github.com/octago/sflags) **star:130** 基于结构的flag生成器，用于flag、urfave/cli、pflag、cobra、kingpin和其他库。   [![godoc][GoDoc]](https://godoc.org/github.com/octago/sflags)
* [flag](https://github.com/cosiner/flag) **star:114** 简单但功能强大的命令行选项解析库，用于支持Go子命令。   [![godoc][GoDoc]](https://godoc.org/github.com/cosiner/flag)
* [ukautz/clif](https://github.com/ukautz/clif) **star:108** 简小的命令行接口框架。   [![最近一年没有更新][Yellow]](https://github.com/ukautz/clif)   [![godoc][GoDoc]](https://godoc.org/github.com/ukautz/clif)
* [job](https://github.com/liujianping/job) **star:105** 工作，把你的短期指令当作长期任务。   [![最近一年没有更新][Yellow]](https://github.com/liujianping/job)
* [cli](https://github.com/teris-io/cli) **star:89** 为 Go 构建命令接口提供简单而完整的API。   [![godoc][GoDoc]](https://godoc.org/github.com/teris-io/cli)
* [climax](http://github.com/tucnak/climax)  Alternative CLI with "human face", in spirit of Go command.
* [env](https://github.com/codingconcepts/env) **star:81** 基于标记的结构化的环境配置。   [![最近一年没有更新][Yellow]](https://github.com/codingconcepts/env)   [![godoc][GoDoc]](https://godoc.org/github.com/codingconcepts/env)
* [cmdr](https://github.com/hedzr/cmdr) **star:78** 一个POSIX/GNU风格的、类似getopt的命令行UI Go库。   [![godoc][GoDoc]](https://godoc.org/github.com/hedzr/cmdr)
* [clîr](https://github.com/leaanthony/clir) **star:75** 一个简单而清晰的CLI库。依赖免费的。   [![godoc][GoDoc]](https://godoc.org/github.com/leaanthony/clir)
* [gocmd](https://github.com/devfacet/gocmd) **star:53** 用于构建命令行应用程序。   [![godoc][GoDoc]](https://godoc.org/github.com/devfacet/gocmd)
* [hiboot cli](https://github.com/hidevopsio/hiboot/tree/master/pkg/app/cli)  具有自动配置和依赖注入的cli应用程序框架。
* [wlog](https://github.com/dixonwille/wlog) **star:51** 支持跨平台和并发的简单日志记录接口。   [![最近一年没有更新][Yellow]](https://github.com/dixonwille/wlog)   [![godoc][GoDoc]](https://godoc.org/github.com/dixonwille/wlog)
* [strumt](https://github.com/antham/strumt) **star:44** 用于创建提示链。   [![godoc][GoDoc]](https://godoc.org/github.com/antham/strumt)
* [flagvar](https://github.com/sgreben/flagvar) **star:37** 符合 Go 标准的“flag”标志参数类型包。   [![最近一年没有更新][Yellow]](https://github.com/sgreben/flagvar)   [![godoc][GoDoc]](https://godoc.org/github.com/sgreben/flagvar)
* [go-getoptions](https://github.com/DavidGamba/go-getoptions) **star:37**  Go 选择解析器，借鉴于Perl灵活性的GetOpt::Long。   [![godoc][GoDoc]](https://godoc.org/github.com/DavidGamba/go-getoptions)
* [cmd](https://github.com/posener/cmd) **star:33** 扩展标准的' flag '包，以支持子命令和更多的idomatic方式。   [![godoc][GoDoc]](https://godoc.org/github.com/posener/cmd)
* [argv](https://github.com/cosiner/argv) **star:30** 基于Base 语法，用于分隔命令行字符串并将其作为参数的 Go 语言库，   [![最近一年没有更新][Yellow]](https://github.com/cosiner/argv)   [![godoc][GoDoc]](https://godoc.org/github.com/cosiner/argv)
* [go-commander](https://github.com/yitsushi/go-commander) **star:23** 用于简化CLI工作流的 Go 库。   [![最近一年没有更新][Yellow]](https://github.com/yitsushi/go-commander)   [![godoc][GoDoc]](https://godoc.org/github.com/yitsushi/go-commander)
* [sand](https://github.com/Zaba505/sand) **star:15** 用于创建解释器等的简单API。   [![最近一年没有更新][Yellow]](https://github.com/Zaba505/sand)   [![godoc][GoDoc]](https://godoc.org/github.com/Zaba505/sand)
* [ts](https://github.com/liujianping/ts) **star:13** 时间戳转换和比较工具。   [![最近一年没有更新][Yellow]](https://github.com/liujianping/ts)   [![godoc][GoDoc]](https://godoc.org/github.com/liujianping/ts)
* [command-chain](https://github.com/rainu/go-command-chain) **star:12** 一个用于配置和运行命令链的go库——比如unix shell中的管道。   [![godoc][GoDoc]](https://godoc.org/github.com/rainu/go-command-chain)
* [go-andotp](https://github.com/grijul/go-andotp) **star:6** 一个CLI程序加密/解密[andOTP](https://github.com/andOTP/andOTP)文件。也可以用作图书馆。   [![godoc][GoDoc]](https://godoc.org/github.com/grijul/go-andotp)

### 高级控制台用户界面

*用于构建控制台应用程序和控制台用户界面的库。 (翻译出错了? 试试 [英文版](README_EN.md#advanced-console-uis) 吧~)*

* [termui](https://github.com/gizak/termui) **star:11163** 此库是基于**termbox-go**实现的，借鉴于[blessed-contrib](https://github.com/yaronn/blessed-contrib)。   [![star > 2000][Awesome]](https://github.com/gizak/termui)   [![godoc][GoDoc]](https://godoc.org/github.com/gizak/termui)
* [gocui](https://github.com/jroimartin/gocui) **star:7327** 旨在创建控制台用户界面的极简Go库。   [![star > 2000][Awesome]](https://github.com/jroimartin/gocui)   [![最近一周有更新][Green]](https://github.com/jroimartin/gocui)   [![godoc][GoDoc]](https://godoc.org/github.com/jroimartin/gocui)
* [gommon/color](https://github.com/labstack/gommon/tree/master/color)  更换终端文本样式。
* [termbox-go](https://github.com/nsf/termbox-go) **star:4121** 基于文本的跨平台接口库。   [![star > 2000][Awesome]](https://github.com/nsf/termbox-go)   [![godoc][GoDoc]](https://godoc.org/github.com/nsf/termbox-go)
* [go-prompt](https://github.com/c-bata/go-prompt) **star:4073** 构建一个强大的交互式提示，借鉴于[python-prompt-toolkit](https://github.com/jonathanslenders/python-prompt-toolkit)   [![star > 2000][Awesome]](https://github.com/c-bata/go-prompt)   [![godoc][GoDoc]](https://godoc.org/github.com/c-bata/go-prompt)
* [progressbar](https://github.com/schollz/progressbar) **star:2006** 基本线程安全的进度条，在每个操作系统工作。   [![star > 2000][Awesome]](https://github.com/schollz/progressbar)   [![godoc][GoDoc]](https://godoc.org/github.com/schollz/progressbar)
* [uiprogress](https://github.com/gosuri/uiprogress) **star:1819** 在终端呈现进度条，可灵活配置的。   [![godoc][GoDoc]](https://godoc.org/github.com/gosuri/uiprogress)
* [pterm](https://github.com/pterm/pterm) **star:1781** 一个在每个平台上使用许多可组合组件美化控制台输出的库。   [![最近一周有更新][Green]](https://github.com/pterm/pterm)   [![godoc][GoDoc]](https://godoc.org/github.com/pterm/pterm)
* [termdash](https://github.com/mum4k/termdash) **star:1779** 此库是基于**termbox-go**实现的，借鉴于[termui](https://github.com/gizak/termui)。   [![godoc][GoDoc]](https://godoc.org/github.com/mum4k/termdash)
* [asciigraph](https://github.com/guptarohit/asciigraph) **star:1725** 在命令行中构建轻量级ASCII线图╭┈╯，应用程序中没有其他依赖项。   [![godoc][GoDoc]](https://godoc.org/github.com/guptarohit/asciigraph)
* [mpb](https://github.com/vbauerster/mpb) **star:1428** 可在终端显示多进度条。   [![godoc][GoDoc]](https://godoc.org/github.com/vbauerster/mpb)
* [uilive](https://github.com/gosuri/uilive) **star:1330** 用于实时更新终端输出的库。   [![godoc][GoDoc]](https://godoc.org/github.com/gosuri/uilive)
* [aurora](https://github.com/logrusorgru/aurora) **star:1116** 支持fmt.Printf/Sprintf的ANSI终端颜色。   [![godoc][GoDoc]](https://godoc.org/github.com/logrusorgru/aurora)
* [gookit/color](https://github.com/gookit/color) **star:894** 终端显色工具库，支持16种颜色，256种颜色，RGB显色输出，兼容Windows。   [![godoc][GoDoc]](https://godoc.org/github.com/gookit/color)   [![包含中文文档][CN]](https://github.com/gookit/color)
* [termenv](https://github.com/muesli/termenv) **star:780** 先进的ANSI风格和颜色支持您的终端应用程序   [![最近一周有更新][Green]](https://github.com/muesli/termenv)   [![godoc][GoDoc]](https://godoc.org/github.com/muesli/termenv)
* [uitable](https://github.com/gosuri/uitable) **star:616** 改善终端应用程序中表格数据的可读性。   [![godoc][GoDoc]](https://godoc.org/github.com/gosuri/uitable)
* [go-colorable](https://github.com/mattn/go-colorable) **star:545** 适用于windows的颜色编写器。   [![godoc][GoDoc]](https://godoc.org/github.com/mattn/go-colorable)
* [go-isatty](https://github.com/mattn/go-isatty) **star:539** Go 实现的 isatty。   [![godoc][GoDoc]](https://godoc.org/github.com/mattn/go-isatty)
* [chalk](https://github.com/ttacon/chalk) **star:379** 美化终端/控制台输出。   [![最近一年没有更新][Yellow]](https://github.com/ttacon/chalk)   [![godoc][GoDoc]](https://godoc.org/github.com/ttacon/chalk)
* [simpletable](https://github.com/alexeyco/simpletable) **star:322** 可在终端显示简易表格。   [![godoc][GoDoc]](https://godoc.org/github.com/alexeyco/simpletable)
* [tabby](https://github.com/cheynewallace/tabby) **star:295** 一个可在终端生成一个极简Golang表格轻量级库   [![godoc][GoDoc]](https://godoc.org/github.com/cheynewallace/tabby)
* [go-colortext](https://github.com/daviddengcn/go-colortext) **star:207** 在终端中使用彩色文字。   [![最近一年没有更新][Yellow]](https://github.com/daviddengcn/go-colortext)   [![godoc][GoDoc]](https://godoc.org/github.com/daviddengcn/go-colortext)
* [yacspin](https://github.com/theckman/yacspin) **star:191** 用于与终端旋转器一起工作。   [![最近一年没有更新][Yellow]](https://github.com/theckman/yacspin)   [![godoc][GoDoc]](https://godoc.org/github.com/theckman/yacspin)
* [box-cli-maker](https://github.com/Delta456/box-cli-maker) **star:141** 为你的CLI制作高度定制的盒子。   [![godoc][GoDoc]](https://godoc.org/github.com/Delta456/box-cli-maker)
* [cfmt](https://github.com/mingrammer/cfmt) **star:79** 提供上下文的fmt，灵感来自于bootstrap color classes。   [![最近一年没有更新][Yellow]](https://github.com/mingrammer/cfmt)   [![godoc][GoDoc]](https://godoc.org/github.com/mingrammer/cfmt)
* [tabular](https://github.com/InVisionApp/tabular) **star:55** 不需要向API传递大量参数就可从命令行实用程序中打印ASCII表。   [![最近一年没有更新][Yellow]](https://github.com/InVisionApp/tabular)   [![godoc][GoDoc]](https://godoc.org/github.com/InVisionApp/tabular)
* [ctc](https://github.com/wzshiming/ctc) **star:33** 不需要Print方法的非侵入性跨平台终端颜色库。   [![最近一年没有更新][Yellow]](https://github.com/wzshiming/ctc)   [![godoc][GoDoc]](https://godoc.org/github.com/wzshiming/ctc)   [![包含中文文档][CN]](https://github.com/wzshiming/ctc)
* [cfmt](https://github.com/i582/cfmt) **star:28** 简单和方便格式化格式化输出完全兼容fmt库。   [![godoc][GoDoc]](https://godoc.org/github.com/i582/cfmt)
* [colourize](https://github.com/TreyBastian/colourize) **star:24** 在终端提供ANSI彩色文本。   [![最近一年没有更新][Yellow]](https://github.com/TreyBastian/colourize)   [![godoc][GoDoc]](https://godoc.org/github.com/TreyBastian/colourize)
* [marker](https://github.com/cyucelen/marker) **star:19** 最简单的方法来匹配和标记字符串的彩色终端输出。   [![godoc][GoDoc]](https://godoc.org/github.com/cyucelen/marker)
* [go-ataman](https://github.com/workanator/go-ataman) **star:11** 在终端提供ANSI彩色文本模板。   [![godoc][GoDoc]](https://godoc.org/github.com/workanator/go-ataman)
* [table](https://github.com/tomlazar/table) **star:8** 为基于终端颜色的表的小库。   [![godoc][GoDoc]](https://godoc.org/github.com/tomlazar/table)

## 配置

*配置解析的库。 (翻译出错了? 试试 [英文版](README_EN.md#configuration) 吧~)*

* [viper](https://github.com/spf13/viper) **star:16509** 配置管理。   [![star > 2000][Awesome]](https://github.com/spf13/viper)   [![最近一周有更新][Green]](https://github.com/spf13/viper)   [![godoc][GoDoc]](https://godoc.org/github.com/spf13/viper)
* [godotenv](https://github.com/joho/godotenv) **star:4058** Ruby 的 dotenv 库的 Go移植版(从.env文件加载环境变量)。   [![star > 2000][Awesome]](https://github.com/joho/godotenv)   [![godoc][GoDoc]](https://godoc.org/github.com/joho/godotenv)
* [kelseyhightower/envconfig](https://github.com/kelseyhightower/envconfig) **star:3734** 管理来自环境变量的配置数据。   [![star > 2000][Awesome]](https://github.com/kelseyhightower/envconfig)   [![godoc][GoDoc]](https://godoc.org/github.com/kelseyhightower/envconfig)
* [ini](https://github.com/go-ini/ini) **star:2580**  读和写INI文件。   [![star > 2000][Awesome]](https://github.com/go-ini/ini)   [![godoc][GoDoc]](https://godoc.org/github.com/go-ini/ini)
* [env](https://github.com/caarlos0/env) **star:1988** 解析环境变量并赋值到struct中(默认值)。   [![最近一周有更新][Green]](https://github.com/caarlos0/env)   [![godoc][GoDoc]](https://godoc.org/github.com/caarlos0/env)
* [konfig](https://github.com/lalamove/konfig) **star:612** 可组合、可观察和高性能的分布式配置管理。   [![godoc][GoDoc]](https://godoc.org/github.com/lalamove/konfig)
* [koanf](https://github.com/knadh/koanf) **star:564** 轻量级可扩展库，用于读取Go应用程序中的配置。内置支持JSON, TOML, YAML, env，命令行。   [![最近一周有更新][Green]](https://github.com/knadh/koanf)   [![godoc][GoDoc]](https://godoc.org/github.com/knadh/koanf)
* [confita](https://github.com/heetch/confita) **star:403** 从多个后端级联加载配置到struct中。   [![godoc][GoDoc]](https://godoc.org/github.com/heetch/confita)
* [cleanenv](https://github.com/ilyakaznacheev/cleanenv) **star:334** 简约的配置阅读器(来自文件、环境，以及你想要的任何地方)。   [![最近一周有更新][Green]](https://github.com/ilyakaznacheev/cleanenv)   [![godoc][GoDoc]](https://godoc.org/github.com/ilyakaznacheev/cleanenv)
* [config](https://github.com/JeremyLoy/config) **star:265** 云本地应用程序配置。将ENV绑定到结构体仅需两行代码。   [![godoc][GoDoc]](https://godoc.org/github.com/JeremyLoy/config)
* [gookit/config](https://github.com/gookit/config) **star:264** 程序配置管理(load,get,set)。支持JSON, YAML, TOML, INI, HCL。支持多文件加载，数据覆盖合并。   [![godoc][GoDoc]](https://godoc.org/github.com/gookit/config)   [![包含中文文档][CN]](https://github.com/gookit/config)
* [aconfig](https://github.com/cristalhq/aconfig) **star:262** 简单，有用和固执的配置加载程序。   [![最近一周有更新][Green]](https://github.com/cristalhq/aconfig)   [![godoc][GoDoc]](https://godoc.org/github.com/cristalhq/aconfig)
* [store](https://github.com/tucnak/store) **star:256** 轻量级配置管理器。   [![最近一年没有更新][Yellow]](https://github.com/tucnak/store)   [![godoc][GoDoc]](https://godoc.org/github.com/tucnak/store)
* [config](https://github.com/olebedev/config) **star:240** 带有环境变量和标记解析的JSON或YAML配置包装器。   [![godoc][GoDoc]](https://godoc.org/github.com/olebedev/config)
* [hjson](https://github.com/hjson/hjson-go) **star:239** 更加人性化的JSON配置。轻松的语法，更少的错误，更多的注释。   [![godoc][GoDoc]](https://godoc.org/github.com/hjson/hjson-go)
* [envconfig](https://github.com/vrischmann/envconfig) **star:206** 从环境变量中读取配置。   [![godoc][GoDoc]](https://godoc.org/github.com/vrischmann/envconfig)
* [joshbetz/config](https://github.com/joshbetz/config) **star:205** 一个可解析环境变量、JSON文件小巧的配置库，在SIGHUP时会自动重新加载。   [![最近一年没有更新][Yellow]](https://github.com/joshbetz/config)   [![godoc][GoDoc]](https://godoc.org/github.com/joshbetz/config)
* [config](https://github.com/golobby/config) **star:165** 一个轻量级但功能强大的配置包，用于Go项目。   [![最近一周有更新][Green]](https://github.com/golobby/config)   [![godoc][GoDoc]](https://godoc.org/github.com/golobby/config)
* [fig](https://github.com/kkyr/fig) **star:158** 用于从文件和环境变量(带有验证和默认值)中读取配置的微型库。   [![godoc][GoDoc]](https://godoc.org/github.com/kkyr/fig)
* [gcfg](https://github.com/go-gcfg/gcfg) **star:153** 将ini的配置文件读入 Go structs中;支持用户定义的类型和子选项。   [![godoc][GoDoc]](https://godoc.org/github.com/go-gcfg/gcfg)
* [goConfig](https://github.com/crgimenes/goConfig) **star:148** 将结构体解析为输入，并用来自命令行、环境变量和配置文件的参数填充该结构体的字段。   [![godoc][GoDoc]](https://godoc.org/github.com/crgimenes/goConfig)
* [xdg](https://github.com/adrg/xdg) **star:119** Go实现[XDG基本目录规范](https://specifications.freedesktop.org/basedir-spec/basedir-spec-latest.html)和[XDG用户目录](https://wiki.archlinux.org/index.php/XDG_user_directories)。   [![godoc][GoDoc]](https://godoc.org/github.com/adrg/xdg)
* [envh](https://github.com/antham/envh) **star:95** 协助管理环境变量的Helpers。   [![godoc][GoDoc]](https://godoc.org/github.com/antham/envh)
* [envcfg](https://github.com/tomazk/envcfg) **star:94** 对环境变量进行解析，并赋值到struct。   [![最近一年没有更新][Yellow]](https://github.com/tomazk/envcfg)   [![godoc][GoDoc]](https://godoc.org/github.com/tomazk/envcfg)
* [harvester](https://github.com/beatlabs/harvester) **star:86** 一个易于使用的静态和动态配置包   [![最近一周有更新][Green]](https://github.com/beatlabs/harvester)   [![godoc][GoDoc]](https://godoc.org/github.com/beatlabs/harvester)
* [configuro](https://github.com/sherifabdlnaby/configuro) **star:74** 固执己见的配置加载和验证框架从环境和文件集中到12因素兼容的应用程序。   [![godoc][GoDoc]](https://godoc.org/github.com/sherifabdlnaby/configuro)
* [xdg](https://github.com/OpenPeeDeeP/xdg) **star:63** 遵循[XDG标准](https://standards.freedesktop.org/basedir-spec/basedir-spec-latest.html)的跨平台包。   [![godoc][GoDoc]](https://godoc.org/github.com/OpenPeeDeeP/xdg)
* [gofigure](https://github.com/ian-kent/gofigure) **star:59** 让程序配置变得简单。   [![最近一年没有更新][Yellow]](https://github.com/ian-kent/gofigure)   [![godoc][GoDoc]](https://godoc.org/github.com/ian-kent/gofigure)
* [gone/jconf](https://github.com/One-com/gone/tree/master/jconf)  模块化的JSON配置。保持配置结构及其配置的代码，并将解析委托给子模块，而不牺牲配置的完整序列化。
* [configure](https://github.com/paked/configure) **star:54** 通过多个源提供配置，包括JSON、flags和环境变量。   [![最近一年没有更新][Yellow]](https://github.com/paked/configure)   [![godoc][GoDoc]](https://godoc.org/github.com/paked/configure)
* [go-aws-ssm](https://github.com/PaddleHQ/go-aws-ssm) **star:41** 从AWS系统管理器-参数存储中获取参数的Go包。   [![godoc][GoDoc]](https://godoc.org/github.com/PaddleHQ/go-aws-ssm)
* [configuration](https://github.com/BoRuDar/configuration) **star:39** 库，用于从环境变量、文件、标记和“默认”标记初始化配置结构。   [![最近一年没有更新][Yellow]](https://github.com/BoRuDar/configuration)   [![godoc][GoDoc]](https://godoc.org/github.com/BoRuDar/configuration)
* [ingo](https://github.com/schachmat/ingo) **star:35** flag保存在类ini的配置文件中。   [![最近一年没有更新][Yellow]](https://github.com/schachmat/ingo)   [![godoc][GoDoc]](https://godoc.org/github.com/schachmat/ingo)
* [uConfig](https://github.com/omeid/uconfig) **star:35** 轻量级、零依赖和可扩展的配置管理。   [![godoc][GoDoc]](https://godoc.org/github.com/omeid/uconfig)
* [go-up](https://github.com/ufoscout/go-up) **star:32** 一个简单的配置库，具有递归占位符解析功能。   [![最近一年没有更新][Yellow]](https://github.com/ufoscout/go-up)   [![godoc][GoDoc]](https://godoc.org/github.com/ufoscout/go-up)
* [hocon](https://github.com/gurkankaymak/hocon) **star:28** 使用HOCON(一种人类友好的JSON超集)格式的配置库，支持环境变量、引用其他值、注释和多个文件等特性。   [![godoc][GoDoc]](https://godoc.org/github.com/gurkankaymak/hocon)
* [mini](https://github.com/sasbury/mini) **star:28** 用于解析ini类型的配置文件。   [![最近一年没有更新][Yellow]](https://github.com/sasbury/mini)   [![godoc][GoDoc]](https://godoc.org/github.com/sasbury/mini)
* [genv](https://github.com/sakirsensoy/genv) **star:24** 使用dotenv支持轻松读取环境变量。   [![最近一年没有更新][Yellow]](https://github.com/sakirsensoy/genv)   [![godoc][GoDoc]](https://godoc.org/github.com/sakirsensoy/genv)
* [conflate](https://github.com/the4thamigo-uk/conflate) **star:19** 合并来自任意url的多个JSON/YAML/TOML文件、针对JSON模式的验证以及模式中定义的默认值的应用程序。   [![godoc][GoDoc]](https://godoc.org/github.com/the4thamigo-uk/conflate)
* [envconf](https://github.com/ian-kent/envconf) **star:10** 从环境配置中读取配置。   [![最近一年没有更新][Yellow]](https://github.com/ian-kent/envconf)   [![godoc][GoDoc]](https://godoc.org/github.com/ian-kent/envconf)
* [go-ssm-config](https://github.com/ianlopshire/go-ssm-config) **star:10** 从AWS SSM(参数存储)加载配置参数的Go实用程序。   [![godoc][GoDoc]](https://godoc.org/github.com/ianlopshire/go-ssm-config)
* [nasermirzaei89/env](https://github.com/nasermirzaei89/env) **star:6** 读取环境变量的简单有用的包。   [![godoc][GoDoc]](https://godoc.org/github.com/nasermirzaei89/env)
* [onion](http://github.com/goraz/onion)  基于层配置的Go，支持JSON, TOML, YAML，属性，etcd, env，和加密使用PGP。
* [go-ini](https://github.com/subpop/go-ini) **star:5** 一个对ini文件进行封送和解送的Go包。   [![godoc][GoDoc]](https://godoc.org/github.com/subpop/go-ini)
* [swap](https://github.com/oblq/swap) **star:4** 根据构建环境递归实例化/配置结构。(YAML, TOML, JSON和env)。   [![godoc][GoDoc]](https://godoc.org/github.com/oblq/swap)
* [typenv](https://github.com/diegomarangoni/typenv) **star:4** 简约，零依赖，类型化环境变量库。   [![最近一年没有更新][Yellow]](https://github.com/diegomarangoni/typenv)   [![godoc][GoDoc]](https://godoc.org/github.com/diegomarangoni/typenv)
* [gonfig](https://github.com/milad-abbasi/gonfig) **star:2** 基于标记的配置解析器，它将来自不同提供程序的值加载到类型安全结构中。   [![godoc][GoDoc]](https://godoc.org/github.com/milad-abbasi/gonfig)

## 持续集成

*用于帮助进行持续集成的工具。 (翻译出错了? 试试 [英文版](README_EN.md#continuous-integration) 吧~)*

* [drone](https://github.com/drone/drone) **star:23733** Drone 是一个基于 Docker 的持续集成平台，用 Go 编写。   [![star > 2000][Awesome]](https://github.com/drone/drone)   [![最近一周有更新][Green]](https://github.com/drone/drone)   [![godoc][GoDoc]](https://godoc.org/github.com/drone/drone)
* [CDS](https://github.com/ovh/cds) **star:3523** 企业级CI/CD和DevOps自动化开源平台。   [![star > 2000][Awesome]](https://github.com/ovh/cds)   [![最近一周有更新][Green]](https://github.com/ovh/cds)   [![godoc][GoDoc]](https://godoc.org/github.com/ovh/cds)
* [goveralls](https://github.com/mattn/goveralls) **star:695** Coveralls.io 是一个用 Go 编写，可持续对代码覆盖率进行检测的系统。   [![godoc][GoDoc]](https://godoc.org/github.com/mattn/goveralls)
* [overalls](https://github.com/go-playground/overalls) **star:106** 针对多package 的 Go 语言项目，可为类似 goveralls 这样的工具生成覆盖率报告。   [![最近一年没有更新][Yellow]](https://github.com/go-playground/overalls)   [![godoc][GoDoc]](https://godoc.org/github.com/go-playground/overalls)
* [duci](https://github.com/duck8823/duci) **star:67** 一个简单的 ci 服务。   [![最近一周有更新][Green]](https://github.com/duck8823/duci)   [![godoc][GoDoc]](https://godoc.org/github.com/duck8823/duci)
* [gomason](https://github.com/nikogura/gomason) **star:51** 在一个干净的工作区中对你的 Go 二进制文件进行测试、构建、签名和发布。   [![godoc][GoDoc]](https://godoc.org/github.com/nikogura/gomason)
* [roveralls](https://github.com/LawrenceWoodman/roveralls) **star:14** 递归覆盖测试工具。   [![最近一年没有更新][Yellow]](https://github.com/LawrenceWoodman/roveralls)   [![godoc][GoDoc]](https://godoc.org/github.com/LawrenceWoodman/roveralls)
* [gotestfmt](https://github.com/haveyoudebuggedit/gotestfmt) **star:11** 为人类测试输出。   [![godoc][GoDoc]](https://godoc.org/github.com/haveyoudebuggedit/gotestfmt)

## CSS预处理器

*用于预处理CSS文件的库。 (翻译出错了? 试试 [英文版](README_EN.md#css-preprocessors) 吧~)*

* [gcss](https://github.com/yosssi/gcss) **star:445** 纯Go编写的 CSS 预处理器。   [![最近一年没有更新][Yellow]](https://github.com/yosssi/gcss)   [![godoc][GoDoc]](https://godoc.org/github.com/yosssi/gcss)
* [go-libsass](https://github.com/wellington/go-libsass) **star:179**  采用 Go封装，100% 与 Sass 兼容的 libsass 项目。

## 数据结构

*用 Go 实现的通用的数据结构和算法。 (翻译出错了? 试试 [英文版](README_EN.md#data-structures) 吧~)*

* [gods](https://github.com/emirpasic/gods) **star:10348** 数据结构。容器、集合、列表、堆栈、地图、BidiMaps、树、HashSet等。   [![star > 2000][Awesome]](https://github.com/emirpasic/gods)   [![godoc][GoDoc]](https://godoc.org/github.com/emirpasic/gods)
* [go-datastructures](https://github.com/Workiva/go-datastructures) **star:6138** 可靠的、高性能的和线程安全的数据结构的集合。   [![star > 2000][Awesome]](https://github.com/Workiva/go-datastructures)   [![godoc][GoDoc]](https://godoc.org/github.com/Workiva/go-datastructures)
* [golang-set](https://github.com/deckarep/golang-set) **star:2037** 线程安全和非线程安全的高性能集。   [![star > 2000][Awesome]](https://github.com/deckarep/golang-set)   [![godoc][GoDoc]](https://godoc.org/github.com/deckarep/golang-set)
* [gota](https://github.com/kniren/gota) **star:1718** 实现了数据帧，序列以及数据噪音。   [![godoc][GoDoc]](https://godoc.org/github.com/kniren/gota)
* [boomfilters](https://github.com/tylertreat/BoomFilters) **star:1368** 用于处理连续的概率数据结构。   [![godoc][GoDoc]](https://godoc.org/github.com/tylertreat/BoomFilters)
* [roaring](https://github.com/RoaringBitmap/roaring) **star:1294** 实现了压缩 bitsets 的Go包。   [![最近一周有更新][Green]](https://github.com/RoaringBitmap/roaring)   [![godoc][GoDoc]](https://godoc.org/github.com/RoaringBitmap/roaring)
* [willf/bloom](https://github.com/willf/bloom) **star:1259** 实现Bloom过滤器。   [![godoc][GoDoc]](https://godoc.org/github.com/willf/bloom)
* [gocache](https://github.com/eko/gocache) **star:932** 一个完整的Go缓存库，具有多个存储(内存，memcache, redis，…)，可链，可加载，指标缓存和更多。   [![最近一周有更新][Green]](https://github.com/eko/gocache)   [![godoc][GoDoc]](https://godoc.org/github.com/eko/gocache)
* [cuckoofilter](https://github.com/seiflotfy/cuckoofilter) **star:815** 布谷鸟过滤器:一个用Go实现，可替代计数 bloom 过滤器。   [![godoc][GoDoc]](https://godoc.org/github.com/seiflotfy/cuckoofilter)
* [hyperloglog](https://github.com/axiomhq/hyperloglog) **star:749** HyperLogLog implementation with Sparse, LogLog-Beta bias correction and TailCut space reduction.   [![godoc][GoDoc]](https://godoc.org/github.com/axiomhq/hyperloglog)
* [bitset](https://github.com/willf/bitset) **star:708** 实现了 bitsets 的 Go 包。   [![godoc][GoDoc]](https://godoc.org/github.com/willf/bitset)
* [algorithms](https://github.com/shady831213/algorithms) **star:552** 算法和数据结构。来源于CLRS。   [![godoc][GoDoc]](https://godoc.org/github.com/shady831213/algorithms)
* [trie](https://github.com/derekparker/trie) **star:544** 在Go中实现Trie。   [![最近一年没有更新][Yellow]](https://github.com/derekparker/trie)   [![godoc][GoDoc]](https://godoc.org/github.com/derekparker/trie)
* [go-geoindex](https://github.com/hailocab/go-geoindex) **star:331** 基于内存的地理索引。   [![最近一年没有更新][Yellow]](https://github.com/hailocab/go-geoindex)   [![godoc][GoDoc]](https://godoc.org/github.com/hailocab/go-geoindex)
* [gostl](https://github.com/liyue201/gostl) **star:297** 用于go的数据结构和算法库，旨在提供类似c++ STL的函数。   [![godoc][GoDoc]](https://godoc.org/github.com/liyue201/gostl)
* [go-edlib](https://github.com/hbollon/go-edlib) **star:276** Go字符串比较和编辑距离算法库(Levenshtein, LCS, Hamming, Damerau Levenshtein, Jaro-Winkler等)兼容Unicode。   [![godoc][GoDoc]](https://godoc.org/github.com/hbollon/go-edlib)
* [merkletree](https://github.com/cbergoon/merkletree) **star:262** 实现了merkle树，提供了对数据结构内容的有效和安全的验证。   [![最近一年没有更新][Yellow]](https://github.com/cbergoon/merkletree)   [![godoc][GoDoc]](https://godoc.org/github.com/cbergoon/merkletree)
* [ttlcache](https://github.com/ReneKroon/ttlcache) **star:262** 内存中的string-interface{}缓存各种基于时间的过期选项和回调。   [![最近一周有更新][Green]](https://github.com/ReneKroon/ttlcache)   [![godoc][GoDoc]](https://godoc.org/github.com/ReneKroon/ttlcache)
* [hilbert](https://github.com/google/hilbert) **star:235** 用于映射空间填充曲线（例如 Hilbert 曲线和 Peano 曲线）和数值。   [![最近一年没有更新][Yellow]](https://github.com/google/hilbert)   [![godoc][GoDoc]](https://godoc.org/github.com/google/hilbert)
* [deque](https://github.com/gammazero/deque) **star:234** 快速环缓冲区deque(双端队列)。   [![godoc][GoDoc]](https://godoc.org/github.com/gammazero/deque)
* [goskiplist](https://github.com/ryszard/goskiplist) **star:227** 基于 Go 的跳表实现。   [![最近一年没有更新][Yellow]](https://github.com/ryszard/goskiplist)   [![godoc][GoDoc]](https://godoc.org/github.com/ryszard/goskiplist)
* [go-adaptive-radix-tree](https://github.com/plar/go-adaptive-radix-tree) **star:203** 自适应基数树。   [![最近一年没有更新][Yellow]](https://github.com/plar/go-adaptive-radix-tree)   [![godoc][GoDoc]](https://godoc.org/github.com/plar/go-adaptive-radix-tree)
* [binpacker](https://github.com/zhuangsirui/binpacker) **star:167** 帮助用户构建自定义二进制流的二进制封装器和解包器   [![godoc][GoDoc]](https://godoc.org/github.com/zhuangsirui/binpacker)
* [cuckoo-filter](https://github.com/linvon/cuckoo-filter) **star:166** 布谷鸟滤波器:一种综合布谷鸟滤波器，与其他实现相比，具有可配置性和空间优化性，原论文中提到的所有特性均可获得。   [![godoc][GoDoc]](https://godoc.org/github.com/linvon/cuckoo-filter)   [![包含中文文档][CN]](https://github.com/linvon/cuckoo-filter)
* [skiplist](https://github.com/MauriceGit/skiplist) **star:165** 高性能的 Go 跳表实现。   [![最近一年没有更新][Yellow]](https://github.com/MauriceGit/skiplist)   [![godoc][GoDoc]](https://godoc.org/github.com/MauriceGit/skiplist)
* [levenshtein](https://github.com/agnivade/levenshtein) **star:154** 实现在Go中计算levenshtein距离。   [![godoc][GoDoc]](https://godoc.org/github.com/agnivade/levenshtein)
* [bloom](https://github.com/zhenjl/bloom) **star:144** 在Go中实现了Bloom过滤器。   [![最近一年没有更新][Yellow]](https://github.com/zhenjl/bloom)   [![godoc][GoDoc]](https://godoc.org/github.com/zhenjl/bloom)
* [goconcurrentqueue](https://github.com/enriquebris/goconcurrentqueue) **star:143** 并行FIFO队列。   [![最近一年没有更新][Yellow]](https://github.com/enriquebris/goconcurrentqueue)   [![godoc][GoDoc]](https://godoc.org/github.com/enriquebris/goconcurrentqueue)
* [iter](https://github.com/disksing/iter) **star:138** Go实现的c++ STL迭代器和算法。   [![最近一年没有更新][Yellow]](https://github.com/disksing/iter)   [![godoc][GoDoc]](https://godoc.org/github.com/disksing/iter)   [![包含中文文档][CN]](https://github.com/disksing/iter)
* [ring](https://github.com/TheTannerRyan/ring) **star:119** 高性能、线程安全的bloom过滤器。   [![godoc][GoDoc]](https://godoc.org/github.com/TheTannerRyan/ring)
* [go-rquad](https://github.com/aurelien-rainone/go-rquad) **star:116** 区域四叉树具有高效的点定位和邻域查找功能。   [![最近一年没有更新][Yellow]](https://github.com/aurelien-rainone/go-rquad)   [![godoc][GoDoc]](https://godoc.org/github.com/aurelien-rainone/go-rquad)
* [encoding](https://github.com/zhenjl/encoding) **star:108** 整形压缩库。   [![最近一年没有更新][Yellow]](https://github.com/zhenjl/encoding)   [![godoc][GoDoc]](https://godoc.org/github.com/zhenjl/encoding)
* [bit](https://github.com/yourbasic/bit) **star:107** Go 语言集合数据结构。提供了额外的位操作功能。   [![最近一年没有更新][Yellow]](https://github.com/yourbasic/bit)   [![godoc][GoDoc]](https://godoc.org/github.com/yourbasic/bit)
* [remember-go](https://github.com/rocketlaunchr/remember-go) **star:100** 用于缓存慢速数据库查询的通用接口(支持redis、memcached、ristretto或in-memory)。   [![godoc][GoDoc]](https://godoc.org/github.com/rocketlaunchr/remember-go)
* [conjungo](https://github.com/InVisionApp/conjungo) **star:95** 一个小型、强大和灵活的合并库。   [![godoc][GoDoc]](https://godoc.org/github.com/InVisionApp/conjungo)
* [bitmap](https://github.com/kelindar/bitmap) **star:78** 密集，零分配，simd启用的位图/位集   [![godoc][GoDoc]](https://godoc.org/github.com/kelindar/bitmap)
* [skiplist](https://github.com/gansidui/skiplist) **star:74** 在Go中实现了跳表。   [![最近一年没有更新][Yellow]](https://github.com/gansidui/skiplist)   [![godoc][GoDoc]](https://godoc.org/github.com/gansidui/skiplist)
* [go-mcache](https://github.com/OrlovEvgeny/go-mcache) **star:68** 基于内存的实现了高性能的key:value存储库。指针缓存。   [![最近一年没有更新][Yellow]](https://github.com/OrlovEvgeny/go-mcache)   [![godoc][GoDoc]](https://godoc.org/github.com/OrlovEvgeny/go-mcache)
* [bloom](https://github.com/yourbasic/bloom) **star:63** Golang Bloom过滤器的实现。   [![最近一年没有更新][Yellow]](https://github.com/yourbasic/bloom)   [![godoc][GoDoc]](https://godoc.org/github.com/yourbasic/bloom)
* [levenshtein](https://github.com/agext/levenshtein) **star:59** Levenshtein distance and similarity metrics with customizable edit costs and Winkler-like bonus for common prefix.   [![godoc][GoDoc]](https://godoc.org/github.com/agext/levenshtein)
* [count-min-log](https://github.com/seiflotfy/count-min-log) **star:53** Go实现Count-Min-log sketch的功能 : 使用近似计数器进行近似计数(类似Count-Min sketch，但使用更少内存)。   [![最近一年没有更新][Yellow]](https://github.com/seiflotfy/count-min-log)   [![godoc][GoDoc]](https://godoc.org/github.com/seiflotfy/count-min-log)
* [crunch](https://github.com/superwhiskers/crunch) **star:44** 打包实现缓冲区，以便轻松处理各种数据类型。   [![godoc][GoDoc]](https://godoc.org/github.com/superwhiskers/crunch)
* [goset](https://github.com/zoumo/goset) **star:37** 一个有用的Go集合实现。   [![godoc][GoDoc]](https://godoc.org/github.com/zoumo/goset)
* [nan](https://github.com/kak-tus/nan) **star:37** 一个库中的可零分配空结构，具有方便的转换函数、编组器和解组器。   [![最近一周有更新][Green]](https://github.com/kak-tus/nan)   [![godoc][GoDoc]](https://godoc.org/github.com/kak-tus/nan)
* [hide](https://github.com/emvi/hide) **star:35** ID type with marshalling to/from hash to prevent sending IDs to clients.   [![godoc][GoDoc]](https://godoc.org/github.com/emvi/hide)
* [concurrent-writer](https://github.com/free/concurrent-writer) **star:34** 具备高并发能力，可替换 bufio.Writer。   [![最近一年没有更新][Yellow]](https://github.com/free/concurrent-writer)   [![godoc][GoDoc]](https://godoc.org/github.com/free/concurrent-writer)
* [pipeline](https://github.com/hyfather/pipeline) **star:31** 实现了 fan-in 和 fan-out 的管道功能。   [![最近一年没有更新][Yellow]](https://github.com/hyfather/pipeline)   [![godoc][GoDoc]](https://godoc.org/github.com/hyfather/pipeline)
* [deque](https://github.com/edwingeng/deque) **star:28** 高度优化的双端队列。   [![godoc][GoDoc]](https://godoc.org/github.com/edwingeng/deque)
* [timedmap](https://github.com/zekroTJA/timedmap) **star:28** 实现了有生命周期的键值对Map。   [![godoc][GoDoc]](https://godoc.org/github.com/zekroTJA/timedmap)
* [typ](https://github.com/gurukami/typ) **star:28** 从复杂结构中获取值，支持空类型、安全的类型转换。   [![最近一年没有更新][Yellow]](https://github.com/gurukami/typ)   [![godoc][GoDoc]](https://godoc.org/github.com/gurukami/typ)
* [null](https://github.com/emvi/null) **star:21** 对空的 Go 数据类型也可以进行JSON进行解析/反解析。   [![godoc][GoDoc]](https://godoc.org/github.com/emvi/null)
* [dict](https://github.com/srfrog/dict) **star:19** 实现类似 python dict的功能(dict)。   [![godoc][GoDoc]](https://godoc.org/github.com/srfrog/dict)
* [go-ef](https://github.com/amallia/go-ef) **star:18** 实现了 Elias-Fano 编码。   [![最近一年没有更新][Yellow]](https://github.com/amallia/go-ef)   [![godoc][GoDoc]](https://godoc.org/github.com/amallia/go-ef)
* [cmap](https://github.com/lrita/cmap) **star:16** 一个线程安全的go map   [![最近一年没有更新][Yellow]](https://github.com/lrita/cmap)   [![godoc][GoDoc]](https://godoc.org/github.com/lrita/cmap)
* [mspm](https://github.com/BlackRabbitt/mspm) **star:16** 用于信息检索的多字符串模式匹配算法。   [![最近一年没有更新][Yellow]](https://github.com/BlackRabbitt/mspm)   [![godoc][GoDoc]](https://godoc.org/github.com/BlackRabbitt/mspm)
* [ptrie](https://github.com/viant/ptrie) **star:16** 前缀树的一种实现。   [![godoc][GoDoc]](https://godoc.org/github.com/viant/ptrie)
* [set](https://github.com/StudioSol/set) **star:15** 使用LinkedHashMap在Go中实现简单的set数据结构。   [![godoc][GoDoc]](https://godoc.org/github.com/StudioSol/set)
* [treap](https://github.com/perdata/treap) **star:12** 使用树堆进行持久、快速有序的映射。   [![最近一年没有更新][Yellow]](https://github.com/perdata/treap)   [![godoc][GoDoc]](https://godoc.org/github.com/perdata/treap)
* [parapipe](https://github.com/nazar256/parapipe) **star:10** FIFO管道，并行执行在每个阶段，同时保持消息和结果的顺序。   [![godoc][GoDoc]](https://godoc.org/github.com/nazar256/parapipe)
* [gofal](https://github.com/xxjwxc/gofal) **star:9** 基于 Go 实现的分数计算。包含分子、分母运算    [![最近一年没有更新][Yellow]](https://github.com/xxjwxc/gofal)   [![godoc][GoDoc]](https://godoc.org/github.com/xxjwxc/gofal)   [![包含中文文档][CN]](https://github.com/xxjwxc/gofal)
* [ordered-concurrently](https://github.com/tejzpr/ordered-concurrently) **star:8** Go模块，处理并发工作，并在通道中返回输入顺序的输出。   [![godoc][GoDoc]](https://godoc.org/github.com/tejzpr/ordered-concurrently)
* [parsefields](https://github.com/MonaxGT/parsefields) **star:6** 用于解析类似json的日志的工具，用于收集惟一的字段和事件。   [![最近一年没有更新][Yellow]](https://github.com/MonaxGT/parsefields)   [![godoc][GoDoc]](https://godoc.org/github.com/MonaxGT/parsefields)
* [dsu](https://github.com/ihebu/dsu) **star:5** 在Go中实现离散集数据结构。   [![godoc][GoDoc]](https://godoc.org/github.com/ihebu/dsu)
* [bloomfilter](https://github.com/OldPanda/bloomfilter) **star:4** 另一个在Go中的Bloomfilter实现，与Java的番石榴库兼容。   [![godoc][GoDoc]](https://godoc.org/github.com/OldPanda/bloomfilter)
* [goterator](https://github.com/yaa110/goterator) **star:4** 迭代器实现，提供映射和减少功能。   [![godoc][GoDoc]](https://godoc.org/github.com/yaa110/goterator)
* [slices](https://github.com/srfrog/slices) **star:3** 对片进行操作的函数;类似于“包字符串”，但适用于使用片。   [![godoc][GoDoc]](https://godoc.org/github.com/srfrog/slices)
* [merkle](https://github.com/bobg/merkle) **star:1** 默克尔根哈希的空间高效计算和包含证明。   [![最近一周有更新][Green]](https://github.com/bobg/merkle)   [![godoc][GoDoc]](https://godoc.org/github.com/bobg/merkle)

## 数据库

*数据库。 (翻译出错了? 试试 [英文版](README_EN.md#database) 吧~)*

* [prometheus](https://github.com/prometheus/prometheus) **star:38356** 用于监控系统和时序的数据库。   [![star > 2000][Awesome]](https://github.com/prometheus/prometheus)   [![最近一周有更新][Green]](https://github.com/prometheus/prometheus)   [![godoc][GoDoc]](https://godoc.org/github.com/prometheus/prometheus)
* [tidb](https://github.com/pingcap/tidb) **star:28765** TiDB是一个分布式SQL数据库。灵感来自谷歌F1的设计。   [![star > 2000][Awesome]](https://github.com/pingcap/tidb)   [![最近一周有更新][Green]](https://github.com/pingcap/tidb)   [![godoc][GoDoc]](https://godoc.org/github.com/pingcap/tidb)   [![包含中文文档][CN]](https://github.com/pingcap/tidb)
* [influxdb](https://github.com/influxdb/influxdb) **star:21951** 可伸缩的数据存储，用于指标衡量、事件和实时分析。   [![star > 2000][Awesome]](https://github.com/influxdb/influxdb)   [![最近一周有更新][Green]](https://github.com/influxdb/influxdb)   [![godoc][GoDoc]](https://godoc.org/github.com/influxdb/influxdb)
* [cockroach](https://github.com/cockroachdb/cockroach) **star:21437** 可伸缩、区域备份、事务性数据存储。   [![star > 2000][Awesome]](https://github.com/cockroachdb/cockroach)   [![最近一周有更新][Green]](https://github.com/cockroachdb/cockroach)   [![godoc][GoDoc]](https://godoc.org/github.com/cockroachdb/cockroach)
* [dgraph](https://github.com/dgraph-io/dgraph) **star:16500** 可伸缩、分布式、低延迟、高吞吐量的图形数据库。   [![star > 2000][Awesome]](https://github.com/dgraph-io/dgraph)   [![最近一周有更新][Green]](https://github.com/dgraph-io/dgraph)   [![godoc][GoDoc]](https://godoc.org/github.com/dgraph-io/dgraph)
* [groupcache](https://github.com/golang/groupcache) **star:10546** Groupcache是一个缓存和缓存填充库，在许多情况下，它是memcached的替代品。   [![star > 2000][Awesome]](https://github.com/golang/groupcache)   [![godoc][GoDoc]](https://godoc.org/github.com/golang/groupcache)
* [badger](https://github.com/dgraph-io/badger) **star:9602** 快速 K/V 存储。   [![star > 2000][Awesome]](https://github.com/dgraph-io/badger)   [![最近一周有更新][Green]](https://github.com/dgraph-io/badger)   [![godoc][GoDoc]](https://godoc.org/github.com/dgraph-io/badger)
* [rqlite](https://github.com/rqlite/rqlite) **star:8699** 基于SQLite的轻量级分布式关系数据库。   [![star > 2000][Awesome]](https://github.com/rqlite/rqlite)   [![最近一周有更新][Green]](https://github.com/rqlite/rqlite)   [![godoc][GoDoc]](https://godoc.org/github.com/rqlite/rqlite)
* [go-cache](https://github.com/pmylund/go-cache) **star:5282** 基于内存的 K/V 存储/缓存 : (类似于Memcached)，适用于单机应用程序。   [![star > 2000][Awesome]](https://github.com/pmylund/go-cache)   [![godoc][GoDoc]](https://godoc.org/github.com/pmylund/go-cache)
* [BigCache](https://github.com/allegro/bigcache) **star:5063** 高效的键/值缓存为千兆字节的数据。   [![star > 2000][Awesome]](https://github.com/allegro/bigcache)   [![最近一周有更新][Green]](https://github.com/allegro/bigcache)   [![godoc][GoDoc]](https://godoc.org/github.com/allegro/bigcache)
* [Bitcask](https://git.mills.io/prologic/bitcask)  Bitcask是一个可嵌入的、持久的、快速的键值(KV)数据库，使用纯Go编写，具有可预测的读写性能、低延迟和高吞吐量，这得益于Bitcask的磁盘布局(LSM+WAL)。
* [VictoriaMetrics](https://github.com/VictoriaMetrics/VictoriaMetrics) **star:4733** 开源，快速，可伸缩的时间序列数据库。支持PromQL。   [![star > 2000][Awesome]](https://github.com/VictoriaMetrics/VictoriaMetrics)   [![最近一周有更新][Green]](https://github.com/VictoriaMetrics/VictoriaMetrics)   [![godoc][GoDoc]](https://godoc.org/github.com/VictoriaMetrics/VictoriaMetrics)
* [bbolt](https://github.com/etcd-io/bbolt) **star:4694** 一个用于Go的嵌入式键/值数据库。   [![star > 2000][Awesome]](https://github.com/etcd-io/bbolt)   [![godoc][GoDoc]](https://godoc.org/github.com/etcd-io/bbolt)
* [goleveldb](https://github.com/syndtr/goleveldb) **star:4504** 在Go中实现[LevelDB](https://github.com/google/leveldb) key/value数据库。   [![star > 2000][Awesome]](https://github.com/syndtr/goleveldb)   [![最近一周有更新][Green]](https://github.com/syndtr/goleveldb)   [![godoc][GoDoc]](https://godoc.org/github.com/syndtr/goleveldb)
* [ledisdb](https://github.com/siddontang/ledisdb) **star:3690** Ledisdb是一种高性能的NoSQL，类似于基于LevelDB的Redis。   [![star > 2000][Awesome]](https://github.com/siddontang/ledisdb)   [![godoc][GoDoc]](https://godoc.org/github.com/siddontang/ledisdb)
* [buntdb](https://github.com/tidwall/buntdb) **star:3411** 基于内存的K/V，快速，可嵌入的数据库，可自定义索引和空间支持。   [![star > 2000][Awesome]](https://github.com/tidwall/buntdb)   [![godoc][GoDoc]](https://godoc.org/github.com/tidwall/buntdb)
* [immudb](https://github.com/codenotary/immudb) **star:3063** immudb是一个轻量级、高速、不可变的数据库，用于用Go编写的系统和应用程序。   [![star > 2000][Awesome]](https://github.com/codenotary/immudb)   [![最近一周有更新][Green]](https://github.com/codenotary/immudb)   [![godoc][GoDoc]](https://godoc.org/github.com/codenotary/immudb)
* [tiedot](https://github.com/HouzuoGuo/tiedot) **star:2611** 属于你的NoSQL数据库。   [![star > 2000][Awesome]](https://github.com/HouzuoGuo/tiedot)   [![最近一年没有更新][Yellow]](https://github.com/HouzuoGuo/tiedot)   [![godoc][GoDoc]](https://godoc.org/github.com/HouzuoGuo/tiedot)
* [dtm](https://github.com/yedf/dtm) **star:1842** 分布式事务管理器。支持XA, TCC, SAGA，可靠消息。   [![最近一周有更新][Green]](https://github.com/yedf/dtm)   [![godoc][GoDoc]](https://godoc.org/github.com/yedf/dtm)   [![包含中文文档][CN]](https://github.com/yedf/dtm)
* [nutsdb](https://github.com/xujiajun/nutsdb) **star:1711** Nutsdb是一个用纯Go编写的简单、快速、可嵌入、持久的键/值存储。它支持完全序列化的事务和许多数据结构，如列表、集合、排序集。   [![godoc][GoDoc]](https://godoc.org/github.com/xujiajun/nutsdb)   [![包含中文文档][CN]](https://github.com/xujiajun/nutsdb)
* [rosedb](https://github.com/roseduan/rosedb) **star:1653** 基于LSM+WAL的嵌入式k-v数据库，支持string、list、hash、set、zset。   [![最近一周有更新][Green]](https://github.com/roseduan/rosedb)   [![godoc][GoDoc]](https://godoc.org/github.com/roseduan/rosedb)   [![包含中文文档][CN]](https://github.com/roseduan/rosedb)
* [GCache](https://github.com/bluele/gcache) **star:1643** 支持过期缓存、LFU、LRU和ARC的缓存库。   [![godoc][GoDoc]](https://godoc.org/github.com/bluele/gcache)
* [cache2go](https://github.com/muesli/cache2go) **star:1590** 基于内存的 K/V 缓存，支持超时的自动失效。   [![godoc][GoDoc]](https://godoc.org/github.com/muesli/cache2go)
* [fastcache](https://github.com/VictoriaMetrics/fastcache) **star:1222** 基于内存的快速线程安全的缓存，可缓存大量的条目。最大限度地减少GC开销。   [![godoc][GoDoc]](https://godoc.org/github.com/VictoriaMetrics/fastcache)
* [CovenantSQL](https://github.com/CovenantSQL/CovenantSQL) **star:1206** 区块链领域的一个SQL数据库。   [![godoc][GoDoc]](https://godoc.org/github.com/CovenantSQL/CovenantSQL)
* [godis](https://github.com/hdt3213/godis) **star:1189** 一个Golang实现了高性能Redis服务器和集群。   [![最近一周有更新][Green]](https://github.com/hdt3213/godis)   [![godoc][GoDoc]](https://godoc.org/github.com/hdt3213/godis)   [![包含中文文档][CN]](https://github.com/hdt3213/godis)
* [diskv](https://github.com/peterbourgon/diskv) **star:1082** 支持磁盘备份的可持久化 K/V 存储。   [![最近一周有更新][Green]](https://github.com/peterbourgon/diskv)   [![godoc][GoDoc]](https://godoc.org/github.com/peterbourgon/diskv)
* [Databunker](https://github.com/paranoidguy/databunker) **star:887** 个人身份信息(PII)存储服务符合GDPR和CCPA。   [![最近一周有更新][Green]](https://github.com/paranoidguy/databunker)   [![godoc][GoDoc]](https://godoc.org/github.com/paranoidguy/databunker)
* [eliasdb](https://github.com/krotik/eliasdb) **star:823** 无其他依赖项，支持REST API，短语搜索和sql类似的查询语言的事务图数据库。   [![godoc][GoDoc]](https://godoc.org/github.com/krotik/eliasdb)
* [moss](https://github.com/couchbase/moss) **star:823** Moss是一个用100% Go编写的简单LSM键值存储引擎。   [![godoc][GoDoc]](https://godoc.org/github.com/couchbase/moss)
* [pogreb](https://github.com/akrylysov/pogreb) **star:806** 针对大量读取工作负载的嵌入式键值存储。   [![godoc][GoDoc]](https://godoc.org/github.com/akrylysov/pogreb)
* [column](https://github.com/kelindar/column) **star:801** 高性能、柱状、可嵌入的内存存储，具有位图索引和事务。   [![godoc][GoDoc]](https://godoc.org/github.com/kelindar/column)
* [levigo](https://github.com/jmhodges/levigo) **star:400** 实现了对LevelDB封装。   [![最近一年没有更新][Yellow]](https://github.com/jmhodges/levigo)   [![godoc][GoDoc]](https://godoc.org/github.com/jmhodges/levigo)
* [pudge](https://github.com/recoilme/pudge) **star:293** 使用Go的标准库编写的快速和简单的键/值存储。   [![godoc][GoDoc]](https://godoc.org/github.com/recoilme/pudge)
* [Vasto](https://github.com/chrislusf/vasto) **star:215** 分布式高性能键值存储。可做磁盘备份。最终一致。高可用。能够在不中断服务的情况下增长或收缩。   [![最近一年没有更新][Yellow]](https://github.com/chrislusf/vasto)   [![godoc][GoDoc]](https://godoc.org/github.com/chrislusf/vasto)
* [Kivik](https://github.com/go-kivik/kivik) **star:212** Kivik为CouchDB、PouchDB和类似的数据库提供了一个通用的Go和GopherJS客户端库。   [![godoc][GoDoc]](https://godoc.org/github.com/go-kivik/kivik)
* [piladb](https://github.com/fern4lvarez/piladb) **star:189** 基于堆栈数据结构的轻量级RESTful数据库引擎。   [![godoc][GoDoc]](https://godoc.org/github.com/fern4lvarez/piladb)
* [Scribble](https://github.com/nanobox-io/golang-scribble) **star:129** 小型平面文件JSON存储。   [![最近一年没有更新][Yellow]](https://github.com/nanobox-io/golang-scribble)   [![godoc][GoDoc]](https://godoc.org/github.com/nanobox-io/golang-scribble)
* [slowpoke](https://github.com/recoilme/slowpoke) **star:97** 具有持久性的键值存储。   [![最近一年没有更新][Yellow]](https://github.com/recoilme/slowpoke)   [![godoc][GoDoc]](https://godoc.org/github.com/recoilme/slowpoke)
* [cache](https://github.com/akyoto/cache) **star:90** 基于内存的 K/V 存储:带生命周期的值存储，0个依赖项，<100 LoC, 100%覆盖率。   [![最近一年没有更新][Yellow]](https://github.com/akyoto/cache)   [![godoc][GoDoc]](https://godoc.org/github.com/akyoto/cache)
* [bcache](https://github.com/iwanbk/bcache) **star:68** 基于内存的最终一致的分布式缓存。   [![最近一年没有更新][Yellow]](https://github.com/iwanbk/bcache)   [![godoc][GoDoc]](https://godoc.org/github.com/iwanbk/bcache)
* [unitdb](https://github.com/unit-io/unitdb) **star:68** 快速timeseries数据库物联网，实时消息传递应用程序。使用pubsub通过tcp或websocket访问unitdb，使用github.com/unit-io/unitd应用程序。   [![godoc][GoDoc]](https://godoc.org/github.com/unit-io/unitdb)
* [couchcache](https://github.com/codingsince1985/couchcache) **star:53** 由 Couchbase服务 支持的RESTful缓存微服务。   [![最近一年没有更新][Yellow]](https://github.com/codingsince1985/couchcache)   [![godoc][GoDoc]](https://godoc.org/github.com/codingsince1985/couchcache)
* [hare](https://github.com/jameycribbs/hare) **star:41** 一个简单的数据库管理系统，将每个表存储为一行分隔的JSON文本文件。   [![godoc][GoDoc]](https://godoc.org/github.com/jameycribbs/hare)
* [clusteredBigCache](https://github.com/oaStuff/clusteredBigCache) **star:37** BigCache 支持集群和独立且生命周期存储项。   [![最近一年没有更新][Yellow]](https://github.com/oaStuff/clusteredBigCache)   [![godoc][GoDoc]](https://godoc.org/github.com/oaStuff/clusteredBigCache)
* [Coffer](https://github.com/claygod/coffer) **star:26** 支持事务的简单ACID键值数据库。   [![godoc][GoDoc]](https://godoc.org/github.com/claygod/coffer)
* [tempdb](https://github.com/rafaeljesus/tempdb) **star:15** 用于临时数据存放的 K/V 存储。   [![最近一年没有更新][Yellow]](https://github.com/rafaeljesus/tempdb)   [![godoc][GoDoc]](https://godoc.org/github.com/rafaeljesus/tempdb)
* [ttlcache](https://github.com/cheshir/ttlcache) **star:3** 内存键值存储与TTL为每个记录。   [![godoc][GoDoc]](https://godoc.org/github.com/cheshir/ttlcache)

*数据库迁移。 (翻译出错了? 试试 [英文版](README_EN.md#database) 吧~)*

* [migrate](https://github.com/golang-migrate/migrate) **star:6962** 基于CLI的数据库迁移库。   [![star > 2000][Awesome]](https://github.com/golang-migrate/migrate)   [![最近一周有更新][Green]](https://github.com/golang-migrate/migrate)   [![godoc][GoDoc]](https://godoc.org/github.com/golang-migrate/migrate)
* [sql-migrate](https://github.com/rubenv/sql-migrate) **star:2205** 数据库迁移工具。允许使用go-bindata将迁移嵌入到应用程序中。   [![star > 2000][Awesome]](https://github.com/rubenv/sql-migrate)   [![最近一周有更新][Green]](https://github.com/rubenv/sql-migrate)   [![godoc][GoDoc]](https://godoc.org/github.com/rubenv/sql-migrate)
* [goose](https://github.com/pressly/goose) **star:1801** 数据库迁移工具。您可以通过创建增量SQL或Go脚本来管理数据库的升级。   [![最近一周有更新][Green]](https://github.com/pressly/goose)   [![godoc][GoDoc]](https://godoc.org/github.com/pressly/goose)
* [skeema](https://github.com/skeema/skeema) **star:930** 用于MySQL的纯sql模式管理系统，支持分片和外部在线模式更改工具。   [![最近一周有更新][Green]](https://github.com/skeema/skeema)   [![godoc][GoDoc]](https://godoc.org/github.com/skeema/skeema)
* [soda](https://github.com/gobuffalo/pop/tree/master/soda)  数据库迁移、创建、ORM等。用于MySQL、PostgreSQL和SQLite。
* [gormigrate](https://github.com/go-gormigrate/gormigrate) **star:645** 面向Gorm ORM的数据库 schema 迁移辅助程序。   [![最近一周有更新][Green]](https://github.com/go-gormigrate/gormigrate)   [![godoc][GoDoc]](https://godoc.org/github.com/go-gormigrate/gormigrate)
* [darwin](https://github.com/GuiaBolso/darwin) **star:120** 用于数据库 schema 升级的库。   [![godoc][GoDoc]](https://godoc.org/github.com/GuiaBolso/darwin)
* [migrator](https://github.com/lopezator/migrator) **star:116** 非常简单的 Go 数据库迁移库。   [![godoc][GoDoc]](https://godoc.org/github.com/lopezator/migrator)
* [go-pg-migrations](https://github.com/robinjoseph08/go-pg-migrations) **star:79** 用Go -pg/pg编写的迁移包。   [![godoc][GoDoc]](https://godoc.org/github.com/robinjoseph08/go-pg-migrations)
* [go-fixtures](https://github.com/RichardKnop/go-fixtures) **star:26** 类似 Django fixture，用于 Go 建立内置数据库/sql库。   [![最近一年没有更新][Yellow]](https://github.com/RichardKnop/go-fixtures)   [![godoc][GoDoc]](https://godoc.org/github.com/RichardKnop/go-fixtures)
* [avro](https://github.com/khezen/avro) **star:25** 发现SQL schemas并将其转换为AVRO schemas。   [![最近一年没有更新][Yellow]](https://github.com/khezen/avro)   [![godoc][GoDoc]](https://godoc.org/github.com/khezen/avro)
* [pravasan](https://github.com/pravasan/pravasan) **star:24** 简易的迁移工具-目前只支持MySQL，但计划很快支持Postgres, SQLite, MongoDB等。   [![最近一年没有更新][Yellow]](https://github.com/pravasan/pravasan)
* [sqlize](https://github.com/sunary/sqlize) **star:17** 数据库迁移生成器。允许生成sql迁移从模型和现有的sql不同。   [![godoc][GoDoc]](https://godoc.org/github.com/sunary/sqlize)
* [migrator](https://github.com/larapulse/migrator) **star:8** MySQL数据库迁移器设计用于运行到您的特性的迁移，并管理数据库模式更新与直观的go代码。   [![godoc][GoDoc]](https://godoc.org/github.com/larapulse/migrator)
* [schema](https://github.com/adlio/schema) **star:7** 库，用于将数据库/sql兼容数据库的模式迁移嵌入到Go二进制文件中。   [![godoc][GoDoc]](https://godoc.org/github.com/adlio/schema)
* [go-pg-migrate](https://github.com/lawzava/go-pg-migrate) **star:4** 用于go-pg迁移管理的cli友好包。   [![godoc][GoDoc]](https://godoc.org/github.com/lawzava/go-pg-migrate)

*数据库工具。 (翻译出错了? 试试 [英文版](README_EN.md#database) 吧~)*

* [vitess](https://github.com/youtube/vitess) **star:12364** vitess提供了可以为大规模web服务扩展MySQL数据库提供便利的服务和工具。   [![star > 2000][Awesome]](https://github.com/youtube/vitess)   [![最近一周有更新][Green]](https://github.com/youtube/vitess)   [![godoc][GoDoc]](https://godoc.org/github.com/youtube/vitess)
* [pgweb](https://github.com/sosedoff/pgweb) **star:6971** 基于web的PostgreSQL数据库浏览器。   [![star > 2000][Awesome]](https://github.com/sosedoff/pgweb)   [![最近一周有更新][Green]](https://github.com/sosedoff/pgweb)   [![godoc][GoDoc]](https://godoc.org/github.com/sosedoff/pgweb)
* [kingshard](https://github.com/flike/kingshard) **star:5782** kingshard 是基于 Golang 的MySQL高性能代理。   [![star > 2000][Awesome]](https://github.com/flike/kingshard)   [![godoc][GoDoc]](https://godoc.org/github.com/flike/kingshard)   [![包含中文文档][CN]](https://github.com/flike/kingshard)
* [orchestrator](https://github.com/github/orchestrator) **star:4197** MySQL复制拓扑管理器和可视化工具。   [![star > 2000][Awesome]](https://github.com/github/orchestrator)   [![godoc][GoDoc]](https://godoc.org/github.com/github/orchestrator)
* [go-mysql-elasticsearch](https://github.com/siddontang/go-mysql-elasticsearch) **star:3563** 自动将MySQL数据同步到Elasticsearch中。   [![star > 2000][Awesome]](https://github.com/siddontang/go-mysql-elasticsearch)   [![godoc][GoDoc]](https://godoc.org/github.com/siddontang/go-mysql-elasticsearch)
* [go-mysql](https://github.com/siddontang/go-mysql) **star:3185**  Go 工具集，用于处理MySQL协议和复制。   [![star > 2000][Awesome]](https://github.com/siddontang/go-mysql)   [![最近一周有更新][Green]](https://github.com/siddontang/go-mysql)   [![godoc][GoDoc]](https://godoc.org/github.com/siddontang/go-mysql)
* [pREST](https://github.com/prest/prest) **star:2768** 简化和加速开发,⚡即时、实时、高性能在任何Postgres应用,现有的或新的。   [![star > 2000][Awesome]](https://github.com/prest/prest)   [![最近一周有更新][Green]](https://github.com/prest/prest)   [![godoc][GoDoc]](https://godoc.org/github.com/prest/prest)
* [chproxy](https://github.com/Vertamedia/chproxy) **star:678** ClickHouse数据库的HTTP代理。   [![godoc][GoDoc]](https://godoc.org/github.com/Vertamedia/chproxy)
* [pg_timetable](https://github.com/cybertec-postgresql/pg_timetable) **star:480** 高级调度为PostgreSQL。   [![最近一周有更新][Green]](https://github.com/cybertec-postgresql/pg_timetable)   [![godoc][GoDoc]](https://godoc.org/github.com/cybertec-postgresql/pg_timetable)
* [clickhouse-bulk](https://github.com/nikepan/clickhouse-bulk) **star:291** 收集小的 insterts 并向 ClickHouse 服务器发送大请求。   [![godoc][GoDoc]](https://godoc.org/github.com/nikepan/clickhouse-bulk)
* [myreplication](https://github.com/2tvenom/myreplication) **star:174** MySql二进制日志复制监听器。支持基于语句和行的复制。   [![最近一年没有更新][Yellow]](https://github.com/2tvenom/myreplication)   [![godoc][GoDoc]](https://godoc.org/github.com/2tvenom/myreplication)
* [octillery](https://github.com/knocknote/octillery) **star:142** 用于数据库分表(支持每个ORM或原生SQL)。   [![godoc][GoDoc]](https://godoc.org/github.com/knocknote/octillery)
* [dbbench](https://github.com/sj14/dbbench) **star:59** 数据库基准测试工具，支持多个数据库和脚本。   [![最近一周有更新][Green]](https://github.com/sj14/dbbench)   [![godoc][GoDoc]](https://godoc.org/github.com/sj14/dbbench)
* [datagen](https://github.com/codingconcepts/datagen) **star:37** 一个快速的数据生成器，支持多表感知和多行DML。   [![最近一年没有更新][Yellow]](https://github.com/codingconcepts/datagen)   [![godoc][GoDoc]](https://godoc.org/github.com/codingconcepts/datagen)
* [prep](https://github.com/hexdigest/prep) **star:28** 在不更改代码的情况下使用准备好的SQL语句。   [![最近一年没有更新][Yellow]](https://github.com/hexdigest/prep)   [![godoc][GoDoc]](https://godoc.org/github.com/hexdigest/prep)
* [rwdb](https://github.com/andizzle/rwdb) **star:12** rwdb为多个数据库服务器的设置提供读取副本功能。   [![最近一年没有更新][Yellow]](https://github.com/andizzle/rwdb)   [![godoc][GoDoc]](https://godoc.org/github.com/andizzle/rwdb)

*SQL查询生成器，用于构建和使用SQL的库。 (翻译出错了? 试试 [英文版](README_EN.md#database) 吧~)*

* [Squirrel](https://github.com/Masterminds/squirrel) **star:4125** 帮助您构建SQL查询的Go库。   [![star > 2000][Awesome]](https://github.com/Masterminds/squirrel)   [![godoc][GoDoc]](https://godoc.org/github.com/Masterminds/squirrel)
* [xo](https://github.com/knq/xo) **star:2846** 基于现有的schema定义和自定义查询生成 Go 代码，基于支持PostgreSQL、MySQL、SQLite、Oracle和Microsoft SQL Server。   [![star > 2000][Awesome]](https://github.com/knq/xo)   [![godoc][GoDoc]](https://godoc.org/github.com/knq/xo)
* [gendry](https://github.com/didi/gendry) **star:1251** 非入侵的SQL构建器和强大的数据绑定器。   [![godoc][GoDoc]](https://godoc.org/github.com/didi/gendry)   [![包含中文文档][CN]](https://github.com/didi/gendry)
* [goqu](https://github.com/doug-martin/goqu) **star:1237** 常用的SQL生成器和查询库。   [![godoc][GoDoc]](https://godoc.org/github.com/doug-martin/goqu)
* [Dotsql](https://github.com/gchaincl/dotsql) **star:595** Go library帮助您将sql文件保存在一个地方，并轻松地使用它们。   [![godoc][GoDoc]](https://godoc.org/github.com/gchaincl/dotsql)
* [ozzo-dbx](https://github.com/go-ozzo/ozzo-dbx) **star:538** Powerful data retrieval methods as well as DB-agnostic query building capabilities.   [![godoc][GoDoc]](https://godoc.org/github.com/go-ozzo/ozzo-dbx)
* [jet](https://github.com/go-jet/jet) **star:456** 用于在Go中编写类型安全的SQL查询的框架，能够轻松地将数据库查询结果转换为所需的任意对象结构。   [![godoc][GoDoc]](https://godoc.org/github.com/go-jet/jet)
* [dbq](https://github.com/rocketlaunchr/dbq) **star:311** Zero boilerplate database operations for Go   [![godoc][GoDoc]](https://godoc.org/github.com/rocketlaunchr/dbq)
* [sqrl](https://github.com/elgris/sqrl) **star:228** SQL查询生成器，从Squirrel fork而来，并再此基础上对性能做了优化。   [![godoc][GoDoc]](https://godoc.org/github.com/elgris/sqrl)
* [Squalus](https://gitlab.com/qosenergy/squalus)  Go SQL中间层，能使得执行查询更加容易。
* [sqlingo](https://github.com/lqs/sqlingo) **star:155** 在Go中构建SQL的轻量级DSL。   [![最近一周有更新][Green]](https://github.com/lqs/sqlingo)   [![godoc][GoDoc]](https://godoc.org/github.com/lqs/sqlingo)
* [sq](https://github.com/bokwoon95/go-structured-query) **star:119** 用于Go的类型安全的SQL生成器和结构映射器。   [![最近一周有更新][Green]](https://github.com/bokwoon95/go-structured-query)   [![godoc][GoDoc]](https://godoc.org/github.com/bokwoon95/go-structured-query)
* [igor](https://github.com/galeone/igor) **star:84** PostgreSQL的抽象层，支持高级功能和类似gorm的语法。   [![最近一年没有更新][Yellow]](https://github.com/galeone/igor)   [![godoc][GoDoc]](https://godoc.org/github.com/galeone/igor)
* [godbal](https://github.com/xujiajun/godbal) **star:52** 数据库抽象层(dbal)。支持SQL builder，轻松获取结果。   [![最近一年没有更新][Yellow]](https://github.com/xujiajun/godbal)   [![godoc][GoDoc]](https://godoc.org/github.com/xujiajun/godbal)
* [buildsqlx](https://github.com/arthurkushman/buildsqlx) **star:36** 去数据库查询生成器库的PostgreSQL。   [![godoc][GoDoc]](https://godoc.org/github.com/arthurkushman/buildsqlx)
* [qry](https://github.com/HnH/qry) **star:20** 该工具使用原始SQL查询从文件生成常量。   [![godoc][GoDoc]](https://godoc.org/github.com/HnH/qry)
* [sqlf](https://github.com/leporo/sqlf) **star:20** 快速SQL查询生成器。   [![最近一年没有更新][Yellow]](https://github.com/leporo/sqlf)   [![godoc][GoDoc]](https://godoc.org/github.com/leporo/sqlf)
* [gosql](https://github.com/twharmon/gosql) **star:16** 支持更好的空值的SQL查询生成器。   [![godoc][GoDoc]](https://godoc.org/github.com/twharmon/gosql)
* [hasql](https://golang.yandex/hasql)  用于访问多主机SQL数据库安装的库。
* [mpath](https://github.com/spacetab-io/mpath-go) **star:9** MPTT(修改前序树遍历)包的SQL记录-物化路径实现。   [![最近一年没有更新][Yellow]](https://github.com/spacetab-io/mpath-go)   [![godoc][GoDoc]](https://godoc.org/github.com/spacetab-io/mpath-go)
* [ormlite](https://github.com/pupizoid/ormlite)  包含一些类似orm的特性和sqlite数据库的辅助程序的轻量级包

## 数据库驱动程序

*用于连接和操作数据库的库。 (翻译出错了? 试试 [英文版](README_EN.md#database-drivers) 吧~)*

* Relational Databases
    * [go-sql-driver/mysql](https://github.com/go-sql-driver/mysql) **star:11220** MySQL驱动程序。   [![star > 2000][Awesome]](https://github.com/go-sql-driver/mysql)   [![最近一周有更新][Green]](https://github.com/go-sql-driver/mysql)   [![godoc][GoDoc]](https://godoc.org/github.com/go-sql-driver/mysql)
    * [pq](https://github.com/lib/pq) **star:6717** 纯 Go 的Postgres驱动。   [![star > 2000][Awesome]](https://github.com/lib/pq)   [![最近一周有更新][Green]](https://github.com/lib/pq)   [![godoc][GoDoc]](https://godoc.org/github.com/lib/pq)
    * [go-sqlite3](https://github.com/mattn/go-sqlite3) **star:5025** SQLite3驱动程序。   [![star > 2000][Awesome]](https://github.com/mattn/go-sqlite3)
    * [pgx](https://github.com/jackc/pgx) **star:4394** PostgreSQL驱动，支持比现有database/sql更多的特性。   [![star > 2000][Awesome]](https://github.com/jackc/pgx)   [![最近一周有更新][Green]](https://github.com/jackc/pgx)   [![godoc][GoDoc]](https://godoc.org/github.com/jackc/pgx)
    * [go-mssqldb](https://github.com/denisenkom/go-mssqldb) **star:1425** 微软MSSQL驱动程序。   [![最近一周有更新][Green]](https://github.com/denisenkom/go-mssqldb)   [![godoc][GoDoc]](https://godoc.org/github.com/denisenkom/go-mssqldb)
    * [go-oci8](https://github.com/mattn/go-oci8) **star:555** Oracle 驱动程序。   [![godoc][GoDoc]](https://godoc.org/github.com/mattn/go-oci8)
    * [godror](https://github.com/godror/godror) **star:283** 基于 ODPI-C 的 Oracle 驱动程序   [![最近一周有更新][Green]](https://github.com/godror/godror)
    * [firebirdsql](https://github.com/nakagami/firebirdsql) **star:151** Firebird RDBMS SQL驱动程序。   [![最近一周有更新][Green]](https://github.com/nakagami/firebirdsql)   [![godoc][GoDoc]](https://godoc.org/github.com/nakagami/firebirdsql)
    * [go-adodb](https://github.com/mattn/go-adodb) **star:120** Microsoft ActiveX对象数据库驱动程序。   [![最近一年没有更新][Yellow]](https://github.com/mattn/go-adodb)   [![godoc][GoDoc]](https://godoc.org/github.com/mattn/go-adodb)
    * [gofreetds](https://github.com/minus5/gofreetds) **star:106** 基于[FreeTDS](http://www.freetds.org)封装的微软MSSQL Go 驱动。   [![godoc][GoDoc]](https://godoc.org/github.com/minus5/gofreetds)
    * [avatica](https://github.com/apache/calcite-avatica-go) **star:77** Apache Avatica/Phoenix SQL驱动程序。   [![godoc][GoDoc]](https://godoc.org/github.com/apache/calcite-avatica-go)
    * [Sqinn-Go](https://github.com/cvilsmeier/sqinn-go) **star:71** SQLite with pure Go.   [![godoc][GoDoc]](https://godoc.org/github.com/cvilsmeier/sqinn-go)
    * [bgc](https://github.com/viant/bgc) **star:15** BigQuery 的数据存储连接。   [![最近一年没有更新][Yellow]](https://github.com/viant/bgc)   [![godoc][GoDoc]](https://godoc.org/github.com/viant/bgc)
    * [pig](https://github.com/alexeyco/pig) **star:4** 简单的[pgx](https://github.com/jackc/pgx)包装器执行和[扫描](https://github.com/georgysavva/scany)查询结果很容易。   [![godoc][GoDoc]](https://godoc.org/github.com/alexeyco/pig)

* NoSQL Databases
    * [redis](https://github.com/go-redis/redis) **star:12238** 基于 Go 的 Redis 客户端。   [![star > 2000][Awesome]](https://github.com/go-redis/redis)   [![最近一周有更新][Green]](https://github.com/go-redis/redis)   [![godoc][GoDoc]](https://godoc.org/github.com/go-redis/redis)
    * [redigo](https://github.com/gomodule/redigo) **star:8599** Redigo 是基于 Go 的Redis 客户端。   [![star > 2000][Awesome]](https://github.com/gomodule/redigo)   [![godoc][GoDoc]](https://godoc.org/github.com/gomodule/redigo)
    * [mongo-go-driver](https://github.com/mongodb/mongo-go-driver) **star:6007** 官方的 MongoDB 驱动。   [![star > 2000][Awesome]](https://github.com/mongodb/mongo-go-driver)   [![最近一周有更新][Green]](https://github.com/mongodb/mongo-go-driver)   [![godoc][GoDoc]](https://godoc.org/github.com/mongodb/mongo-go-driver)
    * [mgo](https://github.com/globalsign/mgo) **star:1905** (已停止维护) MongoDB驱动。   [![godoc][GoDoc]](https://godoc.org/github.com/globalsign/mgo)
    * [gorethink](https://github.com/dancannon/gorethink) **star:1570** RethinkDB 驱动。   [![godoc][GoDoc]](https://godoc.org/github.com/dancannon/gorethink)
    * [qmgo](https://github.com/qiniu/qmgo) **star:595** MongoDB司机走了。它是基于官方MongoDB司机但更容易使用像分别。   [![最近一周有更新][Green]](https://github.com/qiniu/qmgo)   [![godoc][GoDoc]](https://godoc.org/github.com/qiniu/qmgo)   [![包含中文文档][CN]](https://github.com/qiniu/qmgo)
    * [redeo](https://github.com/bsm/redeo) **star:395** 与 redis 协议兼容的 TCP 服务器/服务。   [![godoc][GoDoc]](https://godoc.org/github.com/bsm/redeo)
    * [neoism](https://github.com/jmcvetta/neoism) **star:377** Golang 的 Neo4j 客户端。   [![最近一年没有更新][Yellow]](https://github.com/jmcvetta/neoism)   [![godoc][GoDoc]](https://godoc.org/github.com/jmcvetta/neoism)
    * [aerospike-client-go](https://github.com/aerospike/aerospike-client-go) **star:368** Aerospike 客户端。   [![最近一周有更新][Green]](https://github.com/aerospike/aerospike-client-go)   [![godoc][GoDoc]](https://godoc.org/github.com/aerospike/aerospike-client-go)
    * [mgm](https://github.com/kamva/mgm) **star:351** 基于MongoDB模型的ODM for Go(基于官方MongoDB驱动)。   [![godoc][GoDoc]](https://godoc.org/github.com/kamva/mgm)
    * [gocb](https://github.com/couchbase/gocb) **star:327** 官方Couchbase Go SDK。   [![最近一周有更新][Green]](https://github.com/couchbase/gocb)   [![godoc][GoDoc]](https://godoc.org/github.com/couchbase/gocb)
    * [go-couchbase](https://github.com/couchbase/go-couchbase) **star:312** Couchbase客户端。   [![最近一周有更新][Green]](https://github.com/couchbase/go-couchbase)   [![godoc][GoDoc]](https://godoc.org/github.com/couchbase/go-couchbase)
    * [go-rejson](https://github.com/nitishm/go-rejson) **star:175** 实现了基于 Redigo 客户端的redislabs' ReJSON 模块。可简单地将结构体存储为JSON对象并对其进行操作。   [![godoc][GoDoc]](https://godoc.org/github.com/nitishm/go-rejson)
    * [godis](https://github.com/piaohao/godis) **star:94** 由GoLang实现的redis客户端，灵感来自jedis。   [![最近一年没有更新][Yellow]](https://github.com/piaohao/godis)   [![godoc][GoDoc]](https://godoc.org/github.com/piaohao/godis)
    * [Neo4j-GO](https://github.com/davemeehan/Neo4j-GO) **star:76** Neo4j REST 客户端。   [![最近一年没有更新][Yellow]](https://github.com/davemeehan/Neo4j-GO)   [![godoc][GoDoc]](https://godoc.org/github.com/davemeehan/Neo4j-GO)
    * [arangolite](https://github.com/solher/arangolite) **star:69** 轻量级的 ArangoDB 驱动。   [![godoc][GoDoc]](https://godoc.org/github.com/solher/arangolite)
    * [go-pilosa](https://github.com/pilosa/go-pilosa) **star:46**  Pilosa客户端。   [![最近一年没有更新][Yellow]](https://github.com/pilosa/go-pilosa)   [![godoc][GoDoc]](https://godoc.org/github.com/pilosa/go-pilosa)
    * [forestdb](https://github.com/couchbase/goforestdb) **star:30** 基于 Go 的 ForestDB 接口实现。   [![最近一年没有更新][Yellow]](https://github.com/couchbase/goforestdb)   [![godoc][GoDoc]](https://godoc.org/github.com/couchbase/goforestdb)
    * [neo4j](https://github.com/cihangir/neo4j) **star:26** Neo4j Rest API实现。   [![最近一年没有更新][Yellow]](https://github.com/cihangir/neo4j)   [![godoc][GoDoc]](https://godoc.org/github.com/cihangir/neo4j)
    * [goriak](https://github.com/zegl/goriak) **star:25**  Riak KV 驱动。   [![godoc][GoDoc]](https://godoc.org/github.com/zegl/goriak)
    * [xredis](https://github.com/shomali11/xredis) **star:15** 类型安全，可定制，清晰和易用的Redis客户端。   [![最近一年没有更新][Yellow]](https://github.com/shomali11/xredis)   [![godoc][GoDoc]](https://godoc.org/github.com/shomali11/xredis)
    * [godscache](https://github.com/defcronyke/godscache) **star:9** 谷歌云平台Go Datastore包的封装，它采用了memcached添加缓存。   [![最近一年没有更新][Yellow]](https://github.com/defcronyke/godscache)   [![godoc][GoDoc]](https://godoc.org/github.com/defcronyke/godscache)
    * [gomemcache](https://github.com/bradfitz/gomemcache/)  memcache客户端库。
    * [asc](https://github.com/viant/asc) **star:6** Aerospike 的数据存储连接器。   [![最近一年没有更新][Yellow]](https://github.com/viant/asc)   [![godoc][GoDoc]](https://godoc.org/github.com/viant/asc)
    * [gocosmos](https://github.com/btnguyen2k/gocosmos) **star:4** Azure Cosmos DB的REST客户端和标准的“数据库/sql”驱动程序。   [![godoc][GoDoc]](https://godoc.org/github.com/btnguyen2k/gocosmos)
    * [gocql](http://gocql.github.io)  Apache Cassandra 的 Go 驱动。

* Search and Analytic Databases.
    * [bleve](https://github.com/blevesearch/bleve) **star:7724** 基于 Go 的现代文本索引库。   [![star > 2000][Awesome]](https://github.com/blevesearch/bleve)   [![最近一周有更新][Green]](https://github.com/blevesearch/bleve)   [![godoc][GoDoc]](https://godoc.org/github.com/blevesearch/bleve)
    * [elastic](https://github.com/olivere/elastic) **star:6144** Elasticsearch 客户端。   [![star > 2000][Awesome]](https://github.com/olivere/elastic)   [![最近一周有更新][Green]](https://github.com/olivere/elastic)   [![godoc][GoDoc]](https://godoc.org/github.com/olivere/elastic)
    * [riot](https://github.com/go-ego/riot) **star:5931** 基于 Go 的 开源、分布式、简单高效的搜索引擎。   [![star > 2000][Awesome]](https://github.com/go-ego/riot)   [![godoc][GoDoc]](https://godoc.org/github.com/go-ego/riot)   [![包含中文文档][CN]](https://github.com/go-ego/riot)
    * [go-elasticsearch](https://github.com/elastic/go-elasticsearch) **star:3554** 官方 Elasticsearch 客户端。   [![star > 2000][Awesome]](https://github.com/elastic/go-elasticsearch)   [![最近一周有更新][Green]](https://github.com/elastic/go-elasticsearch)   [![godoc][GoDoc]](https://godoc.org/github.com/elastic/go-elasticsearch)
    * [elastigo](https://github.com/mattbaird/elastigo) **star:948** Elasticsearch 客户端。   [![最近一年没有更新][Yellow]](https://github.com/mattbaird/elastigo)   [![godoc][GoDoc]](https://godoc.org/github.com/mattbaird/elastigo)
    * [elasticsql](https://github.com/cch123/elasticsql) **star:773** 将 SQL 转换为 elasticsearch dsl。   [![godoc][GoDoc]](https://godoc.org/github.com/cch123/elasticsql)
    * [skizze](https://github.com/seiflotfy/skizze) **star:79** 面向概率数据结构的服务和存储。   [![最近一年没有更新][Yellow]](https://github.com/seiflotfy/skizze)   [![godoc][GoDoc]](https://godoc.org/github.com/seiflotfy/skizze)
    * [goes](https://github.com/OwnLocal/goes) **star:24** 实现了与 Elasticsearch 交互的库。   [![godoc][GoDoc]](https://godoc.org/github.com/OwnLocal/goes)

* Multiple Backends.
    * [cayley](https://github.com/google/cayley) **star:13900** 图形数据库，支持多个后端。   [![star > 2000][Awesome]](https://github.com/google/cayley)   [![godoc][GoDoc]](https://godoc.org/github.com/google/cayley)
    * [gokv](https://github.com/philippgille/gokv) **star:353** 可扩展的简单的 K/V 存储(Redis、Consul、etcd、bbolt、BadgerDB、LevelDB、Memcached、DynamoDB、S3、PostgreSQL、MongoDB、CockroachDB等等)。   [![godoc][GoDoc]](https://godoc.org/github.com/philippgille/gokv)
    * [cachego](https://github.com/fabiorphp/cachego) **star:157** 基于多个驱动程序的缓存组件。   [![godoc][GoDoc]](https://godoc.org/github.com/fabiorphp/cachego)
    * [dsc](https://github.com/viant/dsc) **star:22** 面向 SQL、NoSQL、结构化文件的数据存储连接。   [![最近一年没有更新][Yellow]](https://github.com/viant/dsc)   [![godoc][GoDoc]](https://godoc.org/github.com/viant/dsc)

## 日期和时间

*用于处理日期和时间的库。 (翻译出错了? 试试 [英文版](README_EN.md#date-and-time) 吧~)*

* [now](https://github.com/jinzhu/now) **star:3212** now 是时间有关的工具类。   [![star > 2000][Awesome]](https://github.com/jinzhu/now)   [![godoc][GoDoc]](https://godoc.org/github.com/jinzhu/now)
* [dateparse](https://github.com/araddon/dateparse) **star:1510** 可以解析很多格式不固定的日期字符串。   [![godoc][GoDoc]](https://godoc.org/github.com/araddon/dateparse)
* [carbon](https://github.com/golang-module/carbon) **star:1241** datetime的一个简单、语义和开发人员友好的golang包。   [![最近一周有更新][Green]](https://github.com/golang-module/carbon)   [![godoc][GoDoc]](https://godoc.org/github.com/golang-module/carbon)
* [carbon](https://github.com/uniplaces/carbon) **star:617** 简单的时间扩展，包含了许多使用方法，从 PHP Carbon 库移植的。   [![godoc][GoDoc]](https://godoc.org/github.com/uniplaces/carbon)
* [durafmt](https://github.com/hako/durafmt) **star:395** 轻量级、可让time.Duration更加易读的库。   [![godoc][GoDoc]](https://godoc.org/github.com/hako/durafmt)
* [timeutil](https://github.com/leekchan/timeutil) **star:186** 面向 Golang 的时间库，集成了很多有用的扩展(Timedelta, Strftime, ...)。   [![最近一年没有更新][Yellow]](https://github.com/leekchan/timeutil)   [![godoc][GoDoc]](https://godoc.org/github.com/leekchan/timeutil)
* [gostradamus](https://github.com/bykof/gostradamus) **star:156** 和约会对象一起工作的软件包。   [![godoc][GoDoc]](https://godoc.org/github.com/bykof/gostradamus)
* [go-persian-calendar](https://github.com/yaa110/go-persian-calendar) **star:101** 太阳历实现。   [![godoc][GoDoc]](https://godoc.org/github.com/yaa110/go-persian-calendar)
* [iso8601](https://github.com/relvacode/iso8601) **star:95** 不用正则表达式有效解析 ISO8601 日期时间。   [![godoc][GoDoc]](https://godoc.org/github.com/relvacode/iso8601)
* [date](https://github.com/rickb777/date) **star:74** 增加处理日期、日期范围、时间跨度、时间段和time-of-day。   [![最近一周有更新][Green]](https://github.com/rickb777/date)   [![godoc][GoDoc]](https://godoc.org/github.com/rickb777/date)
* [timespan](https://github.com/SaidinWoT/timespan) **star:74** 用于处理时间间隔相关的库，可定义开始时间和持续时间。   [![最近一年没有更新][Yellow]](https://github.com/SaidinWoT/timespan)   [![godoc][GoDoc]](https://godoc.org/github.com/SaidinWoT/timespan)
* [feiertage](https://github.com/wlbr/feiertage) **star:39** 用于计算德国公共假期的函数，比如复活节、感恩节等   [![最近一周有更新][Green]](https://github.com/wlbr/feiertage)   [![godoc][GoDoc]](https://godoc.org/github.com/wlbr/feiertage)
* [go-sunrise](https://github.com/nathan-osman/go-sunrise) **star:36** 计算指定位置的日出和日落时间。   [![godoc][GoDoc]](https://godoc.org/github.com/nathan-osman/go-sunrise)
* [go-str2duration](https://github.com/xhit/go-str2duration) **star:28** 将字符串转换为持续时间。支持的时间。持续时间返回字符串等。   [![最近一年没有更新][Yellow]](https://github.com/xhit/go-str2duration)   [![godoc][GoDoc]](https://godoc.org/github.com/xhit/go-str2duration)
* [kair](https://github.com/GuilhermeCaruso/kair) **star:19** 用于处理日期和时间的 golang 库。   [![最近一年没有更新][Yellow]](https://github.com/GuilhermeCaruso/kair)   [![godoc][GoDoc]](https://godoc.org/github.com/GuilhermeCaruso/kair)
* [cronrange](https://github.com/1set/cronrange) **star:12** 解析cron风格的时间范围表达式，检查给定的时间是否在任何范围内。   [![godoc][GoDoc]](https://godoc.org/github.com/1set/cronrange)
* [NullTime](https://github.com/kirillDanshin/nulltime) **star:11** 可以允许 time.Time 为null。   [![最近一年没有更新][Yellow]](https://github.com/kirillDanshin/nulltime)   [![godoc][GoDoc]](https://godoc.org/github.com/kirillDanshin/nulltime)
* [tuesday](https://github.com/osteele/tuesday) **star:9** Ruby-compatible Strftime function。   [![godoc][GoDoc]](https://godoc.org/github.com/osteele/tuesday)
* [strftime](https://github.com/awoodbeck/strftime) **star:7** C99-compatible strftime formatter。   [![最近一年没有更新][Yellow]](https://github.com/awoodbeck/strftime)   [![godoc][GoDoc]](https://godoc.org/github.com/awoodbeck/strftime)
* [go-week](https://github.com/stoewer/go-week) **star:6** 一个有效的软件包，以配合ISO8601周日期。   [![最近一年没有更新][Yellow]](https://github.com/stoewer/go-week)   [![godoc][GoDoc]](https://godoc.org/github.com/stoewer/go-week)

## 分布式系统

*协助构建分布式系统的包。 (翻译出错了? 试试 [英文版](README_EN.md#distributed-systems) 吧~)*

* [go-kit](https://github.com/go-kit/kit) **star:21036** 支持服务发现、负载平衡、插件式传输、请求跟踪等功能的Microservice toolkit。   [![star > 2000][Awesome]](https://github.com/go-kit/kit)   [![最近一周有更新][Green]](https://github.com/go-kit/kit)   [![godoc][GoDoc]](https://godoc.org/github.com/go-kit/kit)
* [go-micro](https://github.com/micro/go-micro) **star:16544** 分布式系统开发框架。   [![star > 2000][Awesome]](https://github.com/micro/go-micro)   [![godoc][GoDoc]](https://godoc.org/github.com/micro/go-micro)
* [grpc-go](https://github.com/grpc/grpc-go) **star:14316** gRPC的Go语言实现。   [![star > 2000][Awesome]](https://github.com/grpc/grpc-go)   [![最近一周有更新][Green]](https://github.com/grpc/grpc-go)   [![godoc][GoDoc]](https://godoc.org/github.com/grpc/grpc-go)
* [go-zero](https://github.com/tal-tech/go-zero) **star:10451** 一个web和rpc框架。它的诞生是为了确保繁忙场地的稳定性，弹性设计。内置的goctl大大提高了开发效率。   [![star > 2000][Awesome]](https://github.com/tal-tech/go-zero)   [![最近一周有更新][Green]](https://github.com/tal-tech/go-zero)   [![godoc][GoDoc]](https://godoc.org/github.com/tal-tech/go-zero)
* [micro](https://github.com/micro/micro) **star:10300** 一个分布式系统运行时，用于云及其他。   [![star > 2000][Awesome]](https://github.com/micro/micro)   [![最近一周有更新][Green]](https://github.com/micro/micro)   [![godoc][GoDoc]](https://godoc.org/github.com/micro/micro)
* [NATS](https://github.com/nats-io/gnatsd) **star:9707** 轻量级、高性能消息传递系统，可用于微服务、物联网(IoT)和云。   [![star > 2000][Awesome]](https://github.com/nats-io/gnatsd)   [![最近一周有更新][Green]](https://github.com/nats-io/gnatsd)   [![godoc][GoDoc]](https://godoc.org/github.com/nats-io/gnatsd)
* [rpcx](https://github.com/smallnest/rpcx) **star:5910** 分布式可插拔的RPC服务框架，如阿里巴巴Dubbo。   [![star > 2000][Awesome]](https://github.com/smallnest/rpcx)   [![最近一周有更新][Green]](https://github.com/smallnest/rpcx)   [![godoc][GoDoc]](https://godoc.org/github.com/smallnest/rpcx)
* [raft](https://github.com/hashicorp/raft) **star:4951** Raft consensus协议的实现。 by HashiCorp。   [![star > 2000][Awesome]](https://github.com/hashicorp/raft)   [![godoc][GoDoc]](https://godoc.org/github.com/hashicorp/raft)
* [raft](https://github.com/coreos/etcd/tree/master/raft)  Raft consensus协议的实现。 by CoreOS。
* [KrakenD](https://github.com/devopsfaith/krakend) **star:4433** 具有中间件的高性能API网关框架。   [![star > 2000][Awesome]](https://github.com/devopsfaith/krakend)   [![最近一周有更新][Green]](https://github.com/devopsfaith/krakend)   [![godoc][GoDoc]](https://godoc.org/github.com/devopsfaith/krakend)
* [tendermint](https://github.com/tendermint/tendermint) **star:4259** 一个高性能中间件，可将任何语言的状态机转换为 Byzantine Fault 状态机。使用 Tendermint 一致性及区块链协议。   [![star > 2000][Awesome]](https://github.com/tendermint/tendermint)   [![最近一周有更新][Green]](https://github.com/tendermint/tendermint)   [![godoc][GoDoc]](https://godoc.org/github.com/tendermint/tendermint)
* [torrent](https://github.com/anacrolix/torrent) **star:3979** BitTorrent 客户端。   [![star > 2000][Awesome]](https://github.com/anacrolix/torrent)   [![最近一周有更新][Green]](https://github.com/anacrolix/torrent)   [![godoc][GoDoc]](https://godoc.org/github.com/anacrolix/torrent)
* [dragonboat](https://github.com/lni/dragonboat) **star:3780** 一个功能齐全，高性能的库集。   [![star > 2000][Awesome]](https://github.com/lni/dragonboat)   [![最近一周有更新][Green]](https://github.com/lni/dragonboat)   [![godoc][GoDoc]](https://godoc.org/github.com/lni/dragonboat)   [![包含中文文档][CN]](https://github.com/lni/dragonboat)
* [emitter-io](https://github.com/emitter-io/emitter) **star:2987** 高性能、分布式、安全和低延迟的发布-订阅平台，使用MQTT、Websockets和love构建。   [![star > 2000][Awesome]](https://github.com/emitter-io/emitter)   [![godoc][GoDoc]](https://godoc.org/github.com/emitter-io/emitter)
* [glow](https://github.com/chrislusf/glow) **star:2981** 全部用 Go 实现，易用、可伸缩，可用于分布式大数据处理，Map-Reduce, DAG执行。   [![star > 2000][Awesome]](https://github.com/chrislusf/glow)   [![最近一年没有更新][Yellow]](https://github.com/chrislusf/glow)   [![godoc][GoDoc]](https://godoc.org/github.com/chrislusf/glow)
* [gleam](https://github.com/chrislusf/gleam) **star:2876** 使用纯Go和Luajit编写的快速、可伸缩的分布式map/reduce系统，结合了Go的高并发性和Luajit的高性能，可以独立运行或分布式运行。   [![star > 2000][Awesome]](https://github.com/chrislusf/gleam)   [![godoc][GoDoc]](https://godoc.org/github.com/chrislusf/gleam)
* [liftbridge](https://github.com/liftbridge-io/liftbridge) **star:2127** 用于nat的轻量级、容错的消息流。   [![star > 2000][Awesome]](https://github.com/liftbridge-io/liftbridge)   [![最近一周有更新][Green]](https://github.com/liftbridge-io/liftbridge)   [![godoc][GoDoc]](https://godoc.org/github.com/liftbridge-io/liftbridge)
* [hprose](https://github.com/hprose/hprose-golang) **star:1175** 支持25+种语言RPC库。   [![godoc][GoDoc]](https://godoc.org/github.com/hprose/hprose-golang)   [![包含中文文档][CN]](https://github.com/hprose/hprose-golang)
* [ringpop-go](https://github.com/uber/ringpop-go) **star:694** 可伸缩的，容错、应用分层的的Go应用程序。   [![godoc][GoDoc]](https://godoc.org/github.com/uber/ringpop-go)
* [gorpc](https://github.com/valyala/gorpc) **star:639** 简单、快速和可伸缩的RPC库。   [![最近一年没有更新][Yellow]](https://github.com/valyala/gorpc)   [![godoc][GoDoc]](https://godoc.org/github.com/valyala/gorpc)
* [rain](https://github.com/cenkalti/rain) **star:618** BitTorrent客户端和库。   [![godoc][GoDoc]](https://godoc.org/github.com/cenkalti/rain)
* [go-health](https://github.com/InVisionApp/go-health) **star:600** 用于在服务中启用异步依赖项健康检查的库。   [![最近一年没有更新][Yellow]](https://github.com/InVisionApp/go-health)   [![godoc][GoDoc]](https://godoc.org/github.com/InVisionApp/go-health)
* [redis-lock](https://github.com/bsm/redislock) **star:472** 基于redis的分布式锁简易实现。   [![godoc][GoDoc]](https://godoc.org/github.com/bsm/redislock)
* [resgate](https://resgate.io/)  用于构建REST、实时和RPC API的实时API网关，其中所有客户端都是无缝同步的。
* [go-sundheit](https://github.com/AppsFlyer/go-sundheit) **star:425** 为支持为golang服务定义异步服务健康检查而构建的库。   [![最近一周有更新][Green]](https://github.com/AppsFlyer/go-sundheit)   [![godoc][GoDoc]](https://godoc.org/github.com/AppsFlyer/go-sundheit)
* [digota](https://github.com/digota/digota) **star:399** 基于 grpc 的电子商务微服务。   [![godoc][GoDoc]](https://godoc.org/github.com/digota/digota)
* [dot](https://github.com/dotchain/dot/)  基于 transformation/OT 的分布式同步。
* [consistent](https://github.com/buraksezer/consistent) **star:397** Consistent hashing with bounded loads。   [![godoc][GoDoc]](https://godoc.org/github.com/buraksezer/consistent)
* [sleuth](https://github.com/ursiform/sleuth) **star:337** 用于HTTP服务之间进行无中心p2p自动发现和RPC通信的库(使用[ZeroMQ](https://github.com/zeromq/libzmq))。   [![最近一年没有更新][Yellow]](https://github.com/ursiform/sleuth)   [![godoc][GoDoc]](https://godoc.org/github.com/ursiform/sleuth)
* [go-jump](https://github.com/dgryski/go-jump) **star:331** 提供了谷歌的 “Jump” 一致哈希函数接口。   [![最近一年没有更新][Yellow]](https://github.com/dgryski/go-jump)   [![godoc][GoDoc]](https://godoc.org/github.com/dgryski/go-jump)
* [arpc](https://github.com/lesismal/arpc) **star:303** 更有效的网络通信，支持双向呼叫、通知、广播。   [![最近一周有更新][Green]](https://github.com/lesismal/arpc)   [![godoc][GoDoc]](https://godoc.org/github.com/lesismal/arpc)
* [dht](https://github.com/anacrolix/dht) **star:195** BitTorrent Kademlia DHT的实现。   [![最近一周有更新][Green]](https://github.com/anacrolix/dht)   [![godoc][GoDoc]](https://godoc.org/github.com/anacrolix/dht)
* [jsonrpc](https://github.com/ybbus/jsonrpc) **star:182** JSON-RPC 2.0 HTTP客户端。   [![godoc][GoDoc]](https://godoc.org/github.com/ybbus/jsonrpc)
* [jsonrpc](https://github.com/osamingo/jsonrpc) **star:151** jsonrpc 包，实现了 JSON-RPC 2.0。   [![godoc][GoDoc]](https://godoc.org/github.com/osamingo/jsonrpc)
* [celeriac](https://github.com/svcavallar/celeriac.v1) **star:67** 用于对 Celery worker、任务、事件进行交互和监控的库。   [![godoc][GoDoc]](https://godoc.org/github.com/svcavallar/celeriac.v1)
* [doublejump](https://github.com/edwingeng/doublejump) **star:64** 实现了谷歌的jump consistent hash。   [![godoc][GoDoc]](https://godoc.org/github.com/edwingeng/doublejump)
* [outboxer](https://github.com/italolelis/outboxer) **star:54** 实现了 outbox pattern Go 库。   [![最近一周有更新][Green]](https://github.com/italolelis/outboxer)   [![godoc][GoDoc]](https://godoc.org/github.com/italolelis/outboxer)
* [pglock](https://cirello.io/pglock)  postgresql 的分布式锁定实现。
* [pjrpc](https://gitlab.com/pjrpc/pjrpc)  Golang JSON-RPC服务器-客户端与原生buf规范。
* [Semaphore](https://github.com/jexia/semaphore) **star:54** 简单的(微)服务协调器。   [![godoc][GoDoc]](https://godoc.org/github.com/jexia/semaphore)
* [flowgraph](https://github.com/vectaport/flowgraph) **star:41** flow-based programming package。   [![godoc][GoDoc]](https://godoc.org/github.com/vectaport/flowgraph)
* [drmaa](https://github.com/dgruber/drmaa) **star:33** 符合 DRMAA 标准的集群调度程序作业提交库。   [![godoc][GoDoc]](https://godoc.org/github.com/dgruber/drmaa)
* [dynamolock](https://cirello.io/dynamolock)  DynamoDB-backed 分布式锁定实现。
* [go-pdu](https://github.com/pdupub/go-pdu) **star:29** 一个去中心化的基于身份的社交网络。   [![godoc][GoDoc]](https://godoc.org/github.com/pdupub/go-pdu)
* [go-mysql-lock](https://github.com/sanketplus/go-mysql-lock) **star:27** 基于MySQL分布式锁。   [![godoc][GoDoc]](https://godoc.org/github.com/sanketplus/go-mysql-lock)
* [dynatomic](https://github.com/tylfin/dynatomic) **star:14** 基于 DynamoDB 的 原子计数器的库。   [![godoc][GoDoc]](https://godoc.org/github.com/tylfin/dynatomic)
* [gmsec](https://github.com/gmsec/micro) **star:13** 一个Go分布式系统开发框架。   [![godoc][GoDoc]](https://godoc.org/github.com/gmsec/micro)
* [consistenthash](https://github.com/mbrostami/consistenthash) **star:9** 使用可配置副本的一致哈希。   [![最近一年没有更新][Yellow]](https://github.com/mbrostami/consistenthash)   [![godoc][GoDoc]](https://godoc.org/github.com/mbrostami/consistenthash)
* [failured](https://github.com/andy2046/failured) **star:1** 分布式系统的自适应应计故障检测器。   [![godoc][GoDoc]](https://godoc.org/github.com/andy2046/failured)

## 动态域名

*更新动态DNS记录的工具。 (翻译出错了? 试试 [英文版](README_EN.md#dynamic-dns) 吧~)*

* [GoDNS](https://github.com/timothyye/godns) **star:855** 一个动态DNS客户端工具，支持DNSPod & HE.net。   [![godoc][GoDoc]](https://godoc.org/github.com/timothyye/godns)
* [DDNS](https://github.com/skibish/ddns) **star:191** 个人 DDNS 客户端。   [![godoc][GoDoc]](https://godoc.org/github.com/skibish/ddns)
* [dyndns](https://gitlab.com/alcastle/dyndns)  后台去处理定期和自动检查您的IP地址，并作出更新(一个或多个)动态DNS记录，为谷歌域，每当您的地址变化。

## 电子邮件

*实现了电子邮件创建和发送。 (翻译出错了? 试试 [英文版](README_EN.md#email) 吧~)*

* [MailHog](https://github.com/mailhog/MailHog) **star:8887** 电子邮件和SMTP测试工具，对外提供了 web 和 API 接口。   [![star > 2000][Awesome]](https://github.com/mailhog/MailHog)   [![godoc][GoDoc]](https://godoc.org/github.com/mailhog/MailHog)
* [hermes](https://github.com/matcornic/hermes) **star:2311** 可生成干净的、响应式的HTML电子邮件。   [![star > 2000][Awesome]](https://github.com/matcornic/hermes)   [![godoc][GoDoc]](https://godoc.org/github.com/matcornic/hermes)
* [email](https://github.com/jordan-wright/email) **star:1796** 一个强大和灵活的电子邮件库。   [![最近一周有更新][Green]](https://github.com/jordan-wright/email)   [![godoc][GoDoc]](https://godoc.org/github.com/jordan-wright/email)
* [go-imap](https://github.com/emersion/go-imap) **star:1331** 用于客户端和服务器的IMAP库。   [![godoc][GoDoc]](https://godoc.org/github.com/emersion/go-imap)
* [chasquid](https://blitiri.com.ar/p/chasquid)  用Go编写的SMTP服务器。
* [SendGrid](https://github.com/sendgrid/sendgrid-go) **star:747** SendGrid 的 Go语言库，用于发送电子邮件。   [![最近一周有更新][Green]](https://github.com/sendgrid/sendgrid-go)   [![godoc][GoDoc]](https://godoc.org/github.com/sendgrid/sendgrid-go)
* [mailgun-go](https://github.com/mailgun/mailgun-go) **star:539** 使用Mailgun API去库发送邮件。   [![godoc][GoDoc]](https://godoc.org/github.com/mailgun/mailgun-go)
* [email-verifier](https://github.com/AfterShip/email-verifier) **star:286** 一个Go库的电子邮件验证而不发送任何电子邮件。   [![最近一周有更新][Green]](https://github.com/AfterShip/email-verifier)   [![godoc][GoDoc]](https://godoc.org/github.com/AfterShip/email-verifier)
* [go-message](https://github.com/emersion/go-message) **star:210** 用于Internet消息格式化和邮件消息的流媒体库。   [![godoc][GoDoc]](https://godoc.org/github.com/emersion/go-message)
* [Hectane](https://github.com/hectane/hectane) **star:208** 轻量级的SMTP客户机，提供了HTTP API。   [![godoc][GoDoc]](https://godoc.org/github.com/hectane/hectane)
* [douceur](https://github.com/aymerick/douceur) **star:197** 在HTML邮件中支持CSS内联。   [![godoc][GoDoc]](https://godoc.org/github.com/aymerick/douceur)
* [go-simple-mail](https://github.com/xhit/go-simple-mail) **star:187** 非常简单的包发送电子邮件与SMTP保持活动和两个超时:连接和发送。   [![godoc][GoDoc]](https://godoc.org/github.com/xhit/go-simple-mail)
* [mailchain](https://github.com/mailchain/mailchain) **star:84** 发送加密的电子邮件到区块链地址写在Go。   [![godoc][GoDoc]](https://godoc.org/github.com/mailchain/mailchain)
* [go-dkim](https://github.com/toorop/go-dkim) **star:71** DKIM库，用于签署 & 验证电子邮件。   [![godoc][GoDoc]](https://godoc.org/github.com/toorop/go-dkim)
* [go-premailer](https://github.com/vanng822/go-premailer) **star:71** 在HTML邮件中支持CSS内联。   [![godoc][GoDoc]](https://godoc.org/github.com/vanng822/go-premailer)
* [smtp](https://github.com/mailhog/smtp) **star:64** SMTP服务器协议状态机。   [![godoc][GoDoc]](https://godoc.org/github.com/mailhog/smtp)
* [go-email-validator](https://github.com/go-email-validator/go-email-validator) **star:13** 模块化电子邮件验证器的语法，一次性，smtp等…检查。   [![godoc][GoDoc]](https://godoc.org/github.com/go-email-validator/go-email-validator)

## 可嵌入的脚本语言

*在go代码中嵌入其他语言。 (翻译出错了? 试试 [英文版](README_EN.md#embeddable-scripting-languages) 吧~)*

* [gopher-lua](https://github.com/yuin/gopher-lua) **star:4241** 用 Go 实现的 Lua 5.1 虚拟机和编译器。   [![star > 2000][Awesome]](https://github.com/yuin/gopher-lua)   [![godoc][GoDoc]](https://godoc.org/github.com/yuin/gopher-lua)
* [tengo](https://github.com/d5/tengo) **star:2385** 字节码编译的脚本语言。   [![star > 2000][Awesome]](https://github.com/d5/tengo)   [![godoc][GoDoc]](https://godoc.org/github.com/d5/tengo)
* [goja](https://github.com/dop251/goja) **star:2344** ECMAScript 5.1(+)实现在Go。   [![star > 2000][Awesome]](https://github.com/dop251/goja)   [![最近一周有更新][Green]](https://github.com/dop251/goja)   [![godoc][GoDoc]](https://godoc.org/github.com/dop251/goja)
* [go-lua](https://github.com/Shopify/go-lua) **star:2140** 用 Go 实现的 Lua 5.2 VM接口。   [![star > 2000][Awesome]](https://github.com/Shopify/go-lua)   [![godoc][GoDoc]](https://godoc.org/github.com/Shopify/go-lua)
* [expr](https://github.com/antonmedv/expr) **star:1917** Go的表达式计算引擎:快速，非图灵完备，动态类型，静态类型。   [![godoc][GoDoc]](https://godoc.org/github.com/antonmedv/expr)
* [go-python](https://github.com/sbinet/go-python) **star:1293** CPython C-API 的 Go 接口。   [![godoc][GoDoc]](https://godoc.org/github.com/sbinet/go-python)
* [anko](https://github.com/mattn/anko) **star:1160** 用Go编写的解释器。   [![godoc][GoDoc]](https://godoc.org/github.com/mattn/anko)
* [cel-go](https://github.com/google/cel-go) **star:870** 快速，可移植，非图灵完整的表达评估与渐进分型。   [![最近一周有更新][Green]](https://github.com/google/cel-go)   [![godoc][GoDoc]](https://godoc.org/github.com/google/cel-go)
* [go-php](https://github.com/deuill/go-php) **star:809** PHP 的 Go 接口。   [![最近一年没有更新][Yellow]](https://github.com/deuill/go-php)   [![godoc][GoDoc]](https://godoc.org/github.com/deuill/go-php)
* [go-duktape](https://github.com/olebedev/go-duktape) **star:774** 支持 Duktape JavaScript 引擎。   [![godoc][GoDoc]](https://godoc.org/github.com/olebedev/go-duktape)
* [golua](https://github.com/aarzilli/golua) **star:553** Lua C 的 Go 接口。
* [gisp](https://github.com/jcla1/gisp) **star:464** LISP 的 Go 接口。   [![最近一年没有更新][Yellow]](https://github.com/jcla1/gisp)   [![godoc][GoDoc]](https://godoc.org/github.com/jcla1/gisp)
* [gval](https://github.com/PaesslerAG/gval) **star:358** 一种用Go编写的高度可定制的表达式语言。   [![godoc][GoDoc]](https://godoc.org/github.com/PaesslerAG/gval)
* [gentee](https://github.com/gentee/gentee) **star:79** 嵌入式脚本编程语言。   [![godoc][GoDoc]](https://godoc.org/github.com/gentee/gentee)
* [binder](https://github.com/alexeyco/binder) **star:52** Lua接口，基于[gopher-lua](https://github.com/yuin/gopher-lua)。   [![最近一年没有更新][Yellow]](https://github.com/alexeyco/binder)   [![godoc][GoDoc]](https://godoc.org/github.com/alexeyco/binder)
* [purl](https://github.com/ian-kent/purl) **star:33** 嵌入 Go 的 Perl 5.18.2。   [![最近一年没有更新][Yellow]](https://github.com/ian-kent/purl)   [![godoc][GoDoc]](https://godoc.org/github.com/ian-kent/purl)
* [ngaro](https://github.com/db47h/ngaro) **star:20** 嵌入式 Ngaro VM实现，支持在 Retro 中运行脚本。   [![最近一年没有更新][Yellow]](https://github.com/db47h/ngaro)   [![godoc][GoDoc]](https://godoc.org/github.com/db47h/ngaro)
* [ecal](https://github.com/krotik/ecal) **star:11** 一种简单的支持并发事件处理的可嵌入脚本语言。   [![godoc][GoDoc]](https://godoc.org/github.com/krotik/ecal)

## 错误处理

*处理错误的库。 (翻译出错了? 试试 [英文版](README_EN.md#error-handling) 吧~)*

* [errors](https://github.com/pkg/errors) **star:7185** 可让你很简单的进行错误处理。   [![star > 2000][Awesome]](https://github.com/pkg/errors)   [![godoc][GoDoc]](https://godoc.org/github.com/pkg/errors)
* [go-multierror](https://github.com/hashicorp/go-multierror) **star:1331** 可将一系列的错误作为一个整体来显示。   [![godoc][GoDoc]](https://godoc.org/github.com/hashicorp/go-multierror)
* [eris](https://github.com/rotisserie/eris) **star:828** 在Go中处理、跟踪和记录错误的更好方法。兼容标准错误库和github.com/pkg/errors。   [![godoc][GoDoc]](https://godoc.org/github.com/rotisserie/eris)
* [errorx](https://github.com/joomcode/errorx) **star:759** 一个功能丰富的错误包，可进行堆栈跟踪、组装异常信息以及其他。   [![godoc][GoDoc]](https://godoc.org/github.com/joomcode/errorx)
* [tracerr](https://github.com/ztrue/tracerr) **star:675** 可展示错误的堆栈跟踪信息和源码片段。   [![最近一年没有更新][Yellow]](https://github.com/ztrue/tracerr)   [![godoc][GoDoc]](https://godoc.org/github.com/ztrue/tracerr)
* [errlog](https://github.com/snwfdhmp/errlog) **star:398** 用于定位抛出错误的源代码(以及一些其他快速调试特性)。可插入到任何 logger 的位置。   [![godoc][GoDoc]](https://godoc.org/github.com/snwfdhmp/errlog)
* [emperror](https://github.com/emperror/emperror) **star:220** 用于Go库和应用程序的错误处理工具和最佳实践。   [![godoc][GoDoc]](https://godoc.org/github.com/emperror/emperror)
* [errors](https://github.com/emperror/errors) **star:97** 替换标准库错误包和github.com/pkg/errors。提供各种错误处理原语。   [![godoc][GoDoc]](https://godoc.org/github.com/emperror/errors)
* [errors](https://github.com/bnkamalesh/errors) **star:23** 这是一个最小的错误处理包，自定义错误类型，用户友好的消息，Unwrap & is。与非常容易使用和直接的帮助函数。   [![godoc][GoDoc]](https://godoc.org/github.com/bnkamalesh/errors)
* [Falcon](https://github.com/SonicRoshan/falcon) **star:7** 一个简单但功能强大的错误处理包。   [![最近一年没有更新][Yellow]](https://github.com/SonicRoshan/falcon)   [![godoc][GoDoc]](https://godoc.org/github.com/SonicRoshan/falcon)
* [errors](https://github.com/neuronlabs/errors) **star:3** 使用分类原语进行简单的golang错误处理。   [![最近一年没有更新][Yellow]](https://github.com/neuronlabs/errors)   [![godoc][GoDoc]](https://godoc.org/github.com/neuronlabs/errors)
* [errors](https://github.com/PumpkinSeed/errors) **star:3** 最简单的错误包装器，具有出色的性能和最小的内存开销。   [![最近一年没有更新][Yellow]](https://github.com/PumpkinSeed/errors)   [![godoc][GoDoc]](https://godoc.org/github.com/PumpkinSeed/errors)

## 文件处理

*处理文件和文件系统的库。 (翻译出错了? 试试 [英文版](README_EN.md#file-handling) 吧~)*

* [afero](https://github.com/spf13/afero) **star:3929** 文件系统的抽象系统。   [![star > 2000][Awesome]](https://github.com/spf13/afero)   [![godoc][GoDoc]](https://godoc.org/github.com/spf13/afero)
* [pdfcpu](https://github.com/pdfcpu/pdfcpu) **star:2519** PDF处理器。   [![star > 2000][Awesome]](https://github.com/pdfcpu/pdfcpu)   [![godoc][GoDoc]](https://godoc.org/github.com/pdfcpu/pdfcpu)
* [gdu](https://github.com/dundee/gdu) **star:1266** 带有控制台接口的磁盘使用分析器   [![最近一周有更新][Green]](https://github.com/dundee/gdu)   [![godoc][GoDoc]](https://godoc.org/github.com/dundee/gdu)
* [notify](https://github.com/rjeczalik/notify) **star:676** 文件系统事件通知库，具有类似于os/signal的简单API，。   [![godoc][GoDoc]](https://godoc.org/github.com/rjeczalik/notify)
* [copy](https://github.com/otiai10/copy) **star:333** 递归地复制目录。   [![最近一周有更新][Green]](https://github.com/otiai10/copy)   [![godoc][GoDoc]](https://godoc.org/github.com/otiai10/copy)
* [bigfile](https://github.com/bigfile/bigfile) **star:203** 一个文件传输系统，支持管理文件与http api, rpc调用和ftp客户端。   [![最近一年没有更新][Yellow]](https://github.com/bigfile/bigfile)   [![godoc][GoDoc]](https://godoc.org/github.com/bigfile/bigfile)   [![包含中文文档][CN]](https://github.com/bigfile/bigfile)
* [afs](https://github.com/viant/afs) **star:154** 用于Go的抽象文件存储(mem、scp、zip、tar、cloud: s3、gs)。   [![godoc][GoDoc]](https://godoc.org/github.com/viant/afs)
* [vfs](https://github.com/C2FO/vfs) **star:119** 一组可插拔的、可扩展的和自定义的文件系统功能，用于跨越许多文件系统类型，如os、S3和GCS。   [![最近一周有更新][Green]](https://github.com/C2FO/vfs)   [![godoc][GoDoc]](https://godoc.org/github.com/C2FO/vfs)
* [go-csv-tag](https://github.com/artonge/go-csv-tag) **star:89** 使用 tag 加载 csv 文件。   [![godoc][GoDoc]](https://godoc.org/github.com/artonge/go-csv-tag)
* [go-exiftool](https://github.com/barasher/go-exiftool) **star:76** ExifTool 的 Go 实现，这个著名的库用于从文件(图片、PDF、office，…)中提取尽可能多的元数据(EXIF、IPTC，…)。   [![最近一周有更新][Green]](https://github.com/barasher/go-exiftool)   [![godoc][GoDoc]](https://godoc.org/github.com/barasher/go-exiftool)
* [opc](https://github.com/qmuntal/opc) **star:67** 加载Open Packaging Conventions (OPC)文件。   [![godoc][GoDoc]](https://godoc.org/github.com/qmuntal/opc)
* [skywalker](https://github.com/dixonwille/skywalker) **star:65** 可以轻松地并发地遍历文件系统。   [![最近一年没有更新][Yellow]](https://github.com/dixonwille/skywalker)   [![godoc][GoDoc]](https://godoc.org/github.com/dixonwille/skywalker)
* [stl](https://gitlab.com/russoj88/stl)  采用并行读取算法的进行读取和写入STL(立体光刻)文件的模块。
* [tarfs](https://github.com/posener/tarfs) **star:47** tar文件的实现[ FileSystem 接口](https://godoc.org/github.com/kr/fs#FileSystem)。   [![最近一年没有更新][Yellow]](https://github.com/posener/tarfs)   [![godoc][GoDoc]](https://godoc.org/github.com/posener/tarfs)
* [checksum](https://github.com/codingsince1985/checksum) **star:39** 生成大型文件的消息摘要(如 MD5 和 SHA256)。   [![最近一周有更新][Green]](https://github.com/codingsince1985/checksum)   [![godoc][GoDoc]](https://godoc.org/github.com/codingsince1985/checksum)
* [baraka](https://github.com/xis/baraka) **star:33** 一个轻松处理http文件上传的库。   [![godoc][GoDoc]](https://godoc.org/github.com/xis/baraka)
* [parquet](https://github.com/parsyl/parquet) **star:29** 读写[parquet](https://parquet.apache.org)文件。   [![最近一周有更新][Green]](https://github.com/parsyl/parquet)   [![godoc][GoDoc]](https://godoc.org/github.com/parsyl/parquet)
* [go-gtfs](https://github.com/artonge/go-gtfs) **star:27** 加载gtfs文件。   [![godoc][GoDoc]](https://godoc.org/github.com/artonge/go-gtfs)
* [flop](https://github.com/homedepot/flop) **star:25** 文件操作库，是[GNU cp](https://www.gnu.org/software/coreutils/manual/html_node/cp-invoc.html)的镜像。   [![godoc][GoDoc]](https://godoc.org/github.com/homedepot/flop)
* [gut/yos](https://github.com/1set/gut) **star:19** 简单和可靠的包文件操作，如复制/移动/diff/列表的文件，目录和符号链接。   [![godoc][GoDoc]](https://godoc.org/github.com/1set/gut)
* [go-decent-copy](https://github.com/hugocarreira/go-decent-copy) **star:14** 拷贝文件。   [![最近一年没有更新][Yellow]](https://github.com/hugocarreira/go-decent-copy)   [![godoc][GoDoc]](https://godoc.org/github.com/hugocarreira/go-decent-copy)
* [todotxt](https://github.com/1set/todotxt) **star:9** 去吉娜·特拉帕尼的[*todo.txt*](http://todotxt.org/)文件库，支持解析和操作任务列表中的[*todo。txt格式)(https://github.com/todotxt/todo.txt)。   [![godoc][GoDoc]](https://godoc.org/github.com/1set/todotxt)
* [higgs](https://github.com/dastoori/higgs) **star:5** 一个小小的跨平台Go库，用于隐藏/取消隐藏文件和目录。   [![godoc][GoDoc]](https://godoc.org/github.com/dastoori/higgs)
* [pathtype](https://github.com/jonchun/pathtype) **star:5** 将路径视为它们自己的类型，而不是使用字符串。   [![godoc][GoDoc]](https://godoc.org/github.com/jonchun/pathtype)

## 金融

*会计和财务软件包。 (翻译出错了? 试试 [英文版](README_EN.md#financial) 吧~)*

* [decimal](https://github.com/shopspring/decimal) **star:3229** 任意精度定点的十进制数。   [![star > 2000][Awesome]](https://github.com/shopspring/decimal)   [![godoc][GoDoc]](https://godoc.org/github.com/shopspring/decimal)
* [go-money](https://github.com/rhymond/go-money) **star:981** Fowler 货币模式的实现。   [![godoc][GoDoc]](https://godoc.org/github.com/rhymond/go-money)
* [accounting](https://github.com/leekchan/accounting) **star:665** 货币和货币格式。   [![godoc][GoDoc]](https://godoc.org/github.com/leekchan/accounting)
* [go-finance](https://github.com/FlashBoys/go-finance) **star:534** 综合金融市场数据。   [![最近一年没有更新][Yellow]](https://github.com/FlashBoys/go-finance)   [![godoc][GoDoc]](https://godoc.org/github.com/FlashBoys/go-finance)
* [techan](https://github.com/sdcoffey/techan) **star:502** 拥有先进的市场分析和交易策略的技术分析库。   [![godoc][GoDoc]](https://godoc.org/github.com/sdcoffey/techan)
* [currency](https://github.com/bojanz/currency) **star:261** 处理货币金额，提供货币信息和格式。   [![godoc][GoDoc]](https://godoc.org/github.com/bojanz/currency)
* [ach](https://github.com/moov-io/ach) **star:247** 自动化票据交换所(ACH)文件的读取器、写入器和验证器。   [![最近一周有更新][Green]](https://github.com/moov-io/ach)   [![godoc][GoDoc]](https://godoc.org/github.com/moov-io/ach)
* [orderbook](https://github.com/i25959341/orderbook) **star:212** 限购单匹配引擎。   [![godoc][GoDoc]](https://godoc.org/github.com/i25959341/orderbook)
* [go-finance](https://github.com/alpeb/go-finance) **star:108** 用于货币时间价值(年金)、现金流、利率转换、债券和折旧计算的金融函数库。   [![godoc][GoDoc]](https://godoc.org/github.com/alpeb/go-finance)
* [transaction](https://github.com/claygod/transaction) **star:95** 嵌入式事务数据库，可多线程模式运行。   [![godoc][GoDoc]](https://godoc.org/github.com/claygod/transaction)
* [ofxgo](https://github.com/aclindsa/ofxgo) **star:91** 查询 OFX 服务器和/或解析响应。   [![godoc][GoDoc]](https://godoc.org/github.com/aclindsa/ofxgo)
* [vat](https://github.com/dannyvankooten/vat) **star:84** 增值税编号验证 & 欧盟增值税税率。   [![godoc][GoDoc]](https://godoc.org/github.com/dannyvankooten/vat)
* [sleet](https://github.com/BoltApp/sleet) **star:64** 多个付款服务供应商使用统一界面处理网上付款。   [![最近一周有更新][Green]](https://github.com/BoltApp/sleet)   [![godoc][GoDoc]](https://godoc.org/github.com/BoltApp/sleet)
* [go-finnhub](https://github.com/m1/go-finnhub) **star:60** 来自finnhu .io的股票市场、外汇和密码数据客户。从60多个证券交易所、10个外汇经纪人和15多个密码交易所获取实时金融市场数据。   [![最近一年没有更新][Yellow]](https://github.com/m1/go-finnhub)   [![godoc][GoDoc]](https://godoc.org/github.com/m1/go-finnhub)   [![归档项目][Archived]](https://github.com/m1/go-finnhub)
* [currency](https://github.com/bnkamalesh/currency) **star:40** 高性能、准确的货币计算软件包。   [![最近一年没有更新][Yellow]](https://github.com/bnkamalesh/currency)   [![godoc][GoDoc]](https://godoc.org/github.com/bnkamalesh/currency)
* [fastme](https://github.com/newity/fastme) **star:24** 快速可扩展匹配引擎Go实现。   [![godoc][GoDoc]](https://godoc.org/github.com/newity/fastme)
* [payme](https://github.com/jovandeginste/payme) **star:7** 二维码生成器(ASCII & PNG)用于SEPA支付。   [![godoc][GoDoc]](https://godoc.org/github.com/jovandeginste/payme)
* [go-finance](https://github.com/pieterclaerhout/go-finance) **star:5** 模块获取汇率，通过VIES检查增值税号码，检查IBAN银行账号。   [![最近一年没有更新][Yellow]](https://github.com/pieterclaerhout/go-finance)   [![godoc][GoDoc]](https://godoc.org/github.com/pieterclaerhout/go-finance)

## 表单

*用于处理表单的库。 (翻译出错了? 试试 [英文版](README_EN.md#forms) 吧~)*

* [nosurf](https://github.com/justinas/nosurf) **star:1198** CSRF保护中间件。   [![godoc][GoDoc]](https://godoc.org/github.com/justinas/nosurf)
* [binding](https://github.com/mholt/binding) **star:782** 将来自 net/HTTP 请求的表单、JSON 数据绑定到结构体。   [![最近一年没有更新][Yellow]](https://github.com/mholt/binding)   [![godoc][GoDoc]](https://godoc.org/github.com/mholt/binding)
* [gorilla/csrf](https://github.com/gorilla/csrf) **star:688** 用于Go web应用程序和服务的CSRF保护。   [![godoc][GoDoc]](https://godoc.org/github.com/gorilla/csrf)
* [form](https://github.com/go-playground/form) **star:491**  将 url 中的数据解析到 Go 变量中，以及将 Go 语言变量编码进 url。支持 Dual Array 及 Full map。   [![godoc][GoDoc]](https://godoc.org/github.com/go-playground/form)
* [conform](https://github.com/leebenson/conform) **star:229** 控制用户输入。基于struct tags可对数据进行修剪、清理和擦除。   [![godoc][GoDoc]](https://godoc.org/github.com/leebenson/conform)
* [formam](https://github.com/monoculum/formam) **star:163** 将表单的值解码为 struct。   [![godoc][GoDoc]](https://godoc.org/github.com/monoculum/formam)
* [forms](https://github.com/albrow/forms) **star:122** 与框架无关的库，用于解析和验证支持多部分表单和文件的表单/JSON数据。   [![最近一年没有更新][Yellow]](https://github.com/albrow/forms)   [![godoc][GoDoc]](https://godoc.org/github.com/albrow/forms)
* [qs](https://github.com/sonh/qs) **star:57** 去模块编码结构到URL查询参数。   [![godoc][GoDoc]](https://godoc.org/github.com/sonh/qs)
* [bind](https://github.com/robfig/bind) **star:26** 将表单数据与任意 Go 变量进行绑定。   [![最近一年没有更新][Yellow]](https://github.com/robfig/bind)   [![godoc][GoDoc]](https://godoc.org/github.com/robfig/bind)
* [queryparam](https://github.com/tomwright/queryparam) **star:10** 解码的url。值转换为标准或自定义类型的可用结构值。   [![godoc][GoDoc]](https://godoc.org/github.com/tomwright/queryparam)

## 方法

*在Go中支持函数式编程的包。 (翻译出错了? 试试 [英文版](README_EN.md#functional) 吧~)*

* [go-underscore](https://github.com/tobyhede/go-underscore) **star:1206** 常用辅助方法集合。   [![最近一年没有更新][Yellow]](https://github.com/tobyhede/go-underscore)   [![godoc][GoDoc]](https://godoc.org/github.com/tobyhede/go-underscore)
* [fpGo](https://github.com/TeaEntityLab/fpGo) **star:191** 提供函数式编程功能。   [![最近一周有更新][Green]](https://github.com/TeaEntityLab/fpGo)   [![godoc][GoDoc]](https://godoc.org/github.com/TeaEntityLab/fpGo)
* [fuego](https://github.com/seborama/fuego) **star:95** Functional Experiment in Go。   [![godoc][GoDoc]](https://godoc.org/github.com/seborama/fuego)
* [gofp](https://github.com/rbrahul/gofp) **star:86** 一个类似lodash的强大的Golang实用程序库。   [![godoc][GoDoc]](https://godoc.org/github.com/rbrahul/gofp)

## 游戏开发

*很棒的游戏开发库。 (翻译出错了? 试试 [英文版](README_EN.md#game-development) 吧~)*

* [Ebiten](https://github.com/hajimehoshi/ebiten) **star:4931** 很简单的 2D 游戏库。   [![star > 2000][Awesome]](https://github.com/hajimehoshi/ebiten)   [![最近一周有更新][Green]](https://github.com/hajimehoshi/ebiten)   [![godoc][GoDoc]](https://godoc.org/github.com/hajimehoshi/ebiten)
* [Leaf](https://github.com/name5566/leaf) **star:4113** 轻量级游戏服务器框架。   [![star > 2000][Awesome]](https://github.com/name5566/leaf)   [![godoc][GoDoc]](https://godoc.org/github.com/name5566/leaf)   [![包含中文文档][CN]](https://github.com/name5566/leaf)
* [Pixel](https://github.com/faiface/pixel) **star:3599** 手工制作的 2D 游戏库。   [![star > 2000][Awesome]](https://github.com/faiface/pixel)   [![最近一周有更新][Green]](https://github.com/faiface/pixel)   [![godoc][GoDoc]](https://godoc.org/github.com/faiface/pixel)
* [goworld](https://github.com/xiaonanln/goworld) **star:1914** 可伸缩的游戏服务器引擎，具有 space-entity 框架和 hot-swapping 功能。   [![godoc][GoDoc]](https://godoc.org/github.com/xiaonanln/goworld)   [![包含中文文档][CN]](https://github.com/xiaonanln/goworld)
* [nano](https://github.com/lonng/nano) **star:1782** 轻量级、方便、高性能的基于golang的游戏服务器框架。   [![godoc][GoDoc]](https://godoc.org/github.com/lonng/nano)   [![包含中文文档][CN]](https://github.com/lonng/nano)
* [go-sdl2](https://github.com/veandco/go-sdl2) **star:1596** 实现了[Simple DirectMedia Layer](https://www.libsdl.org/)。   [![最近一周有更新][Green]](https://github.com/veandco/go-sdl2)
* [g3n](https://github.com/g3n/engine) **star:1532**  3D游戏引擎。   [![最近一周有更新][Green]](https://github.com/g3n/engine)
* [engo](https://github.com/EngoEngine/engo) **star:1406** 开源 2D 游戏引擎。它遵循 Entity-Component-System 范式。   [![godoc][GoDoc]](https://godoc.org/github.com/EngoEngine/engo)
* [termloop](https://github.com/JoelOtter/termloop) **star:1221** 基于终端的 Go 游戏引擎，建立在 Termbox 之上。   [![godoc][GoDoc]](https://godoc.org/github.com/JoelOtter/termloop)
* [gonet](https://github.com/xtaci/gonet) **star:1147** 实现了游戏服务器骨架。   [![最近一年没有更新][Yellow]](https://github.com/xtaci/gonet)   [![godoc][GoDoc]](https://godoc.org/github.com/xtaci/gonet)
* [Pitaya](https://github.com/topfreegames/pitaya) **star:1135** 可伸缩的游戏服务器框架，支持集群和客户端库的iOS, Android, Unity。   [![最近一周有更新][Green]](https://github.com/topfreegames/pitaya)   [![godoc][GoDoc]](https://godoc.org/github.com/topfreegames/pitaya)
* [Oak](https://github.com/oakmound/oak) **star:913** 纯 Go 实现的游戏引擎。   [![最近一周有更新][Green]](https://github.com/oakmound/oak)   [![godoc][GoDoc]](https://godoc.org/github.com/oakmound/oak)
* [raylib-go](https://github.com/gen2brain/raylib-go) **star:638** 实现了 [raylib](http://www.raylib.com/)，一个简单易用的库，用于学习视频游戏编程。
* [Azul3D](https://github.com/azul3d/engine) **star:498** 用Go编写的 3D 游戏引擎。   [![最近一年没有更新][Yellow]](https://github.com/azul3d/engine)
* [go-astar](https://github.com/beefsack/go-astar) **star:441** 实现了A\*路径查找算法。   [![godoc][GoDoc]](https://godoc.org/github.com/beefsack/go-astar)
* [go3d](https://github.com/ungerik/go3d) **star:205** 以性能为主的2D/3D数学相关包。   [![godoc][GoDoc]](https://godoc.org/github.com/ungerik/go3d)
* [prototype](https://github.com/gonutz/prototype) **star:60** 跨平台(Windows/Linux/Mac)库，用于使用最少的API创建桌面游戏。   [![最近一周有更新][Green]](https://github.com/gonutz/prototype)   [![godoc][GoDoc]](https://godoc.org/github.com/gonutz/prototype)
* [tile](https://github.com/kelindar/tile) **star:29** 面向数据和缓存友好的2D网格库(TileMap)，包括寻路、观察者和导入/导出。   [![godoc][GoDoc]](https://godoc.org/github.com/kelindar/tile)

## 代码生成与泛型

*增强语言的工具，例如通过代码生成支持泛型。 (翻译出错了? 试试 [英文版](README_EN.md#generation-and-generics) 吧~)*

* [go-linq](https://github.com/ahmetalpbalkan/go-linq) **star:2636** 提供类似 .NET LINQ 的查询方法。   [![star > 2000][Awesome]](https://github.com/ahmetalpbalkan/go-linq)   [![godoc][GoDoc]](https://godoc.org/github.com/ahmetalpbalkan/go-linq)
* [jennifer](https://github.com/dave/jennifer) **star:2111** 不使用模板生成任意 Go 代码。   [![star > 2000][Awesome]](https://github.com/dave/jennifer)   [![godoc][GoDoc]](https://godoc.org/github.com/dave/jennifer)
* [gen](https://github.com/clipperhouse/gen) **star:1310** 用于生成泛型等类似方法的功能代码生成工具。   [![最近一年没有更新][Yellow]](https://github.com/clipperhouse/gen)   [![godoc][GoDoc]](https://godoc.org/github.com/clipperhouse/gen)
* [goderive](https://github.com/awalterschulze/goderive) **star:911** 从输入类型来派生函数。   [![godoc][GoDoc]](https://godoc.org/github.com/awalterschulze/goderive)
* [GoWrap](https://github.com/hexdigest/gowrap) **star:530** 使用简单模板为 Go 接口生成装饰器。   [![godoc][GoDoc]](https://godoc.org/github.com/hexdigest/gowrap)
* [interfaces](https://github.com/rjeczalik/interfaces) **star:306** 用于生成接口定义的命令行工具。   [![godoc][GoDoc]](https://godoc.org/github.com/rjeczalik/interfaces)
* [go-enum](https://github.com/abice/go-enum) **star:225** 从代码注释中生成枚举。   [![godoc][GoDoc]](https://godoc.org/github.com/abice/go-enum)
* [pkgreflect](https://github.com/ungerik/pkgreflect) **star:98** 用于包作用域反射的 Go 预处理器。   [![最近一年没有更新][Yellow]](https://github.com/ungerik/pkgreflect)   [![godoc][GoDoc]](https://godoc.org/github.com/ungerik/pkgreflect)
* [efaceconv](https://github.com/t0pep0/efaceconv) **star:49** 代码生成工具，可以不通过内存分配就可以高效的将interface{}转换为不可变类型，。   [![最近一年没有更新][Yellow]](https://github.com/t0pep0/efaceconv)   [![godoc][GoDoc]](https://godoc.org/github.com/t0pep0/efaceconv)
* [gotype](https://github.com/wzshiming/gotype) **star:37** Golang 源码解析，用法类似reflect(反射)。   [![godoc][GoDoc]](https://godoc.org/github.com/wzshiming/gotype)   [![包含中文文档][CN]](https://github.com/wzshiming/gotype)
* [generis](https://github.com/senselogic/GENERIS) **star:29** 提供泛型、free-form 宏、条件编译和HTML模板的代码生成工具。
* [go-xray](https://github.com/pieterclaerhout/go-xray) **star:18** 帮助更容易地使用反射。   [![最近一年没有更新][Yellow]](https://github.com/pieterclaerhout/go-xray)   [![godoc][GoDoc]](https://godoc.org/github.com/pieterclaerhout/go-xray)
* [typeregistry](https://github.com/xiaoxin01/typeregistry) **star:11** 动态创建类型的库。   [![最近一年没有更新][Yellow]](https://github.com/xiaoxin01/typeregistry)   [![godoc][GoDoc]](https://godoc.org/github.com/xiaoxin01/typeregistry)

## 地理

*地理工具和服务器 (翻译出错了? 试试 [英文版](README_EN.md#geographic) 吧~)*

* [Tile38](https://github.com/tidwall/tile38) **star:7621** 具有空间索引和实时地理定位功能的地理定位数据库。   [![star > 2000][Awesome]](https://github.com/tidwall/tile38)   [![godoc][GoDoc]](https://godoc.org/github.com/tidwall/tile38)
* [S2 geometry](https://github.com/golang/geo) **star:1258** S2 geometry 库。   [![godoc][GoDoc]](https://godoc.org/github.com/golang/geo)
* [mbtileserver](https://github.com/consbio/mbtileserver) **star:262** 一个简单的基于go的服务器，用于存储mbtiles格式的地图块。   [![godoc][GoDoc]](https://godoc.org/github.com/consbio/mbtileserver)
* [osm](https://github.com/paulmach/osm) **star:171** 用于读取、写入和处理 OpenStreetMap 数据和 APIs。   [![godoc][GoDoc]](https://godoc.org/github.com/paulmach/osm)
* [WGS84](https://github.com/wroge/wgs84) **star:63** 坐标转换和转换库(ETRS89, OSGB36, NAD83, RGF93, Web Mercator, UTM)。   [![godoc][GoDoc]](https://godoc.org/github.com/wroge/wgs84)
* [geoserver](https://github.com/hishamkaram/geoserver) **star:58** 基于geoserver REST API的 geoserver 实例。   [![godoc][GoDoc]](https://godoc.org/github.com/hishamkaram/geoserver)
* [gismanager](https://github.com/hishamkaram/gismanager) **star:38** 将你的 GIS 数据(矢量数据)发布到 PostGIS 和 Geoserver。   [![最近一年没有更新][Yellow]](https://github.com/hishamkaram/gismanager)   [![godoc][GoDoc]](https://godoc.org/github.com/hishamkaram/gismanager)
* [simplefeatures](https://github.com/peterstace/simplefeatures) **star:27** simplesfeatures是一个2D几何库，提供了建模几何图形的Go类型，以及对几何图形进行操作的算法。   [![最近一周有更新][Green]](https://github.com/peterstace/simplefeatures)   [![godoc][GoDoc]](https://godoc.org/github.com/peterstace/simplefeatures)
* [pbf](https://github.com/maguro/pbf) **star:25** 基于Golang 的 OpenStreetMap PBF 编码器/解码器。   [![godoc][GoDoc]](https://godoc.org/github.com/maguro/pbf)
* [S2 geojson](https://github.com/pantrif/s2-geojson) **star:13** 将geojson转换为s2单元格&在map上演示一些s2的几何特性。   [![最近一年没有更新][Yellow]](https://github.com/pantrif/s2-geojson)   [![godoc][GoDoc]](https://godoc.org/github.com/pantrif/s2-geojson)

## Go 编译器

*可将 Go 转换为其他语言的编译工具。 (翻译出错了? 试试 [英文版](README_EN.md#go-compilers) 吧~)*

* [gopherjs](https://github.com/gopherjs/gopherjs) **star:10393** 将 Go 编译成 JavaScript。   [![star > 2000][Awesome]](https://github.com/gopherjs/gopherjs)   [![最近一周有更新][Green]](https://github.com/gopherjs/gopherjs)   [![godoc][GoDoc]](https://godoc.org/github.com/gopherjs/gopherjs)
* [tardisgo](https://github.com/tardisgo/tardisgo) **star:411** Golang 转换为 Haxe，再转换为 CPP/CSharp/Java/JavaScript 的编译器.   [![最近一年没有更新][Yellow]](https://github.com/tardisgo/tardisgo)   [![godoc][GoDoc]](https://godoc.org/github.com/tardisgo/tardisgo)
* [c4go](https://github.com/Konstantin8105/c4go) **star:279** 将 C 代码转换为 Go 代码。   [![godoc][GoDoc]](https://godoc.org/github.com/Konstantin8105/c4go)
* [f4go](https://github.com/Konstantin8105/f4go) **star:25** 将 FORTRAN 77 转换为 Go代码。   [![godoc][GoDoc]](https://godoc.org/github.com/Konstantin8105/f4go)

## Goroutines

*管理和处理 Goroutines 的工具。 (翻译出错了? 试试 [英文版](README_EN.md#goroutines) 吧~)*

* [ants](https://github.com/panjf2000/ants) **star:6246** 一个高性能且低损耗的 goroutine 池。   [![star > 2000][Awesome]](https://github.com/panjf2000/ants)   [![godoc][GoDoc]](https://godoc.org/github.com/panjf2000/ants)   [![包含中文文档][CN]](https://github.com/panjf2000/ants)
* [goworker](https://github.com/benmanns/goworker) **star:2594** 基于 go 的后台 worker。   [![star > 2000][Awesome]](https://github.com/benmanns/goworker)   [![godoc][GoDoc]](https://godoc.org/github.com/benmanns/goworker)
* [tunny](https://github.com/Jeffail/tunny) **star:2572** golang 的协程池。   [![star > 2000][Awesome]](https://github.com/Jeffail/tunny)   [![godoc][GoDoc]](https://godoc.org/github.com/Jeffail/tunny)
* [grpool](https://github.com/ivpusic/grpool) **star:647** 轻量级协程池。   [![最近一年没有更新][Yellow]](https://github.com/ivpusic/grpool)   [![godoc][GoDoc]](https://godoc.org/github.com/ivpusic/grpool)
* [pool](https://github.com/go-playground/pool) **star:631** 有限消费者协程或无限协程池，可用于更加简单的处理和取消协程   [![godoc][GoDoc]](https://godoc.org/github.com/go-playground/pool)
* [workerpool](https://github.com/gammazero/workerpool) **star:617** 限制任务执行并发数，而不是队列中的任务数量的协程池，。   [![godoc][GoDoc]](https://godoc.org/github.com/gammazero/workerpool)
* [gowp](https://github.com/xxjwxc/gowp) **star:315** gowp是高并发性限制异步工作池。   [![godoc][GoDoc]](https://godoc.org/github.com/xxjwxc/gowp)   [![包含中文文档][CN]](https://github.com/xxjwxc/gowp)
* [pond](https://github.com/alitto/pond) **star:259** 简约和高性能的goroutine工作池写在Go。   [![godoc][GoDoc]](https://godoc.org/github.com/alitto/pond)
* [go-floc](https://github.com/workanator/go-floc) **star:203** 轻松编排 goroutines。   [![godoc][GoDoc]](https://godoc.org/github.com/workanator/go-floc)
* [go-flow](https://github.com/kamildrazkiewicz/go-flow) **star:171** 控制 goroutines 的执行顺序。   [![最近一年没有更新][Yellow]](https://github.com/kamildrazkiewicz/go-flow)   [![godoc][GoDoc]](https://godoc.org/github.com/kamildrazkiewicz/go-flow)
* [semaphore](https://github.com/marusama/semaphore) **star:121** 基于 CAS 的可快速调整的信号量实现(比基于通道的信号量实现更快)。   [![godoc][GoDoc]](https://godoc.org/github.com/marusama/semaphore)
* [artifex](https://github.com/borderstech/artifex) **star:116** 简单的内存作业队列。   [![最近一年没有更新][Yellow]](https://github.com/borderstech/artifex)   [![godoc][GoDoc]](https://godoc.org/github.com/borderstech/artifex)
* [go-workers](https://github.com/catmullet/go-workers) **star:113** 为大型数据处理管道轻松安全地运行工人。   [![godoc][GoDoc]](https://godoc.org/github.com/catmullet/go-workers)
* [async](https://github.com/studiosol/async) **star:89** 一种异步执行函数的安全方法，在出现 panic 时恢复它们。   [![godoc][GoDoc]](https://godoc.org/github.com/studiosol/async)
* [breaker](https://github.com/kamilsk/breaker)  灵活的机制，可以使执行流可中断。
* [neilotoole/errgroup](https://github.com/neilotoole/errgroup) **star:88** “sync/errgroup”的替代方案，仅限于N个worker goroutines池。   [![godoc][GoDoc]](https://godoc.org/github.com/neilotoole/errgroup)
* [semaphore](https://github.com/kamilsk/semaphore) **star:85** 信号量模式实现，可根据通道和上下文进行具备超时功能的锁定/解锁操作。   [![最近一年没有更新][Yellow]](https://github.com/kamilsk/semaphore)   [![godoc][GoDoc]](https://godoc.org/github.com/kamilsk/semaphore)
* [gpool](https://github.com/Sherifabdlnaby/gpool) **star:80** manages a resizeable pool of context-aware goroutines to bound concurrency   [![最近一年没有更新][Yellow]](https://github.com/Sherifabdlnaby/gpool)   [![godoc][GoDoc]](https://godoc.org/github.com/Sherifabdlnaby/gpool)
* [worker-pool](https://github.com/vardius/worker-pool) **star:79** 一个简单的 Go 异步工作池。   [![godoc][GoDoc]](https://godoc.org/github.com/vardius/worker-pool)
* [cyclicbarrier](https://github.com/marusama/cyclicbarrier) **star:71** 基于 Go 的 CyclicBarrier 实现。   [![最近一年没有更新][Yellow]](https://github.com/marusama/cyclicbarrier)   [![godoc][GoDoc]](https://godoc.org/github.com/marusama/cyclicbarrier)
* [gollback](https://github.com/vardius/gollback) **star:60** 异步简单的函数实用程序，用于管理闭包和回调的执行。   [![最近一年没有更新][Yellow]](https://github.com/vardius/gollback)   [![godoc][GoDoc]](https://godoc.org/github.com/vardius/gollback)
* [threadpool](https://github.com/shettyh/threadpool) **star:60** Golang 的 threadpool 实现。   [![最近一年没有更新][Yellow]](https://github.com/shettyh/threadpool)   [![godoc][GoDoc]](https://godoc.org/github.com/shettyh/threadpool)
* [Hunch](https://github.com/AaronJan/Hunch) **star:56** Hunch 提供了诸如 All、First、Retry、Waterfall 等功能，这使得异步流控制更加直观。   [![godoc][GoDoc]](https://godoc.org/github.com/AaronJan/Hunch)
* [routine](https://github.com/x-mod/routine) **star:41** go routine control with context, support: Main, Go, Pool and some useful Executors.   [![godoc][GoDoc]](https://godoc.org/github.com/x-mod/routine)
* [kyoo](https://github.com/dirkaholic/kyoo) **star:33** 提供无限的作业队列和并发工作池。   [![最近一年没有更新][Yellow]](https://github.com/dirkaholic/kyoo)   [![godoc][GoDoc]](https://godoc.org/github.com/dirkaholic/kyoo)
* [nursery](https://github.com/arunsworld/nursery) **star:33** Go中的结构化并发。   [![godoc][GoDoc]](https://godoc.org/github.com/arunsworld/nursery)
* [oversight](https://cirello.io/oversight)  完整的实现了Erlang supervision trees。
* [parallel-fn](https://github.com/rafaeljesus/parallel-fn) **star:31** 并行运行函数。   [![最近一年没有更新][Yellow]](https://github.com/rafaeljesus/parallel-fn)   [![godoc][GoDoc]](https://godoc.org/github.com/rafaeljesus/parallel-fn)
* [async](https://github.com/reugn/async) **star:24** 可选的Go同步库(Future, Promise, Locks)。   [![最近一年没有更新][Yellow]](https://github.com/reugn/async)   [![godoc][GoDoc]](https://godoc.org/github.com/reugn/async)
* [goccm](https://github.com/zenthangplus/goccm) **star:24** Go并发管理器包限制了允许并发运行的goroutines的数量。   [![godoc][GoDoc]](https://godoc.org/github.com/zenthangplus/goccm)
* [go-trylock](https://github.com/subchen/go-trylock) **star:20** 支持 read-write 锁。   [![godoc][GoDoc]](https://godoc.org/github.com/subchen/go-trylock)
* [go-waitgroup](https://github.com/pieterclaerhout/go-waitgroup) **star:20** 像“同步。有错误处理和并发控制。   [![最近一年没有更新][Yellow]](https://github.com/pieterclaerhout/go-waitgroup)   [![godoc][GoDoc]](https://godoc.org/github.com/pieterclaerhout/go-waitgroup)
* [stl](https://github.com/ssgreg/stl) **star:19** 基于软件事务内存(STM)并发控制机制的软件事务锁。   [![最近一年没有更新][Yellow]](https://github.com/ssgreg/stl)   [![godoc][GoDoc]](https://godoc.org/github.com/ssgreg/stl)
* [channelify](https://github.com/ddelizia/channelify) **star:14** 将函数转换为返回通道，以便进行简单而强大的并行处理。   [![godoc][GoDoc]](https://godoc.org/github.com/ddelizia/channelify)
* [gohive](https://github.com/loveleshsharma/gohive) **star:13** 一个高性能和易于使用的Goroutine池去。   [![最近一年没有更新][Yellow]](https://github.com/loveleshsharma/gohive)   [![godoc][GoDoc]](https://godoc.org/github.com/loveleshsharma/gohive)
* [conexec](https://github.com/ITcathyh/conexec) **star:11** 一个并发工具包，帮助以高效和安全的方式并发执行函数。它支持指定总体超时来避免阻塞，并使用goroutine池来提高效率。   [![最近一年没有更新][Yellow]](https://github.com/ITcathyh/conexec)   [![godoc][GoDoc]](https://godoc.org/github.com/ITcathyh/conexec)
* [gowl](https://github.com/hamed-yousefi/gowl) **star:9** Gowl同时是一个流程管理和流程监控工具。无限工作者池使您能够控制池和进程并监视它们的状态。   [![godoc][GoDoc]](https://godoc.org/github.com/hamed-yousefi/gowl)
* [queue](https://github.com/AnikHasibul/queue) **star:9** 提供类似队列组可访问性 sync.WaitGroup 的功能。帮助你节流和限制协程、等待所有协程结束以及更多功能。   [![最近一年没有更新][Yellow]](https://github.com/AnikHasibul/queue)   [![godoc][GoDoc]](https://godoc.org/github.com/AnikHasibul/queue)
* [hands](https://github.com/duanckham/hands) **star:7** 进程控制器，用于控制多个goroutine的执行和返回策略。   [![最近一年没有更新][Yellow]](https://github.com/duanckham/hands)   [![godoc][GoDoc]](https://godoc.org/github.com/duanckham/hands)
* [execpool](https://github.com/hexdigest/execpool) **star:5** 一个围绕exec建立的池。Cmd，它预先启动给定数量的进程，并在需要时将stdin和stdout附加到它们。非常类似于FastCGI或Apache Prefork MPM，但适用于任何命令。   [![godoc][GoDoc]](https://godoc.org/github.com/hexdigest/execpool)
* [go-tools/multithreading](https://github.com/nikhilsaraf/go-tools) **star:5** 轻量级的协程池库，可以通过简单的API来管理。   [![最近一年没有更新][Yellow]](https://github.com/nikhilsaraf/go-tools)   [![godoc][GoDoc]](https://godoc.org/github.com/nikhilsaraf/go-tools)
* [concurrency-limiter](https://github.com/vivek-ng/concurrency-limiter) **star:4** 支持超时、动态优先级和上下文取消的并发限制器。   [![godoc][GoDoc]](https://godoc.org/github.com/vivek-ng/concurrency-limiter)

## GUI

*用于构建GUI应用程序的库。 (翻译出错了? 试试 [英文版](README_EN.md#gui) 吧~)*

*工具包 (翻译出错了? 试试 [英文版](README_EN.md#gui) 吧~)*

* [fyne](https://github.com/fyne-io/fyne) **star:13760** 基于材料设计的Go跨平台本机gui设计。支持:Linux, macOS, Windows, BSD, iOS和Android。   [![star > 2000][Awesome]](https://github.com/fyne-io/fyne)   [![最近一周有更新][Green]](https://github.com/fyne-io/fyne)   [![godoc][GoDoc]](https://godoc.org/github.com/fyne-io/fyne)
* [webview](https://github.com/zserge/webview) **star:8734** 跨平台webview窗口，具有简单的双向JavaScript绑定(Windows / macOS / Linux)。   [![star > 2000][Awesome]](https://github.com/zserge/webview)
* [qt](https://github.com/therecipe/qt) **star:8704** 实现了 Qt 的 Go接口(支持Windows / macOS / Linux / Android / iOS / Sailfish OS / Raspberry Pi)。   [![star > 2000][Awesome]](https://github.com/therecipe/qt)   [![godoc][GoDoc]](https://godoc.org/github.com/therecipe/qt)
* [ui](https://github.com/andlabs/ui) **star:7934** 跨平台的 Platform-native GUI 库。   [![star > 2000][Awesome]](https://github.com/andlabs/ui)   [![godoc][GoDoc]](https://godoc.org/github.com/andlabs/ui)
* [Wails](https://wails.app)  Mac, Windows, Linux桌面应用程序，主要基于含有内置的OS HTML渲染器的HTML UI。
* [walk](https://github.com/lxn/walk) **star:5597** Windows应用程序库。   [![star > 2000][Awesome]](https://github.com/lxn/walk)   [![godoc][GoDoc]](https://godoc.org/github.com/lxn/walk)
* [app](https://github.com/murlokswarm/app) **star:5036** 用于创建包含了 GO, HTML 和 CSS 的应用程序。支持 MacOS, Windows 正在开发中。   [![star > 2000][Awesome]](https://github.com/murlokswarm/app)   [![最近一周有更新][Green]](https://github.com/murlokswarm/app)   [![godoc][GoDoc]](https://godoc.org/github.com/murlokswarm/app)
* [go-astilectron](https://github.com/asticode/go-astilectron) **star:3955** 使用 GO 和 HTML/JS/CSS (电子驱动)进行构建跨平台 GUI 应用程序。   [![star > 2000][Awesome]](https://github.com/asticode/go-astilectron)   [![godoc][GoDoc]](https://godoc.org/github.com/asticode/go-astilectron)
* [go-gtk](http://mattn.github.io/go-gtk/)  实现了 GTK 的 Go接口。
* [go-sciter](https://github.com/sciter-sdk/go-sciter) **star:2169** 实现了 Sciter 的 Go 接口 : 用于现代桌面 UI 开发的可嵌入HTML/CSS/脚本引擎。可跨平台。   [![star > 2000][Awesome]](https://github.com/sciter-sdk/go-sciter)   [![godoc][GoDoc]](https://godoc.org/github.com/sciter-sdk/go-sciter)
* [gotk3](https://github.com/gotk3/gotk3) **star:1555** 实现了 GTK3 的 Go接口。   [![最近一周有更新][Green]](https://github.com/gotk3/gotk3)   [![godoc][GoDoc]](https://godoc.org/github.com/gotk3/gotk3)
* [gowd](https://github.com/dtylman/gowd) **star:325** 跨平台、快速、简单的桌面UI开发，采用了GO, HTML, CSS和NW.js实现。   [![最近一年没有更新][Yellow]](https://github.com/dtylman/gowd)   [![godoc][GoDoc]](https://godoc.org/github.com/dtylman/gowd)

*交互 (翻译出错了? 试试 [英文版](README_EN.md#gui) 吧~)*

* [robotgo](https://github.com/go-vgo/robotgo) **star:6803** 实现跨平台的GUI系统自动化。包含了控制鼠标、键盘等功能。   [![star > 2000][Awesome]](https://github.com/go-vgo/robotgo)   [![最近一周有更新][Green]](https://github.com/go-vgo/robotgo)
* [systray](https://github.com/getlantern/systray) **star:1908** 跨平台 Go 库，可在通知区放置图标和菜单。   [![godoc][GoDoc]](https://godoc.org/github.com/getlantern/systray)
* [gosx-notifier](https://github.com/deckarep/gosx-notifier) **star:543** OSX 桌面通知库。   [![最近一年没有更新][Yellow]](https://github.com/deckarep/gosx-notifier)   [![godoc][GoDoc]](https://godoc.org/github.com/deckarep/gosx-notifier)
* [trayhost](https://github.com/shurcooL/trayhost) **star:213** 跨平台 Go 库，可用于在主机操作系统的任务栏中放置图标。   [![最近一年没有更新][Yellow]](https://github.com/shurcooL/trayhost)   [![godoc][GoDoc]](https://godoc.org/github.com/shurcooL/trayhost)
* [zenity](https://github.com/ncruces/zenity) **star:156** 跨平台的Go库和CLI创建简单的对话框，与用户进行图形化交互。   [![最近一周有更新][Green]](https://github.com/ncruces/zenity)   [![godoc][GoDoc]](https://godoc.org/github.com/ncruces/zenity)
* [go-appindicator](https://github.com/dawidd6/go-appindicator) **star:17** 实现了 libappindicator3 C库 的 Go接口。   [![godoc][GoDoc]](https://godoc.org/github.com/dawidd6/go-appindicator)   [![归档项目][Archived]](https://github.com/dawidd6/go-appindicator)
* [mac-activity-tracker](https://github.com/prashantgupta24/activity-tracker) **star:12** 用于通知计算机上的任何(可插入的)活动的 OSX 库。   [![最近一年没有更新][Yellow]](https://github.com/prashantgupta24/activity-tracker)   [![godoc][GoDoc]](https://godoc.org/github.com/prashantgupta24/activity-tracker)
* [mac-sleep-notifier](https://github.com/prashantgupta24/mac-sleep-notifier) **star:10** OSX 睡眠/唤醒通知。   [![最近一年没有更新][Yellow]](https://github.com/prashantgupta24/mac-sleep-notifier)   [![godoc][GoDoc]](https://godoc.org/github.com/prashantgupta24/mac-sleep-notifier)


## 硬件

*硬件交互相关的库、工具和教程。 (翻译出错了? 试试 [英文版](README_EN.md#hardware) 吧~)*

See [go-hardware](https://github.com/rakyll/go-hardware) for a comprehensive list.

## 图片

*图像处理相关的库。 (翻译出错了? 试试 [英文版](README_EN.md#images) 吧~)*

* [gocv](https://github.com/hybridgroup/gocv) **star:4272** 使用OpenCV 3.3+实现的计算机视觉(ComputerVision)的Go语言包。   [![star > 2000][Awesome]](https://github.com/hybridgroup/gocv)   [![最近一周有更新][Green]](https://github.com/hybridgroup/gocv)   [![godoc][GoDoc]](https://godoc.org/github.com/hybridgroup/gocv)
* [imaging](https://github.com/disintegration/imaging) **star:3871** 简单的Go图像处理包。   [![star > 2000][Awesome]](https://github.com/disintegration/imaging)   [![godoc][GoDoc]](https://godoc.org/github.com/disintegration/imaging)
* [imaginary](https://github.com/h2non/imaginary) **star:3789** 用于图像大小调整的快速、简单的HTTP微服务。   [![star > 2000][Awesome]](https://github.com/h2non/imaginary)   [![godoc][GoDoc]](https://godoc.org/github.com/h2non/imaginary)
* [bild](https://github.com/anthonynsimon/bild) **star:3284** 纯Go语言实现的图像处理算法合集。   [![star > 2000][Awesome]](https://github.com/anthonynsimon/bild)   [![godoc][GoDoc]](https://godoc.org/github.com/anthonynsimon/bild)
* [gg](https://github.com/fogleman/gg) **star:2982** 纯Go语言实现的2D渲染。   [![star > 2000][Awesome]](https://github.com/fogleman/gg)   [![godoc][GoDoc]](https://godoc.org/github.com/fogleman/gg)
* [ln](https://github.com/fogleman/ln) **star:2941** Go实现的3D线艺术（3D Line Art）渲染。   [![star > 2000][Awesome]](https://github.com/fogleman/ln)   [![最近一年没有更新][Yellow]](https://github.com/fogleman/ln)   [![godoc][GoDoc]](https://godoc.org/github.com/fogleman/ln)
* [resize](https://github.com/nfnt/resize) **star:2697** Go实现的使用常用的插值法（interpolation methods）调整图像大小的库。   [![star > 2000][Awesome]](https://github.com/nfnt/resize)   [![godoc][GoDoc]](https://godoc.org/github.com/nfnt/resize)
* [pt](https://github.com/fogleman/pt) **star:1960** Go实现的路径跟踪（path tracing）引擎。   [![最近一年没有更新][Yellow]](https://github.com/fogleman/pt)   [![godoc][GoDoc]](https://godoc.org/github.com/fogleman/pt)
* [svgo](https://github.com/ajstarks/svgo) **star:1701**  Go实现的SVG生成库。   [![godoc][GoDoc]](https://godoc.org/github.com/ajstarks/svgo)
* [smartcrop](https://github.com/muesli/smartcrop) **star:1532** 为任意图片寻找合适的位置进行图片裁剪。   [![godoc][GoDoc]](https://godoc.org/github.com/muesli/smartcrop)
* [bimg](https://github.com/h2non/bimg) **star:1530** 使用libvips实现的快速高效的图像处理包。   [![godoc][GoDoc]](https://godoc.org/github.com/h2non/bimg)
* [picfit](https://github.com/thoas/picfit) **star:1511** Go实现的图像调整服务器。   [![godoc][GoDoc]](https://godoc.org/github.com/thoas/picfit)
* [gift](https://github.com/disintegration/gift) **star:1460** 图像处理包。   [![godoc][GoDoc]](https://godoc.org/github.com/disintegration/gift)
* [imagick](https://github.com/gographics/imagick) **star:1344**  ImageMagick下MagickWand的C API的Go binding。   [![godoc][GoDoc]](https://godoc.org/github.com/gographics/imagick)
* [go-opencv](https://github.com/lazywei/go-opencv) **star:1246** OpenCV库的Go bindings。   [![最近一年没有更新][Yellow]](https://github.com/lazywei/go-opencv)   [![godoc][GoDoc]](https://godoc.org/github.com/lazywei/go-opencv)
* [geopattern](https://github.com/pravj/geopattern) **star:1130** 由字符串创建漂亮图案的图片生成器。   [![最近一年没有更新][Yellow]](https://github.com/pravj/geopattern)   [![godoc][GoDoc]](https://godoc.org/github.com/pravj/geopattern)
* [stegify](https://github.com/DimitarPetrov/stegify) **star:940**  Go实现的LSB隐写（LSB steganography），能够隐藏任何文件到一个图像中。   [![最近一年没有更新][Yellow]](https://github.com/DimitarPetrov/stegify)   [![godoc][GoDoc]](https://godoc.org/github.com/DimitarPetrov/stegify)
* [canvas](https://github.com/tdewolff/canvas) **star:773** 矢量图形到PDF, SVG或光栅图像。   [![最近一周有更新][Green]](https://github.com/tdewolff/canvas)   [![godoc][GoDoc]](https://godoc.org/github.com/tdewolff/canvas)
* [image2ascii](https://github.com/qeesung/image2ascii) **star:568** 将图像转换为ASCII码。   [![godoc][GoDoc]](https://godoc.org/github.com/qeesung/image2ascii)
* [draft](https://github.com/lucasepe/draft) **star:498** 使用简单的YAML语法为GraphViz生成高级微服务架构图。   [![godoc][GoDoc]](https://godoc.org/github.com/lucasepe/draft)
* [govips](https://github.com/davidbyttow/govips) **star:497** 闪电快速的图像处理和调整库的Go。   [![godoc][GoDoc]](https://godoc.org/github.com/davidbyttow/govips)
* [govatar](https://github.com/o1egl/govatar) **star:452** 生成有趣头像的库和CMD工具。   [![godoc][GoDoc]](https://godoc.org/github.com/o1egl/govatar)
* [mort](https://github.com/aldor007/mort) **star:437** Go语言实现的图像存储和处理服务器。   [![最近一周有更新][Green]](https://github.com/aldor007/mort)   [![godoc][GoDoc]](https://godoc.org/github.com/aldor007/mort)
* [goimagehash](https://github.com/corona10/goimagehash) **star:424**  图像哈希处理的Go语言包。   [![godoc][GoDoc]](https://godoc.org/github.com/corona10/goimagehash)
* [go-nude](https://github.com/koyachi/go-nude) **star:334** Go语言实现的裸照检测工具。   [![最近一年没有更新][Yellow]](https://github.com/koyachi/go-nude)   [![godoc][GoDoc]](https://godoc.org/github.com/koyachi/go-nude)
* [rez](https://github.com/bamiaux/rez) **star:200** 纯Go语言和SIMD实现的图像大小调整。   [![最近一年没有更新][Yellow]](https://github.com/bamiaux/rez)   [![godoc][GoDoc]](https://godoc.org/github.com/bamiaux/rez)
* [darkroom](https://github.com/gojek/darkroom) **star:169** An image proxy with changeable storage backends and image processing engines with focus on speed and resiliency.   [![godoc][GoDoc]](https://godoc.org/github.com/gojek/darkroom)
* [mergi](https://github.com/noelyahan/mergi) **star:146** 用于图像处理(合并、裁剪、调整大小、水印、动画)的工具和Go库。   [![最近一年没有更新][Yellow]](https://github.com/noelyahan/mergi)   [![godoc][GoDoc]](https://godoc.org/github.com/noelyahan/mergi)
* [img](https://github.com/hawx/img) **star:138** 图像处理工具的集合。   [![最近一年没有更新][Yellow]](https://github.com/hawx/img)   [![godoc][GoDoc]](https://godoc.org/github.com/hawx/img)
* [gltf](https://github.com/qmuntal/gltf) **star:115** 一个高效、健壮的glTF 2.0文件读取、写入和验证器。   [![godoc][GoDoc]](https://godoc.org/github.com/qmuntal/gltf)
* [go-cairo](https://github.com/ungerik/go-cairo) **star:110**  cairo图形库的Go binding。   [![godoc][GoDoc]](https://godoc.org/github.com/ungerik/go-cairo)
* [steganography](https://github.com/auyer/steganography) **star:110** 纯Go实现的LSB隐写（LSB steganography）的库。   [![godoc][GoDoc]](https://godoc.org/github.com/auyer/steganography)
* [cameron](https://github.com/aofei/cameron) **star:69** 一个Go语言的头像生成器。   [![godoc][GoDoc]](https://godoc.org/github.com/aofei/cameron)
* [go-gd](https://github.com/bolknote/go-gd) **star:53**  GD库的Go binding。   [![最近一年没有更新][Yellow]](https://github.com/bolknote/go-gd)   [![godoc][GoDoc]](https://godoc.org/github.com/bolknote/go-gd)
* [gridder](https://github.com/shomali11/gridder) **star:43** 一个基于网格的2D图形库。   [![最近一年没有更新][Yellow]](https://github.com/shomali11/gridder)   [![godoc][GoDoc]](https://godoc.org/github.com/shomali11/gridder)
* [goimghdr](https://github.com/corona10/goimghdr) **star:36** Go语言实现的imghdr模块用于确定文件的图像类型。   [![最近一年没有更新][Yellow]](https://github.com/corona10/goimghdr)   [![godoc][GoDoc]](https://godoc.org/github.com/corona10/goimghdr)
* [tga](https://github.com/ftrvxmtrx/tga) **star:28** tga包是一个TARGA图像的解码、编码器。   [![最近一年没有更新][Yellow]](https://github.com/ftrvxmtrx/tga)   [![godoc][GoDoc]](https://godoc.org/github.com/ftrvxmtrx/tga)   [![归档项目][Archived]](https://github.com/ftrvxmtrx/tga)
* [go-webcolors](https://github.com/jyotiska/go-webcolors) **star:25** Python下webcolors库的Go语言调用。   [![最近一年没有更新][Yellow]](https://github.com/jyotiska/go-webcolors)   [![godoc][GoDoc]](https://godoc.org/github.com/jyotiska/go-webcolors)
* [webp-server](https://github.com/mehdipourfar/webp-server) **star:24** 能够存储、调整大小、转换和缓存图像的简单和最小的图像服务器。   [![godoc][GoDoc]](https://godoc.org/github.com/mehdipourfar/webp-server)
* [mpo](https://github.com/donatj/mpo) **star:7** MPO三维照片的解码和转换工具。   [![最近一年没有更新][Yellow]](https://github.com/donatj/mpo)   [![godoc][GoDoc]](https://godoc.org/github.com/donatj/mpo)

## 物联网

*物联网设备编程库。 (翻译出错了? 试试 [英文版](README_EN.md#iot-(internet-of-things)) 吧~)*

* [flogo](https://github.com/tibcosoftware/flogo) **star:1827** Flogo是一个面向物联网边缘应用和集成的开源框架。
* [mainflux](https://github.com/Mainflux/mainflux) **star:1515** 工业物联网消息和设备管理服务器。   [![最近一周有更新][Green]](https://github.com/Mainflux/mainflux)   [![godoc][GoDoc]](https://godoc.org/github.com/Mainflux/mainflux)
* [periph](https://periph.io/)  外围设备I/O与低级板(low-level board)设备接口。
* [gatt](https://github.com/paypal/gatt) **star:984** Gatt是一个用于构建低能耗蓝牙外围设备的Go语言包。   [![最近一年没有更新][Yellow]](https://github.com/paypal/gatt)   [![godoc][GoDoc]](https://godoc.org/github.com/paypal/gatt)
* [gobot](https://github.com/hybridgroup/gobot/)  Gobot是一个用于机器人、物理计算和物联网的框架。
* [connectordb](https://github.com/connectordb/connectordb) **star:283** 自我量化和物联网的开源平台。   [![godoc][GoDoc]](https://godoc.org/github.com/connectordb/connectordb)
* [devices](https://github.com/goiot/devices) **star:242** 一套用于物联网设备的库，实验性地用于x/exp/io。   [![最近一年没有更新][Yellow]](https://github.com/goiot/devices)   [![godoc][GoDoc]](https://godoc.org/github.com/goiot/devices)
* [sensorbee](https://github.com/sensorbee/sensorbee) **star:205** 轻量级物联网流处理引擎。   [![最近一年没有更新][Yellow]](https://github.com/sensorbee/sensorbee)   [![godoc][GoDoc]](https://godoc.org/github.com/sensorbee/sensorbee)
* [huego](https://github.com/amimof/huego) **star:187** 一个包含广泛的Philips Hue客户端的Go语言库。   [![godoc][GoDoc]](https://godoc.org/github.com/amimof/huego)
* [iot](https://github.com/vaelen/iot/)  IoT是一个实现谷歌物联网核心设备的简单框架。
* [eywa](https://github.com/xcodersun/eywa) **star:49** Eywa是一个用于跟踪连接的设备连接管理器。   [![最近一年没有更新][Yellow]](https://github.com/xcodersun/eywa)   [![godoc][GoDoc]](https://godoc.org/github.com/xcodersun/eywa)

## 作业调度器

*用于作业调度的库。 (翻译出错了? 试试 [英文版](README_EN.md#job-scheduler) 吧~)*

* [gocron](https://github.com/go-co-op/gocron) **star:1040** 熟练掌握Go工作调度。这是一个积极维护的分叉[jasonlvhit/gocron](https://github.com/jasonlvhit/gocron)。   [![最近一周有更新][Green]](https://github.com/go-co-op/gocron)   [![godoc][GoDoc]](https://godoc.org/github.com/go-co-op/gocron)
* [JobRunner](https://github.com/bamzi/jobrunner) **star:871** 智能和功能丰富的cron作业调度程序（包含任务队列和实时监控）。   [![godoc][GoDoc]](https://godoc.org/github.com/bamzi/jobrunner)
* [gron](https://github.com/roylee0704/gron) **star:870** 使用简单的Go API定义基于时间的任务。 之后Gron的调度程序将运行它们。   [![godoc][GoDoc]](https://godoc.org/github.com/roylee0704/gron)
* [jobs](https://github.com/albrow/jobs) **star:482** 持久和灵活的后台作业库。   [![最近一年没有更新][Yellow]](https://github.com/albrow/jobs)   [![godoc][GoDoc]](https://godoc.org/github.com/albrow/jobs)
* [scheduler](https://github.com/carlescere/scheduler) **star:369** Cronjobs让调度变得很简单。   [![godoc][GoDoc]](https://godoc.org/github.com/carlescere/scheduler)
* [clockwerk](http://github.com/onatm/clockwerk)  使用简单、流畅的语法调度作业的Go语言库。
* [go-cron](https://github.com/rk/go-cron) **star:204** 一个Go实现的简单的定时任务库。可以在不同的时间间隔（每秒一次到在每年在特定的日期执行）执行闭包或函数。主要用于web应用和长时间运行的守护进程。   [![最近一年没有更新][Yellow]](https://github.com/rk/go-cron)   [![godoc][GoDoc]](https://godoc.org/github.com/rk/go-cron)
* [go-quartz](https://github.com/reugn/go-quartz) **star:147** 简单的，无依赖的Go调度库。   [![godoc][GoDoc]](https://godoc.org/github.com/reugn/go-quartz)
* [leprechaun](https://github.com/kilgaloon/leprechaun) **star:83** 支持webhook、crons和经典调度的作业调度程序。   [![godoc][GoDoc]](https://godoc.org/github.com/kilgaloon/leprechaun)
* [tasks](https://github.com/madflojo/tasks) **star:53** 一个易于使用的进程内调度器，用于Go中的重复任务。   [![godoc][GoDoc]](https://godoc.org/github.com/madflojo/tasks)
* [cronticker](https://github.com/krayzpipes/cronticker) **star:1** 支持cron调度的一个自动报价器实现。   [![godoc][GoDoc]](https://godoc.org/github.com/krayzpipes/cronticker)

## JSON

*用于JSON处理的库。 (翻译出错了? 试试 [英文版](README_EN.md#json) 吧~)*

* [GJSON](https://github.com/tidwall/gjson) **star:8803** 使用一行代码获取JSON的值。   [![star > 2000][Awesome]](https://github.com/tidwall/gjson)   [![godoc][GoDoc]](https://godoc.org/github.com/tidwall/gjson)
* [gojson](https://github.com/ChimeraCoder/gojson) **star:2391** 从JSON自动生成Go的结构（struct）定义。   [![star > 2000][Awesome]](https://github.com/ChimeraCoder/gojson)   [![godoc][GoDoc]](https://godoc.org/github.com/ChimeraCoder/gojson)
* [fastjson](https://github.com/valyala/fastjson) **star:1292** 用于Go的快速JSON解析器和验证器。没有自定义结构，没有代码生成，没有反射。   [![godoc][GoDoc]](https://godoc.org/github.com/valyala/fastjson)
* [kazaam](https://github.com/Qntfy/kazaam) **star:203** 用于任意JSON文档转换的API。   [![godoc][GoDoc]](https://godoc.org/github.com/Qntfy/kazaam)
* [gojq](https://github.com/elgs/gojq) **star:173** Go语言实现的JSON请求。   [![godoc][GoDoc]](https://godoc.org/github.com/elgs/gojq)
* [jsondiff](https://github.com/wI2L/jsondiff) **star:125** Go的JSON diff库基于RFC6902 (JSON Patch)。   [![godoc][GoDoc]](https://godoc.org/github.com/wI2L/jsondiff)
* [jettison](https://github.com/wI2L/jettison) **star:111** Go的快速灵活的JSON编码器。   [![godoc][GoDoc]](https://godoc.org/github.com/wI2L/jettison)
* [JSON-to-Go](https://mholt.github.io/json-to-go/)  将JSON转换为Go的结构（struct）。
* [JSON-to-Proto](https://json-to-proto.github.io/)  转换JSON到Protobuf在线。
* [jsongo](https://github.com/ricardolonga/jsongo) **star:96** 使用Fluent API来更容易地创建Json对象。   [![最近一年没有更新][Yellow]](https://github.com/ricardolonga/jsongo)   [![godoc][GoDoc]](https://godoc.org/github.com/ricardolonga/jsongo)
* [gjo](https://github.com/skanehira/gjo) **star:94** 用于创建JSON对象的小工具。   [![godoc][GoDoc]](https://godoc.org/github.com/skanehira/gjo)
* [JayDiff](https://github.com/yazgazan/jaydiff) **star:85** 用Go编写的JSON比对工具。   [![godoc][GoDoc]](https://godoc.org/github.com/yazgazan/jaydiff)
* [json2go](https://github.com/m-zajac/json2go) **star:83** 高级JSON去结构转换。提供一个包，该包可以解析多个JSON文档并创建结构体以适应所有这些文档。   [![godoc][GoDoc]](https://godoc.org/github.com/m-zajac/json2go)
* [ajson](https://github.com/spyzhov/ajson) **star:66** 为Go语言开发的包含JSONPath支持的抽象JSON。   [![最近一年没有更新][Yellow]](https://github.com/spyzhov/ajson)   [![godoc][GoDoc]](https://godoc.org/github.com/spyzhov/ajson)
* [jsonf](https://github.com/miolini/jsonf) **star:62** 用于高亮展示和查询JSON的控制台工具。   [![godoc][GoDoc]](https://godoc.org/github.com/miolini/jsonf)
* [ujson](https://github.com/olvrng/ujson) **star:48** 快速和最小的JSON解析器和转换器，工作在非结构化JSON。   [![godoc][GoDoc]](https://godoc.org/github.com/olvrng/ujson)
* [mp](https://github.com/sanbornm/mp) **star:44** 简单的cli电子邮件解析器。它目前接受stdin并输出JSON。   [![最近一年没有更新][Yellow]](https://github.com/sanbornm/mp)   [![godoc][GoDoc]](https://godoc.org/github.com/sanbornm/mp)
* [go-respond](https://github.com/nicklaw5/go-respond) **star:41** 用于处理常见的HTTP JSON响应的Go语言库。   [![godoc][GoDoc]](https://godoc.org/github.com/nicklaw5/go-respond)
* [vjson](https://github.com/miladibra10/vjson) **star:17** 用流畅API声明JSON模式来验证JSON对象的Go包。   [![godoc][GoDoc]](https://godoc.org/github.com/miladibra10/vjson)
* [go-jsonerror](https://github.com/ddymko/go-jsonerror) **star:10** Go-JsonError允许我们轻松创建符合JsonApi规范的json响应错误。   [![最近一年没有更新][Yellow]](https://github.com/ddymko/go-jsonerror)   [![godoc][GoDoc]](https://godoc.org/github.com/ddymko/go-jsonerror)
* [jsonapi-errors](https://github.com/AmuzaTkts/jsonapi-errors) **star:9** 基于JSON API错误引用的Go bindings。   [![最近一年没有更新][Yellow]](https://github.com/AmuzaTkts/jsonapi-errors)   [![godoc][GoDoc]](https://godoc.org/github.com/AmuzaTkts/jsonapi-errors)
* [jsonhal](https://github.com/RichardKnop/jsonhal) **star:9** 让自定义结构（struct）转化为JSON兼容的HAL（Hypertext Application Language）返回数据的简单Go包。   [![最近一年没有更新][Yellow]](https://github.com/RichardKnop/jsonhal)   [![godoc][GoDoc]](https://godoc.org/github.com/RichardKnop/jsonhal)
* [ask](https://github.com/simonnilsson/ask) **star:7** 容易访问映射和片中的嵌套值。与encoding/json和其他将任意数据“解编组”为Go数据类型的包一起工作。   [![godoc][GoDoc]](https://godoc.org/github.com/simonnilsson/ask)
* [dynjson](https://github.com/cocoonspace/dynjson) **star:7** 用于动态api的可定制的JSON格式。   [![godoc][GoDoc]](https://godoc.org/github.com/cocoonspace/dynjson)
* [ej](https://github.com/lucassscaravelli/ej) **star:7** 简洁地编写和读取来自不同来源的JSON。   [![最近一年没有更新][Yellow]](https://github.com/lucassscaravelli/ej)   [![godoc][GoDoc]](https://godoc.org/github.com/lucassscaravelli/ej)
* [epoch](https://github.com/vtopc/epoch) **star:6** 包含用于封送/解封送Unix时间戳/纪元到内建时间的原语。时间类型为JSON。   [![godoc][GoDoc]](https://godoc.org/github.com/vtopc/epoch)
* [mapslice-json](https://github.com/mickep76/mapslice-json) **star:5** 去MapSlice的有序封送/解封的JSON地图。   [![godoc][GoDoc]](https://godoc.org/github.com/mickep76/mapslice-json)
* [jzon](https://github.com/zerosnake0/jzon) **star:4** 具有标准兼容API/行为的JSON库。   [![godoc][GoDoc]](https://godoc.org/github.com/zerosnake0/jzon)
* [jsonic](https://github.com/sinhashubham95/jsonic) **star:3** 处理和查询JSON的实用程序，无需以类型安全的方式定义结构。   [![godoc][GoDoc]](https://godoc.org/github.com/sinhashubham95/jsonic)
* [omg.jsonparser](https://github.com/dedalqq/omg.jsonparser) **star:1** 简单的JSON解析器，通过golang结构字段标签进行条件验证。   [![最近一周有更新][Green]](https://github.com/dedalqq/omg.jsonparser)   [![godoc][GoDoc]](https://godoc.org/github.com/dedalqq/omg.jsonparser)

## 日志记录

*用于生成和处理日志文件的库。 (翻译出错了? 试试 [英文版](README_EN.md#logging) 吧~)*

* [logrus](https://github.com/Sirupsen/logrus) **star:18499** Go的结构化日志操作 。   [![star > 2000][Awesome]](https://github.com/Sirupsen/logrus)   [![godoc][GoDoc]](https://godoc.org/github.com/Sirupsen/logrus)
* [zap](https://github.com/uber-go/zap) **star:13391** 快速、结构化、多等级的日志记录。   [![star > 2000][Awesome]](https://github.com/uber-go/zap)   [![最近一周有更新][Green]](https://github.com/uber-go/zap)   [![godoc][GoDoc]](https://godoc.org/github.com/uber-go/zap)
* [zerolog](https://github.com/rs/zerolog) **star:5119** Zero-allocation JSON日志记录。   [![star > 2000][Awesome]](https://github.com/rs/zerolog)   [![最近一周有更新][Green]](https://github.com/rs/zerolog)   [![godoc][GoDoc]](https://godoc.org/github.com/rs/zerolog)
* [spew](https://github.com/davecgh/go-spew) **star:4556** 为Go数据结构实现一个漂亮的printer用于帮助调试。   [![star > 2000][Awesome]](https://github.com/davecgh/go-spew)   [![godoc][GoDoc]](https://godoc.org/github.com/davecgh/go-spew)
* [glog](https://github.com/golang/glog) **star:2780** 为Go提供了多等级日志记录。   [![star > 2000][Awesome]](https://github.com/golang/glog)   [![最近一周有更新][Green]](https://github.com/golang/glog)   [![godoc][GoDoc]](https://godoc.org/github.com/golang/glog)
* [lumberjack](https://github.com/natefinch/lumberjack) **star:2717** 简单的滚动日志，io.WriteCloser的实现。   [![star > 2000][Awesome]](https://github.com/natefinch/lumberjack)   [![godoc][GoDoc]](https://godoc.org/github.com/natefinch/lumberjack)
* [tail](https://github.com/hpcloud/tail) **star:2150** 努力模拟实现BSD的tail的特性的Go包。   [![star > 2000][Awesome]](https://github.com/hpcloud/tail)   [![godoc][GoDoc]](https://godoc.org/github.com/hpcloud/tail)
* [seelog](https://github.com/cihub/seelog) **star:1558** 具有灵活调度、过滤和格式化的日志功能。   [![最近一年没有更新][Yellow]](https://github.com/cihub/seelog)   [![godoc][GoDoc]](https://godoc.org/github.com/cihub/seelog)
* [log](https://github.com/apex/log) **star:1159** Go的结构化日志包。   [![godoc][GoDoc]](https://godoc.org/github.com/apex/log)
* [log15](https://github.com/inconshreveable/log15) **star:1015** 简单、强大的日志操作。   [![godoc][GoDoc]](https://godoc.org/github.com/inconshreveable/log15)
* [onelog](https://github.com/francoispqt/onelog) **star:397** Onelog是一个非常简单但非常高效的JSON日志记录器。它是所有场景中最快的JSON记录器。而且，它是配置最低的记录器之一。   [![最近一年没有更新][Yellow]](https://github.com/francoispqt/onelog)   [![godoc][GoDoc]](https://godoc.org/github.com/francoispqt/onelog)
* [phuslu/log](https://github.com/phuslu/log) **star:391** 简化了结构化日志记录。   [![godoc][GoDoc]](https://godoc.org/github.com/phuslu/log)
* [logxi](https://github.com/mgutz/logxi) **star:347** 12-factor app的日志程序，快速且让人高兴地使用。   [![最近一年没有更新][Yellow]](https://github.com/mgutz/logxi)   [![godoc][GoDoc]](https://godoc.org/github.com/mgutz/logxi)
* [logutils](https://github.com/hashicorp/logutils) **star:295** Go的用于更好地进行日志操作的实用程序，继承了标准日志库。   [![最近一年没有更新][Yellow]](https://github.com/hashicorp/logutils)   [![godoc][GoDoc]](https://godoc.org/github.com/hashicorp/logutils)
* [log](https://github.com/go-playground/log) **star:275** Go的简单、可配置和可伸缩的结构化日志。   [![最近一年没有更新][Yellow]](https://github.com/go-playground/log)   [![godoc][GoDoc]](https://godoc.org/github.com/go-playground/log)
* [go-logger](https://github.com/apsdehal/go-logger) **star:267** 简单的日志程序的 Go 程序，与级别处理程序。   [![最近一年没有更新][Yellow]](https://github.com/apsdehal/go-logger)   [![godoc][GoDoc]](https://godoc.org/github.com/apsdehal/go-logger)
* [httpretty](https://github.com/henvic/httpretty) **star:234** 在终端上美化您的常规HTTP请求以便调试(类似于HTTP . dumprequest)。   [![godoc][GoDoc]](https://godoc.org/github.com/henvic/httpretty)
* [sqldb-logger](https://github.com/simukti/sqldb-logger) **star:185** 一个日志程序，用于不修改现有的* SQL . db stdlib用法的Go SQL数据库驱动程序。   [![godoc][GoDoc]](https://godoc.org/github.com/simukti/sqldb-logger)
* [rollingwriter](https://github.com/arthurkiller/rollingWriter) **star:177** RollingWriter是一个自动循环的io.Writer的实现,带有多种策略以提供日志文件循环(rotation)。   [![godoc][GoDoc]](https://godoc.org/github.com/arthurkiller/rollingWriter)
* [logger](https://github.com/azer/logger) **star:148** Go的精简日志库。   [![godoc][GoDoc]](https://godoc.org/github.com/azer/logger)
* [xlog](https://github.com/rs/xlog) **star:136** 针对'net/context`实现的结构化的记录器，用于HTTP处理程序。   [![godoc][GoDoc]](https://godoc.org/github.com/rs/xlog)
* [yell](https://github.com/jfcg/yell)  这是另一个极简的日志库。
* [logur](https://github.com/logur/logur) **star:135** 一个固执的logger接口，集合了著名库的适配器和集成的日志最佳实践([logrus](https://github.com/sirupsen/logrus)， [go-kit log](https://github.com/go-kit/kit/tree/master/log)， [zap](https://github.com/ugo/zap)， [zerolog](https://github.com/rs/zerolog)，等等)。   [![godoc][GoDoc]](https://godoc.org/github.com/logur/logur)
* [glg](https://github.com/kpango/glg) **star:118** glg是一个简单而快速的Go日志库。   [![godoc][GoDoc]](https://godoc.org/github.com/kpango/glg)
* [ozzo-log](https://github.com/go-ozzo/ozzo-log) **star:114** 支持日志多等级、分类和过滤的高性能日志记录。可以发送过滤后的日志消息到各种目标(如控制台，网络，邮件)。   [![godoc][GoDoc]](https://godoc.org/github.com/go-ozzo/ozzo-log)   [![包含中文文档][CN]](https://github.com/go-ozzo/ozzo-log)
* [log-voyage](https://github.com/firstrow/logvoyage) **star:88** 用Go编写的功能齐全的日志写入saas。   [![最近一年没有更新][Yellow]](https://github.com/firstrow/logvoyage)   [![godoc][GoDoc]](https://godoc.org/github.com/firstrow/logvoyage)
* [stdlog](https://github.com/alexcesaro/log) **star:45** Stdlog是一个面向对象的库，提供了多等级日志记录。它对cron任务非常有用。   [![最近一年没有更新][Yellow]](https://github.com/alexcesaro/log)   [![godoc][GoDoc]](https://godoc.org/github.com/alexcesaro/log)
* [go-cronowriter](https://github.com/utahta/go-cronowriter) **star:42** 基于当前日期和时间的自动日志文件写入工具，类似cronolog。   [![godoc][GoDoc]](https://godoc.org/github.com/utahta/go-cronowriter)
* [gologger](https://github.com/sadlil/gologger) **star:39** 为Go提供方便简单的日志操作; 在彩色控制台，简单控制台，文件或Elasticsearch上。   [![最近一年没有更新][Yellow]](https://github.com/sadlil/gologger)   [![godoc][GoDoc]](https://godoc.org/github.com/sadlil/gologger)   [![归档项目][Archived]](https://github.com/sadlil/gologger)
* [logex](https://github.com/chzyer/logex) **star:38** 由标准日志库封装的Go日志库，支持跟踪和多等级。   [![最近一年没有更新][Yellow]](https://github.com/chzyer/logex)   [![godoc][GoDoc]](https://godoc.org/github.com/chzyer/logex)
* [go-log](https://github.com/ian-kent/go-log) **star:37** Log4j的Go语言。   [![最近一年没有更新][Yellow]](https://github.com/ian-kent/go-log)   [![godoc][GoDoc]](https://godoc.org/github.com/ian-kent/go-log)
* [go-log](https://github.com/siddontang/go-log) **star:28** 支持多等级和多处理程序的日志库。   [![最近一年没有更新][Yellow]](https://github.com/siddontang/go-log)   [![godoc][GoDoc]](https://godoc.org/github.com/siddontang/go-log)
* [journald](https://github.com/ssgreg/journald) **star:27**  Go实现systemd Journal的原生API用于日志记录。   [![godoc][GoDoc]](https://godoc.org/github.com/ssgreg/journald)
* [logrusly](https://github.com/sebest/logrusly) **star:27** [logrus](https://github.com/sirupsen/logrus)的插件，将错误信息发送到[Loggly](https://www.loggly.com/)。   [![godoc][GoDoc]](https://godoc.org/github.com/sebest/logrusly)
* [distillog](https://github.com/amoghe/distillog) **star:26** distilled日志记录(可以将其视为stdlib +日志)。   [![最近一年没有更新][Yellow]](https://github.com/amoghe/distillog)   [![godoc][GoDoc]](https://godoc.org/github.com/amoghe/distillog)
* [log](https://github.com/teris-io/log) **star:24** Go的结构化日志接口，清晰地将日志facade与其实现(implementation)分离开来。   [![最近一年没有更新][Yellow]](https://github.com/teris-io/log)   [![godoc][GoDoc]](https://godoc.org/github.com/teris-io/log)
* [mlog](https://github.com/jbrodriguez/mlog) **star:24** 简单的go日志模块，有5个级别，可选循环(rotation)日志文件记录功能和stdout/stderr输出。   [![最近一年没有更新][Yellow]](https://github.com/jbrodriguez/mlog)   [![godoc][GoDoc]](https://godoc.org/github.com/jbrodriguez/mlog)
* [gomol](https://github.com/aphistic/gomol) **star:17** 为Go实现可多方式输出、结构化日志, 并可扩展日志输出方式。   [![最近一年没有更新][Yellow]](https://github.com/aphistic/gomol)   [![godoc][GoDoc]](https://godoc.org/github.com/aphistic/gomol)
* [gone/log](https://github.com/One-com/gone/tree/master/log)  快速、可扩展、功能齐全、std-lib源兼容的日志库。
* [zkits-logger](https://github.com/edoger/zkits-logger) **star:15** 一个强大的零依赖JSON记录器。   [![godoc][GoDoc]](https://godoc.org/github.com/edoger/zkits-logger)
* [glo](https://github.com/lajosbencz/glo) **star:14** 参照PHP的Monolog实现的具有相同日志等级的Go日志库。   [![最近一年没有更新][Yellow]](https://github.com/lajosbencz/glo)   [![godoc][GoDoc]](https://godoc.org/github.com/lajosbencz/glo)
* [logrusiowriter](https://github.com/cabify/logrusiowriter) **star:12** io。作者的实现使用[logrus](https://github.com/sirupsen/logrus) logger。   [![最近一年没有更新][Yellow]](https://github.com/cabify/logrusiowriter)   [![godoc][GoDoc]](https://godoc.org/github.com/cabify/logrusiowriter)
* [go-log](https://github.com/subchen/go-log) **star:11** Go实现的简单且可配置的日志工具，并带有多等级、日志格式化和日志写入工具。   [![最近一年没有更新][Yellow]](https://github.com/subchen/go-log)   [![godoc][GoDoc]](https://godoc.org/github.com/subchen/go-log)
* [logmatic](https://github.com/borderstech/logmatic) **star:10** Go的彩色日志记录器，带有可配置的日志级别。   [![godoc][GoDoc]](https://godoc.org/github.com/borderstech/logmatic)
* [logdump](https://github.com/ewwwwwqm/logdump) **star:9** 用于多等级级日志记录的包。   [![最近一年没有更新][Yellow]](https://github.com/ewwwwwqm/logdump)   [![godoc][GoDoc]](https://godoc.org/github.com/ewwwwwqm/logdump)
* [logo](https://github.com/mbndr/logo) **star:9** Go的日志工具，可配置的日志写入器。   [![godoc][GoDoc]](https://godoc.org/github.com/mbndr/logo)
* [go-log](https://github.com/pieterclaerhout/go-log) **star:8** 具有strack跟踪、对象转储和可选时间戳的日志记录库。   [![最近一年没有更新][Yellow]](https://github.com/pieterclaerhout/go-log)   [![godoc][GoDoc]](https://godoc.org/github.com/pieterclaerhout/go-log)
* [log](https://github.com/aerogo/log) **star:8** 一个O(1)日志系统，允许您将一个日志连接到多个日志写入(例如stdout、文件和TCP连接)。   [![最近一年没有更新][Yellow]](https://github.com/aerogo/log)   [![godoc][GoDoc]](https://godoc.org/github.com/aerogo/log)
* [xlog](https://github.com/xfxdev/xlog) **star:6** 插件架构和灵活的日志系统，带有多级别、多日志目标和自定义日志格式。   [![最近一年没有更新][Yellow]](https://github.com/xfxdev/xlog)   [![godoc][GoDoc]](https://godoc.org/github.com/xfxdev/xlog)
* [kemba](https://github.com/clok/kemba) **star:5** 一个小的调试日志工具，灵感来自[debug](https://github.com/visionmedia/debug)，非常适合CLI工具和应用程序。   [![godoc][GoDoc]](https://godoc.org/github.com/clok/kemba)

## 机器学习

*机器学习库。 (翻译出错了? 试试 [英文版](README_EN.md#machine-learning) 吧~)*

* [GoLearn](https://github.com/sjwhitworth/golearn) **star:7973** 通用机器学习库。   [![star > 2000][Awesome]](https://github.com/sjwhitworth/golearn)   [![godoc][GoDoc]](https://godoc.org/github.com/sjwhitworth/golearn)   [![包含中文文档][CN]](https://github.com/sjwhitworth/golearn)
* [gorse](https://github.com/zhenghaoz/gorse) **star:4276** 基于协同过滤的离线推荐系统后端。   [![star > 2000][Awesome]](https://github.com/zhenghaoz/gorse)   [![最近一周有更新][Green]](https://github.com/zhenghaoz/gorse)   [![godoc][GoDoc]](https://godoc.org/github.com/zhenghaoz/gorse)   [![包含中文文档][CN]](https://github.com/zhenghaoz/gorse)
* [gorgonia](https://github.com/gorgonia/gorgonia) **star:4153** 基于图形（graph-based）的计算库，如Theano：它为构建各种机器学习和神经网络算法提供了基本框架。   [![star > 2000][Awesome]](https://github.com/gorgonia/gorgonia)   [![最近一周有更新][Green]](https://github.com/gorgonia/gorgonia)   [![godoc][GoDoc]](https://godoc.org/github.com/gorgonia/gorgonia)
* [tfgo](https://github.com/galeone/tfgo) **star:1761** 易于使用的Tensorflow bindings:简化了官方Tensorflow Go bindings的使用。在Go中定义计算图形，在Python中加载和执行训练的模型。   [![godoc][GoDoc]](https://godoc.org/github.com/galeone/tfgo)
* [gosseract](https://github.com/otiai10/gosseract) **star:1545** 使用c++的Tesseract库实现的OCR。   [![godoc][GoDoc]](https://godoc.org/github.com/otiai10/gosseract)
* [goml](https://github.com/cdipaolo/goml) **star:1212** 在线机器学习。   [![godoc][GoDoc]](https://godoc.org/github.com/cdipaolo/goml)
* [eaopt](https://github.com/MaxHalford/eaopt) **star:741** 一个进化优化（evolutionary optimization）库。   [![godoc][GoDoc]](https://godoc.org/github.com/MaxHalford/eaopt)
* [bayesian](https://github.com/jbrukh/bayesian) **star:712** Go的朴素贝叶斯分类。   [![最近一年没有更新][Yellow]](https://github.com/jbrukh/bayesian)   [![godoc][GoDoc]](https://godoc.org/github.com/jbrukh/bayesian)
* [CloudForest](https://github.com/ryanbressler/CloudForest) **star:689** 快速、灵活、多线程集成的决策树，用于机器学习。   [![godoc][GoDoc]](https://godoc.org/github.com/ryanbressler/CloudForest)
* [gobrain](https://github.com/goml/gobrain) **star:485** 用 Go 编写的神经网络库。   [![godoc][GoDoc]](https://godoc.org/github.com/goml/gobrain)
* [ocrserver](https://github.com/otiai10/ocrserver) **star:394** 一个简单的OCR API服务器，非常容易地使用Docker和Heroku部署。   [![godoc][GoDoc]](https://godoc.org/github.com/otiai10/ocrserver)
* [onnx-go](https://github.com/owulveryck/onnx-go) **star:339** Go Interface， 用于开放式神经网络交换(Open Neural Network Exchange)。   [![godoc][GoDoc]](https://godoc.org/github.com/owulveryck/onnx-go)
* [go-deep](https://github.com/patrikeh/go-deep) **star:324** 一个功能丰富的神经网络库 。   [![godoc][GoDoc]](https://godoc.org/github.com/patrikeh/go-deep)
* [regommend](https://github.com/muesli/regommend) **star:291** 推荐和协同过滤引擎。   [![最近一年没有更新][Yellow]](https://github.com/muesli/regommend)   [![godoc][GoDoc]](https://godoc.org/github.com/muesli/regommend)
* [go-galib](https://github.com/thoj/go-galib) **star:186** 用Go编写的遗传算法库。   [![最近一年没有更新][Yellow]](https://github.com/thoj/go-galib)   [![godoc][GoDoc]](https://godoc.org/github.com/thoj/go-galib)
* [Goptuna](https://github.com/c-bata/goptuna) **star:185** Bayesian optimization framework for black-box functions written in Go. Everything will be optimized.   [![godoc][GoDoc]](https://godoc.org/github.com/c-bata/goptuna)
* [goRecommend](https://github.com/timkaye11/goRecommend) **star:175** 用Go编写的推荐算法库。   [![最近一年没有更新][Yellow]](https://github.com/timkaye11/goRecommend)   [![godoc][GoDoc]](https://godoc.org/github.com/timkaye11/goRecommend)
* [shield](https://github.com/eaigner/shield) **star:142** 贝叶斯文本分类器，具有灵活的tokenizers和存储后端。   [![最近一年没有更新][Yellow]](https://github.com/eaigner/shield)   [![godoc][GoDoc]](https://godoc.org/github.com/eaigner/shield)
* [goga](https://github.com/tomcraven/goga) **star:111** Go的遗传算法库。   [![最近一年没有更新][Yellow]](https://github.com/tomcraven/goga)   [![godoc][GoDoc]](https://godoc.org/github.com/tomcraven/goga)
* [go-fann](https://github.com/white-pony/go-fann) **star:103** 快速人工神经网络(FANN)库的Go bindings。   [![最近一年没有更新][Yellow]](https://github.com/white-pony/go-fann)   [![godoc][GoDoc]](https://godoc.org/github.com/white-pony/go-fann)
* [gonet](https://github.com/dathoangnd/gonet) **star:68** 基于go的神经网络。   [![最近一年没有更新][Yellow]](https://github.com/dathoangnd/gonet)   [![godoc][GoDoc]](https://godoc.org/github.com/dathoangnd/gonet)
* [libsvm](https://github.com/datastream/libsvm) **star:67** 基于LIBSVM 3.14实现。   [![最近一年没有更新][Yellow]](https://github.com/datastream/libsvm)   [![godoc][GoDoc]](https://godoc.org/github.com/datastream/libsvm)
* [goscore](https://github.com/asafschers/goscore) **star:65**  为预言模型标记语言（PMML）实现的评分API。   [![最近一年没有更新][Yellow]](https://github.com/asafschers/goscore)   [![godoc][GoDoc]](https://godoc.org/github.com/asafschers/goscore)
* [neural-go](https://github.com/schuyler/neural-go) **star:61** 多层感知器网络在Go中的实现，使用反向传播算法进行训练。   [![godoc][GoDoc]](https://godoc.org/github.com/schuyler/neural-go)
* [go-featureprocessing](https://github.com/nikolaydubina/go-featureprocessing) **star:59** Go中低延迟机器删除的快速方便的功能处理。   [![godoc][GoDoc]](https://godoc.org/github.com/nikolaydubina/go-featureprocessing)
* [go-pr](https://github.com/daviddengcn/go-pr) **star:59** Go编写的模式识别包。   [![最近一年没有更新][Yellow]](https://github.com/daviddengcn/go-pr)   [![godoc][GoDoc]](https://godoc.org/github.com/daviddengcn/go-pr)
* [neat](https://github.com/jinyeom/neat) **star:58** 即插即用的并行Go框架，用于增强拓扑的神经进化(NeuroEvolution of Augmenting Topologies)。   [![最近一年没有更新][Yellow]](https://github.com/jinyeom/neat)   [![godoc][GoDoc]](https://godoc.org/github.com/jinyeom/neat)   [![归档项目][Archived]](https://github.com/jinyeom/neat)
* [fonet](https://github.com/Fontinalis/fonet) **star:45** 一个用Go编写的深度神经网络库。   [![godoc][GoDoc]](https://godoc.org/github.com/Fontinalis/fonet)
* [golinear](https://github.com/danieldk/golinear) **star:42**  Go实现的liblinear bindings。   [![最近一年没有更新][Yellow]](https://github.com/danieldk/golinear)   [![godoc][GoDoc]](https://godoc.org/github.com/danieldk/golinear)
* [Varis](https://github.com/Xamber/Varis) **star:37** Go实现的神经网络。   [![最近一年没有更新][Yellow]](https://github.com/Xamber/Varis)   [![godoc][GoDoc]](https://godoc.org/github.com/Xamber/Varis)
* [godist](https://github.com/e-dard/godist) **star:29** 各种概率分布，以及相关的method。   [![最近一年没有更新][Yellow]](https://github.com/e-dard/godist)   [![godoc][GoDoc]](https://godoc.org/github.com/e-dard/godist)
* [go-cluster](https://github.com/e-XpertSolutions/go-cluster) **star:27** Go实现的k-modes和k-prototypes聚类算法。   [![最近一年没有更新][Yellow]](https://github.com/e-XpertSolutions/go-cluster)   [![godoc][GoDoc]](https://godoc.org/github.com/e-XpertSolutions/go-cluster)
* [probab](https://github.com/ThePaw/probab) **star:16** 概率分布函数。贝叶斯推理。使用Go写的。   [![最近一年没有更新][Yellow]](https://github.com/ThePaw/probab)   [![godoc][GoDoc]](https://godoc.org/github.com/ThePaw/probab)
* [evoli](https://github.com/khezen/evoli) **star:15** 遗传算法（Genetic Algorithm）和粒子群优化（Particle Swarm Optimization）库。   [![godoc][GoDoc]](https://godoc.org/github.com/khezen/evoli)
* [GoMind](https://github.com/surenderthakran/gomind) **star:15** 一个简单的神经网络库。   [![最近一年没有更新][Yellow]](https://github.com/surenderthakran/gomind)   [![godoc][GoDoc]](https://godoc.org/github.com/surenderthakran/gomind)
* [randomforest](https://github.com/malaschitz/randomForest) **star:13** 容易使用随机森林库去。   [![最近一周有更新][Green]](https://github.com/malaschitz/randomForest)   [![godoc][GoDoc]](https://godoc.org/github.com/malaschitz/randomForest)
* [ddt](https://github.com/sgrodriguez/ddt) **star:12** 动态决策树，创建定义可定制规则的树。   [![godoc][GoDoc]](https://godoc.org/github.com/sgrodriguez/ddt)

## 消息

*实现消息传递系统的库。 (翻译出错了? 试试 [英文版](README_EN.md#messaging) 吧~)*

* [sarama](https://github.com/Shopify/sarama) **star:7553**  Apache Kafka的Go库。   [![star > 2000][Awesome]](https://github.com/Shopify/sarama)   [![godoc][GoDoc]](https://godoc.org/github.com/Shopify/sarama)
* [gorush](https://github.com/appleboy/gorush) **star:5670** 使用[APNs2](https://github.com/sideshow/apns2)和谷歌[GCM](https://github.com/google/go-gcm)推送通知服务器。   [![star > 2000][Awesome]](https://github.com/appleboy/gorush)   [![最近一周有更新][Green]](https://github.com/appleboy/gorush)   [![godoc][GoDoc]](https://godoc.org/github.com/appleboy/gorush)
* [machinery](https://github.com/RichardKnop/machinery) **star:5503** 基于分布式消息传递的异步任务/作业队列。   [![star > 2000][Awesome]](https://github.com/RichardKnop/machinery)   [![godoc][GoDoc]](https://godoc.org/github.com/RichardKnop/machinery)
* [Centrifugo](https://github.com/centrifugal/centrifugo) **star:5198** 实时消息(Websockets或SockJS)服务器。   [![star > 2000][Awesome]](https://github.com/centrifugal/centrifugo)   [![最近一周有更新][Green]](https://github.com/centrifugal/centrifugo)   [![godoc][GoDoc]](https://godoc.org/github.com/centrifugal/centrifugo)
* [go-socket.io](https://github.com/googollee/go-socket.io) **star:4216** go的socket.io库，一个实时应用程序框架。   [![star > 2000][Awesome]](https://github.com/googollee/go-socket.io)   [![最近一周有更新][Green]](https://github.com/googollee/go-socket.io)   [![godoc][GoDoc]](https://godoc.org/github.com/googollee/go-socket.io)
* [NATS Go Client](https://github.com/nats-io/nats) **star:3501** 轻量级和高性能的发布-订阅(publish-subscribe)和分布式队列消息传递系统——这是一个Go库。   [![star > 2000][Awesome]](https://github.com/nats-io/nats)   [![最近一周有更新][Green]](https://github.com/nats-io/nats)   [![godoc][GoDoc]](https://godoc.org/github.com/nats-io/nats)
* [Benthos](https://github.com/Jeffail/benthos) **star:3340** 一系列协议之间的消息流桥接。   [![star > 2000][Awesome]](https://github.com/Jeffail/benthos)   [![最近一周有更新][Green]](https://github.com/Jeffail/benthos)   [![godoc][GoDoc]](https://godoc.org/github.com/Jeffail/benthos)
* [Confluent Kafka Golang Client](https://github.com/confluentinc/confluent-kafka-go) **star:2857** confluent-kafka-go是Confluent为Apache Kafka和Confluent平台开发的Golang客户端。   [![star > 2000][Awesome]](https://github.com/confluentinc/confluent-kafka-go)   [![最近一周有更新][Green]](https://github.com/confluentinc/confluent-kafka-go)   [![godoc][GoDoc]](https://godoc.org/github.com/confluentinc/confluent-kafka-go)
* [APNs2](https://github.com/sideshow/apns2) **star:2540** HTTP / 2苹果消息推送provider——发送推送消息到iOS, tvOS, Safari和OSX应用。   [![star > 2000][Awesome]](https://github.com/sideshow/apns2)   [![最近一周有更新][Green]](https://github.com/sideshow/apns2)   [![godoc][GoDoc]](https://godoc.org/github.com/sideshow/apns2)
* [Mercure](https://github.com/dunglas/mercure) **star:2516** 使用Mercure协议分派服务器发送(server-sent)更新的服务器和库(构建在服务器发送事件之上)。   [![star > 2000][Awesome]](https://github.com/dunglas/mercure)   [![godoc][GoDoc]](https://godoc.org/github.com/dunglas/mercure)
* [melody](https://github.com/olahol/melody) **star:2196** 处理websocket session的极简框架，包括广播和自动ping/pong处理。   [![star > 2000][Awesome]](https://github.com/olahol/melody)   [![godoc][GoDoc]](https://godoc.org/github.com/olahol/melody)
* [gopush-cluster](https://github.com/Terry-Mao/gopush-cluster) **star:2000** gopush-cluster是一个gopush服务器集群。   [![star > 2000][Awesome]](https://github.com/Terry-Mao/gopush-cluster)   [![最近一年没有更新][Yellow]](https://github.com/Terry-Mao/gopush-cluster)   [![godoc][GoDoc]](https://godoc.org/github.com/Terry-Mao/gopush-cluster)   [![包含中文文档][CN]](https://github.com/Terry-Mao/gopush-cluster)
* [go-nsq](https://github.com/nsqio/go-nsq) **star:1969** NSQ的官方Go包。   [![godoc][GoDoc]](https://godoc.org/github.com/nsqio/go-nsq)
* [Asynq](https://github.com/hibiken/asynq) **star:1439** 一个简单、可靠、高效的基于Redis的分布式任务队列。   [![最近一周有更新][Green]](https://github.com/hibiken/asynq)   [![godoc][GoDoc]](https://godoc.org/github.com/hibiken/asynq)
* [Uniqush-Push](https://github.com/uniqush/uniqush-push) **star:1270** Redis支持的统一推送服务, 用于服务端向移动设备的消息通知。   [![最近一年没有更新][Yellow]](https://github.com/uniqush/uniqush-push)   [![godoc][GoDoc]](https://godoc.org/github.com/uniqush/uniqush-push)
* [Beaver](https://github.com/Clivern/Beaver) **star:1117** 一个实时消息服务器，可用于在web和手机app端构建一个可伸缩的应用内通知，多人游戏，聊天应用。   [![godoc][GoDoc]](https://godoc.org/github.com/Clivern/Beaver)
* [EventBus](https://github.com/asaskevich/EventBus) **star:967** 具有异步兼容性的轻量级事件总线。   [![godoc][GoDoc]](https://godoc.org/github.com/asaskevich/EventBus)
* [zmq4](https://github.com/pebbe/zmq4) **star:920** ZeroMQ的Go interface第4版。也可用于[第3版](https://github.com/pebbe/zmq3)和[第2版](https://github.com/pebbe/zmq2)。   [![godoc][GoDoc]](https://godoc.org/github.com/pebbe/zmq4)
* [Gollum](https://github.com/trivago/gollum) **star:903** 一个n:m多路复用器(n:m multiplexer)，收集不同来源的消息并将其广播到一组目的地。   [![godoc][GoDoc]](https://godoc.org/github.com/trivago/gollum)
* [dbus](https://github.com/godbus/dbus) **star:612** D-Bus的Go bindings。   [![godoc][GoDoc]](https://godoc.org/github.com/godbus/dbus)
* [Chanify](https://github.com/chanify/chanify) **star:594** 推送通知服务器向你的iOS设备发送消息。   [![最近一周有更新][Green]](https://github.com/chanify/chanify)   [![godoc][GoDoc]](https://godoc.org/github.com/chanify/chanify)   [![包含中文文档][CN]](https://github.com/chanify/chanify)
* [golongpoll](https://github.com/jcuga/golongpoll) **star:564** HTTP longpoll服务器库，使web发布-订阅变得简单。   [![godoc][GoDoc]](https://godoc.org/github.com/jcuga/golongpoll)
* [mangos](https://github.com/nanomsg/mangos) **star:431** 具有传输互操作性的Nanomsg(“可伸缩性协议”)的纯go实现。   [![godoc][GoDoc]](https://godoc.org/github.com/nanomsg/mangos)
* [emitter](https://github.com/olebedev/emitter) **star:408** 使用Go的方式发出事件, 带有通配符、谓词、取消可能性和许多其他优点。   [![最近一年没有更新][Yellow]](https://github.com/olebedev/emitter)   [![godoc][GoDoc]](https://godoc.org/github.com/olebedev/emitter)
* [Glue](https://github.com/desertbit/glue) **star:383** 健壮的Go和Javascript Socket库(替代Socket.io)。   [![最近一年没有更新][Yellow]](https://github.com/desertbit/glue)   [![godoc][GoDoc]](https://godoc.org/github.com/desertbit/glue)
* [pubsub](https://github.com/tuxychandru/pubsub) **star:356** 简单的pubsub的go包。   [![最近一年没有更新][Yellow]](https://github.com/tuxychandru/pubsub)   [![godoc][GoDoc]](https://godoc.org/github.com/tuxychandru/pubsub)
* [Bus](https://github.com/mustafaturan/bus) **star:218** 内部通信的最小消息总线实现。   [![godoc][GoDoc]](https://godoc.org/github.com/mustafaturan/bus)
* [messagebus](https://github.com/vardius/message-bus) **star:189** messagebus是一个Go的简单异步消息总线，非常适合在执行事件sourcing、CQRS和DDD时用作事件总线。
* [rabtap](https://github.com/jandelgado/rabtap) **star:187** RabbitMQ的瑞士军刀cli应用。   [![最近一周有更新][Green]](https://github.com/jandelgado/rabtap)   [![godoc][GoDoc]](https://godoc.org/github.com/jandelgado/rabtap)
* [guble](https://github.com/smancke/guble) **star:149** 使用推送通知服务(谷歌Firebase云消息、苹果推送通知服务、SMS)的消息服务器, 支持websockets,REST API，并具有分布式操作和消息持久性。   [![最近一年没有更新][Yellow]](https://github.com/smancke/guble)   [![godoc][GoDoc]](https://godoc.org/github.com/smancke/guble)
* [hub](https://github.com/leandro-lugaresi/hub) **star:107** 适用于Go应用程序的消息/事件中心，使用publish/subscribe模式，并支持别名(类似rabbitMQ exchanges)。   [![godoc][GoDoc]](https://godoc.org/github.com/leandro-lugaresi/hub)
* [oplog](https://github.com/dailymotion/oplog) **star:107** 用于REST api的通用oplog/replication系统。   [![最近一年没有更新][Yellow]](https://github.com/dailymotion/oplog)   [![godoc][GoDoc]](https://godoc.org/github.com/dailymotion/oplog)
* [rabbus](https://github.com/rafaeljesus/rabbus) **star:90** amqp exchanges和队列上的一个小工具。   [![最近一年没有更新][Yellow]](https://github.com/rafaeljesus/rabbus)   [![godoc][GoDoc]](https://godoc.org/github.com/rafaeljesus/rabbus)
* [drone-line](https://github.com/appleboy/drone-line) **star:77** 使用二进制、docker或Drone CI发送[Line](https://at.line.me/en)通知。   [![godoc][GoDoc]](https://godoc.org/github.com/appleboy/drone-line)
* [nsq-event-bus](https://github.com/rafaeljesus/nsq-event-bus) **star:68** 一个围绕NSQ topic和channel的小工具。   [![最近一年没有更新][Yellow]](https://github.com/rafaeljesus/nsq-event-bus)   [![godoc][GoDoc]](https://godoc.org/github.com/rafaeljesus/nsq-event-bus)
* [go-mq](https://github.com/cheshir/go-mq) **star:66** 具有声明式配置的RabbitMQ客户端。   [![godoc][GoDoc]](https://godoc.org/github.com/cheshir/go-mq)
* [redisqueue](https://github.com/robinjoseph08/redisqueue) **star:63** 基于Redis streams的队列的生产者和消费者。   [![godoc][GoDoc]](https://godoc.org/github.com/robinjoseph08/redisqueue)
* [RapidMQ](https://github.com/sybrexsys/RapidMQ) **star:62** RapidMQ是用于管理本地消息队列的轻量且可靠的库。   [![最近一年没有更新][Yellow]](https://github.com/sybrexsys/RapidMQ)   [![godoc][GoDoc]](https://godoc.org/github.com/sybrexsys/RapidMQ)
* [Commander](https://github.com/jeroenrinzema/commander) **star:55** 高级事件驱动的消费者/生产者(consumer/producer)，支持各种“方言”，如Apache Kafka。   [![godoc][GoDoc]](https://godoc.org/github.com/jeroenrinzema/commander)
* [go-notify](https://github.com/TheCreeper/go-notify) **star:54** 原生的freedesktop通知规范实现。   [![godoc][GoDoc]](https://godoc.org/github.com/TheCreeper/go-notify)
* [go-res](https://github.com/jirenius/go-res) **star:48** 用于构建REST/实时服务的包，其中客户端使用NATS和Resgate进行无缝同步。   [![godoc][GoDoc]](https://godoc.org/github.com/jirenius/go-res)
* [event](https://github.com/agoalofalife/event) **star:41** 观察者模式的实现。   [![最近一年没有更新][Yellow]](https://github.com/agoalofalife/event)   [![godoc][GoDoc]](https://godoc.org/github.com/agoalofalife/event)
* [hare](https://github.com/leozz37/hare) **star:29** 一个用户友好的库，用于发送消息和监听TCP套接字。   [![最近一周有更新][Green]](https://github.com/leozz37/hare)   [![godoc][GoDoc]](https://godoc.org/github.com/leozz37/hare)
* [ami](https://github.com/kak-tus/ami) **star:21** 基于Redis集群流的客户端到可靠队列。   [![最近一年没有更新][Yellow]](https://github.com/kak-tus/ami)   [![godoc][GoDoc]](https://godoc.org/github.com/kak-tus/ami)
* [gosd](https://github.com/alexsniffin/gosd) **star:18** 一种用于调度何时将消息分派到通道的库。   [![godoc][GoDoc]](https://godoc.org/github.com/alexsniffin/gosd)
* [go-vitotrol](https://github.com/maxatome/go-vitotrol) **star:16** 用于Viessmann Vitotrol web服务的客户端库。   [![godoc][GoDoc]](https://godoc.org/github.com/maxatome/go-vitotrol)
* [rmqconn](https://github.com/sbabiv/rmqconn) **star:15** RabbitMQ重新连接。amqp.Connection和amqp.Dial之上的Wrapper。允许在强制调用Close()方法关闭连接之前重新连接。   [![最近一年没有更新][Yellow]](https://github.com/sbabiv/rmqconn)   [![godoc][GoDoc]](https://godoc.org/github.com/sbabiv/rmqconn)
* [jazz](https://github.com/socifi/jazz) **star:13** 一个简单的RabbitMQ抽象层，用于队列管理和消息的发布和消费。   [![最近一年没有更新][Yellow]](https://github.com/socifi/jazz)   [![godoc][GoDoc]](https://godoc.org/github.com/socifi/jazz)
* [gaurun-client](https://github.com/osamingo/gaurun-client) **star:9** 用Go编写的Gaurun客户端。   [![godoc][GoDoc]](https://godoc.org/github.com/osamingo/gaurun-client)

## 微软办公软件

* [unioffice](https://github.com/unidoc/unioffice) **star:2941** 用于创建和处理Office Word (.docx)、Excel (.xlsx)和Powerpoint (.pptx)文档的纯go库。   [![star > 2000][Awesome]](https://github.com/unidoc/unioffice)   [![godoc][GoDoc]](https://godoc.org/github.com/unidoc/unioffice)

### Microsoft Excel

*用于操作Microsoft Excel的库。 (翻译出错了? 试试 [英文版](README_EN.md#microsoft-excel) 吧~)*

* [excelize](https://github.com/xuri/excelize) **star:9409** Golang图书馆阅读和写作微软Excel&trade;(XLSX)文件。   [![star > 2000][Awesome]](https://github.com/xuri/excelize)   [![最近一周有更新][Green]](https://github.com/xuri/excelize)   [![godoc][GoDoc]](https://godoc.org/github.com/xuri/excelize)
* [xlsx](https://github.com/tealeg/xlsx) **star:5093** 用以简化在Go程序中读取使用最新版本Microsoft Excel的XML格式文件的库。   [![star > 2000][Awesome]](https://github.com/tealeg/xlsx)   [![godoc][GoDoc]](https://godoc.org/github.com/tealeg/xlsx)
* [xlsx](https://github.com/plandem/xlsx) **star:140** 在Go程序以快速和安全的方式读取/更新现有的Microsoft Excel文件。   [![godoc][GoDoc]](https://godoc.org/github.com/plandem/xlsx)
* [go-excel](https://github.com/szyhf/go-excel) **star:129** 一个简单轻便的阅读器，可以将类关系型数据库(relate-db-like)的excel作为表来读取。   [![godoc][GoDoc]](https://godoc.org/github.com/szyhf/go-excel)
* [goxlsxwriter](https://github.com/fterrag/goxlsxwriter) **star:16** libxlsxwriter的Go binding, 用于编写XLSX (Microsoft Excel)文件。   [![最近一年没有更新][Yellow]](https://github.com/fterrag/goxlsxwriter)   [![godoc][GoDoc]](https://godoc.org/github.com/fterrag/goxlsxwriter)

## 杂项

### 依赖注入

*用于处理依赖项注入的库。 (翻译出错了? 试试 [英文版](README_EN.md#dependency-injection) 吧~)*

* [fx](https://github.com/uber-go/fx) **star:2157** 基于依赖注入的Go应用程序框架(构建在dig之上)。   [![star > 2000][Awesome]](https://github.com/uber-go/fx)   [![最近一周有更新][Green]](https://github.com/uber-go/fx)   [![godoc][GoDoc]](https://godoc.org/github.com/uber-go/fx)
* [dig](https://github.com/uber-go/dig) **star:2035** 一个基于反射的Go依赖注入工具包。   [![star > 2000][Awesome]](https://github.com/uber-go/dig)   [![最近一周有更新][Green]](https://github.com/uber-go/dig)   [![godoc][GoDoc]](https://godoc.org/github.com/uber-go/dig)
* [container](https://github.com/golobby/container) **star:222** 一个强大的IoC容器，具有流畅且易于使用的接口。   [![最近一周有更新][Green]](https://github.com/golobby/container)   [![godoc][GoDoc]](https://godoc.org/github.com/golobby/container)
* [dingo](https://github.com/i-love-flamingo/dingo) **star:108** 基于Guice的Go依赖注入工具包。   [![godoc][GoDoc]](https://godoc.org/github.com/i-love-flamingo/dingo)
* [di](https://github.com/goava/di) **star:102** go编程语言的依赖注入容器。   [![godoc][GoDoc]](https://godoc.org/github.com/goava/di)
* [goioc/di](https://github.com/goioc/di) **star:90** 受spring启发的依赖注入容器。   [![godoc][GoDoc]](https://godoc.org/github.com/goioc/di)
* [alice](https://github.com/magic003/alice) **star:44** Go的外挂的依赖注入容器。   [![最近一年没有更新][Yellow]](https://github.com/magic003/alice)   [![godoc][GoDoc]](https://godoc.org/github.com/magic003/alice)
* [wire](https://github.com/Fs02/wire) **star:33** 适用于Go的严格运行时依赖注入(Strict Runtime Dependency Injection)。   [![最近一年没有更新][Yellow]](https://github.com/Fs02/wire)   [![godoc][GoDoc]](https://godoc.org/github.com/Fs02/wire)
* [linker](https://github.com/logrange/linker) **star:32** A reflection based dependency injection and inversion of control library with components lifecycle support.   [![最近一年没有更新][Yellow]](https://github.com/logrange/linker)   [![godoc][GoDoc]](https://godoc.org/github.com/logrange/linker)
* [gocontainer](https://github.com/vardius/gocontainer) **star:14** 简单的依赖注入容器。   [![最近一年没有更新][Yellow]](https://github.com/vardius/gocontainer)   [![godoc][GoDoc]](https://godoc.org/github.com/vardius/gocontainer)
* [kinit](https://github.com/go-kata/kinit) **star:6** 可定制的依赖注入容器，具有全局模式，级联初始化和紧急安全结束。   [![godoc][GoDoc]](https://godoc.org/github.com/go-kata/kinit)
* [nject/npoint](https://github.com/BlueOwlOpenSource/nject) **star:3** 基于库、测试和端点类型的类型安全的反射框架。   [![godoc][GoDoc]](https://godoc.org/github.com/BlueOwlOpenSource/nject)

### 项目布局

_**Unofficial** set of patterns for structuring projects._

* [golang-standards/project-layout](https://github.com/golang-standards/project-layout) **star:25828** Go生态系统中历史和新兴的项目布局模式集合。   [![star > 2000][Awesome]](https://github.com/golang-standards/project-layout)   [![最近一周有更新][Green]](https://github.com/golang-standards/project-layout)
* [modern-go-application](https://github.com/sagikazarmark/modern-go-application) **star:1039** 应用程序样板和应用现代实践的例子。   [![godoc][GoDoc]](https://godoc.org/github.com/sagikazarmark/modern-go-application)
* [cookiecutter-golang](https://github.com/lacion/cookiecutter-golang) **star:468** 遵循生产最佳实践快速启动项目的Go应用程序样板模板。   [![godoc][GoDoc]](https://godoc.org/github.com/lacion/cookiecutter-golang)
* [golang-templates/seed](https://github.com/golang-templates/seed) **star:194** Go应用程序GitHub存储库模板。
* [scaffold](https://github.com/catchplay/scaffold) **star:99** Scaffold生成一个starter Go项目布局。让您关注已实现的业务逻辑。   [![最近一年没有更新][Yellow]](https://github.com/catchplay/scaffold)   [![godoc][GoDoc]](https://godoc.org/github.com/catchplay/scaffold)
* [go-sample](https://github.com/zitryss/go-sample) **star:90** 带有实际代码的Go应用程序项目的示例布局。   [![最近一年没有更新][Yellow]](https://github.com/zitryss/go-sample)   [![godoc][GoDoc]](https://godoc.org/github.com/zitryss/go-sample)
* [go-todo-backend](https://github.com/Fs02/go-todo-backend) **star:87** 去Todo后端示例使用模块化项目布局的产品微服务。   [![最近一周有更新][Green]](https://github.com/Fs02/go-todo-backend)   [![godoc][GoDoc]](https://godoc.org/github.com/Fs02/go-todo-backend)
* [go-starter](https://github.com/allaboutapps/go-starter) **star:59** 一个自以为是的面向生产的RESTful JSON后端模板，与VSCode DevContainers高度集成。   [![最近一周有更新][Green]](https://github.com/allaboutapps/go-starter)   [![godoc][GoDoc]](https://godoc.org/github.com/allaboutapps/go-starter)
* [gobase](https://github.com/wajox/gobase) **star:9** 一个简单的golang应用框架，带有真实golang应用程序的基本设置。   [![godoc][GoDoc]](https://godoc.org/github.com/wajox/gobase)
* [insidieux/inizio](https://github.com/insidieux/inizio) **star:8** 带有插件的Golang项目布局生成器。   [![godoc][GoDoc]](https://godoc.org/github.com/insidieux/inizio)
* [wangyoucao577/go-project-layout](https://github.com/wangyoucao577/go-project-layout) **star:5** 关于如何构造Go项目布局的一组实践和讨论。   [![godoc][GoDoc]](https://godoc.org/github.com/wangyoucao577/go-project-layout)

### 字符串

*处理字符串的库。 (翻译出错了? 试试 [英文版](README_EN.md#strings) 吧~)*

* [xstrings](https://github.com/huandu/xstrings) **star:931** 从其他语言移植的有用字符串函数合集。   [![godoc][GoDoc]](https://godoc.org/github.com/huandu/xstrings)
* [strutil](https://github.com/ozgio/strutil) **star:125** 字符串处理工具。   [![godoc][GoDoc]](https://godoc.org/github.com/ozgio/strutil)
* [gobeam/Stringy](https://github.com/gobeam/Stringy) **star:68** 字符串操作库，可以将字符串转换为驼色，蛇色，烤肉色等。   [![godoc][GoDoc]](https://godoc.org/github.com/gobeam/Stringy)
* [bexp](https://github.com/mkungla/bexp) **star:3** 执行大括号扩展机制来生成任意字符串。   [![最近一周有更新][Green]](https://github.com/mkungla/bexp)   [![godoc][GoDoc]](https://godoc.org/github.com/mkungla/bexp)
* [go-formatter](https://gitlab.com/tymonx/go-formatter)  实现**替换字段**由大括号'{}'格式字符串包围。

### 未分类的

*这些库之所以放在这里，是因为不适合放在其他分类。 (翻译出错了? 试试 [英文版](README_EN.md#uncategorized) 吧~)*

* [gopsutil](https://github.com/shirou/gopsutil) **star:6643** 用于检索进程和系统利用率(CPU、内存、磁盘等)的跨平台的库。   [![star > 2000][Awesome]](https://github.com/shirou/gopsutil)   [![最近一周有更新][Green]](https://github.com/shirou/gopsutil)   [![godoc][GoDoc]](https://godoc.org/github.com/shirou/gopsutil)
* [archiver](https://github.com/mholt/archiver) **star:3283** 用于生成和解压.zip和.tar.gz文档的库和命令。   [![star > 2000][Awesome]](https://github.com/mholt/archiver)   [![godoc][GoDoc]](https://godoc.org/github.com/mholt/archiver)
* [gofakeit](https://github.com/brianvoe/gofakeit) **star:1998** 用go编写的随机数据生成器。   [![最近一周有更新][Green]](https://github.com/brianvoe/gofakeit)   [![godoc][GoDoc]](https://godoc.org/github.com/brianvoe/gofakeit)
* [gatus](https://github.com/TwinProduction/gatus) **star:1685** 自动服务运行状况仪表板。   [![最近一周有更新][Green]](https://github.com/TwinProduction/gatus)   [![godoc][GoDoc]](https://godoc.org/github.com/TwinProduction/gatus)
* [gosms](https://github.com/haxpax/gosms) **star:1341** Go编写的私人的本地短信网关，可以用来发送短信。   [![godoc][GoDoc]](https://godoc.org/github.com/haxpax/gosms)
* [go-resiliency](https://github.com/eapache/go-resiliency) **star:1239**  Go语言弹性模式(resiliency pattern)。   [![godoc][GoDoc]](https://godoc.org/github.com/eapache/go-resiliency)
* [base64Captcha](https://github.com/mojocn/base64Captcha) **star:1173** base64Captcha支持数字，字母，算术，音频和混合模式的验证码。   [![godoc][GoDoc]](https://godoc.org/github.com/mojocn/base64Captcha)   [![包含中文文档][CN]](https://github.com/mojocn/base64Captcha)
* [go-commons-pool](https://github.com/jolestar/go-commons-pool) **star:973** Go语言的通用对象池。   [![godoc][GoDoc]](https://godoc.org/github.com/jolestar/go-commons-pool)   [![包含中文文档][CN]](https://github.com/jolestar/go-commons-pool)
* [go-openapi](https://github.com/go-openapi)  用于解析和使用开放api模式(open-api schemas)的包的集合。
* [llvm](https://github.com/llir/llvm) **star:774** 用于在纯Go中与LLVM IR交互的库。   [![godoc][GoDoc]](https://godoc.org/github.com/llir/llvm)
* [shortid](https://github.com/teris-io/shortid) **star:691** 分布式地生成超短、唯一、非顺序、URL友好的id。   [![godoc][GoDoc]](https://godoc.org/github.com/teris-io/shortid)
* [health](https://github.com/alexliesenfeld/health) **star:430** 一个简单而灵活的Go健康检查库。   [![最近一周有更新][Green]](https://github.com/alexliesenfeld/health)   [![godoc][GoDoc]](https://godoc.org/github.com/alexliesenfeld/health)
* [health](https://github.com/dimiro1/health) **star:423** 易于使用，可扩展的健康检查库。   [![最近一年没有更新][Yellow]](https://github.com/dimiro1/health)   [![godoc][GoDoc]](https://godoc.org/github.com/dimiro1/health)
* [conv](https://github.com/cstockton/go-conv) **star:371** conv包提供了跨Go类型(Go types)的快速和直观的转换。   [![最近一年没有更新][Yellow]](https://github.com/cstockton/go-conv)   [![godoc][GoDoc]](https://godoc.org/github.com/cstockton/go-conv)
* [banner](https://github.com/dimiro1/banner) **star:351** 在Go应用程序中添加漂亮的横幅(banner)。   [![godoc][GoDoc]](https://godoc.org/github.com/dimiro1/banner)
* [gountries](https://github.com/pariz/gountries) **star:316** 获取国家和细节数据的包。   [![godoc][GoDoc]](https://godoc.org/github.com/pariz/gountries)
* [stateless](https://github.com/qmuntal/stateless) **star:294** 用于创建状态机的流畅库。   [![godoc][GoDoc]](https://godoc.org/github.com/qmuntal/stateless)
* [ffmt](https://github.com/go-ffmt/ffmt) **star:233** 美化数据,使其更适合人查看。   [![godoc][GoDoc]](https://godoc.org/github.com/go-ffmt/ffmt)   [![包含中文文档][CN]](https://github.com/go-ffmt/ffmt)
* [shoutrrr](https://github.com/containrrr/shoutrrr) **star:223** 通知库提供了对各种消息服务(如slack、mattermost、fy和smtp等)的轻松访问。   [![最近一周有更新][Green]](https://github.com/containrrr/shoutrrr)   [![godoc][GoDoc]](https://godoc.org/github.com/containrrr/shoutrrr)
* [lk](https://github.com/hyperboloide/lk) **star:215** 一个简单的版权许可证库。   [![最近一年没有更新][Yellow]](https://github.com/hyperboloide/lk)   [![godoc][GoDoc]](https://godoc.org/github.com/hyperboloide/lk)
* [antch](https://github.com/antchfx/antch) **star:210** 一个快速、强大和可扩展的web爬虫框架。   [![最近一年没有更新][Yellow]](https://github.com/antchfx/antch)   [![godoc][GoDoc]](https://godoc.org/github.com/antchfx/antch)   [![包含中文文档][CN]](https://github.com/antchfx/antch)
* [healthcheck](https://github.com/etherlabsio/healthcheck) **star:192** 用于RESTful服务的强制的(opinionated)并发健康检查HTTP处理程序。   [![godoc][GoDoc]](https://godoc.org/github.com/etherlabsio/healthcheck)
* [battery](https://github.com/distatus/battery) **star:190** 跨平台、标准化的电池信息库。   [![godoc][GoDoc]](https://godoc.org/github.com/distatus/battery)
* [bitio](https://github.com/icza/bitio) **star:164** 高度优化的位级读写器。   [![godoc][GoDoc]](https://godoc.org/github.com/icza/bitio)
* [stats](https://github.com/go-playground/stats) **star:155** Monitors Go MemStats + 诸如如内存，Swap和CPU的系统状态统计，并通过UDP发送到任何你想记录的地方   [![最近一年没有更新][Yellow]](https://github.com/go-playground/stats)   [![godoc][GoDoc]](https://godoc.org/github.com/go-playground/stats)
* [go-unarr](https://github.com/gen2brain/go-unarr) **star:146** 用于RAR、TAR、ZIP和7z文件的解压缩库。   [![godoc][GoDoc]](https://godoc.org/github.com/gen2brain/go-unarr)
* [turtle](https://github.com/hackebrot/turtle) **star:124** Go的Emojis库。   [![godoc][GoDoc]](https://godoc.org/github.com/hackebrot/turtle)
* [gommit](https://github.com/antham/gommit) **star:94** 分析git提交消息，确保它们遵循已定义的格式。   [![godoc][GoDoc]](https://godoc.org/github.com/antham/gommit)
* [gotoprom](https://github.com/cabify/gotoprom) **star:90** 为Prometheus客户端提供类型安全的指标(metric)构建工具库。   [![最近一年没有更新][Yellow]](https://github.com/cabify/gotoprom)   [![godoc][GoDoc]](https://godoc.org/github.com/cabify/gotoprom)
* [indigo](https://github.com/osamingo/indigo) **star:87** 分布式唯一ID生成器, 使用Sonyflake并由Base58编码。   [![godoc][GoDoc]](https://godoc.org/github.com/osamingo/indigo)
* [captcha](https://github.com/steambap/captcha) **star:80** captcha包为验证码生成提供了一个易于使用的、unopinionated的API。   [![godoc][GoDoc]](https://godoc.org/github.com/steambap/captcha)
* [morse](https://github.com/alwindoss/morse) **star:70** 实现字符串与摩尔斯电码转换的库。   [![最近一年没有更新][Yellow]](https://github.com/alwindoss/morse)   [![godoc][GoDoc]](https://godoc.org/github.com/alwindoss/morse)
* [persian](https://github.com/mavihq/persian) **star:57** 一些适用于波斯语的Go工具库。   [![godoc][GoDoc]](https://godoc.org/github.com/mavihq/persian)
* [pdfgen](https://github.com/hyperboloide/pdfgen) **star:52** 通过Json请求生成PDF的HTTP服务。   [![最近一年没有更新][Yellow]](https://github.com/hyperboloide/pdfgen)   [![godoc][GoDoc]](https://godoc.org/github.com/hyperboloide/pdfgen)
* [xkg](https://github.com/go-xkg/xkg) **star:51** X Keyboard Grabber(键盘事件捕获)   [![最近一年没有更新][Yellow]](https://github.com/go-xkg/xkg)   [![godoc][GoDoc]](https://godoc.org/github.com/go-xkg/xkg)
* [faker](https://github.com/pioz/faker) **star:42** 随机假数据和结构生成器为Go。   [![最近一周有更新][Green]](https://github.com/pioz/faker)   [![godoc][GoDoc]](https://godoc.org/github.com/pioz/faker)
* [browscap_go](https://github.com/digitalcrab/browscap_go) **star:37** 用于[Browser Capabilities Project](http://browscap.org/)的Go库。   [![最近一年没有更新][Yellow]](https://github.com/digitalcrab/browscap_go)   [![godoc][GoDoc]](https://godoc.org/github.com/digitalcrab/browscap_go)
* [datacounter](https://github.com/miolini/datacounter) **star:36** 用于readers/writer/http.ResponseWriter的计数器。   [![最近一年没有更新][Yellow]](https://github.com/miolini/datacounter)   [![godoc][GoDoc]](https://godoc.org/github.com/miolini/datacounter)
* [autoflags](https://github.com/artyom/autoflags) **star:34** 从struct字段自动定义命令行flag的Go包。   [![godoc][GoDoc]](https://godoc.org/github.com/artyom/autoflags)
* [url-shortener](https://github.com/pantrif/url-shortener) **star:31** 一个现代的、强大的、健壮的URL转短链接微服务，带有mysql支持。   [![最近一年没有更新][Yellow]](https://github.com/pantrif/url-shortener)   [![godoc][GoDoc]](https://godoc.org/github.com/pantrif/url-shortener)
* [VarHandler](https://github.com/azr/generators/tree/master/varhandler)  用于生成http输入和输出处理模板。
* [sandid](https://github.com/aofei/sandid) **star:30** 能沟让地球上的每一粒沙子都有自己的ID。   [![godoc][GoDoc]](https://godoc.org/github.com/aofei/sandid)
* [gosh](https://github.com/osamingo/gosh) **star:26** 提供Go统计处理程序，结构和测量方法。   [![godoc][GoDoc]](https://godoc.org/github.com/osamingo/gosh)
* [xdg](https://github.com/rkoesters/xdg) **star:26** FreeDesktop.org (xdg)规范在Go中的实现。   [![godoc][GoDoc]](https://godoc.org/github.com/rkoesters/xdg)
* [metrics](https://github.com/pascaldekloe/metrics) **star:20** 用于instrumentation和Prometheus exposition的库。   [![godoc][GoDoc]](https://godoc.org/github.com/pascaldekloe/metrics)
* [shellwords](https://github.com/Wing924/shellwords) **star:15** 一个Go库，实现了依照UNIX Bourne shell的关键词解析规则进行字符串操纵。   [![最近一年没有更新][Yellow]](https://github.com/Wing924/shellwords)   [![godoc][GoDoc]](https://godoc.org/github.com/Wing924/shellwords)
* [anagent](https://github.com/mudler/anagent) **star:13** Go语言的最小化，可插入的evloop/timer处理程序, 带有依赖注入。   [![最近一年没有更新][Yellow]](https://github.com/mudler/anagent)   [![godoc][GoDoc]](https://godoc.org/github.com/mudler/anagent)
* [avgRating](https://github.com/kirillDanshin/avgRating) **star:10** 根据威尔逊得分排序算法(Wilson Score Equation)计算平均分和评分。   [![最近一年没有更新][Yellow]](https://github.com/kirillDanshin/avgRating)   [![godoc][GoDoc]](https://godoc.org/github.com/kirillDanshin/avgRating)
* [hostutils](https://github.com/Wing924/hostutils) **star:9** 一个用于打包和解包FQDNs列表的go语言库。   [![最近一年没有更新][Yellow]](https://github.com/Wing924/hostutils)   [![godoc][GoDoc]](https://godoc.org/github.com/Wing924/hostutils)
* [numa](https://github.com/lrita/numa) **star:6** NUMA是一个用go编写的实用程序库。它可以帮助我们编写一些NUMA-AWARED代码。   [![godoc][GoDoc]](https://godoc.org/github.com/lrita/numa)

## 自然语言处理

*用于处理人类语言的库。 (翻译出错了? 试试 [英文版](README_EN.md#natural-language-processing) 吧~)*

* [prose](https://github.com/jdkato/prose) **star:2780** 支持标记化、词性标记、命名实体提取等文本处理的库。只说英语。   [![star > 2000][Awesome]](https://github.com/jdkato/prose)   [![godoc][GoDoc]](https://godoc.org/github.com/jdkato/prose)
* [gse](https://github.com/go-ego/gse) **star:1622** 高效的文本分割;支持英语、汉语、日语等。   [![最近一周有更新][Green]](https://github.com/go-ego/gse)   [![godoc][GoDoc]](https://godoc.org/github.com/go-ego/gse)   [![包含中文文档][CN]](https://github.com/go-ego/gse)
* [gojieba](https://github.com/yanyiwu/gojieba) **star:1578** 这是一个Go实现的[jieba](https://github.com/fxsjy/jieba)，这是一个中文分词算法。   [![godoc][GoDoc]](https://godoc.org/github.com/yanyiwu/gojieba)   [![包含中文文档][CN]](https://github.com/yanyiwu/gojieba)
* [when](https://github.com/olebedev/when) **star:1123** 带有可插入规则的自然EN和RU语言日期/时间解析器。   [![godoc][GoDoc]](https://godoc.org/github.com/olebedev/when)
* [go-pinyin](https://github.com/mozillazg/go-pinyin) **star:1002** 中文汉字到汉语拼音的转换。   [![godoc][GoDoc]](https://godoc.org/github.com/mozillazg/go-pinyin)
* [spaGO](https://github.com/nlpodyssey/spago) **star:949** Go中的独立机器学习和自然语言处理库。   [![godoc][GoDoc]](https://godoc.org/github.com/nlpodyssey/spago)
* [kagome](https://github.com/ikawaha/kagome) **star:580** JP形态学分析仪编写的纯Go。   [![最近一周有更新][Green]](https://github.com/ikawaha/kagome)   [![godoc][GoDoc]](https://godoc.org/github.com/ikawaha/kagome)
* [whatlanggo](https://github.com/abadojack/whatlanggo) **star:503** Go的自然语言检测包。支持84种语言和24种脚本(书写系统，如拉丁语、西里尔语等)。   [![godoc][GoDoc]](https://godoc.org/github.com/abadojack/whatlanggo)
* [nlp](https://github.com/Shixzie/nlp) **star:369** 从字符串中提取值并用nlp填充结构。   [![最近一年没有更新][Yellow]](https://github.com/Shixzie/nlp)   [![godoc][GoDoc]](https://godoc.org/github.com/Shixzie/nlp)
* [nlp](https://github.com/james-bowman/nlp) **star:335** 支持LSA(潜在语义分析)的Go自然语言处理库。   [![godoc][GoDoc]](https://godoc.org/github.com/james-bowman/nlp)
* [sentences](https://github.com/neurosnap/sentences) **star:307** 句子标记器:将文本转换为句子列表。   [![godoc][GoDoc]](https://godoc.org/github.com/neurosnap/sentences)
* [getlang](https://github.com/rylans/getlang) **star:119** 快速自然语言检测包。   [![godoc][GoDoc]](https://godoc.org/github.com/rylans/getlang)
* [go-i18n](https://github.com/nicksnyder/go-i18n/)  软件包和用于处理本地化文本的附带工具。
* [go-nlp](https://github.com/nuance/go-nlp) **star:89** 用于处理离散概率分布的实用程序和用于进行NLP工作的其他工具。   [![最近一年没有更新][Yellow]](https://github.com/nuance/go-nlp)   [![godoc][GoDoc]](https://godoc.org/github.com/nuance/go-nlp)   [![归档项目][Archived]](https://github.com/nuance/go-nlp)
* [go-unidecode](https://github.com/mozillazg/go-unidecode) **star:89** Unicode文本的ASCII音译。   [![godoc][GoDoc]](https://godoc.org/github.com/mozillazg/go-unidecode)
* [RAKE.go](https://github.com/afjoseph/RAKE.Go) **star:82** 快速自动关键字提取算法(RAKE)的Go端口。   [![最近一年没有更新][Yellow]](https://github.com/afjoseph/RAKE.Go)   [![godoc][GoDoc]](https://godoc.org/github.com/afjoseph/RAKE.Go)
* [gounidecode](https://github.com/fiam/gounidecode) **star:73** 用于Go的Unicode音译器(也称为unidecode)。   [![最近一年没有更新][Yellow]](https://github.com/fiam/gounidecode)   [![godoc][GoDoc]](https://godoc.org/github.com/fiam/gounidecode)
* [textcat](https://github.com/pebbe/textcat) **star:65** Go package支持基于n-gram的文本分类，支持utf-8和原始文本。   [![godoc][GoDoc]](https://godoc.org/github.com/pebbe/textcat)
* [go-stem](https://github.com/agonopol/go-stem) **star:64** 波特词干算法的实现。   [![最近一年没有更新][Yellow]](https://github.com/agonopol/go-stem)   [![godoc][GoDoc]](https://godoc.org/github.com/agonopol/go-stem)
* [segment](https://github.com/blevesearch/segment) **star:64** Go library for performing Unicode Text Segmentation as described in [Unicode Standard Annex #29](http://www.unicode.org/reports/tr29/)   [![godoc][GoDoc]](https://godoc.org/github.com/blevesearch/segment)
* [MMSEGO](https://github.com/awsong/MMSEGO) **star:59** 这是一个 Go 实现的[MMSEG](http://technology.chtsai.org/mmseg/)，这是一个中文分词算法。   [![最近一年没有更新][Yellow]](https://github.com/awsong/MMSEGO)   [![godoc][GoDoc]](https://godoc.org/github.com/awsong/MMSEGO)
* [stemmer](https://github.com/dchest/stemmer) **star:49** 用于Go编程语言的Stemmer包。包括英语和德语词根。   [![最近一年没有更新][Yellow]](https://github.com/dchest/stemmer)   [![godoc][GoDoc]](https://godoc.org/github.com/dchest/stemmer)
* [go2vec](https://github.com/danieldk/go2vec) **star:41** 用于word2vec嵌入式的阅读器和实用程序函数。   [![最近一年没有更新][Yellow]](https://github.com/danieldk/go2vec)   [![godoc][GoDoc]](https://godoc.org/github.com/danieldk/go2vec)
* [porter2](https://github.com/zhenjl/porter2) **star:40** 非常快的波特2史坦默。   [![godoc][GoDoc]](https://godoc.org/github.com/zhenjl/porter2)
* [petrovich](https://github.com/striker2000/petrovich) **star:34** 彼得罗维奇是一个图书馆，它把俄语名字的词形变化成特定的语法格。   [![godoc][GoDoc]](https://godoc.org/github.com/striker2000/petrovich)
* [address](https://github.com/bojanz/address) **star:30** 处理地址表示、验证和格式。   [![godoc][GoDoc]](https://godoc.org/github.com/bojanz/address)
* [snowball](https://github.com/goodsign/snowball) **star:28** 滚雪球柄端口(cgo包装)为 Go 。提供词干提取功能[Snowball native](http://snowball.tartarus.org/)。   [![最近一年没有更新][Yellow]](https://github.com/goodsign/snowball)
* [go-mystem](https://github.com/dveselov/mystem) **star:26** CGo绑定到Yandex。Mystem -俄罗斯形态学分析仪。   [![最近一年没有更新][Yellow]](https://github.com/dveselov/mystem)   [![godoc][GoDoc]](https://godoc.org/github.com/dveselov/mystem)
* [paicehusk](https://github.com/rookii/paicehusk) **star:26** Golang实现了Paice/外壳阻塞算法。   [![最近一年没有更新][Yellow]](https://github.com/rookii/paicehusk)   [![godoc][GoDoc]](https://godoc.org/github.com/rookii/paicehusk)
* [go-localize](https://github.com/m1/go-localize) **star:25** 简单易用的i18n(国际化和本地化)引擎——用于翻译语言环境字符串。   [![godoc][GoDoc]](https://godoc.org/github.com/m1/go-localize)
* [iuliia-go](https://github.com/mehanizm/iuliia-go) **star:23** 直译斯拉夫字母→拉丁以所有可能的方式。   [![godoc][GoDoc]](https://godoc.org/github.com/mehanizm/iuliia-go)
* [golibstemmer](https://github.com/rjohnsondev/golibstemmer) **star:19**  Go 绑定斯诺鲍libstemmer库，包括波特2。   [![最近一年没有更新][Yellow]](https://github.com/rjohnsondev/golibstemmer)   [![godoc][GoDoc]](https://godoc.org/github.com/rjohnsondev/golibstemmer)
* [icu](https://github.com/goodsign/icu) **star:19** Cgo绑定用于icu4c C库的检测和转换功能。保证与版本50.1兼容。   [![最近一年没有更新][Yellow]](https://github.com/goodsign/icu)   [![godoc][GoDoc]](https://godoc.org/github.com/goodsign/icu)
* [govader](https://github.com/jonreiter/govader) **star:15** [VADER情绪分析]的Go实现(https://github.com/cjhutto/vaderSentiment)。   [![godoc][GoDoc]](https://godoc.org/github.com/jonreiter/govader)
* [gotokenizer](https://github.com/xujiajun/gotokenizer) **star:12** 一种基于字典和双字母格朗语言模型的记号赋予器。(现在只支持中文分割)   [![最近一年没有更新][Yellow]](https://github.com/xujiajun/gotokenizer)   [![godoc][GoDoc]](https://godoc.org/github.com/xujiajun/gotokenizer)
* [shamoji](https://github.com/osamingo/shamoji) **star:12** shamoji是用Go编写的word过滤包。   [![godoc][GoDoc]](https://godoc.org/github.com/osamingo/shamoji)
* [transliterator](https://github.com/alexsergivan/transliterator) **star:12** 提供单向字符串音译，并支持特定于语言的音译规则。   [![最近一年没有更新][Yellow]](https://github.com/alexsergivan/transliterator)   [![godoc][GoDoc]](https://godoc.org/github.com/alexsergivan/transliterator)
* [detectlanguage](https://github.com/detectlanguage/detectlanguage-go) **star:10** 语言检测API Go客户端。支持批量请求，短短语或单字语言检测。   [![godoc][GoDoc]](https://godoc.org/github.com/detectlanguage/detectlanguage-go)
* [libtextcat](https://github.com/goodsign/libtextcat) **star:10** 用于libtextcat C库的Cgo绑定。保证与版本2.2兼容。   [![最近一年没有更新][Yellow]](https://github.com/goodsign/libtextcat)   [![godoc][GoDoc]](https://godoc.org/github.com/goodsign/libtextcat)
* [porter](https://github.com/a2800276/porter) **star:8** 这是Martin Porter在C语言中实现的Porter词干分析算法的一个相当简单的移植。   [![最近一年没有更新][Yellow]](https://github.com/a2800276/porter)   [![godoc][GoDoc]](https://godoc.org/github.com/a2800276/porter)
* [gosentiwordnet](https://github.com/dinopuguh/gosentiwordnet) **star:7** 情绪分析器使用的多愁善感网词汇在Go。   [![godoc][GoDoc]](https://godoc.org/github.com/dinopuguh/gosentiwordnet)

## 网络

*用于处理各种网络层的库。 (翻译出错了? 试试 [英文版](README_EN.md#networking) 吧~)*

* [fasthttp](https://github.com/valyala/fasthttp) **star:15797** 一个快速HTTP实现，比net/http快10倍。   [![star > 2000][Awesome]](https://github.com/valyala/fasthttp)   [![最近一周有更新][Green]](https://github.com/valyala/fasthttp)   [![godoc][GoDoc]](https://godoc.org/github.com/valyala/fasthttp)
* [kcptun](https://github.com/xtaci/kcptun) **star:12524** 基于KCP协议的非常简单和快速udp隧道。   [![star > 2000][Awesome]](https://github.com/xtaci/kcptun)   [![godoc][GoDoc]](https://godoc.org/github.com/xtaci/kcptun)
* [webrtc](https://github.com/pions/webrtc) **star:7678** WebRTC API的纯Go实现。   [![star > 2000][Awesome]](https://github.com/pions/webrtc)   [![最近一周有更新][Green]](https://github.com/pions/webrtc)   [![godoc][GoDoc]](https://godoc.org/github.com/pions/webrtc)
* [dns](https://github.com/miekg/dns) **star:5713** 用于 DNS 的库。   [![star > 2000][Awesome]](https://github.com/miekg/dns)   [![godoc][GoDoc]](https://godoc.org/github.com/miekg/dns)
* [quic-go](https://github.com/lucas-clemente/quic-go) **star:5680** 在纯Go中实现了QUIC协议。   [![star > 2000][Awesome]](https://github.com/lucas-clemente/quic-go)   [![最近一周有更新][Green]](https://github.com/lucas-clemente/quic-go)   [![godoc][GoDoc]](https://godoc.org/github.com/lucas-clemente/quic-go)
* [gnet](https://github.com/panjf2000/gnet) **star:5026** “gnet”是一个用纯Go编写的高性能、轻量级、非阻塞、事件驱动的网络框架。   [![star > 2000][Awesome]](https://github.com/panjf2000/gnet)   [![最近一周有更新][Green]](https://github.com/panjf2000/gnet)   [![godoc][GoDoc]](https://godoc.org/github.com/panjf2000/gnet)   [![包含中文文档][CN]](https://github.com/panjf2000/gnet)
* [gopacket](https://github.com/google/gopacket) **star:4293** Go library for packet processing with libpcap bindings.   [![star > 2000][Awesome]](https://github.com/google/gopacket)   [![最近一周有更新][Green]](https://github.com/google/gopacket)   [![godoc][GoDoc]](https://godoc.org/github.com/google/gopacket)
* [HTTPLab](https://github.com/gchaincl/httplab) **star:3712** HTTPLabs 允许你检查 HTTP 请求和伪造响应。   [![star > 2000][Awesome]](https://github.com/gchaincl/httplab)   [![最近一年没有更新][Yellow]](https://github.com/gchaincl/httplab)   [![godoc][GoDoc]](https://godoc.org/github.com/gchaincl/httplab)
* [kcp-go](https://github.com/xtaci/kcp-go) **star:3051** 快速可靠的ARQ协议。   [![star > 2000][Awesome]](https://github.com/xtaci/kcp-go)   [![godoc][GoDoc]](https://godoc.org/github.com/xtaci/kcp-go)
* [gobgp](https://github.com/osrg/gobgp) **star:2263** 基于 Go 的 BGP 实现。   [![star > 2000][Awesome]](https://github.com/osrg/gobgp)   [![最近一周有更新][Green]](https://github.com/osrg/gobgp)   [![godoc][GoDoc]](https://godoc.org/github.com/osrg/gobgp)
* [ssh](https://github.com/gliderlabs/ssh) **star:2117** 用于构建SSH服务器的高级API(封装密码/ SSH)。   [![star > 2000][Awesome]](https://github.com/gliderlabs/ssh)   [![最近一周有更新][Green]](https://github.com/gliderlabs/ssh)   [![godoc][GoDoc]](https://godoc.org/github.com/gliderlabs/ssh)
* [fortio](https://github.com/fortio/fortio) **star:2034** 负载测试库和命令行工具，高级的echo服务器和web UI。允许指定一组每秒查询的负载，并记录延迟直方图和其他有用的统计数据，并将它们作图。支持Tcp、Http、gRPC。   [![star > 2000][Awesome]](https://github.com/fortio/fortio)   [![最近一周有更新][Green]](https://github.com/fortio/fortio)   [![godoc][GoDoc]](https://godoc.org/github.com/fortio/fortio)
* [water](https://github.com/songgao/water) **star:1278** 简单TUN / TAP图书馆。   [![godoc][GoDoc]](https://godoc.org/github.com/songgao/water)
* [gev](https://github.com/Allenxuxu/gev) **star:1224** gev是一个基于反应器模式的轻量级、快速的非阻塞TCP网络库。   [![godoc][GoDoc]](https://godoc.org/github.com/Allenxuxu/gev)
* [go-getter](https://github.com/hashicorp/go-getter) **star:1208**  通过URL来下载文件或目录。   [![最近一周有更新][Green]](https://github.com/hashicorp/go-getter)   [![godoc][GoDoc]](https://godoc.org/github.com/hashicorp/go-getter)
* [NFF-Go](https://github.com/intel-go/nff-go) **star:1083** 用于快速开发云计算和裸机网络功能的框架(原YANFF)。   [![godoc][GoDoc]](https://godoc.org/github.com/intel-go/nff-go)
* [sftp](https://github.com/pkg/sftp) **star:1036** Package sftp implements the SSH File Transfer Protocol as described in https://filezilla-project.org/specs/draft-ietf-secsh-filexfer-02.txt.   [![最近一周有更新][Green]](https://github.com/pkg/sftp)   [![godoc][GoDoc]](https://godoc.org/github.com/pkg/sftp)
* [grab](https://github.com/cavaliercoder/grab) **star:892**  用于管理文件下载。   [![godoc][GoDoc]](https://godoc.org/github.com/cavaliercoder/grab)
* [ftp](https://github.com/jlaffaye/ftp) **star:825** 实现了[RFC 959](http://tools.ietf.org/html/rfc959)中描述的ftp客户端。   [![godoc][GoDoc]](https://godoc.org/github.com/jlaffaye/ftp)
* [mdns](https://github.com/hashicorp/mdns) **star:791** 简单mDNS(Multicast DNS)客户端/服务器库。   [![godoc][GoDoc]](https://godoc.org/github.com/hashicorp/mdns)
* [mqttPaho](https://eclipse.org/paho/clients/golang/)  Paho Go客户端提供了一个 MQTT 客户端库，用于通过TCP、TLS或WebSockets连接到MQTT代理。
* [gosnmp](https://github.com/soniah/gosnmp) **star:745** 用于执行 SNMP 操作的原生 Go 库。   [![godoc][GoDoc]](https://godoc.org/github.com/soniah/gosnmp)
* [vssh](https://github.com/yahoo/vssh) **star:734** Go库建立网络和服务器自动化的SSH协议。   [![godoc][GoDoc]](https://godoc.org/github.com/yahoo/vssh)
* [lhttp](https://github.com/fanux/lhttp) **star:628** 强大的websocket框架，可以让你更容易的构建IM服务器。   [![最近一年没有更新][Yellow]](https://github.com/fanux/lhttp)   [![godoc][GoDoc]](https://godoc.org/github.com/fanux/lhttp)   [![包含中文文档][CN]](https://github.com/fanux/lhttp)
* [cidranger](https://github.com/yl2chen/cidranger) **star:624** 快速得 IP 到 CIDR 查找。   [![godoc][GoDoc]](https://godoc.org/github.com/yl2chen/cidranger)
* [peerdiscovery](https://github.com/schollz/peerdiscovery) **star:497** 基于UDP组播的跨平台本地对等点发现库。   [![godoc][GoDoc]](https://godoc.org/github.com/schollz/peerdiscovery)
* [gotcp](https://github.com/gansidui/gotcp) **star:486** 用于快速编写 tcp 应用程序。   [![最近一年没有更新][Yellow]](https://github.com/gansidui/gotcp)   [![godoc][GoDoc]](https://godoc.org/github.com/gansidui/gotcp)
* [stun](https://github.com/go-rtc/stun) **star:471** Go实现的RFC 5389 STUN协议。   [![godoc][GoDoc]](https://godoc.org/github.com/go-rtc/stun)   [![归档项目][Archived]](https://github.com/go-rtc/stun)
* [go-stun](https://github.com/ccding/go-stun) **star:450** 实现了 STUN 客户端(RFC 3489和RFC 5389)。   [![godoc][GoDoc]](https://godoc.org/github.com/ccding/go-stun)
* [gmqtt](https://github.com/DrmagicE/gmqtt) **star:434** Gmqtt是一个灵活、高性能的MQTT代理库，它完全实现了MQTT协议V3.1.1。   [![godoc][GoDoc]](https://godoc.org/github.com/DrmagicE/gmqtt)   [![包含中文文档][CN]](https://github.com/DrmagicE/gmqtt)
* [gopcap](https://github.com/akrennmair/gopcap) **star:428**  用 Go 实现了对 libpcap 的封装。   [![godoc][GoDoc]](https://godoc.org/github.com/akrennmair/gopcap)
* [raw](https://github.com/mdlayher/raw) **star:400** Package raw支持在设备驱动程序级别读取和写入网络接口的数据。   [![godoc][GoDoc]](https://godoc.org/github.com/mdlayher/raw)
* [tcp_server](https://github.com/firstrow/tcp_server) **star:386**  Go 图书馆建设tcp服务器更快。   [![godoc][GoDoc]](https://godoc.org/github.com/firstrow/tcp_server)
* [gaio](https://github.com/xtaci/gaio) **star:377** 高性能异步io网络在proactor模式下的Golang。   [![godoc][GoDoc]](https://godoc.org/github.com/xtaci/gaio)
* [winrm](https://github.com/masterzen/winrm) **star:322**  Go WinRM客户端远程执行Windows机器上的命令。   [![godoc][GoDoc]](https://godoc.org/github.com/masterzen/winrm)
* [nbio](https://github.com/lesismal/nbio) **star:276** 用Go编写的高性能、非阻塞、事件驱动、易于使用、依赖性最小的网络框架。   [![最近一周有更新][Green]](https://github.com/lesismal/nbio)   [![godoc][GoDoc]](https://godoc.org/github.com/lesismal/nbio)
* [arp](https://github.com/mdlayher/arp) **star:259** 实现了arp协议，如RFC 826中所述。   [![最近一年没有更新][Yellow]](https://github.com/mdlayher/arp)   [![godoc][GoDoc]](https://godoc.org/github.com/mdlayher/arp)
* [ftpserverlib](https://github.com/fclairamb/ftpserverlib) **star:256** 功能齐全的FTP服务器库。   [![godoc][GoDoc]](https://godoc.org/github.com/fclairamb/ftpserverlib)
* [buffstreams](https://github.com/stabbycutyou/buffstreams) **star:245** 通过TCP传输协议缓冲区数据。   [![最近一年没有更新][Yellow]](https://github.com/stabbycutyou/buffstreams)   [![godoc][GoDoc]](https://godoc.org/github.com/stabbycutyou/buffstreams)
* [ethernet](https://github.com/mdlayher/ethernet) **star:226** 实现了对IEEE 802.3以太网II帧和IEEE 802.1Q VLAN标签的编组和解组。   [![最近一年没有更新][Yellow]](https://github.com/mdlayher/ethernet)   [![godoc][GoDoc]](https://godoc.org/github.com/mdlayher/ethernet)
* [gNxI](https://github.com/google/gnxi) **star:187** 一组基于 gNMI 和 gNOI 协议的网络管理工具。   [![godoc][GoDoc]](https://godoc.org/github.com/google/gnxi)
* [jazigo](https://github.com/udhos/jazigo) **star:169** Jazigo是一个用Go编写的工具，用于检索多个网络设备的配置。   [![最近一年没有更新][Yellow]](https://github.com/udhos/jazigo)   [![godoc][GoDoc]](https://godoc.org/github.com/udhos/jazigo)
* [utp](https://github.com/anacrolix/utp) **star:160** Go uTP微传输协议的实现。   [![godoc][GoDoc]](https://godoc.org/github.com/anacrolix/utp)
* [canopus](https://github.com/zubairhamed/canopus) **star:145** CoAP客户端/服务器实现(RFC 7252)。   [![最近一年没有更新][Yellow]](https://github.com/zubairhamed/canopus)   [![godoc][GoDoc]](https://godoc.org/github.com/zubairhamed/canopus)
* [sslb](https://github.com/eduardonunesp/sslb) **star:131** 它是一个超级简单的负载平衡器，只是一个实现某种性能的小项目。   [![最近一年没有更新][Yellow]](https://github.com/eduardonunesp/sslb)   [![godoc][GoDoc]](https://godoc.org/github.com/eduardonunesp/sslb)
* [xtcp](https://github.com/xfxdev/xtcp) **star:123** TCP服务器框架，同时全双工通信，优雅的关机，和自定义协议。   [![最近一年没有更新][Yellow]](https://github.com/xfxdev/xtcp)   [![godoc][GoDoc]](https://godoc.org/github.com/xfxdev/xtcp)
* [dhcp6](https://github.com/mdlayher/dhcp6) **star:70** 实现了一个DHCPv6服务器，如RFC 3315所述。   [![最近一年没有更新][Yellow]](https://github.com/mdlayher/dhcp6)   [![godoc][GoDoc]](https://godoc.org/github.com/mdlayher/dhcp6)
* [ether](https://github.com/songgao/ether) **star:70** 一个用于发送和接收以太网帧的跨平台 Go 库。   [![最近一年没有更新][Yellow]](https://github.com/songgao/ether)   [![godoc][GoDoc]](https://godoc.org/github.com/songgao/ether)
* [packet](https://github.com/aerogo/packet) **star:56** 通过TCP和UDP发送数据包。它可以缓冲消息和热交换连接。   [![最近一年没有更新][Yellow]](https://github.com/aerogo/packet)   [![godoc][GoDoc]](https://godoc.org/github.com/aerogo/packet)
* [linkio](https://github.com/ian-kent/linkio) **star:49** 网络链路速度模拟，主要用于接口的读/写。   [![最近一年没有更新][Yellow]](https://github.com/ian-kent/linkio)   [![godoc][GoDoc]](https://godoc.org/github.com/ian-kent/linkio)
* [iplib](https://github.com/c-robinson/iplib) **star:48** 用于处理IP地址的库(net)。借鉴于python 的 [ipaddress](https://docy-doc.org/3/library/ipaddress.html)和ruby [ipaddr](https://ruby-doc.org/stdlib-2.5.1/libdoc/ipaddr/rdoc/IPAddr.html)   [![godoc][GoDoc]](https://godoc.org/github.com/c-robinson/iplib)
* [portproxy](https://github.com/aybabtme/portproxy) **star:45** Simple TCP proxy which adds CORS support to API's which don't support it.   [![最近一年没有更新][Yellow]](https://github.com/aybabtme/portproxy)   [![godoc][GoDoc]](https://godoc.org/github.com/aybabtme/portproxy)
* [go-powerdns](https://github.com/joeig/go-powerdns) **star:40** Golang的PowerDNS API绑定。   [![最近一周有更新][Green]](https://github.com/joeig/go-powerdns)   [![godoc][GoDoc]](https://godoc.org/github.com/joeig/go-powerdns)
* [graval](https://github.com/koofr/graval) **star:27** FTP服务器框架。   [![godoc][GoDoc]](https://godoc.org/github.com/koofr/graval)
* [panoptes-stream](https://github.com/yahoo/panoptes-stream) **star:25** 云本地分布式流媒体网络遥测(gNMI, Juniper JTI和Cisco MDT)。   [![godoc][GoDoc]](https://godoc.org/github.com/yahoo/panoptes-stream)
* [publicip](https://github.com/polera/publicip) **star:24** 包publicip返回面向公共的IPv4地址(internet出口)。   [![最近一年没有更新][Yellow]](https://github.com/polera/publicip)   [![godoc][GoDoc]](https://godoc.org/github.com/polera/publicip)
* [golibwireshark](https://github.com/sunwxg/golibwireshark) **star:21** 用于解码 pcap 文件和分析解剖数据。   [![最近一年没有更新][Yellow]](https://github.com/sunwxg/golibwireshark)   [![godoc][GoDoc]](https://godoc.org/github.com/sunwxg/golibwireshark)
* [gohooks](https://github.com/averageflow/gohooks) **star:12** gohook使得从Go应用程序发送和使用安全的web钩子变得很容易。灵感来自空间的Laravel Webhook客户端和服务器。   [![godoc][GoDoc]](https://godoc.org/github.com/averageflow/gohooks)
* [goshark](https://github.com/sunwxg/goshark) **star:12** 用于解码IP包，创建用于分析的数据结构包。   [![最近一年没有更新][Yellow]](https://github.com/sunwxg/goshark)   [![godoc][GoDoc]](https://godoc.org/github.com/sunwxg/goshark)
* [llb](https://github.com/kirillDanshin/llb) **star:11** 一个非常简单、快速的代理服务器后端。可用于快速重定向到预定义域，具有零内存分配和快速响应。   [![最近一年没有更新][Yellow]](https://github.com/kirillDanshin/llb)   [![godoc][GoDoc]](https://godoc.org/github.com/kirillDanshin/llb)
* [tspool](https://github.com/two/tspool) **star:10** TCP库使用工作池来提高性能并保护服务器。   [![最近一年没有更新][Yellow]](https://github.com/two/tspool)   [![godoc][GoDoc]](https://godoc.org/github.com/two/tspool)
* [httpproxy](https://github.com/wzshiming/httpproxy) **star:9** HTTP代理处理程序和拨号。   [![godoc][GoDoc]](https://godoc.org/github.com/wzshiming/httpproxy)

### HTTP客户端

*用于发出HTTP请求的库。 (翻译出错了? 试试 [英文版](README_EN.md#http-clients) 吧~)*

* [resty](https://github.com/go-resty/resty) **star:4692** 简单的 HTTP 和 REST 客户端，受到 Ruby rest-client 的启发。   [![star > 2000][Awesome]](https://github.com/go-resty/resty)   [![godoc][GoDoc]](https://godoc.org/github.com/go-resty/resty)
* [heimdall](https://github.com/gojektech/heimdall) **star:2015** 具有重试和hystrix功能的增强http客户机。   [![star > 2000][Awesome]](https://github.com/gojektech/heimdall)   [![godoc][GoDoc]](https://godoc.org/github.com/gojektech/heimdall)
* [httpc](https://github.com/valord577/httpc)  一个可定制的简单HTTP客户端库。仅依赖于标准lib HTTP客户端。
* [grequests](https://github.com/levigross/grequests) **star:1813** 一个 Go “克隆”的伟大和著名的请求库。   [![godoc][GoDoc]](https://godoc.org/github.com/levigross/grequests)
* [sling](https://github.com/dghubble/sling) **star:1344** Sling是一个用于创建和发送API请求的Go HTTP客户端库。   [![godoc][GoDoc]](https://godoc.org/github.com/dghubble/sling)
* [gentleman](https://github.com/h2non/gentleman) **star:910** 功能齐全的插件驱动HTTP客户端库。   [![godoc][GoDoc]](https://godoc.org/github.com/h2non/gentleman)
* [pester](https://github.com/sethgrid/pester) **star:557** 使用重试、后退和并发执行HTTP客户机调用。   [![最近一年没有更新][Yellow]](https://github.com/sethgrid/pester)   [![godoc][GoDoc]](https://godoc.org/github.com/sethgrid/pester)
* [request](https://github.com/monaco-io/request) **star:131** golang的HTTP客户端。如果您有关于axios或请求的经验，您会喜欢它。没有第三依赖性。   [![godoc][GoDoc]](https://godoc.org/github.com/monaco-io/request)
* [rq](https://github.com/ddo/rq) **star:39** golang stdlib HTTP客户端更好的接口。   [![最近一年没有更新][Yellow]](https://github.com/ddo/rq)   [![godoc][GoDoc]](https://godoc.org/github.com/ddo/rq)
* [go-http-client](https://github.com/bozd4g/go-http-client) **star:24** 简单而容易地进行http调用。   [![godoc][GoDoc]](https://godoc.org/github.com/bozd4g/go-http-client)
* [httpretry](https://github.com/ybbus/httpretry) **star:14** 用重试功能丰富默认的go HTTP客户端。   [![最近一年没有更新][Yellow]](https://github.com/ybbus/httpretry)   [![godoc][GoDoc]](https://godoc.org/github.com/ybbus/httpretry)
* [requests](https://github.com/carlmjohnson/requests) **star:10** gopher的HTTP请求。使用上下文。上下文，并且不隐藏底层的net/http。客户端，使其与标准Go api兼容。还包括测试工具。   [![最近一周有更新][Green]](https://github.com/carlmjohnson/requests)   [![godoc][GoDoc]](https://godoc.org/github.com/carlmjohnson/requests)

## OpenGL

*用于在Go中使用OpenGL的库。 (翻译出错了? 试试 [英文版](README_EN.md#opengl) 吧~)*

* [glfw](https://github.com/go-gl/glfw) **star:1133** GLFW 3 的 Go 接口实现。
* [gl](https://github.com/go-gl/gl) **star:821** OpenGL 的 Go 接口实现(通过glow生成)。   [![最近一周有更新][Green]](https://github.com/go-gl/gl)
* [mathgl](https://github.com/go-gl/mathgl) **star:387** 完全基于 Go 实现的数学软件包，专门用于处理三维数学。借鉴于 GLM。   [![godoc][GoDoc]](https://godoc.org/github.com/go-gl/mathgl)
* [goxjs/gl](https://github.com/goxjs/gl) **star:151** 跨平台的OpenGL 接口实现(OS X, Linux, Windows，浏览器，iOS, Android)。   [![godoc][GoDoc]](https://godoc.org/github.com/goxjs/gl)
* [goxjs/glfw](https://github.com/goxjs/glfw) **star:71** 跨平台 glfw 库，可用于创建 OpenGL 上下文并接收事件。   [![最近一年没有更新][Yellow]](https://github.com/goxjs/glfw)   [![godoc][GoDoc]](https://godoc.org/github.com/goxjs/glfw)
* [go-glmatrix](https://github.com/technohippy/go-glmatrix) **star:2** 访问[glMatrix](http://glmatrix.net/)库的端口。   [![godoc][GoDoc]](https://godoc.org/github.com/technohippy/go-glmatrix)

## ORM

*Libraries that implement Object-Relational Mapping or datamapping techniques. (翻译出错了? 试试 [英文版](README_EN.md#orm) 吧~)*

* [beego orm](https://github.com/beego/beego) **star:26836** 强大的orm框架。支持: pq/mysql/sqlite3。   [![star > 2000][Awesome]](https://github.com/beego/beego)   [![最近一周有更新][Green]](https://github.com/beego/beego)   [![godoc][GoDoc]](https://godoc.org/github.com/beego/beego)
* [GORM](https://github.com/go-gorm/gorm) **star:24882** 一个出色的 ORM 库。主要目标是对开发人员友好。   [![star > 2000][Awesome]](https://github.com/go-gorm/gorm)   [![最近一周有更新][Green]](https://github.com/go-gorm/gorm)   [![godoc][GoDoc]](https://godoc.org/github.com/go-gorm/gorm)
* [ent](https://github.com/facebook/ent) **star:8062** 一个用于Go的实体框架。用于建模和查询数据的简单而强大的ORM。   [![star > 2000][Awesome]](https://github.com/facebook/ent)   [![最近一周有更新][Green]](https://github.com/facebook/ent)   [![godoc][GoDoc]](https://godoc.org/github.com/facebook/ent)
* [go-pg](https://github.com/go-pg/pg) **star:4772** 用于 PostgreSQL 的ORM。侧重于 PostgreSQL 的特性和性能。   [![star > 2000][Awesome]](https://github.com/go-pg/pg)   [![godoc][GoDoc]](https://godoc.org/github.com/go-pg/pg)
* [SQLBoiler](https://github.com/volatiletech/sqlboiler) **star:4168** ORM 生成器。根据数据库 schema 生成一个功能强大且运行速度快的ORM。   [![star > 2000][Awesome]](https://github.com/volatiletech/sqlboiler)   [![godoc][GoDoc]](https://godoc.org/github.com/volatiletech/sqlboiler)
* [gorp](https://github.com/go-gorp/gorp) **star:3514** 基于 Go 的关系持久性 ORM-ish 库。   [![star > 2000][Awesome]](https://github.com/go-gorp/gorp)   [![godoc][GoDoc]](https://godoc.org/github.com/go-gorp/gorp)
* [upper.io/db](https://github.com/upper/db) **star:2695** 对外提供统一的接口用于访问不同的存储介质，例如PostgreSQL, MySQL, SQLite, MSSQL, QL、MongoDB.。   [![star > 2000][Awesome]](https://github.com/upper/db)   [![最近一周有更新][Green]](https://github.com/upper/db)   [![godoc][GoDoc]](https://godoc.org/github.com/upper/db)
* [XORM](https://gitea.com/xorm/xorm)  简单而强大的ORM for Go。(支持:MySQL, MyMysql, PostgreSQL, Tidb, SQLite3, MsSql和Oracle)。
* [gormt](https://github.com/xxjwxc/gormt) **star:1358** Mysql数据库到golang gorm结构。   [![godoc][GoDoc]](https://godoc.org/github.com/xxjwxc/gormt)
* [reform](https://github.com/go-reform/reform) **star:1162** 基于非空接口和代码生成的 ORM。   [![godoc][GoDoc]](https://godoc.org/github.com/go-reform/reform)
* [pop/soda](https://github.com/gobuffalo/pop) **star:1106** 数据库迁移、创建、ORM等。用于MySQL、PostgreSQL和SQLite。   [![godoc][GoDoc]](https://godoc.org/github.com/gobuffalo/pop)
* [go-queryset](https://github.com/jirfag/go-queryset) **star:631** 基于 GORM 100% 类型安全的 ORM。可支持 MySQL, PostgreSQL, Sqlite3, SQL Server。   [![godoc][GoDoc]](https://godoc.org/github.com/jirfag/go-queryset)
* [go-sqlbuilder](https://github.com/huandu/go-sqlbuilder) **star:619** 一个灵活而强大的SQL字符串构建器库。   [![godoc][GoDoc]](https://godoc.org/github.com/huandu/go-sqlbuilder)
* [rel](https://github.com/go-rel/rel) **star:404** Golang的现代数据库访问层——可测试、可扩展，并精心设计成一个干净优雅的API。   [![最近一周有更新][Green]](https://github.com/go-rel/rel)   [![godoc][GoDoc]](https://godoc.org/github.com/go-rel/rel)
* [Zoom](https://github.com/albrow/zoom) **star:278** 基于 Redis 的快速数据存储和查询引擎。   [![最近一年没有更新][Yellow]](https://github.com/albrow/zoom)   [![godoc][GoDoc]](https://godoc.org/github.com/albrow/zoom)
* [grimoire](https://github.com/Fs02/grimoire) **star:150** 基于 golang 的数据库访问层和验证库。(支持: MySQL, PostgreSQL和SQLite3)。   [![godoc][GoDoc]](https://godoc.org/github.com/Fs02/grimoire)
* [go-sql](https://github.com/rushteam/gosql) **star:143** 一个简单的ORM为mysql。   [![godoc][GoDoc]](https://godoc.org/github.com/rushteam/gosql)
* [go-store](https://github.com/gosuri/go-store) **star:102** 简单且快速的 Redis 键值存储库。   [![最近一年没有更新][Yellow]](https://github.com/gosuri/go-store)   [![godoc][GoDoc]](https://godoc.org/github.com/gosuri/go-store)
* [go-firestorm](https://github.com/jschoedt/go-firestorm) **star:24** 一个轻量级的ORM。用于Google/Firebase Cloud Firestore。   [![godoc][GoDoc]](https://godoc.org/github.com/jschoedt/go-firestorm)
* [lore](https://github.com/abrahambotros/lore) **star:8** Simple and lightweight pseudo-ORM/pseudo-struct-mapping environment for Go.   [![最近一年没有更新][Yellow]](https://github.com/abrahambotros/lore)   [![godoc][GoDoc]](https://godoc.org/github.com/abrahambotros/lore)
* [marlow](https://github.com/marlow/marlow) **star:6** 从项目结构生成ORM。   [![最近一年没有更新][Yellow]](https://github.com/marlow/marlow)   [![godoc][GoDoc]](https://godoc.org/github.com/marlow/marlow)

## 包管理

*用于管理依赖和包的官方工具 (翻译出错了? 试试 [英文版](README_EN.md#package-management) 吧~)*

* [go modules](https://golang.org/cmd/go/#hdr-Modules__module_versions__and_more)  Modules 是源码的版本控制和交换的单位。go命令直接支持处理模块，包括记录和解决对其他模块的依赖关系。

*包管理的官方实验工具 (翻译出错了? 试试 [英文版](README_EN.md#package-management) 吧~)*

* [dep](https://github.com/golang/dep) **star:13146**  Go 的依赖管理工具，需要 Go 1.9+   [![star > 2000][Awesome]](https://github.com/golang/dep)   [![godoc][GoDoc]](https://godoc.org/github.com/golang/dep)   [![归档项目][Archived]](https://github.com/golang/dep)
* [vgo](https://go.googlesource.com/vgo/)  Go 命令版本管理

*用于包和依赖项管理的非官方库。 (翻译出错了? 试试 [英文版](README_EN.md#package-management) 吧~)*

* [glide](https://github.com/Masterminds/glide) **star:8115** 轻松管理您的 golang 第三方包。受Maven、Bundler和Pip等工具的启发。   [![star > 2000][Awesome]](https://github.com/Masterminds/glide)   [![godoc][GoDoc]](https://godoc.org/github.com/Masterminds/glide)
* [godep](https://github.com/tools/godep) **star:5609** godep是go的依赖工具，它通过修复包的依赖关系来帮助构建可重复的包。   [![star > 2000][Awesome]](https://github.com/tools/godep)   [![最近一年没有更新][Yellow]](https://github.com/tools/godep)   [![godoc][GoDoc]](https://godoc.org/github.com/tools/godep)   [![归档项目][Archived]](https://github.com/tools/godep)
* [govendor](https://github.com/kardianos/govendor) **star:5001** 包管理器。使用 vendor 文件的 Go vendor 工具。   [![star > 2000][Awesome]](https://github.com/kardianos/govendor)   [![最近一年没有更新][Yellow]](https://github.com/kardianos/govendor)   [![godoc][GoDoc]](https://godoc.org/github.com/kardianos/govendor)   [![归档项目][Archived]](https://github.com/kardianos/govendor)
* [gopm](https://github.com/gpmgo/gopm) **star:2496** 包管理器。   [![star > 2000][Awesome]](https://github.com/gpmgo/gopm)   [![最近一年没有更新][Yellow]](https://github.com/gpmgo/gopm)   [![godoc][GoDoc]](https://godoc.org/github.com/gpmgo/gopm)   [![归档项目][Archived]](https://github.com/gpmgo/gopm)
* [gom](https://github.com/mattn/gom) **star:1395** Go Manager - bundle for Go。   [![最近一年没有更新][Yellow]](https://github.com/mattn/gom)   [![godoc][GoDoc]](https://godoc.org/github.com/mattn/gom)
* [gpm](https://github.com/pote/gpm) **star:1197** 基本的 Go 依赖管理器。   [![最近一年没有更新][Yellow]](https://github.com/pote/gpm)
* [goop](https://github.com/nitrous-io/goop) **star:778** Go 的简单依赖管理器，灵感来自Bundler。   [![最近一年没有更新][Yellow]](https://github.com/nitrous-io/goop)   [![godoc][GoDoc]](https://godoc.org/github.com/nitrous-io/goop)
* [modgv](https://github.com/lucasepe/modgv) **star:386** 将'go mod graph'输出转换为Graphviz的点语言。   [![godoc][GoDoc]](https://godoc.org/github.com/lucasepe/modgv)
* [nut](https://github.com/jingweno/nut) **star:239** vendor 依赖。   [![最近一年没有更新][Yellow]](https://github.com/jingweno/nut)   [![godoc][GoDoc]](https://godoc.org/github.com/jingweno/nut)
* [johnny-deps](https://github.com/VividCortex/johnny-deps) **star:215** 使用Git的最小依赖版本。
* [mvn-golang](https://github.com/raydac/mvn-golang) **star:131** 插件，为自动加载Golang SDK，依赖关系管理和启动Maven项目基础设施中的构建环境提供了方法。   [![最近一周有更新][Green]](https://github.com/raydac/mvn-golang)
* [VenGO](https://github.com/DamnWidget/VenGO) **star:120** 创建和管理可导出的隔离go虚拟环境。   [![最近一年没有更新][Yellow]](https://github.com/DamnWidget/VenGO)   [![godoc][GoDoc]](https://godoc.org/github.com/DamnWidget/VenGO)
* [gop](https://github.com/lunny/gop) **star:49** 在GOPATH之外构建和管理Go应用程序。   [![最近一年没有更新][Yellow]](https://github.com/lunny/gop)   [![godoc][GoDoc]](https://godoc.org/github.com/lunny/gop)   [![包含中文文档][CN]](https://github.com/lunny/gop)   [![归档项目][Archived]](https://github.com/lunny/gop)

## 性能

* [jaeger](https://github.com/jaegertracing/jaeger) **star:14074** 分布式跟踪系统。   [![star > 2000][Awesome]](https://github.com/jaegertracing/jaeger)   [![最近一周有更新][Green]](https://github.com/jaegertracing/jaeger)   [![godoc][GoDoc]](https://godoc.org/github.com/jaegertracing/jaeger)
* [pixie](https://github.com/pixie-labs/pixie) **star:1750** 通过eBPF对Golang应用程序没有检测跟踪。   [![最近一周有更新][Green]](https://github.com/pixie-labs/pixie)
* [profile](https://github.com/pkg/profile) **star:1548** Go的简单分析支持包。   [![godoc][GoDoc]](https://godoc.org/github.com/pkg/profile)
* [statsviz](https://github.com/arl/statsviz) **star:1520** 实时可视化您的Go应用程序运行时统计数据。   [![godoc][GoDoc]](https://godoc.org/github.com/arl/statsviz)
* [tracer](https://github.com/kamilsk/tracer) **star:51** 简单、轻量级的跟踪。   [![godoc][GoDoc]](https://godoc.org/github.com/kamilsk/tracer)

## 查询语言

* [graphql-go](https://github.com/graphql-go/graphql) **star:7889** 为Go实现GraphQL。   [![star > 2000][Awesome]](https://github.com/graphql-go/graphql)   [![godoc][GoDoc]](https://godoc.org/github.com/graphql-go/graphql)
* [gqlgen](https://github.com/99designs/gqlgen) **star:6412** 去生成基于graphql服务器库。   [![star > 2000][Awesome]](https://github.com/99designs/gqlgen)   [![最近一周有更新][Green]](https://github.com/99designs/gqlgen)   [![godoc][GoDoc]](https://godoc.org/github.com/99designs/gqlgen)
* [graphql](https://github.com/neelance/graphql-go) **star:3838** 关注易用性的GraphQL服务器。   [![star > 2000][Awesome]](https://github.com/neelance/graphql-go)   [![godoc][GoDoc]](https://godoc.org/github.com/neelance/graphql-go)
* [gojsonq](https://github.com/thedevsaddam/gojsonq) **star:1721** 一个用来查询JSON数据的Go包。   [![最近一周有更新][Green]](https://github.com/thedevsaddam/gojsonq)   [![godoc][GoDoc]](https://godoc.org/github.com/thedevsaddam/gojsonq)
* [dasel](https://github.com/tomwright/dasel) **star:1338** 使用命令行中的选择器查询和更新数据结构。与jq/yq类似，但支持JSON、YAML、TOML和XML，运行时依赖关系为零。   [![最近一周有更新][Green]](https://github.com/tomwright/dasel)   [![godoc][GoDoc]](https://godoc.org/github.com/tomwright/dasel)
* [jsonql](https://github.com/elgs/jsonql) **star:245** Golang中的JSON查询表达式库。   [![godoc][GoDoc]](https://godoc.org/github.com/elgs/jsonql)
* [rql](https://github.com/a8m/rql) **star:221** 用于REST API的资源查询语言。   [![godoc][GoDoc]](https://godoc.org/github.com/a8m/rql)
* [jsonslice](https://github.com/bhmj/jsonslice) **star:54** 使用高级过滤器查询Jsonpath。   [![godoc][GoDoc]](https://godoc.org/github.com/bhmj/jsonslice)
* [graphql](https://github.com/tmc/graphql) **star:53** graphql解析器+工具集   [![最近一年没有更新][Yellow]](https://github.com/tmc/graphql)   [![godoc][GoDoc]](https://godoc.org/github.com/tmc/graphql)
* [api-fu](https://github.com/ccbrown/api-fu) **star:34** 综合GraphQL实现。   [![godoc][GoDoc]](https://godoc.org/github.com/ccbrown/api-fu)
* [straf](https://github.com/SonicRoshan/straf) **star:31** 轻松地将Golang结构转换为GraphQL对象。   [![最近一年没有更新][Yellow]](https://github.com/SonicRoshan/straf)   [![godoc][GoDoc]](https://godoc.org/github.com/SonicRoshan/straf)
* [rqp](https://github.com/timsolov/rest-query-parser) **star:25** REST API的查询解析器。查询中直接支持筛选、验证、'和'或'操作。   [![godoc][GoDoc]](https://godoc.org/github.com/timsolov/rest-query-parser)
* [jsonpath](https://github.com/AsaiYusuke/jsonpath) **star:5** 一个基于JSONPath语法检索部分JSON的查询库。   [![godoc][GoDoc]](https://godoc.org/github.com/AsaiYusuke/jsonpath)
* [gws](https://github.com/Zaba505/gws) **star:4** Apollos的“GraphQL over Websocket”客户端和服务器实现。   [![godoc][GoDoc]](https://godoc.org/github.com/Zaba505/gws)

## 嵌入的资源

* [packr](https://github.com/gobuffalo/packr) **star:3255** 将静态文件嵌入到Go二进制文件中的简单方法。   [![star > 2000][Awesome]](https://github.com/gobuffalo/packr)   [![godoc][GoDoc]](https://godoc.org/github.com/gobuffalo/packr)
* [statik](https://github.com/rakyll/statik) **star:3238** 将静态文件嵌入到Go可执行文件中。   [![star > 2000][Awesome]](https://github.com/rakyll/statik)   [![godoc][GoDoc]](https://godoc.org/github.com/rakyll/statik)
* [go.rice](https://github.com/GeertJohan/go.rice) **star:2235** 走了。rice是一个Go包，它使得处理HTML、JS、CSS、图像和模板等资源非常容易。   [![star > 2000][Awesome]](https://github.com/GeertJohan/go.rice)   [![godoc][GoDoc]](https://godoc.org/github.com/GeertJohan/go.rice)
* [vfsgen](https://github.com/shurcooL/vfsgen) **star:931** 生成一个vfsdata。静态实现给定虚拟文件系统的go文件。   [![最近一年没有更新][Yellow]](https://github.com/shurcooL/vfsgen)   [![godoc][GoDoc]](https://godoc.org/github.com/shurcooL/vfsgen)
* [esc](https://github.com/mjibson/esc) **star:602** 将文件嵌入到Go程序中并提供http文件系统接口。   [![最近一年没有更新][Yellow]](https://github.com/mjibson/esc)   [![godoc][GoDoc]](https://godoc.org/github.com/mjibson/esc)
* [fileb0x](https://github.com/UnnoTed/fileb0x) **star:588** 一个可定制的工具用来在Go中嵌入文件   [![godoc][GoDoc]](https://godoc.org/github.com/UnnoTed/fileb0x)
* [go-resources](https://github.com/omeid/go-resources) **star:172** 嵌入到Go中的普通资源。   [![godoc][GoDoc]](https://godoc.org/github.com/omeid/go-resources)
* [statics](https://github.com/go-playground/statics) **star:63** 将静态资源嵌入到go文件中，用于单个二进制编译+使用http。文件系统+符号链接。   [![最近一年没有更新][Yellow]](https://github.com/go-playground/statics)   [![godoc][GoDoc]](https://godoc.org/github.com/go-playground/statics)
* [templify](https://github.com/wlbr/templify) **star:26** 将外部模板文件嵌入到Go代码中，以创建单个文件二进制文件。   [![最近一周有更新][Green]](https://github.com/wlbr/templify)   [![godoc][GoDoc]](https://godoc.org/github.com/wlbr/templify)
* [rebed](https://github.com/soypat/rebed) **star:18** 重新创建Go 1.16' embed中的文件夹结构和文件。FS的类型   [![godoc][GoDoc]](https://godoc.org/github.com/soypat/rebed)
* [mule](https://github.com/wlbr/mule) **star:9** 嵌入外部资源，如图像，电影…   [![最近一周有更新][Green]](https://github.com/wlbr/mule)   [![godoc][GoDoc]](https://godoc.org/github.com/wlbr/mule)
* [debme](https://github.com/leaanthony/debme) **star:8** 创建一个“嵌入。FS '从一个现有的'嵌入。FS的子目录。   [![godoc][GoDoc]](https://godoc.org/github.com/leaanthony/debme)

## 科学与数据分析

*用于科学计算和数据分析的库。 (翻译出错了? 试试 [英文版](README_EN.md#science-and-data-analysis) 吧~)*

* [gonum](https://github.com/gonum/gonum) **star:5104** Gonum是一组用于Go编程语言的数字库。它包含用于矩阵、统计、优化等的库。   [![star > 2000][Awesome]](https://github.com/gonum/gonum)   [![最近一周有更新][Green]](https://github.com/gonum/gonum)   [![godoc][GoDoc]](https://godoc.org/github.com/gonum/gonum)
* [stats](https://github.com/montanaflynn/stats) **star:2029** 包含Golang标准库中缺少的公共函数的统计软件包。   [![star > 2000][Awesome]](https://github.com/montanaflynn/stats)   [![godoc][GoDoc]](https://godoc.org/github.com/montanaflynn/stats)
* [gonum/plot](https://github.com/gonum/plot) **star:1961** gonum/plot提供了一个API，用于在Go中构建和绘制绘图。   [![最近一周有更新][Green]](https://github.com/gonum/plot)   [![godoc][GoDoc]](https://godoc.org/github.com/gonum/plot)
* [gosl](https://github.com/cpmech/gosl) **star:1599** 提供线性代数，FFT，几何，NURBS，数值方法，概率，优化，微分方程，等等。   [![godoc][GoDoc]](https://godoc.org/github.com/cpmech/gosl)
* [streamtools](https://github.com/nytlabs/streamtools) **star:1312** 通用图形工具，用于处理数据流。   [![最近一年没有更新][Yellow]](https://github.com/nytlabs/streamtools)   [![godoc][GoDoc]](https://godoc.org/github.com/nytlabs/streamtools)
* [go-dsp](https://github.com/mjibson/go-dsp) **star:743** Go数字信号处理。   [![最近一年没有更新][Yellow]](https://github.com/mjibson/go-dsp)   [![godoc][GoDoc]](https://godoc.org/github.com/mjibson/go-dsp)
* [chart](https://github.com/vdobler/chart) **star:686** 简单的图表绘制库。支持多种图形类型。   [![godoc][GoDoc]](https://godoc.org/github.com/vdobler/chart)
* [goraph](https://github.com/gyuho/goraph) **star:645** 纯Go图论库(数据结构，算法可视化)。   [![最近一年没有更新][Yellow]](https://github.com/gyuho/goraph)   [![godoc][GoDoc]](https://godoc.org/github.com/gyuho/goraph)
* [dataframe-go](https://github.com/rocketlaunchr/dataframe-go) **star:595** 用于机器学习和统计的数据框架(类似于panda)。   [![godoc][GoDoc]](https://godoc.org/github.com/rocketlaunchr/dataframe-go)
* [graph](https://github.com/yourbasic/graph) **star:472** 基本图形算法库。   [![godoc][GoDoc]](https://godoc.org/github.com/yourbasic/graph)
* [orb](https://github.com/paulmach/orb) **star:413** 2D几何类型，支持剪切、GeoJSON和Mapbox矢量平铺。   [![godoc][GoDoc]](https://godoc.org/github.com/paulmach/orb)
* [ewma](https://github.com/VividCortex/ewma) **star:337** 提供指数加权移动平均算法。   [![最近一周有更新][Green]](https://github.com/VividCortex/ewma)   [![godoc][GoDoc]](https://godoc.org/github.com/VividCortex/ewma)
* [calendarheatmap](https://github.com/nikolaydubina/calendarheatmap) **star:320** 基于Github贡献活动的日历热图。   [![最近一周有更新][Green]](https://github.com/nikolaydubina/calendarheatmap)   [![godoc][GoDoc]](https://godoc.org/github.com/nikolaydubina/calendarheatmap)
* [gohistogram](https://github.com/VividCortex/gohistogram) **star:156** 数据流的近似直方图。   [![godoc][GoDoc]](https://godoc.org/github.com/VividCortex/gohistogram)
* [TextRank](https://github.com/DavidBelicza/TextRank) **star:142** TextRank在Golang中的实现，支持扩展特性(摘要、加权、短语提取)和多线程(goroutine)。   [![godoc][GoDoc]](https://godoc.org/github.com/DavidBelicza/TextRank)
* [sparse](https://github.com/james-bowman/sparse) **star:119**  Go 稀疏矩阵格式的线性代数支持科学和机器学习应用程序，兼容gonum矩阵库。   [![godoc][GoDoc]](https://godoc.org/github.com/james-bowman/sparse)
* [go-estimate](https://github.com/milosgajdos/go-estimate) **star:75** Go中的状态估计和滤波算法。   [![godoc][GoDoc]](https://godoc.org/github.com/milosgajdos/go-estimate)
* [pagerank](https://github.com/alixaxel/pagerank) **star:71** 加权 PageRank 算法在Go中的实现。   [![godoc][GoDoc]](https://godoc.org/github.com/alixaxel/pagerank)
* [geom](https://github.com/skelterjohn/geom) **star:48**  Go 的二维几何。   [![最近一年没有更新][Yellow]](https://github.com/skelterjohn/geom)   [![godoc][GoDoc]](https://godoc.org/github.com/skelterjohn/geom)
* [evaler](https://github.com/soniah/evaler) **star:45** 简单的浮点算术表达式求值器。   [![最近一年没有更新][Yellow]](https://github.com/soniah/evaler)   [![godoc][GoDoc]](https://godoc.org/github.com/soniah/evaler)
* [goent](https://github.com/kzahedi/goent) **star:25**  Go 实现熵度量。   [![最近一年没有更新][Yellow]](https://github.com/kzahedi/goent)   [![godoc][GoDoc]](https://godoc.org/github.com/kzahedi/goent)
* [triangolatte](https://github.com/tchayen/triangolatte) **star:24** 二维三角库。允许将线和多边形(都基于点)转换为gpu语言。   [![godoc][GoDoc]](https://godoc.org/github.com/tchayen/triangolatte)
* [decimal](https://github.com/db47h/decimal) **star:23** Package decimal实现任意精度的十进制浮点运算。   [![最近一年没有更新][Yellow]](https://github.com/db47h/decimal)   [![godoc][GoDoc]](https://godoc.org/github.com/db47h/decimal)
* [piecewiselinear](https://github.com/sgreben/piecewiselinear) **star:19** 微型线性插值库。   [![godoc][GoDoc]](https://godoc.org/github.com/sgreben/piecewiselinear)
* [GoStats](https://github.com/OGFris/GoStats) **star:16** GoStats是一个开放源码的GoLang库，主要用于机器学习领域的数学统计，它涵盖了大多数统计度量函数。   [![最近一年没有更新][Yellow]](https://github.com/OGFris/GoStats)   [![godoc][GoDoc]](https://godoc.org/github.com/OGFris/GoStats)
* [jsonl-graph](https://github.com/nikolaydubina/jsonl-graph) **star:16** 使用graphviz支持操作JSONL图形的工具。   [![godoc][GoDoc]](https://godoc.org/github.com/nikolaydubina/jsonl-graph)
* [godesim](https://github.com/soypat/godesim) **star:15** 扩展/多变量ODE求解器框架，用于基于事件的模拟与简单的API。   [![godoc][GoDoc]](https://godoc.org/github.com/soypat/godesim)
* [PiHex](https://github.com/claygod/PiHex) **star:14** 实现了针对16进制数 Pi 的“bailee - borwein - plouffe”算法。   [![godoc][GoDoc]](https://godoc.org/github.com/claygod/PiHex)
* [ode](https://github.com/ChristopherRabotin/ode) **star:13** 常微分方程(ODE)求解器，支持扩展状态和基于信道的迭代停止条件。   [![最近一年没有更新][Yellow]](https://github.com/ChristopherRabotin/ode)   [![godoc][GoDoc]](https://godoc.org/github.com/ChristopherRabotin/ode)
* [assocentity](https://github.com/ndabAP/assocentity) **star:5** assocentity 返回单词到给定实体的平均距离。   [![godoc][GoDoc]](https://godoc.org/github.com/ndabAP/assocentity)
* [go-gt](https://github.com/ThePaw/go-gt) **star:5** 用“Go”语言编写的图论算法。   [![最近一年没有更新][Yellow]](https://github.com/ThePaw/go-gt)   [![godoc][GoDoc]](https://godoc.org/github.com/ThePaw/go-gt)
* [rootfinding](https://github.com/khezen/rootfinding) **star:5** 二次函数求根算法库。   [![最近一年没有更新][Yellow]](https://github.com/khezen/rootfinding)   [![godoc][GoDoc]](https://godoc.org/github.com/khezen/rootfinding)
* [bradleyterry](https://github.com/seanhagen/bradleyterry) **star:4** 为成对比较提供了一个 Bradley-Terry 模型。   [![最近一年没有更新][Yellow]](https://github.com/seanhagen/bradleyterry)   [![godoc][GoDoc]](https://godoc.org/github.com/seanhagen/bradleyterry)

## 安全

*用于帮助您的应用程序更安全的库。 (翻译出错了? 试试 [英文版](README_EN.md#security) 吧~)*

* [lego](https://github.com/go-acme/lego) **star:4751** 纯 Go ACME 客户端库及命令行工具   [![star > 2000][Awesome]](https://github.com/go-acme/lego)   [![最近一周有更新][Green]](https://github.com/go-acme/lego)   [![godoc][GoDoc]](https://godoc.org/github.com/go-acme/lego)
* [Cameradar](https://github.com/Ullaakut/cameradar) **star:2652** 工具和库，以远程入侵RTSP流从监控摄像头。   [![star > 2000][Awesome]](https://github.com/Ullaakut/cameradar)   [![godoc][GoDoc]](https://godoc.org/github.com/Ullaakut/cameradar)
* [memguard](https://github.com/awnumar/memguard) **star:1972** 一个用于处理内存中敏感值的纯Go库。   [![godoc][GoDoc]](https://godoc.org/github.com/awnumar/memguard)
* [acmetool](https://github.com/hlandau/acme) **star:1868** ACME(让我们用自动更新加密)客户端工具。   [![godoc][GoDoc]](https://godoc.org/github.com/hlandau/acme)
* [secure](https://github.com/unrolled/secure) **star:1804** Go 语言 HTTP 中间件，为 Go 提供了一些安全功能   [![godoc][GoDoc]](https://godoc.org/github.com/unrolled/secure)
* [themis](https://github.com/cossacklabs/themis) **star:1328** 用于解决典型数据安全任务(安全数据存储、安全消息传递、零知识证明认证)的高级加密库，可用于14种语言，最适合多平台应用程序。
* [acra](https://github.com/cossacklabs/acra) **star:785** 网络加密代理保护基于数据库的应用程序免受数据泄漏:强选择性加密，SQL注入预防，入侵检测系统。   [![godoc][GoDoc]](https://godoc.org/github.com/cossacklabs/acra)
* [nacl](https://github.com/kevinburke/nacl) **star:508**  Go 实现NaCL API的集合。   [![godoc][GoDoc]](https://godoc.org/github.com/kevinburke/nacl)
* [firewalld-rest](https://github.com/prashantgupta24/firewalld-rest) **star:306** 用于动态更新linux服务器上的firewalld规则的rest应用程序。   [![godoc][GoDoc]](https://godoc.org/github.com/prashantgupta24/firewalld-rest)
* [ssh-vault](https://github.com/ssh-vault/ssh-vault) **star:304** 使用ssh密钥加密/解密。   [![godoc][GoDoc]](https://godoc.org/github.com/ssh-vault/ssh-vault)
* [BadActor](https://github.com/jaredfolkins/badactor) **star:300** 一个驻留在内存中的，应用驱动的监控程序，受 fail2ban 的启发   [![最近一年没有更新][Yellow]](https://github.com/jaredfolkins/badactor)   [![godoc][GoDoc]](https://godoc.org/github.com/jaredfolkins/badactor)
* [go-password-validator](https://github.com/lane-c-wagner/go-password-validator) **star:288** 基于原始密码熵值的密码验证器。   [![godoc][GoDoc]](https://godoc.org/github.com/lane-c-wagner/go-password-validator)
* [optimus-go](https://github.com/pjebs/optimus-go) **star:283** 使用Knuth的算法进行ID哈希和混淆。   [![最近一年没有更新][Yellow]](https://github.com/pjebs/optimus-go)   [![godoc][GoDoc]](https://godoc.org/github.com/pjebs/optimus-go)
* [passlib](https://github.com/hlandau/passlib) **star:250** 不过时的密码哈希库。   [![godoc][GoDoc]](https://godoc.org/github.com/hlandau/passlib)
* [go-yara](https://github.com/hillu/go-yara) **star:219** YARA的 Go 语言接口，号称是 “对于恶意软件研究者（以及其他人）来说是模式匹配的瑞士军刀”   [![godoc][GoDoc]](https://godoc.org/github.com/hillu/go-yara)
* [simple-scrypt](https://github.com/elithrar/simple-scrypt) **star:172** Scrypt 库，具有简单、易懂的 API，同时具有内置的自动校准功能   [![godoc][GoDoc]](https://godoc.org/github.com/elithrar/simple-scrypt)
* [argon2pw](https://github.com/raja/argon2pw) **star:85** 使用常量时间密码比较生成Argon2密码散列。   [![最近一年没有更新][Yellow]](https://github.com/raja/argon2pw)   [![godoc][GoDoc]](https://godoc.org/github.com/raja/argon2pw)
* [autocert](https://godoc.org/golang.org/x/crypto/acme/autocert)  让我们加密证书并启动TLS服务器。
* [goSecretBoxPassword](https://github.com/dwin/goSecretBoxPassword) **star:42** 一个安全哈希和加密密码的偏执包。   [![godoc][GoDoc]](https://godoc.org/github.com/dwin/goSecretBoxPassword)
* [Interpol](https://bitbucket.org/vahidi/interpol)  基于规则的数据生成器，用于模糊和渗透测试。
* [go-generate-password](https://github.com/m1/go-generate-password) **star:26** 可以在cli上或作为库使用的密码生成器。   [![最近一周有更新][Green]](https://github.com/m1/go-generate-password)   [![godoc][GoDoc]](https://godoc.org/github.com/m1/go-generate-password)
* [certificates](https://github.com/mvmaasakkers/certificates) **star:21** 用于生成tls证书的自定义工具。   [![godoc][GoDoc]](https://godoc.org/github.com/mvmaasakkers/certificates)
* [secureio](https://github.com/xaionaro-go/secureio) **star:18** 一个密钥交换+认证+加密的包装和多路复用的' io。读写ecloser '基于XChaCha20-poly1305, ECDH和ED25519。   [![最近一年没有更新][Yellow]](https://github.com/xaionaro-go/secureio)   [![godoc][GoDoc]](https://godoc.org/github.com/xaionaro-go/secureio)
* [goArgonPass](https://github.com/dwin/goArgonPass) **star:14** Argon2密码散列和验证设计为与现有Python和PHP实现兼容。   [![godoc][GoDoc]](https://godoc.org/github.com/dwin/goArgonPass)
* [argon2-hashing](https://github.com/andskur/argon2-hashing) **star:13** 轻包装周围的Go的argon2包，它与Go的标准库Bcrypt和simple-scrypt包密切镜像。   [![最近一年没有更新][Yellow]](https://github.com/andskur/argon2-hashing)   [![godoc][GoDoc]](https://godoc.org/github.com/andskur/argon2-hashing)
* [sslmgr](https://github.com/adrianosela/sslmgr) **star:11** 使用围绕acme/autocert的高级包装器，SSL证书变得很容易。   [![最近一年没有更新][Yellow]](https://github.com/adrianosela/sslmgr)   [![godoc][GoDoc]](https://godoc.org/github.com/adrianosela/sslmgr)


## 序列化

*用于二进制序列化的库和工具。 (翻译出错了? 试试 [英文版](README_EN.md#serialization) 吧~)*

* [jsoniter](https://github.com/json-iterator/go) **star:9691** 高性能，100% 兼容的“encoding/json” 替代品   [![star > 2000][Awesome]](https://github.com/json-iterator/go)   [![最近一周有更新][Green]](https://github.com/json-iterator/go)   [![godoc][GoDoc]](https://godoc.org/github.com/json-iterator/go)
* [goprotobuf](https://github.com/golang/protobuf) **star:7847** 通过库和协议编译器插件使 Go 语言支持 Google的 protocol buffers.   [![star > 2000][Awesome]](https://github.com/golang/protobuf)   [![godoc][GoDoc]](https://godoc.org/github.com/golang/protobuf)
* [mapstructure](https://github.com/mitchellh/mapstructure) **star:4774** 用于对原生键值对进行解码生成 Go 语言结构体   [![star > 2000][Awesome]](https://github.com/mitchellh/mapstructure)   [![godoc][GoDoc]](https://godoc.org/github.com/mitchellh/mapstructure)
* [gogoprotobuf](https://github.com/gogo/protobuf) **star:4773** Go 语言的 Protocol Buffer 库。   [![star > 2000][Awesome]](https://github.com/gogo/protobuf)   [![最近一周有更新][Green]](https://github.com/gogo/protobuf)   [![godoc][GoDoc]](https://godoc.org/github.com/gogo/protobuf)
* [go-codec](https://github.com/ugorji/go) **star:1569** 高性能、多功能、规范化编码解码以及 rpc 库， 用于 msgpack, cbor 和 json，支持基于运行时的 OR 码生成   [![godoc][GoDoc]](https://godoc.org/github.com/ugorji/go)
* [colfer](https://github.com/pascaldekloe/colfer) **star:616** 为Colfer二进制格式生成代码。   [![godoc][GoDoc]](https://godoc.org/github.com/pascaldekloe/colfer)
* [csvutil](https://github.com/jszwec/csvutil) **star:564** 高性能、惯用的CSV记录编码和解码到本机Go结构。   [![godoc][GoDoc]](https://godoc.org/github.com/jszwec/csvutil)
* [cbor](https://github.com/fxamacker/cbor) **star:308** 小，安全，容易的CBOR编码和解码库。   [![最近一周有更新][Green]](https://github.com/fxamacker/cbor)   [![godoc][GoDoc]](https://godoc.org/github.com/fxamacker/cbor)
* [go-capnproto](https://github.com/glycerine/go-capnproto) **star:279** Go 语言用的 Cap'n Proto 库及解析器   [![最近一年没有更新][Yellow]](https://github.com/glycerine/go-capnproto)   [![godoc][GoDoc]](https://godoc.org/github.com/glycerine/go-capnproto)
* [php_session_decoder](https://github.com/yvasiyarov/php_session_decoder) **star:151** 用于协同 PHP session 格式数据和 PHP 序列化／反序列化函数工作的go语言库   [![最近一年没有更新][Yellow]](https://github.com/yvasiyarov/php_session_decoder)   [![godoc][GoDoc]](https://godoc.org/github.com/yvasiyarov/php_session_decoder)
* [structomap](https://github.com/tuvistavie/structomap) **star:124** 用于从静态结构体简单、动态的生成键值对的库   [![最近一年没有更新][Yellow]](https://github.com/tuvistavie/structomap)   [![godoc][GoDoc]](https://godoc.org/github.com/tuvistavie/structomap)
* [bambam](https://github.com/glycerine/bambam) **star:62** 用于 Go 语言生成 Cap'n Proto schemas 的生成器   [![最近一年没有更新][Yellow]](https://github.com/glycerine/bambam)   [![godoc][GoDoc]](https://godoc.org/github.com/glycerine/bambam)
* [asn1](https://github.com/PromonLogicalis/asn1) **star:47** 面向golang的BER和DER编码库。   [![最近一年没有更新][Yellow]](https://github.com/PromonLogicalis/asn1)   [![godoc][GoDoc]](https://godoc.org/github.com/PromonLogicalis/asn1)   [![归档项目][Archived]](https://github.com/PromonLogicalis/asn1)
* [binstruct](https://github.com/ghostiam/binstruct) **star:32** 用于将数据映射到结构中的Golang二进制解码器。   [![最近一年没有更新][Yellow]](https://github.com/ghostiam/binstruct)   [![godoc][GoDoc]](https://godoc.org/github.com/ghostiam/binstruct)
* [elastic](https://github.com/epiclabs-io/elastic) **star:15** 在运行时跨不同类型转换片、映射或任何其他未知值   [![godoc][GoDoc]](https://godoc.org/github.com/epiclabs-io/elastic)
* [fwencoder](https://github.com/o1egl/fwencoder) **star:14** 用于Go的固定宽度文件解析器(编码和解码库)。   [![最近一年没有更新][Yellow]](https://github.com/o1egl/fwencoder)   [![godoc][GoDoc]](https://godoc.org/github.com/o1egl/fwencoder)
* [pletter](https://github.com/vimeda/pletter) **star:14** A standard way to wrap a proto message for message brokers.   [![godoc][GoDoc]](https://godoc.org/github.com/vimeda/pletter)
* [bel](https://github.com/32leaves/bel) **star:13** 从Go structs/interface生成TypeScript接口。对JSON RPC很有用。   [![最近一年没有更新][Yellow]](https://github.com/32leaves/bel)   [![godoc][GoDoc]](https://godoc.org/github.com/32leaves/bel)
* [fixedwidth](https://github.com/huydang284/fixedwidth) **star:5** 固定宽度的文本格式(支持UTF-8)。   [![最近一年没有更新][Yellow]](https://github.com/huydang284/fixedwidth)   [![godoc][GoDoc]](https://godoc.org/github.com/huydang284/fixedwidth)
* [go-lctree](https://github.com/sbourlon/go-lctree) **star:2** 提供一个CLI和原语来序列化和反序列化[LeetCode二进制树](https://support.leetcode.com/hc/en-us/articles/360011883654-what-does -1-null-2-3-mean-in-二进制树表示)。   [![最近一年没有更新][Yellow]](https://github.com/sbourlon/go-lctree)   [![godoc][GoDoc]](https://godoc.org/github.com/sbourlon/go-lctree)
* [unitpacking](https://github.com/recolude/unitpacking) **star:2** 标准库将单元向量打包到尽可能少的字节中。   [![godoc][GoDoc]](https://godoc.org/github.com/recolude/unitpacking)

## 服务器应用程序

* [etcd](https://github.com/coreos/etcd) **star:36953** 为共享配置和服务发现提供高可用的键值存储。   [![star > 2000][Awesome]](https://github.com/coreos/etcd)   [![最近一周有更新][Green]](https://github.com/coreos/etcd)   [![godoc][GoDoc]](https://godoc.org/github.com/coreos/etcd)
* [Caddy](https://github.com/caddyserver/caddy) **star:34295** Caddy是另一种HTTP/2 web服务器，易于配置和使用。   [![star > 2000][Awesome]](https://github.com/caddyserver/caddy)   [![最近一周有更新][Green]](https://github.com/caddyserver/caddy)   [![godoc][GoDoc]](https://godoc.org/github.com/caddyserver/caddy)
* [consul](https://www.consul.io/)  Consul 是一个用于服务发现、监控和配置的工具
* [minio](https://github.com/minio/minio) **star:28973** Minio是一个分布式对象存储服务器。   [![star > 2000][Awesome]](https://github.com/minio/minio)   [![最近一周有更新][Green]](https://github.com/minio/minio)   [![godoc][GoDoc]](https://godoc.org/github.com/minio/minio)
* [Moxy](https://github.com/sinhashubham95/moxy)  Moxy是一个简单的模拟和代理应用程序服务器，您可以创建模拟端点以及代理请求，以防端点不存在模拟。
* [RoadRunner](https://github.com/spiral/roadrunner) **star:5788** 高性能PHP应用服务器，负载平衡器和进程管理器。   [![star > 2000][Awesome]](https://github.com/spiral/roadrunner)   [![最近一周有更新][Green]](https://github.com/spiral/roadrunner)   [![godoc][GoDoc]](https://godoc.org/github.com/spiral/roadrunner)
* [Easegress](https://github.com/megaease/easegress) **star:3485** 具有可观察性和可扩展性的云本地高可用性/性能流量编排系统。   [![star > 2000][Awesome]](https://github.com/megaease/easegress)   [![最近一周有更新][Green]](https://github.com/megaease/easegress)   [![godoc][GoDoc]](https://godoc.org/github.com/megaease/easegress)
* [devd](https://github.com/cortesi/devd) **star:3158** 为开发人员提供本地web服务器。   [![star > 2000][Awesome]](https://github.com/cortesi/devd)   [![最近一周有更新][Green]](https://github.com/cortesi/devd)   [![godoc][GoDoc]](https://godoc.org/github.com/cortesi/devd)
* [SFTPGo](https://github.com/drakkan/sftpgo) **star:2847** 完全功能和高度可配置的SFTP服务器与可选的FTP/S和WebDAV支持。它可以为本地文件系统和云存储后端(如S3和谷歌云存储)提供服务。   [![star > 2000][Awesome]](https://github.com/drakkan/sftpgo)   [![最近一周有更新][Green]](https://github.com/drakkan/sftpgo)   [![godoc][GoDoc]](https://godoc.org/github.com/drakkan/sftpgo)
* [algernon](https://github.com/xyproto/algernon) **star:1838** 内置支持Lua、Markdown、GCSS和Amber的HTTP/2 web服务器。   [![最近一周有更新][Green]](https://github.com/xyproto/algernon)   [![godoc][GoDoc]](https://godoc.org/github.com/xyproto/algernon)
* [Fider](https://github.com/getfider/fider) **star:1672** Fider是一个收集和组织客户反馈的开放平台。   [![最近一周有更新][Green]](https://github.com/getfider/fider)   [![godoc][GoDoc]](https://godoc.org/github.com/getfider/fider)
* [Flagr](https://github.com/checkr/flagr) **star:1642** Flagr是一个开源特性标记和A/B测试服务。   [![godoc][GoDoc]](https://godoc.org/github.com/checkr/flagr)
* [flipt](https://github.com/markphelps/flipt) **star:1541** 一个用Go和Vue.js编写的自包含特性标志解决方案   [![最近一周有更新][Green]](https://github.com/markphelps/flipt)   [![godoc][GoDoc]](https://godoc.org/github.com/markphelps/flipt)
* [Trickster](https://github.com/tricksterproxy/trickster) **star:1500** HTTP反向代理缓存和时间序列加速器。   [![godoc][GoDoc]](https://godoc.org/github.com/tricksterproxy/trickster)
* [discovery](https://github.com/Bilibili/discovery) **star:1476** 用于弹性中间层负载平衡和故障转移的注册表。   [![godoc][GoDoc]](https://godoc.org/github.com/Bilibili/discovery)
* [jackal](https://github.com/ortuman/jackal) **star:1123** 用Go编写的XMPP服务器。   [![最近一周有更新][Green]](https://github.com/ortuman/jackal)   [![godoc][GoDoc]](https://godoc.org/github.com/ortuman/jackal)
* [go-feature-flag](https://github.com/thomaspoignant/go-feature-flag) **star:355** 一个特性标志解决方案，在后端只有一个YAML文件(S3、GitHub、HTTP、本地文件……)，不需要安装服务器，只需要在中央系统中添加一个文件并引用它。   [![godoc][GoDoc]](https://godoc.org/github.com/thomaspoignant/go-feature-flag)
* [dudeldu](https://github.com/krotik/dudeldu) **star:129** 一个简单的SHOUTcast服务器。   [![最近一年没有更新][Yellow]](https://github.com/krotik/dudeldu)   [![godoc][GoDoc]](https://godoc.org/github.com/krotik/dudeldu)
* [lets-proxy2](https://github.com/rekby/lets-proxy2) **star:57** Reverse proxy for handle https with issue certificates in fly from lets-encrypt.   [![godoc][GoDoc]](https://godoc.org/github.com/rekby/lets-proxy2)
* [psql-streamer](https://github.com/blind-oracle/psql-streamer) **star:29** 从PostgreSQL到Kafka的流数据库事件。   [![最近一年没有更新][Yellow]](https://github.com/blind-oracle/psql-streamer)   [![godoc][GoDoc]](https://godoc.org/github.com/blind-oracle/psql-streamer)
* [riemann-relay](https://github.com/blind-oracle/riemann-relay)  传递到负载平衡Riemann事件并/或将其转换为 Carbon。
* [nginx-prometheus](https://github.com/blind-oracle/nginx-prometheus) **star:24** Nginx日志解析器和Prometheus 导出。   [![godoc][GoDoc]](https://godoc.org/github.com/blind-oracle/nginx-prometheus)
* [nsq](http://nsq.io/)  一个实时分布式消息平台。
* [simple-jwt-provider](https://github.com/leberKleber/simple-jwt-provider) **star:20** 展示JWTs的简单轻量级提供者，支持登录、密码重置(通过邮件)和用户管理。   [![godoc][GoDoc]](https://godoc.org/github.com/leberKleber/simple-jwt-provider)
* [cortex-tenant](https://github.com/blind-oracle/cortex-tenant) **star:17** Prometheus远程写代理，添加了基于度量标签的add Cortex租户ID头。   [![godoc][GoDoc]](https://godoc.org/github.com/blind-oracle/cortex-tenant)
* [protoxy](https://github.com/camgraff/protoxy) **star:17** 将JSON请求体转换为协议缓冲区的代理服务器。   [![godoc][GoDoc]](https://godoc.org/github.com/camgraff/protoxy)
* [go-proxy-cache](https://github.com/fabiocicerchia/go-proxy-cache) **star:13** 简单的反向代理与缓存，写在Go，使用Redis。   [![godoc][GoDoc]](https://godoc.org/github.com/fabiocicerchia/go-proxy-cache)


## 流处理

*用于流处理和响应式编程的库和工具。 (翻译出错了? 试试 [英文版](README_EN.md#stream-processing) 吧~)*

* [go-streams](https://github.com/reugn/go-streams) **star:697** 流处理库。   [![最近一周有更新][Green]](https://github.com/reugn/go-streams)   [![godoc][GoDoc]](https://godoc.org/github.com/reugn/go-streams)
* [machine](https://github.com/whitaker-io/machine) **star:93** 使用内置的度量和可跟踪性来编写和生成流工作人员。   [![最近一周有更新][Green]](https://github.com/whitaker-io/machine)   [![godoc][GoDoc]](https://godoc.org/github.com/whitaker-io/machine)
* [stream](https://github.com/youthlin/stream) **star:39** 去流，像Java 8流:过滤器/地图/平面地图/Peek/排序/ForEach/减少…   [![godoc][GoDoc]](https://godoc.org/github.com/youthlin/stream)

## 模板引擎

*用于模板和词法分析的库和工具。 (翻译出错了? 试试 [英文版](README_EN.md#template-engines) 吧~)*

* [gofpdf](https://github.com/jung-kurt/gofpdf) **star:3836** PDF 文档生成器，支持文本，绘图和图片   [![star > 2000][Awesome]](https://github.com/jung-kurt/gofpdf)   [![最近一年没有更新][Yellow]](https://github.com/jung-kurt/gofpdf)   [![godoc][GoDoc]](https://godoc.org/github.com/jung-kurt/gofpdf)   [![归档项目][Archived]](https://github.com/jung-kurt/gofpdf)
* [sprig](https://github.com/Masterminds/sprig) **star:2490** Go模板的有用模板函数。   [![star > 2000][Awesome]](https://github.com/Masterminds/sprig)   [![最近一周有更新][Green]](https://github.com/Masterminds/sprig)   [![godoc][GoDoc]](https://godoc.org/github.com/Masterminds/sprig)
* [quicktemplate](https://github.com/valyala/quicktemplate) **star:2169** 快速、强大且易用的模板引擎。将模板转化为 Go 语言并进行编译   [![star > 2000][Awesome]](https://github.com/valyala/quicktemplate)   [![godoc][GoDoc]](https://godoc.org/github.com/valyala/quicktemplate)
* [pongo2](https://github.com/flosch/pongo2) **star:2027** 类似 DjanGo 的模板引擎   [![star > 2000][Awesome]](https://github.com/flosch/pongo2)   [![godoc][GoDoc]](https://godoc.org/github.com/flosch/pongo2)
* [hero](https://github.com/shiyanhui/hero) **star:1467** Hero是一个方便、快速和强大的go模板引擎。   [![最近一年没有更新][Yellow]](https://github.com/shiyanhui/hero)   [![godoc][GoDoc]](https://godoc.org/github.com/shiyanhui/hero)   [![包含中文文档][CN]](https://github.com/shiyanhui/hero)
* [mustache](https://github.com/hoisie/mustache) **star:1017** Go 语言实现的 Mustache 模板语言   [![godoc][GoDoc]](https://godoc.org/github.com/hoisie/mustache)
* [amber](https://github.com/eknkc/amber) **star:879** Amber是一个优雅的Go编程语言模板引擎，它的灵感来自HAML和Jade。   [![godoc][GoDoc]](https://godoc.org/github.com/eknkc/amber)
* [jet](https://github.com/CloudyKit/jet) **star:818** Jet模板引擎。   [![godoc][GoDoc]](https://godoc.org/github.com/CloudyKit/jet)
* [ace](https://github.com/yosssi/ace) **star:801** Ace 是一个 Go 语言的 HTML 模板引擎，受到了 Slim 和 Jade 的启发。 Ace 是对Gold的一种改进。   [![最近一年没有更新][Yellow]](https://github.com/yosssi/ace)   [![godoc][GoDoc]](https://godoc.org/github.com/yosssi/ace)
* [Razor](https://github.com/sipin/gorazor) **star:786** Go 语言的 Razor 视图引擎   [![godoc][GoDoc]](https://godoc.org/github.com/sipin/gorazor)
* [fasttemplate](https://github.com/valyala/fasttemplate) **star:523** 简单快速的模板引擎。进行模板元素替换时，速度是比[text/template](http://golang.org/pkg/text/template/)快10倍。   [![godoc][GoDoc]](https://godoc.org/github.com/valyala/fasttemplate)
* [ego](https://github.com/benbjohnson/ego) **star:497** 轻量级模板语言，允许您在Go中编写模板。模板被翻译成Go并编译。   [![godoc][GoDoc]](https://godoc.org/github.com/benbjohnson/ego)
* [raymond](https://github.com/aymerick/raymond) **star:438** 使用 Go 语言实现的完整的 handlebars   [![godoc][GoDoc]](https://godoc.org/github.com/aymerick/raymond)
* [maroto](https://github.com/johnfercher/maroto) **star:421** 创建pdf文件的maroto方法。Maroto的灵感来自于Bootstrap并使用gofpdf。快速和简单。   [![godoc][GoDoc]](https://godoc.org/github.com/johnfercher/maroto)
* [goview](https://github.com/foolin/goview) **star:241** Goview是一个轻量级、极简的模板库，基于golang html/template构建Go web应用程序。   [![godoc][GoDoc]](https://godoc.org/github.com/foolin/goview)
* [Soy](https://github.com/robfig/soy) **star:155** Go 语言实现的谷歌闭包模板(也就是 Soy templates) ,遵循[官方规范](https://developer.google.com/closure/templates/)。   [![godoc][GoDoc]](https://godoc.org/github.com/robfig/soy)
* [liquid](https://github.com/osteele/liquid) **star:132** Go 语言实现的 Shopify Liquid 模板.   [![godoc][GoDoc]](https://godoc.org/github.com/osteele/liquid)
* [kasia.go](https://github.com/ziutek/kasia.go) **star:72** 一个用于HTML 和其他文本文件的模板系统，使用go语言实现   [![最近一年没有更新][Yellow]](https://github.com/ziutek/kasia.go)   [![godoc][GoDoc]](https://godoc.org/github.com/ziutek/kasia.go)
* [velvet](https://github.com/gobuffalo/velvet) **star:71** 使用 Go 语言实现的完整的 handlebars   [![最近一年没有更新][Yellow]](https://github.com/gobuffalo/velvet)   [![godoc][GoDoc]](https://godoc.org/github.com/gobuffalo/velvet)
* [extemplate](https://github.com/dannyvankooten/extemplate) **star:39**  对 html/template 进行了简单的封装，支持基于文件的模板可以利用其他模板文件进行扩展   [![godoc][GoDoc]](https://godoc.org/github.com/dannyvankooten/extemplate)
* [gospin](https://github.com/m1/gospin) **star:27** 文章纺纱和spintax/纺纱语法引擎，适用于A/B，测试文本/文章片段和创建更多的自然对话。   [![godoc][GoDoc]](https://godoc.org/github.com/m1/gospin)
* [damsel](https://github.com/dskinner/damsel) **star:24** 标记语言，通过css选择器实现了 html 框架 ，并可以通过 pkg html/template 等进行扩展   [![最近一年没有更新][Yellow]](https://github.com/dskinner/damsel)   [![godoc][GoDoc]](https://godoc.org/github.com/dskinner/damsel)
* [tbd](https://github.com/lucasepe/tbd) **star:16** 创建带有占位符的文本模板的一种非常简单的方法——公开额外的内置Git repo元数据   [![godoc][GoDoc]](https://godoc.org/github.com/lucasepe/tbd)

## 测试

*用于测试代码库和生成测试数据的库。 (翻译出错了? 试试 [英文版](README_EN.md#testing) 吧~)*

* Testing Frameworks
    * [Testify](https://github.com/stretchr/testify) **star:14047** 对标准测试包的扩展。   [![star > 2000][Awesome]](https://github.com/stretchr/testify)   [![godoc][GoDoc]](https://godoc.org/github.com/stretchr/testify)
    * [testmd](https://godoc.org/github.com/tvastar/test/cmd/testmd)  将markdown代码段转换为可测试的go代码。
    * [go-cmp](https://github.com/google/go-cmp) **star:2442** 用于比较测试中的Go值的包。   [![star > 2000][Awesome]](https://github.com/google/go-cmp)   [![godoc][GoDoc]](https://godoc.org/github.com/google/go-cmp)
    * [httpexpect](https://github.com/gavv/httpexpect) **star:1750** 简洁的、声明式的、易用的端到端HTTP 及 REST API 测试   [![godoc][GoDoc]](https://godoc.org/github.com/gavv/httpexpect)
    * [godog](https://github.com/DATA-DOG/godog) **star:1431** 类似 Cucumber 或 Behat 的 BDD 框架   [![最近一周有更新][Green]](https://github.com/DATA-DOG/godog)   [![godoc][GoDoc]](https://godoc.org/github.com/DATA-DOG/godog)
    * [goblin](https://github.com/franela/goblin) **star:810** 类似Mocha的测试框架。   [![godoc][GoDoc]](https://godoc.org/github.com/franela/goblin)
    * [go-vcr](https://github.com/dnaeon/go-vcr) **star:764** 记录并回放HTTP交互，以便进行快速、确定和准确的测试。   [![godoc][GoDoc]](https://godoc.org/github.com/dnaeon/go-vcr)
    * [baloo](https://github.com/h2non/baloo) **star:712** 表达性强、多功能的、端到端的HTTP API 测试工具   [![最近一年没有更新][Yellow]](https://github.com/h2non/baloo)   [![godoc][GoDoc]](https://godoc.org/github.com/h2non/baloo)
    * [testfixtures](https://github.com/go-testfixtures/testfixtures) **star:690** 类似 Rails 的测试工具，用于测试数据库应用   [![godoc][GoDoc]](https://godoc.org/github.com/go-testfixtures/testfixtures)
    * [gnomock](https://github.com/orlangure/gnomock) **star:510** 在Docker中运行与真实依赖项(数据库、缓存，甚至是Kubernetes或AWS)的集成测试，而不使用模拟。   [![最近一周有更新][Green]](https://github.com/orlangure/gnomock)   [![godoc][GoDoc]](https://godoc.org/github.com/orlangure/gnomock)
    * [go-mutesting](https://github.com/zimmski/go-mutesting) **star:411** 变异测试的Go源代码。   [![最近一周有更新][Green]](https://github.com/zimmski/go-mutesting)   [![godoc][GoDoc]](https://godoc.org/github.com/zimmski/go-mutesting)
    * [goc](https://github.com/qiniu/goc) **star:407** Goc是一个针对Go编程语言的全面覆盖测试系统。   [![最近一周有更新][Green]](https://github.com/qiniu/goc)   [![godoc][GoDoc]](https://godoc.org/github.com/qiniu/goc)
    * [gocheck](http://labix.org/gocheck)  更加高级的测试框架，用于替换 Gotest
    * [GoConvey](https://github.com/smartystreets/goconvey/)  BDD 风格的测试框架，具有 web 界面和计时刷新功能
    * [gofight](https://github.com/appleboy/gofight) **star:384** 对 Go 语言的路由框架进行 API 测试   [![godoc][GoDoc]](https://godoc.org/github.com/appleboy/gofight)
    * [embedded-postgres](https://github.com/fergusstrange/embedded-postgres) **star:276** 作为另一个Go应用程序或测试的一部分，在Linux、OSX或Windows上本地运行一个真正的Postgres数据库。   [![最近一周有更新][Green]](https://github.com/fergusstrange/embedded-postgres)   [![godoc][GoDoc]](https://godoc.org/github.com/fergusstrange/embedded-postgres)
    * [frisby](https://github.com/verdverm/frisby) **star:266** REST API测试框架。   [![最近一年没有更新][Yellow]](https://github.com/verdverm/frisby)   [![godoc][GoDoc]](https://godoc.org/github.com/verdverm/frisby)
    * [ginkgo](http://onsi.github.io/ginkgo/)  Go的BDD测试框架。
    * [gotest.tools](https://github.com/gotestyourself/gotest.tools) **star:251** 一组包，用于增强go测试包并支持公共模式。   [![godoc][GoDoc]](https://godoc.org/github.com/gotestyourself/gotest.tools)
    * [go-carpet](https://github.com/msoap/go-carpet) **star:213** 在终端中查看测试覆盖率的工具。   [![godoc][GoDoc]](https://godoc.org/github.com/msoap/go-carpet)
    * [testza](https://github.com/MarvinJWendt/testza) **star:204** 功能齐全的测试框架，带有漂亮的彩色输出。   [![最近一周有更新][Green]](https://github.com/MarvinJWendt/testza)   [![godoc][GoDoc]](https://godoc.org/github.com/MarvinJWendt/testza)
    * [charlatan](https://github.com/percolate/charlatan) **star:194** 为测试生成假接口实现的工具。   [![最近一年没有更新][Yellow]](https://github.com/percolate/charlatan)   [![godoc][GoDoc]](https://godoc.org/github.com/percolate/charlatan)
    * [endly](https://github.com/viant/endly) **star:191** 声明性端到端功能测试。   [![godoc][GoDoc]](https://godoc.org/github.com/viant/endly)
    * [go-testdeep](https://github.com/maxatome/go-testdeep) **star:190** 极具灵活性的golang深度比较，扩展了go测试包。   [![最近一周有更新][Green]](https://github.com/maxatome/go-testdeep)   [![godoc][GoDoc]](https://godoc.org/github.com/maxatome/go-testdeep)
    * [commander](https://github.com/SimonBaeumer/commander) **star:187** 用于在windows、linux和osx上测试cli应用程序的工具。   [![godoc][GoDoc]](https://godoc.org/github.com/SimonBaeumer/commander)
    * [cupaloy](https://github.com/bradleyjkemp/cupaloy) **star:168** 测试框架的简单快照测试插件。   [![godoc][GoDoc]](https://godoc.org/github.com/bradleyjkemp/cupaloy)
    * [dbcleaner](https://github.com/khaiql/dbcleaner) **star:131** 清空数据库用于测试，受到database_cleaner 的启发   [![最近一年没有更新][Yellow]](https://github.com/khaiql/dbcleaner)   [![godoc][GoDoc]](https://godoc.org/github.com/khaiql/dbcleaner)
    * [GoSpec](https://github.com/orfjackal/gospec) **star:114** 用于 Go 编程语言的bdd风格的测试框架。   [![最近一年没有更新][Yellow]](https://github.com/orfjackal/gospec)   [![godoc][GoDoc]](https://godoc.org/github.com/orfjackal/gospec)
    * [wstest](https://github.com/posener/wstest) **star:85** 用于单元测试Websocket http.Handler的Websocket客户机。   [![godoc][GoDoc]](https://godoc.org/github.com/posener/wstest)
    * [gocrest](https://github.com/corbym/gocrest) **star:81** 用于 Go 断言的可组合的类似 hamcrest 的 matchers。   [![godoc][GoDoc]](https://godoc.org/github.com/corbym/gocrest)
    * [testcase](https://github.com/adamluzsi/testcase) **star:76** 行为驱动开发的惯用测试框架。   [![最近一周有更新][Green]](https://github.com/adamluzsi/testcase)   [![godoc][GoDoc]](https://godoc.org/github.com/adamluzsi/testcase)
    * [apitest](https://apitest.dev)  基于REST的服务/HTTP处理程序的简单且可扩展的行为测试库,支持模拟外部HTTP调用和呈现序列图
    * [jsonassert](https://github.com/kinbiko/jsonassert) **star:68** 用于验证JSON有效负载已正确序列化的包。   [![最近一周有更新][Green]](https://github.com/kinbiko/jsonassert)   [![godoc][GoDoc]](https://godoc.org/github.com/kinbiko/jsonassert)
    * [gospecify](https://github.com/stesla/gospecify) **star:53** 支持 BDD 语法 。对于任何使用过 rspec 等库的人来说应该非常熟悉。   [![最近一年没有更新][Yellow]](https://github.com/stesla/gospecify)   [![godoc][GoDoc]](https://godoc.org/github.com/stesla/gospecify)
    * [restit](https://github.com/yookoala/restit) **star:53** 帮助编写 RESTful API 集成测试的 Go 语言微型框架.。   [![最近一年没有更新][Yellow]](https://github.com/yookoala/restit)   [![godoc][GoDoc]](https://godoc.org/github.com/yookoala/restit)
    * [go-hit](https://github.com/Eun/go-hit) **star:43** Hit是一个用golang编写的http集成测试框架。   [![godoc][GoDoc]](https://godoc.org/github.com/Eun/go-hit)
    * [covergates](https://github.com/covergates/covergates) **star:41** 自托管的代码覆盖报告审查和管理服务。   [![godoc][GoDoc]](https://godoc.org/github.com/covergates/covergates)
    * [gomatch](https://github.com/jfilipczyk/gomatch) **star:41** 为针对模式测试JSON而创建的库。   [![godoc][GoDoc]](https://godoc.org/github.com/jfilipczyk/gomatch)
    * [gomega](http://onsi.github.io/gomega/)  类似 Rspec 的 matcher/assertion 库
    * [dsunit](https://github.com/viant/dsunit) **star:38** 用于SQL、NoSQL、结构化文件的数据存储测试。   [![最近一年没有更新][Yellow]](https://github.com/viant/dsunit)   [![godoc][GoDoc]](https://godoc.org/github.com/viant/dsunit)
    * [assert](https://github.com/go-playground/assert) **star:34** 基础断言库，用于对 Go 语言程序进行测试，提供了一些用于自定义断言的代码块   [![godoc][GoDoc]](https://godoc.org/github.com/go-playground/assert)
    * [Hamcrest](https://github.com/rdrdr/hamcrest) **star:26** 用于声明性 Matcher 对象的连贯框架，当将其应用于输入值时，将产生自描述结果。   [![godoc][GoDoc]](https://godoc.org/github.com/rdrdr/hamcrest)
    * [flute](https://github.com/suzuki-shunsuke/flute) **star:16** HTTP客户端测试框架。   [![godoc][GoDoc]](https://godoc.org/github.com/suzuki-shunsuke/flute)
    * [schema](https://github.com/jgroeneveld/schema) **star:15** 快速、简单地匹配请求和响应中使用的JSON模式的表达式。   [![最近一年没有更新][Yellow]](https://github.com/jgroeneveld/schema)   [![godoc][GoDoc]](https://godoc.org/github.com/jgroeneveld/schema)
    * [badio](https://github.com/cavaliercoder/badio) **star:10** Go 语言 testing/iotest 包的扩展。   [![最近一年没有更新][Yellow]](https://github.com/cavaliercoder/badio)   [![godoc][GoDoc]](https://godoc.org/github.com/cavaliercoder/badio)
    * [biff](https://github.com/fulldump/biff) **star:10** 分支测试框架，BDD兼容。   [![godoc][GoDoc]](https://godoc.org/github.com/fulldump/biff)
    * [gogiven](https://github.com/corbym/gogiven) **star:10** 类似于 YATSPEC 的Go BDD测试框架。   [![godoc][GoDoc]](https://godoc.org/github.com/corbym/gogiven)
    * [gosuite](https://github.com/pavlo/gosuite) **star:10** 轻量级测试套，为 Go1.7's Subtests 带来了setup/teardown 功能   [![最近一年没有更新][Yellow]](https://github.com/pavlo/gosuite)   [![godoc][GoDoc]](https://godoc.org/github.com/pavlo/gosuite)
    * [testsql](https://github.com/zhulongcheng/testsql) **star:10** 在测试前从SQL文件生成测试数据，并在测试完成后清除数据。   [![最近一年没有更新][Yellow]](https://github.com/zhulongcheng/testsql)   [![godoc][GoDoc]](https://godoc.org/github.com/zhulongcheng/testsql)
    * [stop-and-go](https://github.com/elgohr/stop-and-go) **star:6** 并发性测试助手。   [![最近一周有更新][Green]](https://github.com/elgohr/stop-and-go)   [![godoc][GoDoc]](https://godoc.org/github.com/elgohr/stop-and-go)
    * [trial](https://github.com/jgroeneveld/trial) **star:5** 无需引入太多样板，即可快速轻松地扩展断言。   [![最近一年没有更新][Yellow]](https://github.com/jgroeneveld/trial)   [![godoc][GoDoc]](https://godoc.org/github.com/jgroeneveld/trial)
    * [Tt](https://github.com/vcaesar/tt) **star:5** 简单而丰富多彩的测试工具。   [![godoc][GoDoc]](https://godoc.org/github.com/vcaesar/tt)

* Mock
    * [gomock](https://github.com/golang/mock) **star:6063** 用于Go编程语言的mock框架。   [![star > 2000][Awesome]](https://github.com/golang/mock)   [![godoc][GoDoc]](https://godoc.org/github.com/golang/mock)
    * [go-sqlmock](https://github.com/DATA-DOG/go-sqlmock) **star:3733** Mock SQL ，用于测试数据库交互   [![star > 2000][Awesome]](https://github.com/DATA-DOG/go-sqlmock)   [![godoc][GoDoc]](https://godoc.org/github.com/DATA-DOG/go-sqlmock)
    * [hoverfly](https://github.com/SpectoLabs/hoverfly) **star:1769** 使用可扩展中间件和易于使用的CLI记录和模拟REST/SOAP api的HTTP(S)代理。   [![最近一周有更新][Green]](https://github.com/SpectoLabs/hoverfly)   [![godoc][GoDoc]](https://godoc.org/github.com/SpectoLabs/hoverfly)
    * [gock](https://github.com/h2non/gock) **star:1461** 多功能、易用 HTTP mock   [![godoc][GoDoc]](https://godoc.org/github.com/h2non/gock)
    * [httpmock](https://github.com/jarcoal/httpmock) **star:1130** 轻松模拟来自外部资源的HTTP响应。   [![godoc][GoDoc]](https://godoc.org/github.com/jarcoal/httpmock)
    * [counterfeiter](https://github.com/maxbrunsfeld/counterfeiter) **star:562** 用于生成自包含 mock 对象的工具   [![godoc][GoDoc]](https://godoc.org/github.com/maxbrunsfeld/counterfeiter)
    * [minimock](https://github.com/gojuno/minimock) **star:404** Go接口的模拟生成器。   [![godoc][GoDoc]](https://godoc.org/github.com/gojuno/minimock)
    * [go-txdb](https://github.com/DATA-DOG/go-txdb) **star:376** 基于单事务的数据库驱动，主要用于测试目的   [![godoc][GoDoc]](https://godoc.org/github.com/DATA-DOG/go-txdb)
    * [govcr](https://github.com/seborama/govcr) **star:97** HTTP mock : 离线测试时记录和重放浏览器的动作   [![最近一年没有更新][Yellow]](https://github.com/seborama/govcr)   [![godoc][GoDoc]](https://godoc.org/github.com/seborama/govcr)
    * [timex](https://github.com/cabify/timex) **star:55** 一个测试友好的本地“时间”包的替代品。   [![最近一年没有更新][Yellow]](https://github.com/cabify/timex)   [![godoc][GoDoc]](https://godoc.org/github.com/cabify/timex)
    * [mockhttp](https://github.com/tv42/mockhttp) **star:22** Go http.ResponseWriter的模拟对象。   [![最近一年没有更新][Yellow]](https://github.com/tv42/mockhttp)   [![godoc][GoDoc]](https://godoc.org/github.com/tv42/mockhttp)
    * [go-localstack](https://github.com/elgohr/go-localstack) **star:14** 用于在AWS测试中使用localstack的工具。   [![最近一周有更新][Green]](https://github.com/elgohr/go-localstack)   [![godoc][GoDoc]](https://godoc.org/github.com/elgohr/go-localstack)
    * [mockit](https://github.com/pasdam/mockit) **star:8** 允许函数和方法容易被模拟，而不需要定义新的类型;它类似于Java的Mockito。   [![godoc][GoDoc]](https://godoc.org/github.com/pasdam/mockit)

* Fuzzing and delta-debugging/reducing/shrinking.
    * [go-fuzz](https://github.com/dvyukov/go-fuzz) **star:4105** 随机测试系统。   [![star > 2000][Awesome]](https://github.com/dvyukov/go-fuzz)   [![godoc][GoDoc]](https://godoc.org/github.com/dvyukov/go-fuzz)
    * [gofuzz](https://github.com/google/gofuzz) **star:1114** 用于生成随机值来初始化 Go 语言对象的库   [![godoc][GoDoc]](https://godoc.org/github.com/google/gofuzz)
    * [Tavor](https://github.com/zimmski/tavor) **star:232** 通用模糊测试框架   [![最近一年没有更新][Yellow]](https://github.com/zimmski/tavor)   [![godoc][GoDoc]](https://godoc.org/github.com/zimmski/tavor)

* Selenium and browser control tools.
    * [chromedp](https://github.com/knq/chromedp) **star:6642** 用于驱动和测试 Chrome, Safari, Edge, Android Webviews, 以及其他支持 Chrome 调试协议的产品   [![star > 2000][Awesome]](https://github.com/knq/chromedp)   [![最近一周有更新][Green]](https://github.com/knq/chromedp)   [![godoc][GoDoc]](https://godoc.org/github.com/knq/chromedp)
    * [selenoid](https://github.com/aerokube/selenoid) **star:1961** Selenium hub 服务器的替代品，在容器中启动浏览器   [![最近一周有更新][Green]](https://github.com/aerokube/selenoid)   [![godoc][GoDoc]](https://godoc.org/github.com/aerokube/selenoid)
    * [rod](https://github.com/go-rod/rod) **star:1717** 一个Devtools驱动程序，使web自动化和抓取更加容易。   [![godoc][GoDoc]](https://godoc.org/github.com/go-rod/rod)
    * [cdp](https://github.com/mafredri/cdp) **star:567** 用于Chrome调试协议的类型安全绑定，可与实现该协议的浏览器或其他调试目标一起使用。   [![godoc][GoDoc]](https://godoc.org/github.com/mafredri/cdp)
    * [playwright-go](https://github.com/mxschmitt/playwright-go) **star:464** 浏览器自动化库控制铬，Firefox和WebKit与一个单一的API。   [![最近一周有更新][Green]](https://github.com/mxschmitt/playwright-go)   [![godoc][GoDoc]](https://godoc.org/github.com/mxschmitt/playwright-go)
    * [ggr](https://github.com/aerokube/ggr) **star:273** 一个轻量级服务器，可以将 Selenium Wedriver 的请求路由或代理到多个 Selenium hubs   [![godoc][GoDoc]](https://godoc.org/github.com/aerokube/ggr)

* Fail injection
    * [failpoint](https://github.com/pingcap/failpoint) **star:600** 为Golang实现[failpoints](http://www.freebsd.org/cgi/man.cgi?query=fail)。   [![godoc][GoDoc]](https://godoc.org/github.com/pingcap/failpoint)

## 文本处理

*用于解析和操作文本的库。 (翻译出错了? 试试 [英文版](README_EN.md#text-processing) 吧~)*

* Specific Formats
    * [colly](https://github.com/asciimoo/colly) **star:14630** 快速和优雅的 Scraping 框架。   [![star > 2000][Awesome]](https://github.com/asciimoo/colly)   [![godoc][GoDoc]](https://godoc.org/github.com/asciimoo/colly)
    * [GoQuery](https://github.com/PuerkitoBio/goquery) **star:10510** GoQuery 为 Go 语言带来了一组类似 jQuery 的语法和功能   [![star > 2000][Awesome]](https://github.com/PuerkitoBio/goquery)   [![godoc][GoDoc]](https://godoc.org/github.com/PuerkitoBio/goquery)
    * [blackfriday](https://github.com/russross/blackfriday) **star:4776** Markdown 解析器   [![star > 2000][Awesome]](https://github.com/russross/blackfriday)   [![godoc][GoDoc]](https://godoc.org/github.com/russross/blackfriday)
    * [sh](https://github.com/mvdan/sh) **star:3937** Shell解析器和格式化工具。   [![star > 2000][Awesome]](https://github.com/mvdan/sh)   [![最近一周有更新][Green]](https://github.com/mvdan/sh)   [![godoc][GoDoc]](https://godoc.org/github.com/mvdan/sh)
    * [toml](https://github.com/BurntSushi/toml) **star:3563** TOML配置格式(带反射的编码器/解码器)。   [![star > 2000][Awesome]](https://github.com/BurntSushi/toml)   [![godoc][GoDoc]](https://godoc.org/github.com/BurntSushi/toml)
    * [go-humanize](https://github.com/dustin/go-humanize) **star:2772** 格式化程序，用于将时间、数字和内存大小转换为可读格式。   [![star > 2000][Awesome]](https://github.com/dustin/go-humanize)   [![godoc][GoDoc]](https://godoc.org/github.com/dustin/go-humanize)
    * [bluemonday](https://github.com/microcosm-cc/bluemonday) **star:2019** HTML 清理工具   [![star > 2000][Awesome]](https://github.com/microcosm-cc/bluemonday)   [![godoc][GoDoc]](https://godoc.org/github.com/microcosm-cc/bluemonday)
    * [gofeed](https://github.com/mmcdole/gofeed) **star:1692** 在Go中解析RSS和Atom feeds。   [![godoc][GoDoc]](https://godoc.org/github.com/mmcdole/gofeed)
    * [inject](https://github.com/facebookgo/inject) **star:1341** 包注入提供了一个基于反射的注入器。   [![最近一年没有更新][Yellow]](https://github.com/facebookgo/inject)   [![godoc][GoDoc]](https://godoc.org/github.com/facebookgo/inject)   [![归档项目][Archived]](https://github.com/facebookgo/inject)
    * [go-toml](https://github.com/pelletier/go-toml) **star:1075** 使用带有查询支持和方便的cli工具的TOML格式库。   [![最近一周有更新][Green]](https://github.com/pelletier/go-toml)   [![godoc][GoDoc]](https://godoc.org/github.com/pelletier/go-toml)
    * [commonregex](https://github.com/mingrammer/commonregex) **star:781** 一组用于Go的公共正则表达式。   [![最近一年没有更新][Yellow]](https://github.com/mingrammer/commonregex)   [![godoc][GoDoc]](https://godoc.org/github.com/mingrammer/commonregex)
    * [slug](https://github.com/gosimple/slug) **star:668** URL 友好的 slug 化工具，支持多种语言   [![godoc][GoDoc]](https://godoc.org/github.com/gosimple/slug)
    * [mxj](https://github.com/clbanning/mxj) **star:479** 将XML编码/解码为JSON或map[string]接口{};使用点符号路径和通配符提取值。替换x2j和j2x包。   [![godoc][GoDoc]](https://godoc.org/github.com/clbanning/mxj)
    * [dataflowkit](https://github.com/slotix/dataflowkit) **star:474** Web抓取框架将网站转换为结构化数据。   [![最近一年没有更新][Yellow]](https://github.com/slotix/dataflowkit)   [![godoc][GoDoc]](https://godoc.org/github.com/slotix/dataflowkit)
    * [gographviz](https://github.com/awalterschulze/gographviz) **star:443** 解析Graphviz DOT语言。   [![godoc][GoDoc]](https://godoc.org/github.com/awalterschulze/gographviz)
    * [gommon/bytes](https://github.com/labstack/gommon/tree/master/bytes)  格式化二进制为字符串。
    * [htmlquery](https://github.com/antchfx/htmlquery) **star:389** 用于HTML的XPath查询包，允许您通过XPath表达式从HTML文档中提取数据或求值。   [![最近一周有更新][Green]](https://github.com/antchfx/htmlquery)   [![godoc][GoDoc]](https://godoc.org/github.com/antchfx/htmlquery)
    * [go-runewidth](https://github.com/mattn/go-runewidth) **star:375** 函数获取字符或字符串的固定宽度。   [![godoc][GoDoc]](https://godoc.org/github.com/mattn/go-runewidth)
    * [omniparser](https://github.com/jf-tech/omniparser) **star:366** 一个通用的ETL库，以流方式解析文本输入(CSV/txt/JSON/XML/EDI/X12/EDIFACT/etc)，并使用数据驱动模式将数据转换为JSON输出。   [![godoc][GoDoc]](https://godoc.org/github.com/jf-tech/omniparser)
    * [gotext](https://github.com/leonelquinteros/gotext) **star:302** GNU gettext 工具   [![godoc][GoDoc]](https://godoc.org/github.com/leonelquinteros/gotext)
    * [html-to-markdown](https://github.com/JohannesKaufmann/html-to-markdown) **star:239** 将HTML转换成Markdown   [![godoc][GoDoc]](https://godoc.org/github.com/JohannesKaufmann/html-to-markdown)
    * [goq](https://github.com/andrewstuart/goq) **star:198**  声明式 HTML 编组，使用结构标签和 jQuery 语法 (使用 GoQuery).   [![最近一年没有更新][Yellow]](https://github.com/andrewstuart/goq)   [![godoc][GoDoc]](https://godoc.org/github.com/andrewstuart/goq)
    * [goribot](https://github.com/zhshch2002/goribot) **star:197** 一个简单的golang spider/抓取框架，构建一个三行蜘蛛。   [![最近一年没有更新][Yellow]](https://github.com/zhshch2002/goribot)   [![godoc][GoDoc]](https://godoc.org/github.com/zhshch2002/goribot)   [![包含中文文档][CN]](https://github.com/zhshch2002/goribot)   [![归档项目][Archived]](https://github.com/zhshch2002/goribot)
    * [go-nmea](https://github.com/adrianmo/go-nmea) **star:153** 用于Go语言的NMEA解析器库。   [![godoc][GoDoc]](https://godoc.org/github.com/adrianmo/go-nmea)
    * [sdp](https://github.com/gortc/sdp) **star:111** SDP:会话描述协议[[RFC 4566](https://tools.ietf.org/html/rfc4566)]。   [![最近一年没有更新][Yellow]](https://github.com/gortc/sdp)   [![godoc][GoDoc]](https://godoc.org/github.com/gortc/sdp)   [![归档项目][Archived]](https://github.com/gortc/sdp)
    * [go-zero-width](https://github.com/trubitsyn/go-zero-width) **star:96** 用于Go的零宽度字符检测和删除。   [![最近一年没有更新][Yellow]](https://github.com/trubitsyn/go-zero-width)   [![godoc][GoDoc]](https://godoc.org/github.com/trubitsyn/go-zero-width)
    * [podcast](https://github.com/eduncan911/podcast) **star:94** 在Golang兼容iTunes和RSS 2.0播客生成器   [![godoc][GoDoc]](https://godoc.org/github.com/eduncan911/podcast)
    * [editorconfig-core-go](https://github.com/editorconfig/editorconfig-core-go) **star:85** Editorconfig文件解析器和Go操作器。   [![最近一周有更新][Green]](https://github.com/editorconfig/editorconfig-core-go)   [![godoc][GoDoc]](https://godoc.org/github.com/editorconfig/editorconfig-core-go)
    * [align](https://github.com/Guitarbum722/align) **star:70** 对文本进行对齐的通用应用程序。   [![godoc][GoDoc]](https://godoc.org/github.com/Guitarbum722/align)
    * [go-slugify](https://github.com/mozillazg/go-slugify) **star:68** 生成漂亮的固定链接地址（slug），支持多种语言   [![最近一年没有更新][Yellow]](https://github.com/mozillazg/go-slugify)   [![godoc][GoDoc]](https://godoc.org/github.com/mozillazg/go-slugify)
    * [genex](https://github.com/alixaxel/genex) **star:60** 将正则表达式计数并展开为所有匹配的字符串。   [![最近一年没有更新][Yellow]](https://github.com/alixaxel/genex)   [![godoc][GoDoc]](https://godoc.org/github.com/alixaxel/genex)
    * [github_flavored_markdown](https://godoc.org/github.com/shurcooL/github_flavored_markdown)  GitHub 风格的 Markdown 渲染器 (使用 blackfriday) ，支持代码块高亮以及可点击的锚点
    * [go-vcard](https://github.com/emersion/go-vcard) **star:60** 解析和格式化vCard。   [![godoc][GoDoc]](https://godoc.org/github.com/emersion/go-vcard)
    * [goregen](https://github.com/zach-klippenstein/goregen) **star:58** 根据正则表达式生成随机字符串   [![godoc][GoDoc]](https://godoc.org/github.com/zach-klippenstein/goregen)
    * [go-fixedwidth](https://github.com/ianlopshire/go-fixedwidth) **star:54** 固定宽度的文本格式(带反射的编码器/解码器)。   [![godoc][GoDoc]](https://godoc.org/github.com/ianlopshire/go-fixedwidth)
    * [guesslanguage](https://github.com/endeveit/guesslanguage) **star:53** 通过一个 unicode 文本来猜测该文本使用的语言   [![最近一年没有更新][Yellow]](https://github.com/endeveit/guesslanguage)   [![godoc][GoDoc]](https://godoc.org/github.com/endeveit/guesslanguage)
    * [did](https://github.com/ockam-network/did) **star:52** DID(分散标识符)解析器和Stringer。   [![godoc][GoDoc]](https://godoc.org/github.com/ockam-network/did)
    * [allot](https://github.com/sbstjn/allot) **star:48** 用于CLI工具和机器人的占位符和通配符文本解析。   [![godoc][GoDoc]](https://godoc.org/github.com/sbstjn/allot)
    * [pagser](https://github.com/foolin/pagser) **star:37** Pagser是一个简单的，可扩展的，可配置的解析和反序列化的html页面结构，基于goquery和结构标签的golang爬虫。   [![最近一年没有更新][Yellow]](https://github.com/foolin/pagser)   [![godoc][GoDoc]](https://godoc.org/github.com/foolin/pagser)
    * [gonameparts](https://github.com/polera/gonameparts) **star:33** 将人名解析为单独的名称部分。   [![最近一年没有更新][Yellow]](https://github.com/polera/gonameparts)   [![godoc][GoDoc]](https://godoc.org/github.com/polera/gonameparts)
    * [Slugify](https://github.com/avelino/slugify) **star:27** 字符串 slug 化的工具。   [![最近一年没有更新][Yellow]](https://github.com/avelino/slugify)   [![godoc][GoDoc]](https://godoc.org/github.com/avelino/slugify)
    * [normalize](https://github.com/avito-tech/normalize) **star:19** 消毒，规范化和比较模糊的文本。   [![godoc][GoDoc]](https://godoc.org/github.com/avito-tech/normalize)
    * [codetree](https://github.com/aerogo/codetree) **star:17** 解析缩进代码(python、pixy、scarlet等)并返回树结构。   [![最近一年没有更新][Yellow]](https://github.com/aerogo/codetree)   [![godoc][GoDoc]](https://godoc.org/github.com/aerogo/codetree)
    * [bafi](https://github.com/mmalcek/bafi) **star:16** 通用JSON, BSON, YAML, XML转换器使用模板的任何格式   [![最近一周有更新][Green]](https://github.com/mmalcek/bafi)   [![godoc][GoDoc]](https://godoc.org/github.com/mmalcek/bafi)
    * [enca](https://github.com/endeveit/enca) **star:11** [libenca](http://cihar.com/software/enca/)的最小cgo绑定。   [![最近一年没有更新][Yellow]](https://github.com/endeveit/enca)   [![godoc][GoDoc]](https://godoc.org/github.com/endeveit/enca)
    * [syndfeed](https://github.com/zhengchun/syndfeed) **star:7** Atom 1.0和RSS 2.0的联合提要。   [![最近一年没有更新][Yellow]](https://github.com/zhengchun/syndfeed)   [![godoc][GoDoc]](https://godoc.org/github.com/zhengchun/syndfeed)
    * [bbConvert](https://github.com/CalebQ42/bbConvert) **star:6** 将bbCode转换为HTML，使您可以添加对自定义bbCode标记的支持。   [![最近一年没有更新][Yellow]](https://github.com/CalebQ42/bbConvert)   [![godoc][GoDoc]](https://godoc.org/github.com/CalebQ42/bbConvert)
    * [doi](https://github.com/hscells/doi) **star:6** 文档对象标识符(doi)解析器。   [![最近一年没有更新][Yellow]](https://github.com/hscells/doi)   [![godoc][GoDoc]](https://godoc.org/github.com/hscells/doi)
    * [ltsv](https://github.com/Wing924/ltsv) **star:5** 高性能[LTSV(Labeled Tab Separated Value)](http://ltsv.org/)。   [![最近一年没有更新][Yellow]](https://github.com/Wing924/ltsv)   [![godoc][GoDoc]](https://godoc.org/github.com/Wing924/ltsv)
    * [encdec](https://github.com/mickep76/encdec) **star:4** 软件包为编码器和解码器提供了通用接口。   [![最近一年没有更新][Yellow]](https://github.com/mickep76/encdec)   [![godoc][GoDoc]](https://godoc.org/github.com/mickep76/encdec)
    * [go-wildcard](https://github.com/IGLOU-EU/go-wildcard) **star:2** 简单而轻量级的通配符模式匹配。   [![godoc][GoDoc]](https://godoc.org/github.com/IGLOU-EU/go-wildcard)
    * [go-output-format](https://github.com/drewstinnett/go-output-format) **star:1** 在你的命令行应用程序中将go结构输出为多种格式(YAML/JSON/etc)。   [![godoc][GoDoc]](https://godoc.org/github.com/drewstinnett/go-output-format)
* Utility
    * [xurls](https://github.com/mvdan/xurls) **star:818** 从文本中提取url。   [![godoc][GoDoc]](https://godoc.org/github.com/mvdan/xurls)
    * [gotabulate](https://github.com/bndr/gotabulate) **star:267** 使用 Go 语言简单、美观的打印表格数据   [![godoc][GoDoc]](https://godoc.org/github.com/bndr/gotabulate)
    * [radix](https://github.com/yourbasic/radix) **star:173** 快速字符串排序算法。   [![最近一年没有更新][Yellow]](https://github.com/yourbasic/radix)   [![godoc][GoDoc]](https://godoc.org/github.com/yourbasic/radix)
    * [regroup](https://github.com/oriser/regroup) **star:91** 使用结构标记和自动解析将正则表达式命名组匹配到go结构中。   [![godoc][GoDoc]](https://godoc.org/github.com/oriser/regroup)
    * [parth](https://github.com/codemodus/parth) **star:40** URL路径分割解析。   [![最近一年没有更新][Yellow]](https://github.com/codemodus/parth)   [![godoc][GoDoc]](https://godoc.org/github.com/codemodus/parth)
    * [gofuckyourself](https://github.com/JoshuaDoes/gofuckyourself) **star:37** 一个基于 sanitization 的 Go 敏感词过滤器。   [![godoc][GoDoc]](https://godoc.org/github.com/JoshuaDoes/gofuckyourself)
    * [xj2go](https://github.com/stackerzzq/xj2go) **star:21** 将xml或json转换为struct。   [![最近一年没有更新][Yellow]](https://github.com/stackerzzq/xj2go)   [![godoc][GoDoc]](https://godoc.org/github.com/stackerzzq/xj2go)
    * [kace](https://github.com/codemodus/kace) **star:17** 通用大小写转换工具   [![最近一年没有更新][Yellow]](https://github.com/codemodus/kace)   [![godoc][GoDoc]](https://godoc.org/github.com/codemodus/kace)
    * [Tagify](https://github.com/zoomio/tagify) **star:17** 从给定源生成一组标记。   [![最近一周有更新][Green]](https://github.com/zoomio/tagify)   [![godoc][GoDoc]](https://godoc.org/github.com/zoomio/tagify)
    * [TySug](https://github.com/Dynom/TySug) **star:10** 关于键盘布局的其他建议。   [![最近一年没有更新][Yellow]](https://github.com/Dynom/TySug)   [![godoc][GoDoc]](https://godoc.org/github.com/Dynom/TySug)
    * [parseargs-go](https://github.com/nproc/parseargs-go) **star:8** 字符串参数解析器，能够理解引用及反斜杠。   [![最近一年没有更新][Yellow]](https://github.com/nproc/parseargs-go)   [![godoc][GoDoc]](https://godoc.org/github.com/nproc/parseargs-go)
	* [textwrap](https://github.com/isbm/textwrap) **star:2** 从Python实现“textwrap”模块。   [![最近一年没有更新][Yellow]](https://github.com/isbm/textwrap)   [![godoc][GoDoc]](https://godoc.org/github.com/isbm/textwrap)

## 第三方api

*用于访问第三方api的库。 (翻译出错了? 试试 [英文版](README_EN.md#third-party-apis) 吧~)*

* [github](https://github.com/google/go-github) **star:7687** 访问GitHub REST API v3的库。   [![star > 2000][Awesome]](https://github.com/google/go-github)   [![最近一周有更新][Green]](https://github.com/google/go-github)   [![godoc][GoDoc]](https://godoc.org/github.com/google/go-github)
* [aws-sdk-go](https://github.com/aws/aws-sdk-go) **star:7074** AWS 提供的官方go语言 SDK   [![star > 2000][Awesome]](https://github.com/aws/aws-sdk-go)   [![最近一周有更新][Green]](https://github.com/aws/aws-sdk-go)   [![godoc][GoDoc]](https://godoc.org/github.com/aws/aws-sdk-go)
* [slack](https://github.com/slack-go/slack) **star:3617** Slack API。   [![star > 2000][Awesome]](https://github.com/slack-go/slack)   [![最近一周有更新][Green]](https://github.com/slack-go/slack)   [![godoc][GoDoc]](https://godoc.org/github.com/slack-go/slack)
* [google](https://github.com/google/google-api-go-client) **star:2744** 为Go自动生成谷歌api。   [![star > 2000][Awesome]](https://github.com/google/google-api-go-client)   [![最近一周有更新][Green]](https://github.com/google/google-api-go-client)   [![godoc][GoDoc]](https://godoc.org/github.com/google/google-api-go-client)
* [google-cloud](https://github.com/GoogleCloudPlatform/gcloud-golang) **star:2617** 谷歌云api Go 客户端库。   [![star > 2000][Awesome]](https://github.com/GoogleCloudPlatform/gcloud-golang)   [![最近一周有更新][Green]](https://github.com/GoogleCloudPlatform/gcloud-golang)   [![godoc][GoDoc]](https://godoc.org/github.com/GoogleCloudPlatform/gcloud-golang)
* [discordgo](https://github.com/bwmarrin/discordgo) **star:2253**  Discord Chat API的客户端。   [![star > 2000][Awesome]](https://github.com/bwmarrin/discordgo)   [![最近一周有更新][Green]](https://github.com/bwmarrin/discordgo)   [![godoc][GoDoc]](https://godoc.org/github.com/bwmarrin/discordgo)
* [stripe](https://github.com/stripe/stripe-go) **star:1400**  Stripe API 的 Go 语言客户端   [![最近一周有更新][Green]](https://github.com/stripe/stripe-go)   [![godoc][GoDoc]](https://godoc.org/github.com/stripe/stripe-go)
* [minio-go](https://github.com/minio/minio-go) **star:1368** 用于Amazon S3兼容云存储的Minio Go库。   [![最近一周有更新][Green]](https://github.com/minio/minio-go)   [![godoc][GoDoc]](https://godoc.org/github.com/minio/minio-go)
* [go-twitter](https://github.com/dghubble/go-twitter) **star:1292**  Twitter v1.1 api 的客户端.   [![godoc][GoDoc]](https://godoc.org/github.com/dghubble/go-twitter)
* [anaconda](https://github.com/ChimeraCoder/anaconda) **star:1100**  Twitter 1.1 API 的 go 语言客户端   [![godoc][GoDoc]](https://godoc.org/github.com/ChimeraCoder/anaconda)
* [facebook](https://github.com/huandu/facebook) **star:990** 支持 Facebook Graph API 的库   [![godoc][GoDoc]](https://godoc.org/github.com/huandu/facebook)
* [go-jira](https://github.com/andygrunwald/go-jira) **star:944**  Go [Atlassian JIRA](https://www.atlassian.com/software/jira)的客户端库   [![godoc][GoDoc]](https://godoc.org/github.com/andygrunwald/go-jira)
* [githubql](https://github.com/shurcooL/githubql) **star:796** 访问GitHub GraphQL API v4的库。   [![godoc][GoDoc]](https://godoc.org/github.com/shurcooL/githubql)
* [webhooks](https://github.com/go-playground/webhooks) **star:643** GitHub 和 Bitbucket 的Webhook接收器。   [![godoc][GoDoc]](https://godoc.org/github.com/go-playground/webhooks)
* [paypal](https://github.com/logpacker/PayPal-Go-SDK) **star:437** PayPal支付API的包装器。   [![最近一周有更新][Green]](https://github.com/logpacker/PayPal-Go-SDK)   [![godoc][GoDoc]](https://godoc.org/github.com/logpacker/PayPal-Go-SDK)
* [geo-golang](https://github.com/codingsince1985/geo-golang) **star:408** 去图书馆访问谷歌地图(https://developers.google.com/maps/documentation/geocoding/intro), (MapQuest) (http://open.mapquestapi.com/geocoding/), (Nominatim) (https://developer.mapquest.com/documentation/open/nominatim-search), (OpenCage) (https://opencagedata.com/api), (Bing) (https://msdn.microsoft.com/en-us/library/ff701715.aspx),[Mapbox](https://www.mapbox.com/developers/api/geocoding/)和[OpenStreetMap](https://wiki.openstreetmap.org/wiki/Nominatim)地理编码/反向地理编码api。   [![最近一周有更新][Green]](https://github.com/codingsince1985/geo-golang)   [![godoc][GoDoc]](https://godoc.org/github.com/codingsince1985/geo-golang)
* [ethrpc](https://github.com/onrik/ethrpc) **star:213**  Ethereum JSON RPC API的客户端。   [![最近一年没有更新][Yellow]](https://github.com/onrik/ethrpc)   [![godoc][GoDoc]](https://godoc.org/github.com/onrik/ethrpc)
* [go-marathon](https://github.com/gambol99/go-marathon) **star:196**  用于和 Mesosphere's Marathon PAAS 交互的 Go 语言库   [![godoc][GoDoc]](https://godoc.org/github.com/gambol99/go-marathon)
* [Trello](https://github.com/adlio/trello) **star:180**  Trello API的 Go 语言封装。   [![godoc][GoDoc]](https://godoc.org/github.com/adlio/trello)
* [twitter-scraper](https://github.com/n0madic/twitter-scraper) **star:133** 刮Twitter前端API没有认证和限制。   [![godoc][GoDoc]](https://godoc.org/github.com/n0madic/twitter-scraper)
* [Medium](https://github.com/Medium/medium-sdk-go) **star:130** Medium的OAuth2 API 客户端。   [![最近一年没有更新][Yellow]](https://github.com/Medium/medium-sdk-go)   [![godoc][GoDoc]](https://godoc.org/github.com/Medium/medium-sdk-go)
* [gostorm](https://github.com/jsgilmore/gostorm) **star:127** GoStorm是一个Go库，它实现了编写Storm spout和bolt所需的通信协议，这些协议用于与Storm shell通信。   [![最近一年没有更新][Yellow]](https://github.com/jsgilmore/gostorm)   [![godoc][GoDoc]](https://godoc.org/github.com/jsgilmore/gostorm)
* [go-trending](https://github.com/andygrunwald/go-trending) **star:116** 在Github上访问[trends repository](https://github.com/trends)和[developers](https://github.com/trending/developers)的库。   [![godoc][GoDoc]](https://godoc.org/github.com/andygrunwald/go-trending)
* [hipchat (xmpp)](https://github.com/daneharrigan/hipchat) **star:111** 一个用于通过XMPP与HipChat通信的golang包。   [![最近一年没有更新][Yellow]](https://github.com/daneharrigan/hipchat)   [![godoc][GoDoc]](https://godoc.org/github.com/daneharrigan/hipchat)
* [wit-go](https://github.com/wit-ai/wit-go) **star:108** wit.ai HTTP API 客户端。   [![godoc][GoDoc]](https://godoc.org/github.com/wit-ai/wit-go)
* [hipchat](https://github.com/andybons/hipchat) **star:105** 这个项目为Hipchat API实现了一个golang客户端库。   [![最近一年没有更新][Yellow]](https://github.com/andybons/hipchat)   [![godoc][GoDoc]](https://godoc.org/github.com/andybons/hipchat)
* [pushover](https://github.com/gregdel/pushover) **star:102**  Go 包装的 Pushover API。   [![godoc][GoDoc]](https://godoc.org/github.com/gregdel/pushover)
* [cachet](https://github.com/andygrunwald/cachet) **star:88** 使用客户端库[Cachet(开源状态页系统)](https://cachethq.io/)。   [![godoc][GoDoc]](https://godoc.org/github.com/andygrunwald/cachet)
* [igdb](https://github.com/Henry-Sarabia/igdb) **star:68** [Internet Game Database API](https://api.igdb.com/) 客户端。   [![godoc][GoDoc]](https://godoc.org/github.com/Henry-Sarabia/igdb)
* [gosip](https://github.com/koltyakov/gosip) **star:62** 去客户端库SharePoint API。   [![godoc][GoDoc]](https://godoc.org/github.com/koltyakov/gosip)
* [circleci](https://github.com/jszwedko/go-circleci) **star:59** CircleCI的API的客户端   [![最近一年没有更新][Yellow]](https://github.com/jszwedko/go-circleci)   [![godoc][GoDoc]](https://godoc.org/github.com/jszwedko/go-circleci)
* [simples3](https://github.com/rhnvrm/simples3) **star:59** 使用REST和用Go编写的V4签名的AWS S3库非常简单。   [![godoc][GoDoc]](https://godoc.org/github.com/rhnvrm/simples3)
* [go-unsplash](https://github.com/hbagdi/go-unsplash) **star:56** 使用[Unsplash.com](https://unsplash.com) API的客户端库。   [![godoc][GoDoc]](https://godoc.org/github.com/hbagdi/go-unsplash)
* [clarifai](https://github.com/samuelcouch/clarifai) **star:55** Clarifai API的客户端。   [![最近一年没有更新][Yellow]](https://github.com/samuelcouch/clarifai)   [![godoc][GoDoc]](https://godoc.org/github.com/samuelcouch/clarifai)
* [gogtrends](https://github.com/groovili/gogtrends) **star:55** 非官方的Google Trends API。   [![godoc][GoDoc]](https://godoc.org/github.com/groovili/gogtrends)
* [megos](https://github.com/andygrunwald/megos) **star:54** 用于访问[Apache Mesos](http://mesos.apache.org/)集群的客户端库。   [![godoc][GoDoc]](https://godoc.org/github.com/andygrunwald/megos)
* [amazon-product-advertising-api](https://github.com/ngs/go-amazon-product-advertising-api) **star:49** [Amazon Product Advertising API](https://program.amazon.com/gp/advertising/api/detail/main.html)的客户端库。   [![最近一年没有更新][Yellow]](https://github.com/ngs/go-amazon-product-advertising-api)   [![godoc][GoDoc]](https://godoc.org/github.com/ngs/go-amazon-product-advertising-api)
* [gads](https://github.com/emiddleton/gads) **star:49**  Google Adwords 非官方 API   [![最近一年没有更新][Yellow]](https://github.com/emiddleton/gads)   [![godoc][GoDoc]](https://godoc.org/github.com/emiddleton/gads)
* [ynab](https://github.com/brunomvsouza/ynab.go) **star:48**  YNAB API 的 Go 语言封装。   [![godoc][GoDoc]](https://godoc.org/github.com/brunomvsouza/ynab.go)
* [uptimerobot](https://github.com/bitfield/uptimerobot) **star:46** 运行时Robot v2 API 的 Go 语言封装和命令行客户端。   [![godoc][GoDoc]](https://godoc.org/github.com/bitfield/uptimerobot)
* [go-xkcd](https://github.com/nishanths/go-xkcd) **star:45**  xkcd API 的客户端。   [![godoc][GoDoc]](https://godoc.org/github.com/nishanths/go-xkcd)
* [go-yapla](https://git.iglou.eu/Production/go-yapla)  Go ypla v2.0 API的客户端库。
* [GoMusicBrainz](https://github.com/michiwend/gomusicbrainz) **star:44**  Go MusicBrainz WS2客户端库。   [![godoc][GoDoc]](https://godoc.org/github.com/michiwend/gomusicbrainz)
* [golang-tmdb](https://github.com/cyruzin/golang-tmdb) **star:43** 电影数据库API v3的Golang包装器。   [![godoc][GoDoc]](https://godoc.org/github.com/cyruzin/golang-tmdb)
* [fcm](https://github.com/maddevsio/fcm) **star:41**  Firebase Cloud Messaging 的 Go 语言库   [![最近一年没有更新][Yellow]](https://github.com/maddevsio/fcm)   [![godoc][GoDoc]](https://godoc.org/github.com/maddevsio/fcm)
* [mixpanel](https://github.com/dukex/mixpanel) **star:39** Mixpanel是一个库，用于跟踪事件并将Mixpanel概要文件更新从go应用程序发送到Mixpanel。   [![godoc][GoDoc]](https://godoc.org/github.com/dukex/mixpanel)
* [spotify](https://github.com/rapito/go-spotify) **star:39**  用于接入 Spotify WEB API 的 Go 语言库   [![godoc][GoDoc]](https://godoc.org/github.com/rapito/go-spotify)
* [golyrics](https://github.com/mamal72/golyrics) **star:36** Golyrics是一个从Wikia网站获取音乐歌词数据的Go库。   [![最近一年没有更新][Yellow]](https://github.com/mamal72/golyrics)   [![godoc][GoDoc]](https://godoc.org/github.com/mamal72/golyrics)
* [translate](https://github.com/poorny/translate) **star:31**  Go 在线翻译包。   [![最近一年没有更新][Yellow]](https://github.com/poorny/translate)   [![godoc][GoDoc]](https://godoc.org/github.com/poorny/translate)
* [gami](https://github.com/bit4bit/gami) **star:30**  Asterisk Manager Interface 的 Go 语言库   [![最近一年没有更新][Yellow]](https://github.com/bit4bit/gami)   [![godoc][GoDoc]](https://godoc.org/github.com/bit4bit/gami)   [![归档项目][Archived]](https://github.com/bit4bit/gami)
* [go-postman-collection](https://github.com/rbretecher/go-postman-collection) **star:30** 去模块工作与[邮递员收集](https://learning.getpostman.com/docs/postman/collections/creating-collections/)(兼容失眠)。   [![最近一周有更新][Green]](https://github.com/rbretecher/go-postman-collection)   [![godoc][GoDoc]](https://godoc.org/github.com/rbretecher/go-postman-collection)
* [gcm](https://github.com/Aorioli/gcm) **star:29**  Google Cloud Messaging 库   [![最近一年没有更新][Yellow]](https://github.com/Aorioli/gcm)   [![godoc][GoDoc]](https://godoc.org/github.com/Aorioli/gcm)
* [airtable](https://github.com/mehanizm/airtable) **star:26** 去客户端库[Airtable API](https://airtable.com/api)。   [![godoc][GoDoc]](https://godoc.org/github.com/mehanizm/airtable)
* [patreon-go](https://github.com/mxpv/patreon-go) **star:26**  Go Patreon API库。   [![最近一年没有更新][Yellow]](https://github.com/mxpv/patreon-go)   [![godoc][GoDoc]](https://godoc.org/github.com/mxpv/patreon-go)
* [go-myanimelist](https://github.com/nstratos/go-myanimelist) **star:24** 去访问[MyAnimeList API]的客户端库(https://myanimelist.net/apiconfig/references/api/v2)。   [![godoc][GoDoc]](https://godoc.org/github.com/nstratos/go-myanimelist)
* [steam](https://github.com/sostronk/go-steam) **star:24**  用于与Steam服务器进行交互的库。   [![最近一年没有更新][Yellow]](https://github.com/sostronk/go-steam)   [![godoc][GoDoc]](https://godoc.org/github.com/sostronk/go-steam)
* [lastpass-go](https://github.com/ansd/lastpass-go) **star:22** 使用[LastPass](https://www.lastpass.com/) API的客户端库。   [![godoc][GoDoc]](https://godoc.org/github.com/ansd/lastpass-go)
* [go-imgur](https://github.com/koffeinsource/go-imgur) **star:21** Go [imgur](https://imgur.com)的客户端库   [![godoc][GoDoc]](https://godoc.org/github.com/koffeinsource/go-imgur)
* [go-twitch](https://github.com/knspriggs/go-twitch) **star:21**  Twitch v3 API 的客户端。   [![最近一年没有更新][Yellow]](https://github.com/knspriggs/go-twitch)   [![godoc][GoDoc]](https://godoc.org/github.com/knspriggs/go-twitch)
* [shopify](https://github.com/rapito/go-shopify) **star:21** 一个用于通过 Shopify API 进行增删改查的 Go 语言库。   [![godoc][GoDoc]](https://godoc.org/github.com/rapito/go-shopify)
* [brewerydb](https://github.com/naegelejd/brewerydb) **star:17** 用于访问 BreweryDB API的 Go 语言库   [![最近一年没有更新][Yellow]](https://github.com/naegelejd/brewerydb)   [![godoc][GoDoc]](https://godoc.org/github.com/naegelejd/brewerydb)
* [codeship-go](https://github.com/codeship/codeship-go) **star:17**  Codeship API v2的客户端。   [![godoc][GoDoc]](https://godoc.org/github.com/codeship/codeship-go)
* [textbelt](https://github.com/dietsche/textbelt) **star:17** textbelt.com txt messaging API 的go语言客户端。   [![最近一年没有更新][Yellow]](https://github.com/dietsche/textbelt)   [![godoc][GoDoc]](https://godoc.org/github.com/dietsche/textbelt)
* [google-play-scraper](https://github.com/n0madic/google-play-scraper) **star:15** 从谷歌播放存储获取数据。   [![godoc][GoDoc]](https://godoc.org/github.com/n0madic/google-play-scraper)
* [go-hacknews](https://github.com/PaulRosset/go-hacknews) **star:13** HackerNews API的小型Go客户端。   [![最近一年没有更新][Yellow]](https://github.com/PaulRosset/go-hacknews)   [![godoc][GoDoc]](https://godoc.org/github.com/PaulRosset/go-hacknews)
* [coinpaprika-go](https://github.com/coinpaprika/coinpaprika-api-go-client) **star:12** Coinpaprika API的客户端。   [![godoc][GoDoc]](https://godoc.org/github.com/coinpaprika/coinpaprika-api-go-client)
* [go-aws-news](https://github.com/circa10a/go-aws-news) **star:12** 去应用程序和库获取AWS的新内容。   [![最近一周有更新][Green]](https://github.com/circa10a/go-aws-news)   [![godoc][GoDoc]](https://godoc.org/github.com/circa10a/go-aws-news)
* [google-analytics](https://github.com/chonthu/go-google-analytics) **star:12** 简单的包装，方便的谷歌分析报告。   [![最近一年没有更新][Yellow]](https://github.com/chonthu/go-google-analytics)   [![godoc][GoDoc]](https://godoc.org/github.com/chonthu/go-google-analytics)
* [device-check-go](https://github.com/rinchsan/device-check-go) **star:10** Go客户端库与[iOS DeviceCheck API](https://developer.apple.com/documentation/devicecheck) v1交互。   [![godoc][GoDoc]](https://godoc.org/github.com/rinchsan/device-check-go)
* [gopaapi5](https://github.com/utekaravinash/gopaapi5) **star:10** Go客户端库[亚马逊产品广告API 5.0](https://webservices.amazon.com/paapi5/documentation/)。   [![最近一年没有更新][Yellow]](https://github.com/utekaravinash/gopaapi5)   [![godoc][GoDoc]](https://godoc.org/github.com/utekaravinash/gopaapi5)
* [smite](https://github.com/sergiotapia/smitego) **star:10** 对 Smite game API 的封装。   [![最近一年没有更新][Yellow]](https://github.com/sergiotapia/smitego)   [![godoc][GoDoc]](https://godoc.org/github.com/sergiotapia/smitego)
* [go-here](https://github.com/abdullahselek/go-here) **star:9** 转到基于这里位置的api的客户端库。   [![最近一年没有更新][Yellow]](https://github.com/abdullahselek/go-here)   [![godoc][GoDoc]](https://godoc.org/github.com/abdullahselek/go-here)
* [gomalshare](https://github.com/MonaxGT/gomalshare) **star:9** Go library MalShare API [malshare.com](http://www.malshare.com/)   [![最近一年没有更新][Yellow]](https://github.com/MonaxGT/gomalshare)   [![godoc][GoDoc]](https://godoc.org/github.com/MonaxGT/gomalshare)
* [go-sophos](https://github.com/esurdam/go-sophos) **star:8** 无任何依赖的[Sophos UTM REST API](https://www.sophos.com/en-us/medialibrary/pdfs/documentation/utmonaws/sophos-ut-restful-api.pdf?la=en)客户端   [![godoc][GoDoc]](https://godoc.org/github.com/esurdam/go-sophos)
* [rrdaclient](https://github.com/Omie/rrdaclient) **star:8** 用于接入 statdns.com API 的库——RRDA API。通过HTTP协议进行 DNS查询。   [![最近一年没有更新][Yellow]](https://github.com/Omie/rrdaclient)   [![godoc][GoDoc]](https://godoc.org/github.com/Omie/rrdaclient)   [![归档项目][Archived]](https://github.com/Omie/rrdaclient)
* [google-email-audit-api](https://github.com/ngs/go-google-email-audit-api) **star:7** [谷歌G Suite Email Audit API](https://developer.google.com/admin-sdk/email-audit/) 的客户端。   [![最近一年没有更新][Yellow]](https://github.com/ngs/go-google-email-audit-api)   [![godoc][GoDoc]](https://godoc.org/github.com/ngs/go-google-email-audit-api)
* [go-openproject](https://github.com/manuelbcd/go-openproject) **star:6** 去与[OpenProject](https://docs.openproject.org/api/) API交互的客户端库。   [![godoc][GoDoc]](https://godoc.org/github.com/manuelbcd/go-openproject)
* [go-sptrans](https://github.com/sergioaugrod/go-sptrans) **star:6**  SPTrans Olho Vivo API 的客户端。   [![godoc][GoDoc]](https://godoc.org/github.com/sergioaugrod/go-sptrans)
* [tumblr](https://github.com/mattcunningham/gumblr) **star:6**  Tumblr v2 API 的 Go 语言封装。   [![最近一年没有更新][Yellow]](https://github.com/mattcunningham/gumblr)   [![godoc][GoDoc]](https://godoc.org/github.com/mattcunningham/gumblr)
* [zooz](https://github.com/gojuno/go-zooz) **star:6**  Zooz API 的 Go 语言客户端。   [![godoc][GoDoc]](https://godoc.org/github.com/gojuno/go-zooz)
* [go-chronos](https://github.com/axelspringer/go-chronos) **star:4** 用于与[Chronos](https://mesos.github.io/chronos/)作业调度程序进行交互的Go库   [![最近一年没有更新][Yellow]](https://github.com/axelspringer/go-chronos)   [![godoc][GoDoc]](https://godoc.org/github.com/axelspringer/go-chronos)
* [kanka](https://github.com/Henry-Sarabia/kanka) **star:3** [Kanka API](https://kanka.io/en-US/docs/1.0)的Go客户端。   [![最近一年没有更新][Yellow]](https://github.com/Henry-Sarabia/kanka)   [![godoc][GoDoc]](https://godoc.org/github.com/Henry-Sarabia/kanka)
* [libgoffi](https://github.com/clevabit/libgoffi) **star:3** 库适配器工具箱，用于本地[libffi](http://sourceware.org/libffi/)集成   [![最近一年没有更新][Yellow]](https://github.com/clevabit/libgoffi)   [![godoc][GoDoc]](https://godoc.org/github.com/clevabit/libgoffi)
* [appstore-sdk-go](https://github.com/Kachit/appstore-sdk-go) **star:2** 非官方的用于AppStore Connect API的Golang SDK。   [![godoc][GoDoc]](https://godoc.org/github.com/Kachit/appstore-sdk-go)
* [go-restcountries](https://github.com/chriscross0/go-restcountries) **star:2** 去[REST国家API]库(https://restcountries.eu/)。   [![godoc][GoDoc]](https://godoc.org/github.com/chriscross0/go-restcountries)
* [rawg-sdk-go](https://github.com/dimuska139/rawg-sdk-go) **star:2** 去[RAWG视频游戏数据库](https://rawg.io/) API库   [![godoc][GoDoc]](https://godoc.org/github.com/dimuska139/rawg-sdk-go)
* [go-swagger-ui](https://github.com/esurdam/go-swagger-ui) **star:1** Go库包含预编译[Swagger UI](https://swagger.io/tools/swagger-ui/)，用于服务Swagger json。
* [go-telegraph](https://gitlab.com/toby3d/telegraph)  Telegraph 发布平台 API 客户端。
* [playlyfe](https://github.com/playlyfe/playlyfe-go-sdk) **star:1** Playlyfe Rest API Go SDK。   [![最近一年没有更新][Yellow]](https://github.com/playlyfe/playlyfe-go-sdk)   [![godoc][GoDoc]](https://godoc.org/github.com/playlyfe/playlyfe-go-sdk)
* [TripAdvisor](https://github.com/mrbenosborne/tripadvisor-golang) **star:1**  TripAdvisor API 的 Go 语言封装。   [![最近一年没有更新][Yellow]](https://github.com/mrbenosborne/tripadvisor-golang)   [![godoc][GoDoc]](https://godoc.org/github.com/mrbenosborne/tripadvisor-golang)
* [vl-go](https://github.com/verifid/vl-go) **star:1** 使用客户端库中的VerifID身份验证层API。   [![godoc][GoDoc]](https://godoc.org/github.com/verifid/vl-go)

## 公用事业公司

*可以让你的生活变得更简单的实用工具.。 (翻译出错了? 试试 [英文版](README_EN.md#utilities) 吧~)*

* [fzf](https://github.com/junegunn/fzf) **star:38575** 用Go编写的命令行模糊查找器。   [![star > 2000][Awesome]](https://github.com/junegunn/fzf)   [![最近一周有更新][Green]](https://github.com/junegunn/fzf)   [![godoc][GoDoc]](https://godoc.org/github.com/junegunn/fzf)
* [hub](https://github.com/github/hub) **star:21125** 封装了 git 命令，提供了额外的功能用于在终端中和 Github 进行交互。   [![star > 2000][Awesome]](https://github.com/github/hub)   [![最近一周有更新][Green]](https://github.com/github/hub)   [![godoc][GoDoc]](https://godoc.org/github.com/github/hub)
* [ctop](https://github.com/bcicen/ctop) **star:11836** [Top-like](http://ctop.sh)接口(例如htop)， 用于容器数据收集。   [![star > 2000][Awesome]](https://github.com/bcicen/ctop)   [![godoc][GoDoc]](https://godoc.org/github.com/bcicen/ctop)
* [sqlx](https://github.com/jmoiron/sqlx) **star:10650** 为内建的数据库/sql 软件包提供一组扩展。   [![star > 2000][Awesome]](https://github.com/jmoiron/sqlx)   [![最近一周有更新][Green]](https://github.com/jmoiron/sqlx)   [![godoc][GoDoc]](https://godoc.org/github.com/jmoiron/sqlx)
* [wuzz](https://github.com/asciimoo/wuzz) **star:9721** 用于HTTP检查的交互式cli工具。   [![star > 2000][Awesome]](https://github.com/asciimoo/wuzz)   [![godoc][GoDoc]](https://godoc.org/github.com/asciimoo/wuzz)
* [goreleaser](https://github.com/goreleaser/goreleaser) **star:8470** 尽可能快速的发布 Go 语言二进制文件。   [![star > 2000][Awesome]](https://github.com/goreleaser/goreleaser)   [![最近一周有更新][Green]](https://github.com/goreleaser/goreleaser)   [![godoc][GoDoc]](https://godoc.org/github.com/goreleaser/goreleaser)
* [usql](https://github.com/knq/usql) **star:6668** usql 是一个通用的命令行接口，用于操作 sql 数据库。   [![star > 2000][Awesome]](https://github.com/knq/usql)   [![godoc][GoDoc]](https://godoc.org/github.com/knq/usql)
* [peco](https://github.com/peco/peco) **star:6479** 简单的交互过滤工具。   [![star > 2000][Awesome]](https://github.com/peco/peco)   [![godoc][GoDoc]](https://godoc.org/github.com/peco/peco)
* [godropbox](https://github.com/dropbox/godropbox) **star:3961** 用于编写 Go 语言服务／应用的库，来自 Dropbox.。   [![star > 2000][Awesome]](https://github.com/dropbox/godropbox)   [![最近一年没有更新][Yellow]](https://github.com/dropbox/godropbox)   [![godoc][GoDoc]](https://godoc.org/github.com/dropbox/godropbox)
* [hystrix-go](https://github.com/afex/hystrix-go) **star:3314** 实现 Hystrix 风格的、程序员预定义的 fallback 机制（熔断。   [![star > 2000][Awesome]](https://github.com/afex/hystrix-go)   [![最近一周有更新][Green]](https://github.com/afex/hystrix-go)   [![godoc][GoDoc]](https://godoc.org/github.com/afex/hystrix-go)
* [goreporter](https://github.com/wgliang/goreporter) **star:2899** 进行代码静态分析，单元测试，代码检视并生成代码质量报告的工具   [![star > 2000][Awesome]](https://github.com/wgliang/goreporter)   [![最近一年没有更新][Yellow]](https://github.com/wgliang/goreporter)   [![godoc][GoDoc]](https://godoc.org/github.com/wgliang/goreporter)
* [go-funk](https://github.com/thoas/go-funk) **star:2830** 现代 Go 语言工具库，提供了很多有用的工具 (map, find, contains, filter, chunk, reverse, ...)   [![star > 2000][Awesome]](https://github.com/thoas/go-funk)   [![godoc][GoDoc]](https://godoc.org/github.com/thoas/go-funk)
* [minify](https://github.com/tdewolff/minify) **star:2739** 用于HTML、CSS、JS、XML、JSON和SVG文件格式的快速缩小器。   [![star > 2000][Awesome]](https://github.com/tdewolff/minify)   [![最近一周有更新][Green]](https://github.com/tdewolff/minify)   [![godoc][GoDoc]](https://godoc.org/github.com/tdewolff/minify)
* [panicparse](https://github.com/maruel/panicparse) **star:2682** 将类似的协程分组并对调用栈进行着色   [![star > 2000][Awesome]](https://github.com/maruel/panicparse)   [![godoc][GoDoc]](https://godoc.org/github.com/maruel/panicparse)
* [mc](https://github.com/minio/mc) **star:1884** Minio Client 提供了一组工具，用于操作 Amazon S3 兼容云存储和文件系统。   [![最近一周有更新][Green]](https://github.com/minio/mc)   [![godoc][GoDoc]](https://godoc.org/github.com/minio/mc)
* [Storm](https://github.com/asdine/storm) **star:1758** 一个简单又强大的用于 BoltDB 的工具   [![godoc][GoDoc]](https://godoc.org/github.com/asdine/storm)
* [mergo](https://github.com/imdario/mergo) **star:1639** 用于将结构体和map合并进 Go 语言的工具。对于配置默认值，避免杂乱的if语句很有帮助。   [![godoc][GoDoc]](https://godoc.org/github.com/imdario/mergo)
* [spinner](https://github.com/briandowns/spinner) **star:1558**  一个 Go 语言软件包，提供多种选项，方便在终端中创建加载动画。   [![godoc][GoDoc]](https://godoc.org/github.com/briandowns/spinner)
* [mole](https://github.com/davrodpin/mole) **star:1489** cli应用程序可以轻松创建ssh隧道。   [![最近一周有更新][Green]](https://github.com/davrodpin/mole)   [![godoc][GoDoc]](https://godoc.org/github.com/davrodpin/mole)
* [boilr](https://github.com/tmrts/boilr) **star:1374** 非常快的CLI工具，用于从样板模板创建项目。   [![godoc][GoDoc]](https://godoc.org/github.com/tmrts/boilr)
* [filetype](https://github.com/h2non/filetype) **star:1340** 通过数字签名来推测文件类型。   [![godoc][GoDoc]](https://godoc.org/github.com/h2non/filetype)
* [jump](https://github.com/gsamokovarov/jump) **star:1152** 通过学习你的习惯，可以帮助你更快地导航。   [![godoc][GoDoc]](https://godoc.org/github.com/gsamokovarov/jump)
* [circuitbreaker](https://github.com/rubyist/circuitbreaker) **star:955** 接通断路器。   [![最近一年没有更新][Yellow]](https://github.com/rubyist/circuitbreaker)   [![godoc][GoDoc]](https://godoc.org/github.com/rubyist/circuitbreaker)
* [git-time-metric](https://github.com/git-time-metric/gtm) **star:872** git-time-metric - 。   [![godoc][GoDoc]](https://godoc.org/github.com/git-time-metric/gtm)
* [immortal](https://github.com/immortal/immortal) **star:713** \*nix 跨平台 (与操作系统无关的)监控程序。   [![最近一年没有更新][Yellow]](https://github.com/immortal/immortal)   [![godoc][GoDoc]](https://godoc.org/github.com/immortal/immortal)
* [hostctl](https://github.com/guumaster/hostctl) **star:669** 一个使用简单命令管理/etc/主机的CLI工具。   [![godoc][GoDoc]](https://godoc.org/github.com/guumaster/hostctl)
* [circuit](https://github.com/cep21/circuit) **star:584** 一个高效和功能齐全的 类似 Hystrix Go 实现断路器模式。   [![godoc][GoDoc]](https://godoc.org/github.com/cep21/circuit)
* [mimetype](https://github.com/gabriel-vasile/mimetype) **star:550** 用于基于神奇数字的MIME类型检测的包。   [![最近一周有更新][Green]](https://github.com/gabriel-vasile/mimetype)   [![godoc][GoDoc]](https://godoc.org/github.com/gabriel-vasile/mimetype)
* [create-go-app](https://github.com/create-go-app/cli) **star:533** 一个强大的CLI，用于通过运行一个命令创建一个后端服务(Golang)，前端(JavaScript, TypeScript)和部署自动化(Ansible, Docker)的可生产项目。   [![godoc][GoDoc]](https://godoc.org/github.com/create-go-app/cli)
* [htcat](https://github.com/htcat/htcat) **star:533** 并行及流水线的 HTTP GET 工具。   [![最近一年没有更新][Yellow]](https://github.com/htcat/htcat)   [![godoc][GoDoc]](https://godoc.org/github.com/htcat/htcat)
* [godaemon](https://github.com/VividCortex/godaemon) **star:477** 用于编写守护进程的工具   [![godoc][GoDoc]](https://godoc.org/github.com/VividCortex/godaemon)
* [ergo](https://github.com/cristianoliveira/ergo) **star:473** 管理运行在不同端口上的多个本地服务变得很容易。   [![godoc][GoDoc]](https://godoc.org/github.com/cristianoliveira/ergo)
* [koazee](https://github.com/wesovilabs/koazee) **star:469** 库的灵感来自于延迟计算和函数式编程，从而减少了使用数组的麻烦。   [![godoc][GoDoc]](https://godoc.org/github.com/wesovilabs/koazee)
* [go-dry](https://github.com/ungerik/go-dry) **star:466** DRY(don't repeat yourself)库。   [![godoc][GoDoc]](https://godoc.org/github.com/ungerik/go-dry)
* [gopencils](https://github.com/bndr/gopencils) **star:436** 小而简单的包，可以轻松地使用REST api。   [![最近一年没有更新][Yellow]](https://github.com/bndr/gopencils)   [![godoc][GoDoc]](https://godoc.org/github.com/bndr/gopencils)
* [request](https://github.com/mozillazg/request) **star:398** Go 语言版的 HTTP Requests for Humans™.。   [![最近一年没有更新][Yellow]](https://github.com/mozillazg/request)   [![godoc][GoDoc]](https://godoc.org/github.com/mozillazg/request)
* [delve](https://github.com/derekparker/delve) **star:364** Go 语言调试器   [![最近一周有更新][Green]](https://github.com/derekparker/delve)   [![godoc][GoDoc]](https://godoc.org/github.com/derekparker/delve)
* [gubrak](https://github.com/novalagung/gubrak) **star:364** 带有语法糖的Golang实用工具，就像lodash。   [![最近一年没有更新][Yellow]](https://github.com/novalagung/gubrak)   [![godoc][GoDoc]](https://godoc.org/github.com/novalagung/gubrak)
* [Deepcopier](https://github.com/ulule/deepcopier) **star:354** 结构体拷贝   [![最近一年没有更新][Yellow]](https://github.com/ulule/deepcopier)   [![godoc][GoDoc]](https://godoc.org/github.com/ulule/deepcopier)
* [clockwork](https://github.com/jonboulle/clockwork) **star:344** 一个简单的假 clock 。   [![godoc][GoDoc]](https://godoc.org/github.com/jonboulle/clockwork)
* [scany](https://github.com/georgysavva/scany) **star:344** 库扫描数据从数据库到Go structs和更多。   [![最近一周有更新][Green]](https://github.com/georgysavva/scany)   [![godoc][GoDoc]](https://godoc.org/github.com/georgysavva/scany)
* [go-rate](https://github.com/beefsack/go-rate) **star:339**  Go 限速器。   [![godoc][GoDoc]](https://godoc.org/github.com/beefsack/go-rate)
* [retry](https://github.com/kamilsk/retry) **star:308** 基于上下文的功能机制，反复执行命令直到成功。   [![godoc][GoDoc]](https://godoc.org/github.com/kamilsk/retry)
* [gohper](https://github.com/cosiner/gohper) **star:253** 多种能够帮助你进行软件开发的工具和模块。   [![最近一年没有更新][Yellow]](https://github.com/cosiner/gohper)   [![godoc][GoDoc]](https://godoc.org/github.com/cosiner/gohper)   [![归档项目][Archived]](https://github.com/cosiner/gohper)
* [serve](https://github.com/syntaqx/serve) **star:245** 任何您需要的静态http服务器。   [![godoc][GoDoc]](https://godoc.org/github.com/syntaqx/serve)
* [scan](https://github.com/blockloop/scan) **star:224** 扫描golang的sql。行直接指向结构、片或基本类型。   [![godoc][GoDoc]](https://godoc.org/github.com/blockloop/scan)
* [go-trigger](https://github.com/sadlil/go-trigger) **star:218** Go 语言全局事件触发器，通过 id 和触发器，在程序的任何地方注册事件。   [![最近一年没有更新][Yellow]](https://github.com/sadlil/go-trigger)   [![godoc][GoDoc]](https://godoc.org/github.com/sadlil/go-trigger)
* [util](https://github.com/shomali11/util) **star:214** 有用实用函数的集合。(字符串，并发，操作，…)   [![最近一年没有更新][Yellow]](https://github.com/shomali11/util)   [![godoc][GoDoc]](https://godoc.org/github.com/shomali11/util)
* [gotenv](https://github.com/subosito/gotenv) **star:204** 从 `.env` 或者任何 `io.Reader`。   [![godoc][GoDoc]](https://godoc.org/github.com/subosito/gotenv)
* [Death](https://github.com/vrecan/death) **star:172** 利用信号管理应用程序的关闭。   [![godoc][GoDoc]](https://godoc.org/github.com/vrecan/death)
* [go-bind-plugin](https://github.com/wendigo/go-bind-plugin) **star:170** Go:generate 工具，用于构建 Go 语言插件(1.8 only)，并对导出的符号进行包装。   [![最近一年没有更新][Yellow]](https://github.com/wendigo/go-bind-plugin)   [![godoc][GoDoc]](https://godoc.org/github.com/wendigo/go-bind-plugin)
* [toolbox](https://github.com/viant/toolbox) **star:163** 切片, map, multimap, 结构体, 函数,数据转换工具。服务路由，宏求值和标记器。   [![godoc][GoDoc]](https://godoc.org/github.com/viant/toolbox)
* [rerun](https://github.com/ivpusic/rerun) **star:162** 当源代码发生更改时，重新编译和重新运行go应用程序。   [![最近一年没有更新][Yellow]](https://github.com/ivpusic/rerun)   [![godoc][GoDoc]](https://godoc.org/github.com/ivpusic/rerun)
* [moldova](https://github.com/StabbyCutyou/moldova) **star:161** 基于输入目标生成随机数据的工具   [![最近一年没有更新][Yellow]](https://github.com/StabbyCutyou/moldova)   [![godoc][GoDoc]](https://godoc.org/github.com/StabbyCutyou/moldova)
* [go-sitemap-generator](https://github.com/ikeikeikeike/go-sitemap-generator) **star:159** 用Go编写的XML站点地图生成器。   [![godoc][GoDoc]](https://godoc.org/github.com/ikeikeikeike/go-sitemap-generator)
* [apm](https://github.com/topfreegames/apm) **star:153** Go 语言进程管理工具具有HTTP API.。   [![最近一年没有更新][Yellow]](https://github.com/topfreegames/apm)   [![godoc][GoDoc]](https://godoc.org/github.com/topfreegames/apm)
* [robustly](https://github.com/VividCortex/robustly) **star:150** 有弹性的执行函数，遇到错误时捕获并重新运行。   [![godoc][GoDoc]](https://godoc.org/github.com/VividCortex/robustly)
* [chyle](https://github.com/antham/chyle) **star:138** 使用具有多种配置可能性的git存储库生成变更日志。   [![godoc][GoDoc]](https://godoc.org/github.com/antham/chyle)
* [go-bsdiff](https://github.com/gabstv/go-bsdiff) **star:122** 纯Go bsdiff和bspatch库和CLI工具。   [![最近一年没有更新][Yellow]](https://github.com/gabstv/go-bsdiff)   [![godoc][GoDoc]](https://godoc.org/github.com/gabstv/go-bsdiff)
* [onecache](https://github.com/adelowo/onecache) **star:121** 支持多个后端存储(Redis、Memcached、文件系统等)的缓存库。   [![最近一年没有更新][Yellow]](https://github.com/adelowo/onecache)   [![godoc][GoDoc]](https://godoc.org/github.com/adelowo/onecache)
* [lrserver](https://github.com/jaschaephraim/lrserver) **star:119** LiveReload 服务器。   [![最近一年没有更新][Yellow]](https://github.com/jaschaephraim/lrserver)   [![godoc][GoDoc]](https://godoc.org/github.com/jaschaephraim/lrserver)
* [countries](https://github.com/biter777/countries) **star:109** 完整实现ISO-3166-1、ISO-4217、ITU-T E.164、Unicode CLDR和IANA ccTLD标准。   [![godoc][GoDoc]](https://godoc.org/github.com/biter777/countries)
* [mssqlx](https://github.com/linxGnu/mssqlx) **star:89** 数据库客户端，用于主-从 (或主-主) 数据库，集成了简单的、轻量级的轮询调度负载均衡。   [![godoc][GoDoc]](https://godoc.org/github.com/linxGnu/mssqlx)
* [nostromo](https://github.com/pokanop/nostromo) **star:89** CLI用于构建强大的别名。   [![godoc][GoDoc]](https://godoc.org/github.com/pokanop/nostromo)
* [goseaweedfs](https://github.com/linxGnu/goseaweedfs) **star:88** conseilSeaweedFS 客户端，几乎具有全部的特性。   [![godoc][GoDoc]](https://godoc.org/github.com/linxGnu/goseaweedfs)
* [pattern-match](https://github.com/alexpantyukhin/go-pattern-match) **star:88** 模式匹配图书馆。   [![最近一年没有更新][Yellow]](https://github.com/alexpantyukhin/go-pattern-match)   [![godoc][GoDoc]](https://godoc.org/github.com/alexpantyukhin/go-pattern-match)
* [xferspdy](https://github.com/monmohan/xferspdy) **star:87** Xferspdy在golang中提供二进制diff和补丁库。   [![godoc][GoDoc]](https://godoc.org/github.com/monmohan/xferspdy)
* [changie](https://github.com/miniscruff/changie) **star:86** 自动化的变更日志工具，用于准备带有大量定制选项的版本。   [![godoc][GoDoc]](https://godoc.org/github.com/miniscruff/changie)
* [sorty](https://github.com/jfcg/sorty) **star:82** 快速并发/并行排序。   [![最近一周有更新][Green]](https://github.com/jfcg/sorty)   [![godoc][GoDoc]](https://godoc.org/github.com/jfcg/sorty)
* [go-health](https://github.com/Talento90/go-health) **star:81** 健康包简化了向服务中添加健康检查的方式。   [![最近一年没有更新][Yellow]](https://github.com/Talento90/go-health)   [![godoc][GoDoc]](https://godoc.org/github.com/Talento90/go-health)
* [pm](https://github.com/VividCortex/pm) **star:78** 进程(即goroutine)管理器与HTTP API。   [![godoc][GoDoc]](https://godoc.org/github.com/VividCortex/pm)
* [repeat](https://github.com/ssgreg/repeat) **star:77** 执行不同的后 backoff 策略，这对重新尝试操作和心跳非常有用。   [![最近一年没有更新][Yellow]](https://github.com/ssgreg/repeat)   [![godoc][GoDoc]](https://godoc.org/github.com/ssgreg/repeat)
* [mongo-go-pagination](https://github.com/gobeam/mongo-go-pagination) **star:71** 用于官方Mongodb /mongo-go驱动程序包的Mongodb分页，它支持正常的查询和聚合管道。   [![godoc][GoDoc]](https://godoc.org/github.com/gobeam/mongo-go-pagination)
* [netbug](https://github.com/e-dard/netbug) **star:69** 远程对你的服务进行性能分析   [![最近一年没有更新][Yellow]](https://github.com/e-dard/netbug)   [![godoc][GoDoc]](https://godoc.org/github.com/e-dard/netbug)
* [UNIS](https://github.com/esemplastic/unis) **star:67** Go 语言字符串处理函数的通用架构 。   [![最近一年没有更新][Yellow]](https://github.com/esemplastic/unis)   [![godoc][GoDoc]](https://godoc.org/github.com/esemplastic/unis)
* [handy](https://github.com/miguelpragier/handy) **star:65** 许多实用程序和帮助程序，如字符串处理程序/格式化程序和验证器。   [![godoc][GoDoc]](https://godoc.org/github.com/miguelpragier/handy)
* [multitick](https://github.com/VividCortex/multitick) **star:65** 用于 aligned tickers 的多路复用   [![godoc][GoDoc]](https://godoc.org/github.com/VividCortex/multitick)
* [cmd](https://github.com/SimonBaeumer/cmd) **star:64** 用于在osx、windows和linux上执行shell命令的库。   [![最近一年没有更新][Yellow]](https://github.com/SimonBaeumer/cmd)   [![godoc][GoDoc]](https://godoc.org/github.com/SimonBaeumer/cmd)
* [mimemagic](https://github.com/zRedShift/mimemagic) **star:64** 纯粹 Go 超性能MIME嗅探库/实用程序。   [![godoc][GoDoc]](https://godoc.org/github.com/zRedShift/mimemagic)
* [clipboard](https://github.com/golang-design/clipboard) **star:62** 📋跨平台剪贴板包中去。   [![最近一周有更新][Green]](https://github.com/golang-design/clipboard)   [![godoc][GoDoc]](https://godoc.org/github.com/golang-design/clipboard)
* [minquery](https://github.com/icza/minquery) **star:59** MongoDB / mgo.v2, 支持高效分页查询(用于继续列出我们停止的文档的游标)。   [![godoc][GoDoc]](https://godoc.org/github.com/icza/minquery)
* [goreadability](https://github.com/philipjkim/goreadability) **star:58** 网页摘要提取器使用Facebook开放图形和arc90的可读性。   [![最近一年没有更新][Yellow]](https://github.com/philipjkim/goreadability)   [![godoc][GoDoc]](https://godoc.org/github.com/philipjkim/goreadability)
* [go-astitodo](https://github.com/asticode/go-astitodo) **star:57** 解析你 Go 语言代码中的 TODOs（待办事项）。   [![最近一年没有更新][Yellow]](https://github.com/asticode/go-astitodo)   [![godoc][GoDoc]](https://godoc.org/github.com/asticode/go-astitodo)
* [golog](https://github.com/mlimaloureiro/golog) **star:55** 简单、轻量级的命令后工具，用于对你的计划任务进行跟踪。   [![最近一年没有更新][Yellow]](https://github.com/mlimaloureiro/golog)   [![godoc][GoDoc]](https://godoc.org/github.com/mlimaloureiro/golog)
* [goval](https://github.com/maja42/goval) **star:53** 在Go中计算任意表达式。   [![godoc][GoDoc]](https://godoc.org/github.com/maja42/goval)
* [pgo](https://github.com/arthurkushman/pgo) **star:53** 用于PHP社区的 Convenient 函数。   [![godoc][GoDoc]](https://godoc.org/github.com/arthurkushman/pgo)
* [copy-pasta](https://github.com/jutkko/copy-pasta) **star:49** 通用多工作站剪切板，使用类似 S3 的后端作为存储。   [![最近一年没有更新][Yellow]](https://github.com/jutkko/copy-pasta)   [![godoc][GoDoc]](https://godoc.org/github.com/jutkko/copy-pasta)
* [go-lock](https://github.com/viney-shih/go-lock) **star:49** go-lock是一个锁库，它实现了读写互斥锁和读写尝试锁，而不需要等待。   [![godoc][GoDoc]](https://godoc.org/github.com/viney-shih/go-lock)
* [filter](https://github.com/gookit/filter) **star:48** 提供Go数据的过滤、清理和转换。   [![godoc][GoDoc]](https://godoc.org/github.com/gookit/filter)
* [retry](https://github.com/thedevsaddam/retry) **star:48** 简单易用的重试机制包，为 Go 。   [![godoc][GoDoc]](https://godoc.org/github.com/thedevsaddam/retry)
* [rospo](https://github.com/ferama/rospo) **star:48** 简单可靠的ssh隧道与嵌入的ssh服务器Golang   [![godoc][GoDoc]](https://godoc.org/github.com/ferama/rospo)
* [beyond](https://github.com/wesovilabs/beyond) **star:47** Go工具将带你进入AOP的世界!   [![godoc][GoDoc]](https://godoc.org/github.com/wesovilabs/beyond)
* [golarm](https://github.com/msempere/golarm) **star:45** 告警（支持系统事件）。   [![最近一年没有更新][Yellow]](https://github.com/msempere/golarm)   [![godoc][GoDoc]](https://godoc.org/github.com/msempere/golarm)
* [goback](https://github.com/carlescere/goback) **star:44**  一个 Go 语言的简单的指数补偿包。   [![godoc][GoDoc]](https://godoc.org/github.com/carlescere/goback)
* [dbt](https://github.com/nikogura/dbt) **star:43** 用于从中心可信存储库运行自更新签名二进制文件的框架。   [![godoc][GoDoc]](https://godoc.org/github.com/nikogura/dbt)
* [slice](https://github.com/psampaz/slice) **star:43** 用于普通Go切片操作的类型安全函数。   [![最近一年没有更新][Yellow]](https://github.com/psampaz/slice)   [![godoc][GoDoc]](https://godoc.org/github.com/psampaz/slice)
* [intrinsic](https://github.com/mengzhuo/intrinsic) **star:42** 不需要编写任何汇编代码就能使用 x86 SIMD。   [![最近一年没有更新][Yellow]](https://github.com/mengzhuo/intrinsic)   [![godoc][GoDoc]](https://godoc.org/github.com/mengzhuo/intrinsic)   [![归档项目][Archived]](https://github.com/mengzhuo/intrinsic)
* [gpath](https://github.com/tenntenn/gpath) **star:40**  用于简化结构体域访问的库。   [![最近一年没有更新][Yellow]](https://github.com/tenntenn/gpath)   [![godoc][GoDoc]](https://godoc.org/github.com/tenntenn/gpath)
* [retry-go](https://github.com/rafaeljesus/retry-go) **star:40** 对 Go 来说，重试变得简单而容易。   [![最近一年没有更新][Yellow]](https://github.com/rafaeljesus/retry-go)   [![godoc][GoDoc]](https://godoc.org/github.com/rafaeljesus/retry-go)
* [limiters](https://github.com/mennanov/limiters) **star:37** Golang中的分布式应用程序速率限制器，具有可配置的后端和分布式锁。   [![godoc][GoDoc]](https://godoc.org/github.com/mennanov/limiters)
* [go-httpheader](https://github.com/mozillazg/go-httpheader) **star:35**  用于将结构体编码进 http 头的 Go 语言库   [![godoc][GoDoc]](https://godoc.org/github.com/mozillazg/go-httpheader)
* [myhttp](https://github.com/inancgumus/myhttp) **star:33** 简单的API，使HTTP GET请求与超时支持。   [![最近一年没有更新][Yellow]](https://github.com/inancgumus/myhttp)   [![godoc][GoDoc]](https://godoc.org/github.com/inancgumus/myhttp)   [![归档项目][Archived]](https://github.com/inancgumus/myhttp)
* [equalizer](https://github.com/reugn/equalizer) **star:32** 用Go实现的限流工具   [![godoc][GoDoc]](https://godoc.org/github.com/reugn/equalizer)
* [evaluator](https://github.com/nullne/evaluator) **star:32** 基于 s-expression。它很简单，很容易扩展。   [![godoc][GoDoc]](https://godoc.org/github.com/nullne/evaluator)
* [gostrutils](https://github.com/ik5/gostrutils) **star:32** 字符串操作和转换函数的集合。   [![最近一周有更新][Green]](https://github.com/ik5/gostrutils)   [![godoc][GoDoc]](https://godoc.org/github.com/ik5/gostrutils)
* [rclient](https://github.com/zpatrick/rclient) **star:32** 可读、灵活、易于使用的REST api客户端。   [![最近一年没有更新][Yellow]](https://github.com/zpatrick/rclient)   [![godoc][GoDoc]](https://godoc.org/github.com/zpatrick/rclient)
* [tome](https://github.com/cyruzin/tome) **star:28** Tome设计用于对简单的RESTful api进行分页。   [![最近一年没有更新][Yellow]](https://github.com/cyruzin/tome)   [![godoc][GoDoc]](https://godoc.org/github.com/cyruzin/tome)
* [slicer](https://github.com/leaanthony/slicer) **star:25** 使处理切片更容易。   [![godoc][GoDoc]](https://godoc.org/github.com/leaanthony/slicer)
* [ugo](https://github.com/alxrm/ugo) **star:25** uGo 是一个切片工具箱，有着和 Go 语言一致的语法法。   [![最近一年没有更新][Yellow]](https://github.com/alxrm/ugo)   [![godoc][GoDoc]](https://godoc.org/github.com/alxrm/ugo)
* [backscanner](https://github.com/icza/backscanner) **star:24** 类似 bufio 的扫描器，但它以相反的顺序读取和返回行，从给定的位置开始，然后返回。   [![godoc][GoDoc]](https://godoc.org/github.com/icza/backscanner)
* [generate](https://github.com/go-playground/generate) **star:24** 针对一个路径或环境变量，递归的执行 Go generate，可以通过正则表达式来进行过滤。   [![最近一年没有更新][Yellow]](https://github.com/go-playground/generate)   [![godoc][GoDoc]](https://godoc.org/github.com/go-playground/generate)
* [goplaceholder](https://github.com/michiwend/goplaceholder) **star:22** 一个小巧的 Go 语言库用于生成占位图片。   [![最近一年没有更新][Yellow]](https://github.com/michiwend/goplaceholder)   [![godoc][GoDoc]](https://godoc.org/github.com/michiwend/goplaceholder)
* [rerate](https://github.com/abo/rerate) **star:21** 基于 Redis 的速率计数器和限速器   [![最近一年没有更新][Yellow]](https://github.com/abo/rerate)   [![godoc][GoDoc]](https://godoc.org/github.com/abo/rerate)
* [ghokin](https://github.com/antham/ghokin) **star:19** 没有外部依赖的gherkin (cucumber, behat…)并行格式化程序。   [![godoc][GoDoc]](https://godoc.org/github.com/antham/ghokin)
* [shutdown](https://github.com/ztrue/shutdown) **star:19** ' os的应用程序关闭挂钩。信号的处理。   [![最近一年没有更新][Yellow]](https://github.com/ztrue/shutdown)   [![godoc][GoDoc]](https://godoc.org/github.com/ztrue/shutdown)
* [ctxutil](https://github.com/posener/ctxutil) **star:18** 上下文工具。   [![最近一年没有更新][Yellow]](https://github.com/posener/ctxutil)   [![godoc][GoDoc]](https://godoc.org/github.com/posener/ctxutil)
* [structs](https://github.com/PumpkinSeed/structs) **star:17** 简单来讲就是 "Make" 的替代品。   [![最近一年没有更新][Yellow]](https://github.com/PumpkinSeed/structs)   [![godoc][GoDoc]](https://godoc.org/github.com/PumpkinSeed/structs)
* [dlog](https://github.com/kirillDanshin/dlog) **star:16** 编译时控制的日志，让你的 release 包变得更小而不需移除 debug 调用。   [![最近一年没有更新][Yellow]](https://github.com/kirillDanshin/dlog)   [![godoc][GoDoc]](https://godoc.org/github.com/kirillDanshin/dlog)
* [filler](https://github.com/yaronsumel/filler) **star:16** 使用“fill”标签填充结构的小工具。   [![最近一年没有更新][Yellow]](https://github.com/yaronsumel/filler)   [![godoc][GoDoc]](https://godoc.org/github.com/yaronsumel/filler)
* [mimesniffer](https://github.com/aofei/mimesniffer) **star:16** 一个用于Go的MIME类型嗅探器。   [![godoc][GoDoc]](https://godoc.org/github.com/aofei/mimesniffer)
* [okrun](https://github.com/xta/okrun) **star:15**  Go 运行错误 steamroller。   [![最近一年没有更新][Yellow]](https://github.com/xta/okrun)   [![godoc][GoDoc]](https://godoc.org/github.com/xta/okrun)
* [command](https://github.com/txgruppi/command) **star:14** 命令模式，支持线程安全的串行、并行调度。   [![最近一年没有更新][Yellow]](https://github.com/txgruppi/command)   [![godoc][GoDoc]](https://godoc.org/github.com/txgruppi/command)
* [jsend](https://github.com/clevergo/jsend) **star:14** 在Go中编写JSend的实现。   [![godoc][GoDoc]](https://godoc.org/github.com/clevergo/jsend)
* [rest-go](https://github.com/edermanoel94/rest-go) **star:13** 一个包，它为使用rest api提供了许多有用的方法。   [![最近一年没有更新][Yellow]](https://github.com/edermanoel94/rest-go)   [![godoc][GoDoc]](https://godoc.org/github.com/edermanoel94/rest-go)
* [go-convert](https://github.com/Eun/go-convert) **star:12** Package go-convert允许您将一个值转换成另一种类型。   [![godoc][GoDoc]](https://godoc.org/github.com/Eun/go-convert)
* [go-type](https://github.com/mikekonan/go-types) **star:11** 为ISO-4217、ISO-3166和其他类型的存储/验证和传输提供Go类型的库。   [![godoc][GoDoc]](https://godoc.org/github.com/mikekonan/go-types)
* [ptr](https://github.com/gotidy/ptr) **star:11** 提供函数的包，用于从基本类型的常量简化指针的创建。   [![godoc][GoDoc]](https://godoc.org/github.com/gotidy/ptr)
* [retry](https://github.com/shafreeck/retry) **star:11** 一个相当简单的库，以确保您的工作可以完成。   [![最近一年没有更新][Yellow]](https://github.com/shafreeck/retry)   [![godoc][GoDoc]](https://godoc.org/github.com/shafreeck/retry)
* [go-problemdetails](https://github.com/mvmaasakkers/go-problemdetails) **star:10** 打包处理问题细节。   [![最近一年没有更新][Yellow]](https://github.com/mvmaasakkers/go-problemdetails)   [![godoc][GoDoc]](https://godoc.org/github.com/mvmaasakkers/go-problemdetails)
* [mani](https://github.com/alajmo/mani) **star:10** CLI工具，帮助您管理多个存储库。   [![最近一周有更新][Green]](https://github.com/alajmo/mani)   [![godoc][GoDoc]](https://godoc.org/github.com/alajmo/mani)
* [go-countries](https://github.com/mikekonan/go-countries) **star:9** 对ISO-3166代码的轻量级查找。   [![godoc][GoDoc]](https://godoc.org/github.com/mikekonan/go-countries)
* [silk](https://github.com/chrispassas/silk) **star:9** 阅读silk netflow文件。   [![godoc][GoDoc]](https://godoc.org/github.com/chrispassas/silk)
* [copy](https://github.com/gotidy/copy) **star:8** 包快速复制不同类型的struct。   [![godoc][GoDoc]](https://godoc.org/github.com/gotidy/copy)
* [statiks](https://github.com/janiltonmaciel/statiks) **star:8** 快速，零配置，静态HTTP文件服务器。   [![godoc][GoDoc]](https://godoc.org/github.com/janiltonmaciel/statiks)
* [go-clip](https://github.com/prashantgupta24/go-clip) **star:7** Mac的一个极简的剪贴板管理器。   [![godoc][GoDoc]](https://godoc.org/github.com/prashantgupta24/go-clip)
* [nfdump](https://github.com/chrispassas/nfdump) **star:7** 读取nfdump netflow文件。   [![godoc][GoDoc]](https://godoc.org/github.com/chrispassas/nfdump)
* [retry](https://github.com/percolate/retry) **star:7** 一个简单但高度可配置的Go重试包。   [![最近一年没有更新][Yellow]](https://github.com/percolate/retry)
* [sliceconv](https://github.com/Henry-Sarabia/sliceconv) **star:7** 基本类型之间的片转换。   [![最近一年没有更新][Yellow]](https://github.com/Henry-Sarabia/sliceconv)   [![godoc][GoDoc]](https://godoc.org/github.com/Henry-Sarabia/sliceconv)
* [blank](https://github.com/Henry-Sarabia/blank) **star:6** 验证或删除字符串中的空白。   [![最近一年没有更新][Yellow]](https://github.com/Henry-Sarabia/blank)   [![godoc][GoDoc]](https://godoc.org/github.com/Henry-Sarabia/blank)
* [go-safe](https://github.com/kenkyu392/go-safe) **star:4** Panic-safe沙箱。   [![godoc][GoDoc]](https://godoc.org/github.com/kenkyu392/go-safe)
* [lets-go](https://github.com/aplescia-chwy/lets-go) **star:3** Go模块，为云本地REST API开发提供公共工具。还包含AWS特定的实用程序。   [![godoc][GoDoc]](https://godoc.org/github.com/aplescia-chwy/lets-go)
* [goctx](https://github.com/zerosnake0/goctx) **star:2** 获得高性能的上下文值。   [![godoc][GoDoc]](https://godoc.org/github.com/zerosnake0/goctx)
* [olaf](https://github.com/btnguyen2k/olaf) **star:2** Twitter Snowflake 在Go中实现。   [![最近一年没有更新][Yellow]](https://github.com/btnguyen2k/olaf)   [![godoc][GoDoc]](https://godoc.org/github.com/btnguyen2k/olaf)
* [tik](https://github.com/andy2046/tik) **star:2** 简单和容易的时间轮包去。   [![godoc][GoDoc]](https://godoc.org/github.com/andy2046/tik)
* [bleep](https://github.com/sinhashubham95/bleep) **star:1** 在Go中对任意一组OS信号执行任意数量的操作。   [![godoc][GoDoc]](https://godoc.org/github.com/sinhashubham95/bleep)
* [go-actuator](https://github.com/sinhashubham95/go-actuator) **star:1** 基于Go的web框架的生产就绪特性。   [![godoc][GoDoc]](https://godoc.org/github.com/sinhashubham95/go-actuator)

## UUID

*用于处理uuid的库。 (翻译出错了? 试试 [英文版](README_EN.md#uuid) 吧~)*

* [uuid](https://github.com/google/uuid) **star:2977** 基于RFC 4122和DCE 1.1的uuid包:身份验证和安全服务。   [![star > 2000][Awesome]](https://github.com/google/uuid)   [![最近一周有更新][Green]](https://github.com/google/uuid)   [![godoc][GoDoc]](https://godoc.org/github.com/google/uuid)
* [ulid](https://github.com/oklog/ulid) **star:2336** 实现了ULID(普遍唯一的词典分类标识符)。   [![star > 2000][Awesome]](https://github.com/oklog/ulid)   [![godoc][GoDoc]](https://godoc.org/github.com/oklog/ulid)
* [uniq](https://gitlab.com/skilstak/code/go/uniq)  没有麻烦，安全，快速的唯一标识符与命令。
* [uuid](https://github.com/gofrs/uuid) **star:960** 通用唯一标识符(UUID)的实现。支持uuid的创建和解析。积极维护satori uuid的fork。   [![godoc][GoDoc]](https://godoc.org/github.com/gofrs/uuid)
* [wuid](https://github.com/edwingeng/wuid) **star:423** 一个非常快的唯一数字生成器，比UUID快10-135倍。   [![最近一周有更新][Green]](https://github.com/edwingeng/wuid)   [![godoc][GoDoc]](https://godoc.org/github.com/edwingeng/wuid)
* [sno](https://github.com/muyo/sno) **star:51** 使用嵌入元数据的紧凑、可排序和快速的惟一id。   [![godoc][GoDoc]](https://godoc.org/github.com/muyo/sno)
* [nanoid](https://github.com/aidarkhanov/nanoid) **star:33** 一个小而有效的Go唯一字符串ID生成器。   [![最近一年没有更新][Yellow]](https://github.com/aidarkhanov/nanoid)   [![godoc][GoDoc]](https://godoc.org/github.com/aidarkhanov/nanoid)
* [goid](https://github.com/jakehl/goid) **star:30** 生成和解析RFC4122兼容的V4 uuid。   [![最近一年没有更新][Yellow]](https://github.com/jakehl/goid)   [![godoc][GoDoc]](https://godoc.org/github.com/jakehl/goid)
* [uuid](https://github.com/agext/uuid) **star:14** 使用快速或加密质量的随机节点标识符生成、编码和解码UUIDs v1。   [![最近一年没有更新][Yellow]](https://github.com/agext/uuid)   [![godoc][GoDoc]](https://godoc.org/github.com/agext/uuid)
* [gouid](https://github.com/twharmon/gouid) **star:9** 生成加密安全的随机字符串id，只有一个分配。   [![godoc][GoDoc]](https://godoc.org/github.com/twharmon/gouid)
* [goflake](https://github.com/hart87/GoFlake) **star:7** 一种在分布式系统中使用的小型、可扩展的、无服务器的唯一ID生成器。受到推特雪花的启发。   [![godoc][GoDoc]](https://godoc.org/github.com/hart87/GoFlake)

## 验证

*库进行验证。 (翻译出错了? 试试 [英文版](README_EN.md#validation) 吧~)*

* [validator](https://github.com/go-playground/validator) **star:8441**  Go 结构体及域验证，包括：跨域、跨结构体, Map, 切片和数组。   [![star > 2000][Awesome]](https://github.com/go-playground/validator)   [![最近一周有更新][Green]](https://github.com/go-playground/validator)   [![godoc][GoDoc]](https://godoc.org/github.com/go-playground/validator)
* [govalidator](https://github.com/asaskevich/govalidator) **star:4876** 用于字符串，数字，切片和结构的验证器和sanitizers。   [![star > 2000][Awesome]](https://github.com/asaskevich/govalidator)   [![godoc][GoDoc]](https://godoc.org/github.com/asaskevich/govalidator)
* [ozzo-validation](https://github.com/go-ozzo/ozzo-validation) **star:2278** 支持各种数据类型(结构、字符串、映射、片等)的验证，使用可配置和可扩展的验证规则，这些规则在通常的代码构造中指定，而不是在结构标签中指定。   [![star > 2000][Awesome]](https://github.com/go-ozzo/ozzo-validation)   [![godoc][GoDoc]](https://godoc.org/github.com/go-ozzo/ozzo-validation)
* [govalidator](https://github.com/thedevsaddam/govalidator) **star:1009** 用简单的规则验证Golang请求数据。深受Laravel请求验证的启发。   [![godoc][GoDoc]](https://godoc.org/github.com/thedevsaddam/govalidator)
* [validate](https://github.com/gookit/validate) **star:463**  Go 封装数据验证和过滤。支持验证映射、结构、请求(表单、JSON、url)。值，上载文件)数据和更多特性。   [![godoc][GoDoc]](https://godoc.org/github.com/gookit/validate)   [![包含中文文档][CN]](https://github.com/gookit/validate)
* [checkdigit](https://github.com/osamingo/checkdigit) **star:80** 提供校验数字算法(Luhn, Verhoeff, Damm)和计算器(ISBN, EAN, JAN, UPC等)。   [![godoc][GoDoc]](https://godoc.org/github.com/osamingo/checkdigit)
* [terraform-validator](https://github.com/thazelart/terraform-validator) **star:70** 一种规范和约定验证器。   [![godoc][GoDoc]](https://godoc.org/github.com/thazelart/terraform-validator)
* [jio](https://github.com/faceair/jio) **star:60** jio是一个json模式验证器，类似于[joi](https://github.com/hapijs/joi)。   [![最近一年没有更新][Yellow]](https://github.com/faceair/jio)   [![godoc][GoDoc]](https://godoc.org/github.com/faceair/jio)   [![包含中文文档][CN]](https://github.com/faceair/jio)
* [validate](https://github.com/gobuffalo/validate) **star:59** 这个包提供了一个框架，用于为Go应用程序编写验证。   [![godoc][GoDoc]](https://godoc.org/github.com/gobuffalo/validate)
* [gody](https://github.com/guiferpa/gody) **star:51** :一个轻量级的结构验证器。   [![godoc][GoDoc]](https://godoc.org/github.com/guiferpa/gody)
* [govalid](https://github.com/twharmon/govalid) **star:22** 快速、基于标签的结构验证。   [![最近一周有更新][Green]](https://github.com/twharmon/govalid)   [![godoc][GoDoc]](https://godoc.org/github.com/twharmon/govalid)

## 版本控制

*用于版本控制的库。 (翻译出错了? 试试 [英文版](README_EN.md#version-control) 吧~)*

* [go-git](https://github.com/go-git/go-git) **star:2557** 纯Go中高度可扩展的Git实现。   [![star > 2000][Awesome]](https://github.com/go-git/go-git)   [![godoc][GoDoc]](https://godoc.org/github.com/go-git/go-git)
* [git2go](https://github.com/libgit2/git2go) **star:1637**  libgit2 的 Go 语言接口。   [![godoc][GoDoc]](https://godoc.org/github.com/libgit2/git2go)
* [hercules](https://github.com/src-d/hercules) **star:1399** 从Git存储库历史中获得高级见解。   [![godoc][GoDoc]](https://godoc.org/github.com/src-d/hercules)
* [gh](https://github.com/rjeczalik/gh) **star:75** 用于GitHub webhook的可编写脚本的服务器和net/http中间件。   [![最近一年没有更新][Yellow]](https://github.com/rjeczalik/gh)   [![godoc][GoDoc]](https://godoc.org/github.com/rjeczalik/gh)
* [go-vcs](https://github.com/sourcegraph/go-vcs) **star:75** 在Go中操作和检查VCS存储库。   [![godoc][GoDoc]](https://godoc.org/github.com/sourcegraph/go-vcs)
* [githooks](https://github.com/gabyx/githooks) **star:21** 每回购和共享Git挂钩版本控制和自动更新。   [![godoc][GoDoc]](https://godoc.org/github.com/gabyx/githooks)
* [hgo](https://github.com/beyang/hgo) **star:13** Hgo是一组Go包的集合，提供对本地Mercurial存储库的读取访问。   [![最近一年没有更新][Yellow]](https://github.com/beyang/hgo)   [![godoc][GoDoc]](https://godoc.org/github.com/beyang/hgo)

## 视频

*用于操作视频的库。 (翻译出错了? 试试 [英文版](README_EN.md#video) 吧~)*

* [goav](https://github.com/giorgisio/goav) **star:1687** FFmpeg的全面Go绑定。   [![godoc][GoDoc]](https://godoc.org/github.com/giorgisio/goav)
* [m3u8](https://github.com/grafov/m3u8) **star:841** 苹果HLS的M3U8播放列表解析器和生成器库。   [![godoc][GoDoc]](https://godoc.org/github.com/grafov/m3u8)
* [gmf](https://github.com/3d0c/gmf) **star:696**  FFmpeg av\* 库的 Go 语言接口。   [![godoc][GoDoc]](https://godoc.org/github.com/3d0c/gmf)
* [go-astits](https://github.com/asticode/go-astits) **star:373** 在GO中解析和演示MPEG传输流(.ts)。   [![godoc][GoDoc]](https://godoc.org/github.com/asticode/go-astits)
* [go-astisub](https://github.com/asticode/go-astisub) **star:329** 使用 Go 语言操作字幕(.srt, .stl, .ttml, .webvtt, .ssa/.ass, teletext, .smi, etc.)。   [![最近一周有更新][Green]](https://github.com/asticode/go-astisub)   [![godoc][GoDoc]](https://godoc.org/github.com/asticode/go-astisub)
* [libvlc-go](https://github.com/adrg/libvlc-go) **star:234** Go绑定libvlc 2.X/3.X/4。X(由VLC媒体播放器使用)。   [![godoc][GoDoc]](https://godoc.org/github.com/adrg/libvlc-go)
* [gst](https://github.com/ziutek/gst) **star:160**  GStreamer的Go工具。   [![godoc][GoDoc]](https://godoc.org/github.com/ziutek/gst)
* [gortsplib](https://github.com/aler9/gortsplib) **star:110** 纯Go RTSP服务器和客户端库。   [![godoc][GoDoc]](https://godoc.org/github.com/aler9/gortsplib)
* [go-m3u8](https://github.com/quangngotan95/go-m3u8) **star:76** 苹果m3u8播放列表的解析器和生成器库。   [![最近一年没有更新][Yellow]](https://github.com/quangngotan95/go-m3u8)   [![godoc][GoDoc]](https://godoc.org/github.com/quangngotan95/go-m3u8)
* [v4l](https://github.com/korandiz/v4l) **star:58** 用于Linux的视频捕捉库，用Go编写。   [![godoc][GoDoc]](https://godoc.org/github.com/korandiz/v4l)
* [libgosubs](https://github.com/wargarblgarbl/libgosubs) **star:14** 字幕格式支持 .srt、.ttml和.ass。   [![最近一年没有更新][Yellow]](https://github.com/wargarblgarbl/libgosubs)   [![godoc][GoDoc]](https://godoc.org/github.com/wargarblgarbl/libgosubs)
* [go-mpd](https://github.com/unki2aut/go-mpd) **star:10** MPEG-DASH清单文件的解析器和生成器库。   [![最近一年没有更新][Yellow]](https://github.com/unki2aut/go-mpd)   [![godoc][GoDoc]](https://godoc.org/github.com/unki2aut/go-mpd)

## Web框架

*全栈 web 框架。 (翻译出错了? 试试 [英文版](README_EN.md#web-frameworks) 吧~)*

* [Gin](https://github.com/gin-gonic/gin) **star:50648** Gin是一个用Go编写的web框架!它具有一个类似于martini的API，性能更好，速度快40倍。   [![star > 2000][Awesome]](https://github.com/gin-gonic/gin)   [![最近一周有更新][Green]](https://github.com/gin-gonic/gin)   [![godoc][GoDoc]](https://godoc.org/github.com/gin-gonic/gin)
* [Beego](https://github.com/beego/beego) **star:26836** beego是一种用于 Go 编程语言的开源高性能web框架。   [![star > 2000][Awesome]](https://github.com/beego/beego)   [![最近一周有更新][Green]](https://github.com/beego/beego)   [![godoc][GoDoc]](https://godoc.org/github.com/beego/beego)
* [Buffalo](http://gobuffalo.io)  为 Go 语言带来堪比 Rails 的高生产效率!
* [Confetti Framework](https://www.confetti-framework.com)  Confetti is a Go web application framework with an expressive, elegant syntax. Confetti combines the elegance of Laravel and the simplicity of Go.
* [Echo](https://github.com/labstack/echo) **star:20468** 高性能、极简的Go web框架。   [![star > 2000][Awesome]](https://github.com/labstack/echo)   [![最近一周有更新][Green]](https://github.com/labstack/echo)   [![godoc][GoDoc]](https://godoc.org/github.com/labstack/echo)
* [Fiber](https://github.com/gofiber/fiber) **star:14680** 一个灵感来自Express.js的web框架构建在Fasthttp上。   [![star > 2000][Awesome]](https://github.com/gofiber/fiber)   [![最近一周有更新][Green]](https://github.com/gofiber/fiber)   [![godoc][GoDoc]](https://godoc.org/github.com/gofiber/fiber)
* [Revel](https://github.com/revel/revel) **star:12349** 用于Go语言的高效web框架。   [![star > 2000][Awesome]](https://github.com/revel/revel)   [![godoc][GoDoc]](https://godoc.org/github.com/revel/revel)
* [Goa](https://github.com/goadesign/goa) **star:4342** Goa为在Go中开发远程api和微服务提供了一种全面的方法。   [![star > 2000][Awesome]](https://github.com/goadesign/goa)   [![最近一周有更新][Green]](https://github.com/goadesign/goa)   [![godoc][GoDoc]](https://godoc.org/github.com/goadesign/goa)
* [go-json-rest](https://github.com/ant0ine/go-json-rest) **star:3478** 设置RESTful JSON API的快速简便方法。   [![star > 2000][Awesome]](https://github.com/ant0ine/go-json-rest)   [![godoc][GoDoc]](https://godoc.org/github.com/ant0ine/go-json-rest)
* [Gizmo](https://github.com/NYTimes/gizmo) **star:3465** 《纽约时报》使用的微服务工具包。   [![star > 2000][Awesome]](https://github.com/NYTimes/gizmo)   [![godoc][GoDoc]](https://godoc.org/github.com/NYTimes/gizmo)
* [Macaron](https://github.com/go-macaron/macaron) **star:3189** Macaron 是一个高效的模块化设计的web框架   [![star > 2000][Awesome]](https://github.com/go-macaron/macaron)   [![godoc][GoDoc]](https://godoc.org/github.com/go-macaron/macaron)
* [utron](https://github.com/gernest/utron) **star:2200** Go(Golang)的轻量级MVC框架。   [![star > 2000][Awesome]](https://github.com/gernest/utron)   [![最近一年没有更新][Yellow]](https://github.com/gernest/utron)   [![godoc][GoDoc]](https://godoc.org/github.com/gernest/utron)
* [tigertonic](https://github.com/rcrowley/go-tigertonic) **star:997** 用于构建 JSON web 服务的 Go 语言框架，受到 Dropwizard 的启发。   [![最近一年没有更新][Yellow]](https://github.com/rcrowley/go-tigertonic)   [![godoc][GoDoc]](https://godoc.org/github.com/rcrowley/go-tigertonic)
* [Goyave](https://github.com/go-goyave/goyave) **star:881** 功能完备的REST API框架，旨在干净的代码和快速的开发，具有强大的内置功能。   [![最近一周有更新][Green]](https://github.com/go-goyave/goyave)   [![godoc][GoDoc]](https://godoc.org/github.com/go-goyave/goyave)
* [tango](https://github.com/lunny/tango) **star:834** 微型的、支持插件的 web 框架。   [![最近一年没有更新][Yellow]](https://github.com/lunny/tango)   [![godoc][GoDoc]](https://godoc.org/github.com/lunny/tango)   [![包含中文文档][CN]](https://github.com/lunny/tango)   [![归档项目][Archived]](https://github.com/lunny/tango)
* [Gearbox](https://github.com/abahmed/gearbox) **star:535** 一个用Go编写的web框架，专注于高性能和内存优化。   [![最近一周有更新][Green]](https://github.com/abahmed/gearbox)   [![godoc][GoDoc]](https://godoc.org/github.com/abahmed/gearbox)
* [gongular](https://github.com/mustafaakin/gongular) **star:442**  快速 Go web 框架，支持输入映射／验证以及依赖注入。   [![最近一年没有更新][Yellow]](https://github.com/mustafaakin/gongular)   [![godoc][GoDoc]](https://godoc.org/github.com/mustafaakin/gongular)
* [neo](https://github.com/ivpusic/neo) **star:413** Neo是一个非常简单且快速的Web框架API。   [![最近一年没有更新][Yellow]](https://github.com/ivpusic/neo)   [![godoc][GoDoc]](https://godoc.org/github.com/ivpusic/neo)
* [Air](https://github.com/aofei/air) **star:406** 一个理想的精细化的Go web框架。   [![godoc][GoDoc]](https://godoc.org/github.com/aofei/air)
* [Aero](https://github.com/aerogo/aero) **star:397** 高性能的Go web框架，在Lighthouse中达到最高分。   [![最近一年没有更新][Yellow]](https://github.com/aerogo/aero)   [![godoc][GoDoc]](https://godoc.org/github.com/aerogo/aero)
* [mango](https://github.com/paulbellamy/mango) **star:357** ManGo 是一个模块化 web 应用框架，受到 Rack 和 PEP333 的启发。   [![最近一年没有更新][Yellow]](https://github.com/paulbellamy/mango)   [![godoc][GoDoc]](https://godoc.org/github.com/paulbellamy/mango)
* [Gondola](https://github.com/rainycape/gondola) **star:308** web框架写的网站越快越好。   [![最近一年没有更新][Yellow]](https://github.com/rainycape/gondola)   [![godoc][GoDoc]](https://godoc.org/github.com/rainycape/gondola)
* [Golf](https://github.com/dinever/golf) **star:250** Golf 是一个快速、简单、轻量级的 Go 语言微型 web 框架。具有强大的功能且没有标准库以外的依赖。   [![最近一年没有更新][Yellow]](https://github.com/dinever/golf)   [![godoc][GoDoc]](https://godoc.org/github.com/dinever/golf)
* [Flamingo](https://github.com/i-love-flamingo/flamingo) **star:224** 可插拔web项目的框架。包括模块的概念和提供DI、Configareas、i18n、模板引擎、graphql、可观察性、安全性、事件、路由和反向路由等功能。   [![最近一周有更新][Green]](https://github.com/i-love-flamingo/flamingo)   [![godoc][GoDoc]](https://godoc.org/github.com/i-love-flamingo/flamingo)
* [Flamingo Commerce](https://github.com/i-love-flamingo/flamingo-commerce) **star:201** 提供使用干净的体系结构(如DDD和端口和适配器)的电子商务功能，您可以使用这些功能来构建灵活的电子商务应用程序。   [![godoc][GoDoc]](https://godoc.org/github.com/i-love-flamingo/flamingo-commerce)
* [Ginrpc](https://github.com/xxjwxc/ginrpc) **star:182** Gin参数自动绑定工具，Gin rpc工具。   [![godoc][GoDoc]](https://godoc.org/github.com/xxjwxc/ginrpc)   [![包含中文文档][CN]](https://github.com/xxjwxc/ginrpc)
* [WebGo](https://github.com/bnkamalesh/webgo) **star:181** 构建web应用程序的微框架;处理程序链接、中间件和上下文注入。与标准库兼容的HTTP处理程序(即http.HandlerFunc)。   [![godoc][GoDoc]](https://godoc.org/github.com/bnkamalesh/webgo)
* [hiboot](https://github.com/hidevopsio/hiboot) **star:163** hiboot是一个高性能的web应用程序框架，支持自动配置和依赖注入。   [![godoc][GoDoc]](https://godoc.org/github.com/hidevopsio/hiboot)   [![包含中文文档][CN]](https://github.com/hidevopsio/hiboot)
* [uAdmin](https://github.com/uadmin/uadmin) **star:146** 受到 Sinatra 启发的 Go 语言 web 框架。   [![godoc][GoDoc]](https://godoc.org/github.com/uadmin/uadmin)
* [go-rest](https://github.com/ungerik/go-rest) **star:125** 小型的 REST 框架。   [![最近一年没有更新][Yellow]](https://github.com/ungerik/go-rest)   [![godoc][GoDoc]](https://godoc.org/github.com/ungerik/go-rest)
* [appy](https://github.com/appist/appy) **star:105** 一个固执己见的高效web框架，有助于更容易地扩展业务。   [![godoc][GoDoc]](https://godoc.org/github.com/appist/appy)
* [patron](https://github.com/beatlabs/patron) **star:78** Patron是一个遵循最佳云实践的微服务框架，专注于提升开发效率。   [![最近一周有更新][Green]](https://github.com/beatlabs/patron)   [![godoc][GoDoc]](https://godoc.org/github.com/beatlabs/patron)
* [Microservice](https://github.com/claygod/microservice) **star:74** 创建微服务的框架，用Golang编写。   [![最近一年没有更新][Yellow]](https://github.com/claygod/microservice)   [![godoc][GoDoc]](https://godoc.org/github.com/claygod/microservice)
* [Golax](https://github.com/fulldump/golax) **star:73** 一个非Sinatra快速HTTP框架，支持谷歌自定义方法、深度拦截器、递归等。   [![最近一年没有更新][Yellow]](https://github.com/fulldump/golax)   [![godoc][GoDoc]](https://godoc.org/github.com/fulldump/golax)
* [vox](https://github.com/aisk/vox) **star:73** 一个面向人类的golang web框架，深受Koa的启发。   [![godoc][GoDoc]](https://godoc.org/github.com/aisk/vox)
* [rux](https://github.com/gookit/rux) **star:66** 简单而快速的web框架，可用于构建golang HTTP应用程序   [![godoc][GoDoc]](https://godoc.org/github.com/gookit/rux)   [![包含中文文档][CN]](https://github.com/gookit/rux)
* [YARF](https://github.com/yarf-framework/yarf) **star:62** 快速微框架，旨在以快速和简单的方式构建REST api和web服务。   [![最近一年没有更新][Yellow]](https://github.com/yarf-framework/yarf)   [![godoc][GoDoc]](https://godoc.org/github.com/yarf-framework/yarf)
* [aah](https://aahframework.org)  可伸缩、高性能、快速开发的Go Web框架。
* [Fireball](https://github.com/zpatrick/fireball) **star:56** 感觉更加自然的 web 框架。   [![最近一年没有更新][Yellow]](https://github.com/zpatrick/fireball)   [![godoc][GoDoc]](https://godoc.org/github.com/zpatrick/fireball)
* [goa](https://github.com/goa-go/goa) **star:45** goa就像golang中的koajs一样，是一个灵活、轻量级、高性能和可扩展的基于中间件的web框架。   [![最近一年没有更新][Yellow]](https://github.com/goa-go/goa)   [![godoc][GoDoc]](https://godoc.org/github.com/goa-go/goa)
* [GoTuna](https://github.com/gotuna/gotuna) **star:34** Go的极简web框架，包含mux路由器，中间件，会话，模板，嵌入视图和静态文件。   [![godoc][GoDoc]](https://godoc.org/github.com/gotuna/gotuna)
* [Resoursea](https://github.com/resoursea/api) **star:31** 用于快速编写基于资源的服务的REST框架。   [![最近一年没有更新][Yellow]](https://github.com/resoursea/api)   [![godoc][GoDoc]](https://godoc.org/github.com/resoursea/api)
* [REST Layer](http://rest-layer.io)  框架，用于在数据库之上构建REST/GraphQL API，主要是通过代码进行配置。
* [rex](https://github.com/goanywhere/rex) **star:31**  Rex 是一个用于进行模块化开发的库，基于Gorilla/mux 完全兼容大多数的 net/HTTP.   [![最近一年没有更新][Yellow]](https://github.com/goanywhere/rex)   [![godoc][GoDoc]](https://godoc.org/github.com/goanywhere/rex)
* [goweb](https://github.com/twharmon/goweb) **star:24** 具有路由、websockets、日志、中间件、静态文件服务器(可选gzip)和自动TLS的Web框架。   [![godoc][GoDoc]](https://godoc.org/github.com/twharmon/goweb)
* [Banjo](https://github.com/nsheremet/banjo) **star:18** 非常简单和快速的网络框架 Go 。   [![最近一年没有更新][Yellow]](https://github.com/nsheremet/banjo)   [![godoc][GoDoc]](https://godoc.org/github.com/nsheremet/banjo)

### 中间件

#### 仿真中间件

* [Tollbooth](https://github.com/didip/tollbooth) **star:1985** 限制速率的 HTTP 请求处理程序。   [![godoc][GoDoc]](https://godoc.org/github.com/didip/tollbooth)
* [CORS](https://github.com/rs/cors) **star:1886** 轻松地向API添加CORS功能。   [![godoc][GoDoc]](https://godoc.org/github.com/rs/cors)
* [Limiter](https://github.com/ulule/limiter) **star:1313** 简单的速度限制中间件。   [![最近一周有更新][Green]](https://github.com/ulule/limiter)   [![godoc][GoDoc]](https://godoc.org/github.com/ulule/limiter)
* [go-server-timing](https://github.com/mitchellh/go-server-timing) **star:819** 添加/解析Server-Timing头。   [![godoc][GoDoc]](https://godoc.org/github.com/mitchellh/go-server-timing)
* [go-fault](https://github.com/github/go-fault) **star:407** Go的故障注入中间件。   [![最近一周有更新][Green]](https://github.com/github/go-fault)   [![godoc][GoDoc]](https://godoc.org/github.com/github/go-fault)
* [ln-paywall](https://github.com/philippgille/ln-paywall) **star:111** 使用Lightning Network(比特币)实现基于每个请求的api货币化中间件。   [![最近一年没有更新][Yellow]](https://github.com/philippgille/ln-paywall)   [![godoc][GoDoc]](https://godoc.org/github.com/philippgille/ln-paywall)
* [XFF](https://github.com/sebest/xff) **star:82** 处理 X-Forwarded-For 头的中间件。   [![godoc][GoDoc]](https://godoc.org/github.com/sebest/xff)
* [formjson](https://github.com/rs/formjson) **star:36** 透明地将JSON输入作为标准表单POST处理。   [![最近一年没有更新][Yellow]](https://github.com/rs/formjson)   [![godoc][GoDoc]](https://godoc.org/github.com/rs/formjson)
* [client-timing](https://github.com/posener/client-timing) **star:19** 用于服务器定时报头的HTTP客户机。   [![最近一年没有更新][Yellow]](https://github.com/posener/client-timing)   [![godoc][GoDoc]](https://godoc.org/github.com/posener/client-timing)

#### 用于创建HTTP中间件的库

* [negroni](https://github.com/urfave/negroni) **star:7057** 符合语言习惯的 HTTP 中间件库。   [![star > 2000][Awesome]](https://github.com/urfave/negroni)   [![godoc][GoDoc]](https://godoc.org/github.com/urfave/negroni)   [![包含中文文档][CN]](https://github.com/urfave/negroni)
* [alice](https://github.com/justinas/alice) **star:2334** 用于连接中间件的库，简单无痛苦。   [![star > 2000][Awesome]](https://github.com/justinas/alice)   [![godoc][GoDoc]](https://godoc.org/github.com/justinas/alice)
* [render](https://github.com/unrolled/render) **star:1529** Go package用于方便地呈现JSON、XML和HTML模板响应。   [![godoc][GoDoc]](https://godoc.org/github.com/unrolled/render)
* [stats](https://github.com/thoas/stats) **star:580** 使用中间件来存储关于web应用程序的各种信息。   [![最近一年没有更新][Yellow]](https://github.com/thoas/stats)   [![godoc][GoDoc]](https://godoc.org/github.com/thoas/stats)
* [interpose](https://github.com/carbocation/interpose) **star:291** golang的极简网络/http中间件。   [![最近一年没有更新][Yellow]](https://github.com/carbocation/interpose)   [![godoc][GoDoc]](https://godoc.org/github.com/carbocation/interpose)
* [renderer](https://github.com/thedevsaddam/renderer) **star:224** 简单、轻量级和更快的响应(JSON、JSONP、XML、YAML、HTML、文件)。   [![godoc][GoDoc]](https://godoc.org/github.com/thedevsaddam/renderer)
* [muxchain](https://github.com/stephens2424/muxchain) **star:209** 用于net/http的轻量级中间件。   [![最近一年没有更新][Yellow]](https://github.com/stephens2424/muxchain)   [![godoc][GoDoc]](https://godoc.org/github.com/stephens2424/muxchain)
* [gores](https://github.com/alioygur/gores) **star:97** 处理HTML、JSON、XML等响应的Go包。对于RESTful api非常有用。   [![godoc][GoDoc]](https://godoc.org/github.com/alioygur/gores)
* [rye](https://github.com/InVisionApp/rye) **star:97** 支持JWT、CORS、Statsd和Go 1.7上下文的小型Go中间件库(带有罐装中间件)。   [![最近一年没有更新][Yellow]](https://github.com/InVisionApp/rye)   [![godoc][GoDoc]](https://godoc.org/github.com/InVisionApp/rye)
* [mediary](https://github.com/HereMobilityDevelopers/mediary) **star:74** 在http中添加拦截器。客户端允许转储/成型/跟踪/…的请求/响应。   [![最近一年没有更新][Yellow]](https://github.com/HereMobilityDevelopers/mediary)   [![godoc][GoDoc]](https://godoc.org/github.com/HereMobilityDevelopers/mediary)
* [chain](https://github.com/codemodus/chain) **star:63** 带有范围数据的处理程序包装器链接(基于网络/上下文的“中间件”)。   [![最近一年没有更新][Yellow]](https://github.com/codemodus/chain)   [![godoc][GoDoc]](https://godoc.org/github.com/codemodus/chain)
* [go-wrap](https://github.com/go-on/wrap) **star:59** net/http的小型中间件包。   [![最近一年没有更新][Yellow]](https://github.com/go-on/wrap)   [![godoc][GoDoc]](https://godoc.org/github.com/go-on/wrap)   [![归档项目][Archived]](https://github.com/go-on/wrap)
* [catena](https://github.com/codemodus/catena) **star:7** HTTP.Handler wrapper catenation (和chain具有相同的 API ).。   [![最近一年没有更新][Yellow]](https://github.com/codemodus/catena)   [![godoc][GoDoc]](https://godoc.org/github.com/codemodus/catena)

### 路由器

* [mux](https://github.com/gorilla/mux) **star:14932** 强大的URL路由器和调度器为golang。   [![star > 2000][Awesome]](https://github.com/gorilla/mux)   [![godoc][GoDoc]](https://godoc.org/github.com/gorilla/mux)
* [httprouter](https://github.com/julienschmidt/httprouter) **star:13047** 高性能路由。使用这个库和标准http处理工具可以构建一个非常高性能大web框架。   [![star > 2000][Awesome]](https://github.com/julienschmidt/httprouter)   [![godoc][GoDoc]](https://godoc.org/github.com/julienschmidt/httprouter)
* [chi](https://github.com/go-chi/chi) **star:9917** 小巧、快速、具有丰富表达力的 HTTP 路由，基于net/context.。   [![star > 2000][Awesome]](https://github.com/go-chi/chi)   [![最近一周有更新][Green]](https://github.com/go-chi/chi)   [![godoc][GoDoc]](https://godoc.org/github.com/go-chi/chi)
* [gocraft/web](https://github.com/gocraft/web) **star:1445** Mux和中间件包在Go中。   [![godoc][GoDoc]](https://godoc.org/github.com/gocraft/web)
* [Bone](https://github.com/go-zoo/bone) **star:1274** 闪电快速HTTP多路复用器。   [![最近一年没有更新][Yellow]](https://github.com/go-zoo/bone)   [![godoc][GoDoc]](https://godoc.org/github.com/go-zoo/bone)
* [fasthttprouter](https://github.com/buaazp/fasthttprouter) **star:873** 高性能路由器分叉从`httprouter`。第一个路由器适合`fasthttp`。   [![最近一年没有更新][Yellow]](https://github.com/buaazp/fasthttprouter)   [![godoc][GoDoc]](https://godoc.org/github.com/buaazp/fasthttprouter)
* [Goji](https://github.com/goji/goji) **star:872** 枸杞是一种简约的和灵活的与支持'net/context` HTTP请求多路复用器。   [![最近一年没有更新][Yellow]](https://github.com/goji/goji)   [![godoc][GoDoc]](https://godoc.org/github.com/goji/goji)
* [httptreemux](https://github.com/dimfeld/httptreemux) **star:500** 高速，灵活，基于树的 HTTP 路由。受到了 httprouter 的启发。   [![godoc][GoDoc]](https://godoc.org/github.com/dimfeld/httptreemux)
* [xujiajun/gorouter](https://github.com/xujiajun/gorouter) **star:500** 一个简单和快速的HTTP路由器 Go 。   [![最近一年没有更新][Yellow]](https://github.com/xujiajun/gorouter)   [![godoc][GoDoc]](https://godoc.org/github.com/xujiajun/gorouter)
* [ozzo-routing](https://github.com/go-ozzo/ozzo-routing) **star:408** 一个非常快的Go (golang) HTTP路由器，支持正则表达式路由匹配。完全支持构建RESTful api。   [![godoc][GoDoc]](https://godoc.org/github.com/go-ozzo/ozzo-routing)
* [lars](https://github.com/go-playground/lars) **star:382** 是一个轻量级、快速、可扩展、零分配的HTTP路由，用于创建定制化的框架。   [![最近一年没有更新][Yellow]](https://github.com/go-playground/lars)   [![godoc][GoDoc]](https://godoc.org/github.com/go-playground/lars)
* [Siesta](https://github.com/VividCortex/siesta) **star:349** 编写中间件和处理程序的可组合框架。   [![godoc][GoDoc]](https://godoc.org/github.com/VividCortex/siesta)
* [vestigo](https://github.com/husobee/vestigo) **star:263** 高性能，独立，HTTP兼容的URL路由器的go web应用程序。   [![godoc][GoDoc]](https://godoc.org/github.com/husobee/vestigo)
* [gowww/router](https://github.com/gowww/router) **star:160** 超快的HTTP 路由，完全兼容 net/HTTP.Handler 接口.。   [![最近一年没有更新][Yellow]](https://github.com/gowww/router)   [![godoc][GoDoc]](https://godoc.org/github.com/gowww/router)
* [alien](https://github.com/gernest/alien) **star:120** 轻量级和快速http路由器从外层空间。   [![最近一年没有更新][Yellow]](https://github.com/gernest/alien)   [![godoc][GoDoc]](https://godoc.org/github.com/gernest/alien)
* [pure](https://github.com/go-playground/pure) **star:115** 是一个轻量级HTTP路由器，它坚持net/ HTTP“实现”的std。   [![godoc][GoDoc]](https://godoc.org/github.com/go-playground/pure)
* [violetear](https://github.com/nbari/violetear) **star:103** HTTP路由器。   [![godoc][GoDoc]](https://godoc.org/github.com/nbari/violetear)
* [Bxog](https://github.com/claygod/Bxog) **star:102** 简单和快速的HTTP路由器 Go 。它可以处理不同难度、长度和嵌套的路径。他还知道如何根据接收到的参数创建URL。   [![最近一年没有更新][Yellow]](https://github.com/claygod/Bxog)   [![godoc][GoDoc]](https://godoc.org/github.com/claygod/Bxog)
* [GoRouter](https://github.com/vardius/gorouter) **star:98** GoRouter 是一个服务器/API 微型框架、HTTP 请求路由 router, 数据分选器，提供了支持net/context的中间件。   [![godoc][GoDoc]](https://godoc.org/github.com/vardius/gorouter)
* [xmux](https://github.com/rs/xmux) **star:90** 高性能mux基于httprouter 'net/context`支持。   [![最近一年没有更新][Yellow]](https://github.com/rs/xmux)   [![godoc][GoDoc]](https://godoc.org/github.com/rs/xmux)
* [bellt](https://github.com/GuilhermeCaruso/bellt) **star:52** 一个简单的Go HTTP路由器。   [![最近一年没有更新][Yellow]](https://github.com/GuilhermeCaruso/bellt)   [![godoc][GoDoc]](https://godoc.org/github.com/GuilhermeCaruso/bellt)
* [FastRouter](https://github.com/razonyang/fastrouter) **star:19** 一个快速，灵活的HTTP路由器写在Go。   [![最近一年没有更新][Yellow]](https://github.com/razonyang/fastrouter)   [![godoc][GoDoc]](https://godoc.org/github.com/razonyang/fastrouter)
* [goroute](https://github.com/goroute/route) **star:7** 简单但功能强大的HTTP请求多路复用器。   [![最近一年没有更新][Yellow]](https://github.com/goroute/route)   [![godoc][GoDoc]](https://godoc.org/github.com/goroute/route)

## WebAssembly

* [tinygo](https://github.com/tinygo-org/tinygo) **star:8425** 去编译小地方。微控制器、网络组装和命令行工具。基于LLVM。   [![star > 2000][Awesome]](https://github.com/tinygo-org/tinygo)   [![最近一周有更新][Green]](https://github.com/tinygo-org/tinygo)   [![godoc][GoDoc]](https://godoc.org/github.com/tinygo-org/tinygo)
* [dom](https://github.com/dennwc/dom) **star:433** DOM库。   [![最近一年没有更新][Yellow]](https://github.com/dennwc/dom)   [![godoc][GoDoc]](https://godoc.org/github.com/dennwc/dom)
* [go-canvas](https://github.com/markfarnan/go-canvas) **star:140** 库使用HTML5画布，与所有绘画内的go代码。   [![godoc][GoDoc]](https://godoc.org/github.com/markfarnan/go-canvas)
* [webapi](https://github.com/gowebapi/webapi) **star:86** 从WebIDL生成的DOM和HTML的绑定。   [![godoc][GoDoc]](https://godoc.org/github.com/gowebapi/webapi)
* [wasmbrowsertest](https://github.com/agnivade/wasmbrowsertest) **star:82** 在浏览器中运行Go WASM测试。   [![godoc][GoDoc]](https://godoc.org/github.com/agnivade/wasmbrowsertest)
* [vert](https://github.com/norunners/vert) **star:50** Go和JS值之间的互操作。   [![godoc][GoDoc]](https://godoc.org/github.com/norunners/vert)

## Windows

* [go-ole](https://github.com/go-ole/go-ole) **star:781** 为 Go 语言实现的 Win32 OLE。   [![godoc][GoDoc]](https://godoc.org/github.com/go-ole/go-ole)
* [d3d9](https://github.com/gonutz/d3d9) **star:123**  Direct3D9 的 Go 语言接口。   [![godoc][GoDoc]](https://godoc.org/github.com/gonutz/d3d9)
* [gosddl](https://github.com/MonaxGT/gosddl) **star:7** 从SDDL-string到用户友好的JSON的转换器。SDDL由四个部分组成:所有者、主群、DACL、SACL。   [![最近一年没有更新][Yellow]](https://github.com/MonaxGT/gosddl)   [![godoc][GoDoc]](https://godoc.org/github.com/MonaxGT/gosddl)

## XML

*用于操作XML的库和工具。 (翻译出错了? 试试 [英文版](README_EN.md#xml) 吧~)*

* [zek](https://github.com/miku/zek) **star:487** 从XML生成Go结构。   [![最近一周有更新][Green]](https://github.com/miku/zek)   [![godoc][GoDoc]](https://godoc.org/github.com/miku/zek)
* [xpath](https://github.com/antchfx/xpath) **star:412** Go的XPath包。   [![godoc][GoDoc]](https://godoc.org/github.com/antchfx/xpath)
* [xquery](https://github.com/antchfx/xquery) **star:154** XQuery允许您使用XPath表达式从HTML/XML文档中提取数据。   [![最近一年没有更新][Yellow]](https://github.com/antchfx/xquery)   [![godoc][GoDoc]](https://godoc.org/github.com/antchfx/xquery)   [![归档项目][Archived]](https://github.com/antchfx/xquery)
* [xml2map](https://github.com/sbabiv/xml2map) **star:33** XML来映射转换器编写的Golang。   [![godoc][GoDoc]](https://godoc.org/github.com/sbabiv/xml2map)
* [xmlwriter](https://github.com/shabbyrobe/xmlwriter) **star:20** 基于libxml2的xmlwriter模块的过程性XML生成API。   [![godoc][GoDoc]](https://godoc.org/github.com/shabbyrobe/xmlwriter)
* [XML-Comp](https://github.com/xml-comp/xml-comp) **star:15** 简单的命令行XML比较器，生成文件夹、文件和标记的差异。   [![最近一年没有更新][Yellow]](https://github.com/xml-comp/xml-comp)   [![godoc][GoDoc]](https://godoc.org/github.com/xml-comp/xml-comp)

# 工具

* Go 软件和插件。 (翻译出错了? 试试 [英文版](README_EN.md#tools) 吧~)*

## 代码分析

* [GoLint](https://github.com/golang/lint) **star:3908** Go 源码的 linter。   [![star > 2000][Awesome]](https://github.com/golang/lint)   [![godoc][GoDoc]](https://godoc.org/github.com/golang/lint)   [![归档项目][Archived]](https://github.com/golang/lint)
* [Golint online](http://go-lint.appspot.com/)  Lints online Go source files on GitHub, Bitbucket and Google Project Hosting using the golint package.
* [errcheck](https://github.com/kisielk/errcheck) **star:1720** Errcheck是一个用于检查Go程序中未检查错误的程序。   [![godoc][GoDoc]](https://godoc.org/github.com/kisielk/errcheck)
* [gcvis](https://github.com/davecheney/gcvis) **star:1026** 实时可视化跟踪 GC 数据。   [![最近一年没有更新][Yellow]](https://github.com/davecheney/gcvis)   [![godoc][GoDoc]](https://godoc.org/github.com/davecheney/gcvis)
* [go-critic](https://github.com/go-critic/go-critic) **star:972** 源代码检查工具。   [![godoc][GoDoc]](https://godoc.org/github.com/go-critic/go-critic)
* [php-parser](https://github.com/z7zmey/php-parser) **star:817** 用 Go 编写的 PHP 解析器。   [![godoc][GoDoc]](https://godoc.org/github.com/z7zmey/php-parser)
* [staticcheck](https://github.com/dominikh/go-tools/tree/master/cmd/staticcheck)  用于大量静态分析检查，您可能已经从 c# 的 ReSharper 等工具中习惯了这些检查。
* [goast-viewer](https://github.com/yuroyoro/goast-viewer) **star:530** 基于 Web 的 Golang AST 可视化工具。   [![最近一年没有更新][Yellow]](https://github.com/yuroyoro/goast-viewer)
* [GoCover.io](http://gocover.io/)  GoCover.io 提供了任意 golang 包的代码覆盖率服务。
* [goimports](https://godoc.org/golang.org/x/tools/cmd/goimports)  来修复(添加，删除) Go 中自动导入的工具。
* [go-mod-outdated](https://github.com/psampaz/go-mod-outdated) **star:521** 找出项目中过期的依赖项。   [![godoc][GoDoc]](https://godoc.org/github.com/psampaz/go-mod-outdated)
* [go-cleanarch](https://github.com/roblaszczak/go-cleanarch) **star:488** go-cleanarch 的创建是为了验证 Clean 体系结构规则，比如 Go 项目中的依赖关系。   [![godoc][GoDoc]](https://godoc.org/github.com/roblaszczak/go-cleanarch)
* [GoPlantUML](https://github.com/jfeliu007/goplantuml) **star:459** 生成文本plantump类图的库和CLI，其中包含关于结构和接口的信息，以及它们之间的关系。   [![godoc][GoDoc]](https://godoc.org/github.com/jfeliu007/goplantuml)
* [goreturns](https://sourcegraph.com/github.com/sqs/goreturns)  添加 zero 返回声明，以匹配 func 返回类型。
* [gosimple](https://github.com/dominikh/go-tools/tree/master/cmd/gosimple)  gosimple 是 Go 源代码的linter，专门用于简化代码。
* [unconvert](https://github.com/mdempsky/unconvert) **star:310** 在源码中删除不必要的类型转换。   [![最近一年没有更新][Yellow]](https://github.com/mdempsky/unconvert)   [![godoc][GoDoc]](https://godoc.org/github.com/mdempsky/unconvert)
* [unused](https://github.com/dominikh/go-tools/tree/master/cmd/unused)  对未使用的常量、变量、函数和类型的代码进行检查。
* [tickgit](https://github.com/augmentable-dev/tickgit) **star:258** CLI和go包用于显示代码注释TODOs(以任何语言)并应用“git blame”来识别作者。   [![最近一年没有更新][Yellow]](https://github.com/augmentable-dev/tickgit)   [![godoc][GoDoc]](https://godoc.org/github.com/augmentable-dev/tickgit)
* [dupl](https://github.com/mibk/dupl) **star:251** 用于代码克隆检测的工具。   [![godoc][GoDoc]](https://godoc.org/github.com/mibk/dupl)
* [gostatus](https://github.com/shurcooL/gostatus) **star:246** 用于显示包含 Go 包的存储库的状态的命令行工具，。   [![最近一年没有更新][Yellow]](https://github.com/shurcooL/gostatus)   [![godoc][GoDoc]](https://godoc.org/github.com/shurcooL/gostatus)
* [golines](https://github.com/segmentio/golines) **star:220** 格式化程序，它自动缩短Go代码中的长行。   [![godoc][GoDoc]](https://godoc.org/github.com/segmentio/golines)
* [apicompat](https://github.com/bradleyfalzon/apicompat) **star:174** 检查 Go 项目最近的向下不兼容修改。   [![最近一年没有更新][Yellow]](https://github.com/bradleyfalzon/apicompat)   [![godoc][GoDoc]](https://godoc.org/github.com/bradleyfalzon/apicompat)
* [go-checkstyle](https://github.com/qiniu/checkstyle) **star:115** checkstyle是一个类似于java checkstyle的检查工具。   [![godoc][GoDoc]](https://godoc.org/github.com/qiniu/checkstyle)
* [lint](https://github.com/surullabs/lint) **star:66** 将 linters 作为测试的一部分。   [![最近一年没有更新][Yellow]](https://github.com/surullabs/lint)   [![godoc][GoDoc]](https://godoc.org/github.com/surullabs/lint)
* [validate](https://github.com/mccoyst/validate) **star:60** 使用 tags 自动验证结构体字段。   [![最近一年没有更新][Yellow]](https://github.com/mccoyst/validate)   [![godoc][GoDoc]](https://godoc.org/github.com/mccoyst/validate)
* [go-outdated](https://github.com/firstrow/go-outdated) **star:45** 显示过期包的终端应用。   [![最近一年没有更新][Yellow]](https://github.com/firstrow/go-outdated)   [![godoc][GoDoc]](https://godoc.org/github.com/firstrow/go-outdated)   [![归档项目][Archived]](https://github.com/firstrow/go-outdated)
* [tarp](https://github.com/verygoodsoftwarenotvirus/tarp) **star:14** 在源码中寻找没有直接单元测试的函数和方法。   [![最近一年没有更新][Yellow]](https://github.com/verygoodsoftwarenotvirus/tarp)   [![godoc][GoDoc]](https://godoc.org/github.com/verygoodsoftwarenotvirus/tarp)   [![归档项目][Archived]](https://github.com/verygoodsoftwarenotvirus/tarp)
* [golang-ifood-sdk](https://github.com/arxdsilva/golang-ifood-sdk) **star:6** 好   [![godoc][GoDoc]](https://godoc.org/github.com/arxdsilva/golang-ifood-sdk)

## 编辑器插件

* [vim-go](https://github.com/fatih/vim-go) **star:13675** Go 开发会用到的 Vim 插件。   [![star > 2000][Awesome]](https://github.com/fatih/vim-go)   [![最近一周有更新][Green]](https://github.com/fatih/vim-go)
* [gocode](https://github.com/nsf/gocode) **star:4925** Autocompletion daemon for the Go programming language.   [![star > 2000][Awesome]](https://github.com/nsf/gocode)   [![godoc][GoDoc]](https://godoc.org/github.com/nsf/gocode)
* [GoSublime](https://github.com/DisposaBoy/GoSublime) **star:3411** 包含了可为文本编辑器 SublimeText 3 提供代码自动填充和其他类似IDE的功能的 Golang IDE 插件集合。   [![star > 2000][Awesome]](https://github.com/DisposaBoy/GoSublime)   [![最近一年没有更新][Yellow]](https://github.com/DisposaBoy/GoSublime)   [![godoc][GoDoc]](https://godoc.org/github.com/DisposaBoy/GoSublime)
* [vscode-go](https://github.com/golang/vscode-go) **star:1965** Visual Studio代码的扩展(VS代码)，它提供了对Go语言的支持。   [![最近一周有更新][Green]](https://github.com/golang/vscode-go)
* [go-plus](https://github.com/joefitzgerald/go-plus) **star:1520** 在 Atom 中添加自动完成，格式化，语法检查，高亮和审查。   [![归档项目][Archived]](https://github.com/joefitzgerald/go-plus)
* [go-mode](https://github.com/dominikh/go-mode.el) **star:1168** 在 GNU/Emacs 支持 GO。
* [Watch](https://github.com/eaburns/Watch) **star:187** Runs a command in an acme win on file changes.   [![最近一年没有更新][Yellow]](https://github.com/eaburns/Watch)   [![godoc][GoDoc]](https://godoc.org/github.com/eaburns/Watch)
* [vim-compiler-go](https://github.com/rjohnsondev/vim-compiler-go) **star:88** 在保存时突出显示语法错误的 Vim 插件。   [![最近一年没有更新][Yellow]](https://github.com/rjohnsondev/vim-compiler-go)
* [Go plugin for JetBrains IDEs](https://plugins.jetbrains.com/plugin/9568-go)  JetBrains IDEs 的 Go 插件。
* [goimports-reviser](https://github.com/incu6us/goimports-reviser) **star:60** 用于导入的格式化工具。   [![godoc][GoDoc]](https://godoc.org/github.com/incu6us/goimports-reviser)
* [goprofiling](https://marketplace.visualstudio.com/items?itemName=MaxMedia.go-prof)  在 VS Code 中支持 Go 的基准分析。
* [go-language-server](https://github.com/theia-ide/go-language-server) **star:32** A wrapper to turn the VSCode go extension into a language server supporting the language-server-protocol.   [![最近一年没有更新][Yellow]](https://github.com/theia-ide/go-language-server)
* [gounit-vim](https://github.com/hexdigest/gounit-vim) **star:22** 基于函数或方法的签名生成Go测试的Vim插件。   [![最近一年没有更新][Yellow]](https://github.com/hexdigest/gounit-vim)
* [theia-go-extension](https://github.com/theia-ide/theia-go-extension) **star:15** 在 Theia IDE中支持 Go。   [![最近一年没有更新][Yellow]](https://github.com/theia-ide/theia-go-extension)

## Go 生成工具

* [gotests](https://github.com/cweill/gotests) **star:3382** 从源代码生成测试用例。   [![star > 2000][Awesome]](https://github.com/cweill/gotests)   [![godoc][GoDoc]](https://godoc.org/github.com/cweill/gotests)
* [genny](https://github.com/cheekybits/genny) **star:1560** 优雅的 Go 泛型。   [![godoc][GoDoc]](https://godoc.org/github.com/cheekybits/genny)
* [re2dfa](https://github.com/opennota/re2dfa) **star:185** 将正则表达式转换为有限状态机，并输出 Go 源代码。   [![最近一年没有更新][Yellow]](https://github.com/opennota/re2dfa)   [![godoc][GoDoc]](https://godoc.org/github.com/opennota/re2dfa)
* [TOML-to-Go](https://xuri.me/toml-to-go)  在浏览器中将 TOML 转换为 Go 类型。
* [xgen](https://github.com/xuri/xgen) **star:107** XSD (XML模式定义)解析器和Go/C/Java/Rust/TypeScript代码生成器。   [![godoc][GoDoc]](https://godoc.org/github.com/xuri/xgen)
* [hasgo](https://github.com/DylanMeeus/hasgo) **star:96** 可生成用于切片的 Haskell。   [![godoc][GoDoc]](https://godoc.org/github.com/DylanMeeus/hasgo)
* [gocontracts](https://github.com/Parquery/gocontracts) **star:73** 通过同步代码和文档来实现 design-by-contract 设计。   [![最近一年没有更新][Yellow]](https://github.com/Parquery/gocontracts)   [![godoc][GoDoc]](https://godoc.org/github.com/Parquery/gocontracts)
* [gonerics](http://github.com/bouk/gonerics)  Go中的易用的泛型。
* [gounit](https://github.com/hexdigest/gounit) **star:56** 使用您自己的模板生成Go测试用例。   [![最近一年没有更新][Yellow]](https://github.com/hexdigest/gounit)   [![godoc][GoDoc]](https://godoc.org/github.com/hexdigest/gounit)
* [generic](https://github.com/usk81/generic) **star:40** 灵活的 Go 数据类型。   [![godoc][GoDoc]](https://godoc.org/github.com/usk81/generic)

## Go 工具

* [go-swagger](https://github.com/go-swagger/go-swagger) **star:6684** 基于 Go 的Swagger 2.0实现。   [![star > 2000][Awesome]](https://github.com/go-swagger/go-swagger)   [![最近一周有更新][Green]](https://github.com/go-swagger/go-swagger)   [![godoc][GoDoc]](https://godoc.org/github.com/go-swagger/go-swagger)
* [OctoLinker](https://github.com/OctoLinker/browser-extension) **star:4789** 借助的 OctoLinker 浏览器扩展，可以高效的地浏览  GitHub go文件。   [![star > 2000][Awesome]](https://github.com/OctoLinker/browser-extension)
* [go-callvis](https://github.com/TrueFurby/go-callvis) **star:3472** 使用 dot format 可视化 Go 程序的调用图。   [![star > 2000][Awesome]](https://github.com/TrueFurby/go-callvis)   [![最近一周有更新][Green]](https://github.com/TrueFurby/go-callvis)   [![godoc][GoDoc]](https://godoc.org/github.com/TrueFurby/go-callvis)
* [depth](https://github.com/KyleBanks/depth) **star:636** 通过分析导入，将包依赖关系树可视化输出。   [![最近一年没有更新][Yellow]](https://github.com/KyleBanks/depth)   [![godoc][GoDoc]](https://godoc.org/github.com/KyleBanks/depth)
* [richgo](https://github.com/kyoh86/richgo) **star:597** 用文本装饰丰富 go test 的输出。   [![godoc][GoDoc]](https://godoc.org/github.com/kyoh86/richgo)
* [rts](https://github.com/galeone/rts) **star:214** 从服务器响应生成Go结构。   [![最近一年没有更新][Yellow]](https://github.com/galeone/rts)   [![godoc][GoDoc]](https://godoc.org/github.com/galeone/rts)
* [godbg](https://github.com/tylerwince/godbg) **star:178** 实现了 Rusts 的 dbg! 宏，可以方便的在开发过程中快速、容易地调试。   [![最近一年没有更新][Yellow]](https://github.com/tylerwince/godbg)   [![godoc][GoDoc]](https://godoc.org/github.com/tylerwince/godbg)
* [gomodrun](https://github.com/dustinblackman/gomodrun/)  执行并缓存Go中包含的二进制文件的Go工具。国防部文件。
* [typex](https://github.com/dtgorski/typex) **star:132** 检查Go类型及其传递依赖关系，或者将结果导出为TypeScript值对象(或类型)声明。   [![godoc][GoDoc]](https://godoc.org/github.com/dtgorski/typex)
* [colorgo](https://github.com/songgao/colorgo) **star:108** 将 go 命令包装成彩色的 go build 输出。   [![最近一年没有更新][Yellow]](https://github.com/songgao/colorgo)   [![godoc][GoDoc]](https://godoc.org/github.com/songgao/colorgo)
* [gothanks](https://github.com/psampaz/gothanks) **star:101** GoThanks自动帮你开始。mod github依赖，以这种方式发送一些爱给他们的维护者。   [![godoc][GoDoc]](https://godoc.org/github.com/psampaz/gothanks)
* [roumon](https://github.com/becheran/roumon) **star:60** 通过命令行接口监控所有激活goroutines的当前状态。   [![godoc][GoDoc]](https://godoc.org/github.com/becheran/roumon)
* [igo](https://github.com/rocketlaunchr/igo) **star:44** 一个igo to go transpiler (go语言的新语言功能!)   [![最近一年没有更新][Yellow]](https://github.com/rocketlaunchr/igo)   [![godoc][GoDoc]](https://godoc.org/github.com/rocketlaunchr/igo)
* [go-james](https://github.com/pieterclaerhout/go-james) **star:43** 去项目骨架创造者，建立和测试您的项目没有手动设置。   [![godoc][GoDoc]](https://godoc.org/github.com/pieterclaerhout/go-james)
* [go-pkg-complete](https://github.com/skelterjohn/go-pkg-complete) **star:38** Bash completion for go and wgo。   [![最近一年没有更新][Yellow]](https://github.com/skelterjohn/go-pkg-complete)
* [generator-go-lang](https://github.com/axelspringer/generator-go-lang) **star:23** 一个[Yeoman](http://yeoman.io)生成器，用于启动新的 Go 项目。   [![最近一年没有更新][Yellow]](https://github.com/axelspringer/generator-go-lang)   [![归档项目][Archived]](https://github.com/axelspringer/generator-go-lang)
* [docs](https://github.com/go-oas/docs) **star:7** 自动为GO项目生成RESTful API文档-与开放API规范标准一致。   [![godoc][GoDoc]](https://godoc.org/github.com/go-oas/docs)

## 软件包

*用Go编写的软件。 (翻译出错了? 试试 [英文版](README_EN.md#software-packages) 吧~)*

### DevOps 工具

* [kubernetes](https://github.com/kubernetes/kubernetes) **star:80173** 来自谷歌的容器集群管理器。   [![star > 2000][Awesome]](https://github.com/kubernetes/kubernetes)   [![最近一周有更新][Green]](https://github.com/kubernetes/kubernetes)   [![godoc][GoDoc]](https://godoc.org/github.com/kubernetes/kubernetes)
* [Moby](https://github.com/moby/moby) **star:60919** Collaborative project for the container ecosystem to assemble container-based systems.   [![star > 2000][Awesome]](https://github.com/moby/moby)   [![最近一周有更新][Green]](https://github.com/moby/moby)   [![godoc][GoDoc]](https://godoc.org/github.com/moby/moby)
* [traefik](https://github.com/containous/traefik) **star:34747** 反向代理和负载均衡器，支持多个后端。   [![star > 2000][Awesome]](https://github.com/containous/traefik)   [![最近一周有更新][Green]](https://github.com/containous/traefik)   [![godoc][GoDoc]](https://godoc.org/github.com/containous/traefik)
* [Gitea](https://github.com/go-gitea/gitea) **star:25789** 从 Gogs fork，完全由社区驱动。   [![star > 2000][Awesome]](https://github.com/go-gitea/gitea)   [![最近一周有更新][Green]](https://github.com/go-gitea/gitea)   [![godoc][GoDoc]](https://godoc.org/github.com/go-gitea/gitea)   [![包含中文文档][CN]](https://github.com/go-gitea/gitea)
* [gitea-github-migrator](https://git.jonasfranz.software/JonasFranzDEV/gitea-github-migrator)  将所有GitHub repositories、issues、milestones 和 labels 都迁移到 Gitea。
* [Vegeta](https://github.com/tsenart/vegeta) **star:18077** HTTP负载测试工具和库。超过9000 !   [![star > 2000][Awesome]](https://github.com/tsenart/vegeta)   [![godoc][GoDoc]](https://godoc.org/github.com/tsenart/vegeta)
* [Packer](https://github.com/mitchellh/packer) **star:13088** 用于从一个源配置为多个平台创建相同的机器图像。   [![star > 2000][Awesome]](https://github.com/mitchellh/packer)   [![最近一周有更新][Green]](https://github.com/mitchellh/packer)   [![godoc][GoDoc]](https://godoc.org/github.com/mitchellh/packer)
* [Hey](https://github.com/rakyll/hey) **star:11819** 压力测试工具，可用来代替 ApacheBench (ab)。   [![star > 2000][Awesome]](https://github.com/rakyll/hey)   [![godoc][GoDoc]](https://godoc.org/github.com/rakyll/hey)
* [webhook](https://github.com/adnanh/webhook) **star:6822** 允许用户创建在服务器上执行命令的 HTTP hooks。   [![star > 2000][Awesome]](https://github.com/adnanh/webhook)   [![godoc][GoDoc]](https://godoc.org/github.com/adnanh/webhook)
* [Wide](https://wide.b3log.org/login)  为使用 Golang 的团队提供基于 web 的 IDE。
* [GVM](https://github.com/moovweb/gvm) **star:6497** GVM 提供了一个接口来管理 Go 版本。   [![star > 2000][Awesome]](https://github.com/moovweb/gvm)
* [gaia](https://github.com/gaia-pipeline/gaia) **star:4433** 可用于任何编程语言来构建强大的管道。   [![star > 2000][Awesome]](https://github.com/gaia-pipeline/gaia)   [![godoc][GoDoc]](https://godoc.org/github.com/gaia-pipeline/gaia)
* [gox](https://github.com/mitchellh/gox) **star:4078** 非常简单，没有多余的跨平台编译工具。   [![star > 2000][Awesome]](https://github.com/mitchellh/gox)   [![godoc][GoDoc]](https://godoc.org/github.com/mitchellh/gox)
* [bosun](https://github.com/bosun-monitor/bosun) **star:3176** 按照时间轴发出告警的框架。   [![star > 2000][Awesome]](https://github.com/bosun-monitor/bosun)   [![godoc][GoDoc]](https://godoc.org/github.com/bosun-monitor/bosun)
* [bombardier](https://github.com/codesenberg/bombardier) **star:2742** 快速跨平台 HTTP 基准测试工具。   [![star > 2000][Awesome]](https://github.com/codesenberg/bombardier)   [![godoc][GoDoc]](https://godoc.org/github.com/codesenberg/bombardier)
* [Pomerium](https://github.com/pomerium/pomerium) **star:2666** Pomerium是一个可识别身份的访问代理。   [![star > 2000][Awesome]](https://github.com/pomerium/pomerium)   [![最近一周有更新][Green]](https://github.com/pomerium/pomerium)   [![godoc][GoDoc]](https://godoc.org/github.com/pomerium/pomerium)
* [script](https://github.com/bitfield/script) **star:1867** 让DevOps编写类shell和系统管理任务变得更加容易。   [![godoc][GoDoc]](https://godoc.org/github.com/bitfield/script)
* [fac](https://github.com/mkchoi212/fac) **star:1722** 修复 git 合并冲突。   [![最近一年没有更新][Yellow]](https://github.com/mkchoi212/fac)   [![godoc][GoDoc]](https://godoc.org/github.com/mkchoi212/fac)
* [kala](https://github.com/ajvb/kala) **star:1707** 简单、现代和高性能的作业调度程序。   [![godoc][GoDoc]](https://godoc.org/github.com/ajvb/kala)
* [goxc](https://github.com/laher/goxc) **star:1671** 专注于跨平台编译和打包的 Go 构建工具。   [![最近一年没有更新][Yellow]](https://github.com/laher/goxc)   [![godoc][GoDoc]](https://godoc.org/github.com/laher/goxc)
* [StatusOK](https://github.com/sanathp/statusok) **star:1506** 监视您的网站和REST api。当服务器宕机或响应时间超过预期时，通过Slack、电子邮件获得通知。   [![godoc][GoDoc]](https://godoc.org/github.com/sanathp/statusok)
* [s3gof3r](https://github.com/rlmcpherson/s3gof3r) **star:1102** 小型实用程序/库，针对大型对象在Amazon S3中的高速传输进行了优化。   [![godoc][GoDoc]](https://godoc.org/github.com/rlmcpherson/s3gof3r)
* [go-selfupdate](https://github.com/sanbornm/go-selfupdate) **star:858** 允许你的 Go应用程序 进行自我更新。   [![godoc][GoDoc]](https://godoc.org/github.com/sanbornm/go-selfupdate)
* [s5cmd](https://github.com/peak/s5cmd) **star:764** 非常快的S3和本地文件系统执行工具。   [![最近一周有更新][Green]](https://github.com/peak/s5cmd)   [![godoc][GoDoc]](https://godoc.org/github.com/peak/s5cmd)
* [skm](https://github.com/TimothyYe/skm) **star:703** SKM是一个简单而强大的SSH密钥管理器，它可以帮助您轻松地管理多个SSH密钥!   [![godoc][GoDoc]](https://godoc.org/github.com/TimothyYe/skm)
* [Scaleway-cli](https://github.com/scaleway/scaleway-cli) **star:682** 从命令行管理 BareMetal 服务器(与使用Docker一样容易)。   [![最近一周有更新][Green]](https://github.com/scaleway/scaleway-cli)   [![godoc][GoDoc]](https://godoc.org/github.com/scaleway/scaleway-cli)
* [aurora](https://github.com/xuri/aurora) **star:530** 基于web的跨平台 Beanstalkd 队列服务器控制台。   [![最近一周有更新][Green]](https://github.com/xuri/aurora)
* [cassowary](https://github.com/rogerwelin/cassowary) **star:527** 用Go编写的跨平台HTTP负载测试工具。   [![godoc][GoDoc]](https://godoc.org/github.com/rogerwelin/cassowary)   [![包含中文文档][CN]](https://github.com/rogerwelin/cassowary)
* [uTask](https://github.com/ovh/utask) **star:498** 对yaml中声明的业务流程进行建模和执行的自动化引擎。   [![godoc][GoDoc]](https://godoc.org/github.com/ovh/utask)
* [govvv](https://github.com/ahmetalpbalkan/govvv) **star:496** 可轻松地添加版本信息到 Go 二进制文件。   [![最近一年没有更新][Yellow]](https://github.com/ahmetalpbalkan/govvv)   [![godoc][GoDoc]](https://godoc.org/github.com/ahmetalpbalkan/govvv)
* [ghorg](https://github.com/gabrie30/ghorg) **star:482** 支持GitHub, GitLab, Gitea和Bitbucket。   [![最近一周有更新][Green]](https://github.com/gabrie30/ghorg)   [![godoc][GoDoc]](https://godoc.org/github.com/gabrie30/ghorg)
* [gonative](https://github.com/inconshreveable/gonative) **star:326** 用原生 Go 创建一个跨平台的 Go 工具链。   [![最近一年没有更新][Yellow]](https://github.com/inconshreveable/gonative)   [![godoc][GoDoc]](https://godoc.org/github.com/inconshreveable/gonative)
* [trubka](https://github.com/xitonix/trubka) **star:300** 一个CLI工具，用于管理和故障排除Apache Kafka集群，具有通用发布/使用协议缓冲区和与Kafka之间的纯文本事件的能力。   [![godoc][GoDoc]](https://godoc.org/github.com/xitonix/trubka)
* [Pewpew](https://github.com/bengadbois/pewpew) **star:292** 灵活的 HTTP 命令行压测工具。   [![godoc][GoDoc]](https://godoc.org/github.com/bengadbois/pewpew)
* [Mora](https://github.com/emicklei/mora) **star:291** 用于访问 MongoDB 文档和元数据的 REST 服务器。   [![godoc][GoDoc]](https://godoc.org/github.com/emicklei/mora)
* [lstags](https://github.com/ivanilves/lstags) **star:282** 提供了工具和API，可用来同步不同注册中心的Docker图像。   [![godoc][GoDoc]](https://godoc.org/github.com/ivanilves/lstags)
* [jcli](https://github.com/jenkins-zh/jenkins-cli) **star:275** 詹金斯CLI允许你管理你的詹金斯作为一个简单的方法。   [![最近一周有更新][Green]](https://github.com/jenkins-zh/jenkins-cli)   [![godoc][GoDoc]](https://godoc.org/github.com/jenkins-zh/jenkins-cli)   [![包含中文文档][CN]](https://github.com/jenkins-zh/jenkins-cli)
* [dogo](https://github.com/liudng/dogo) **star:240** 监视源文件中的更改并自动编译和运行(restart)。   [![最近一年没有更新][Yellow]](https://github.com/liudng/dogo)   [![godoc][GoDoc]](https://godoc.org/github.com/liudng/dogo)   [![包含中文文档][CN]](https://github.com/liudng/dogo)
* [manssh](https://github.com/xwjdsh/manssh) **star:228** manssh是一个命令行工具，可以方便地管理ssh别名配置。   [![最近一年没有更新][Yellow]](https://github.com/xwjdsh/manssh)   [![godoc][GoDoc]](https://godoc.org/github.com/xwjdsh/manssh)
* [godbg](https://github.com/sirnewton01/godbg) **star:225** 基于 web 的 gdb 前端应用程序。   [![最近一年没有更新][Yellow]](https://github.com/sirnewton01/godbg)
* [Gogs](https://gogs.io/)  自托管的Git服务。
* [Blast](https://github.com/dave/blast) **star:200** 一个用于API负载测试和批处理作业的简单工具。   [![最近一年没有更新][Yellow]](https://github.com/dave/blast)   [![godoc][GoDoc]](https://godoc.org/github.com/dave/blast)
* [Balerter](https://github.com/balerter/balerter) **star:198** 自托管的基于脚本的警报管理器   [![最近一周有更新][Green]](https://github.com/balerter/balerter)   [![godoc][GoDoc]](https://godoc.org/github.com/balerter/balerter)
* [easyssh-proxy](https://github.com/appleboy/easyssh-proxy) **star:195** Golang package for easy remote execution through SSH and SCP downloading via `ProxyCommand`.   [![godoc][GoDoc]](https://godoc.org/github.com/appleboy/easyssh-proxy)
* [gobrew](https://github.com/cryptojuice/gobrew) **star:182** gobrew 允许您轻松地在 go 的多个版本之间切换。   [![最近一年没有更新][Yellow]](https://github.com/cryptojuice/gobrew)
* [ostent](https://github.com/ostrost/ostent) **star:172** 收集和显示系统指标，并可选 Graphite and/or fluxdb作为依赖。   [![最近一年没有更新][Yellow]](https://github.com/ostrost/ostent)   [![godoc][GoDoc]](https://godoc.org/github.com/ostrost/ostent)
* [abbreviate](https://github.com/dnnrly/abbreviate) **star:167** 缩写是一种工具，可以将长字符串转换为具有可配置分隔符的短字符串，例如将分支名称嵌入到部署堆栈id中。   [![godoc][GoDoc]](https://godoc.org/github.com/dnnrly/abbreviate)
* [terraform-provider-openapi](https://github.com/dikhan/terraform-provider-openapi) **star:161** Terraform provider plugin，它根据OpenAPI文档(以前称为swagger文件)在运行时动态配置自身，该文档包含了公开的api的定义。   [![godoc][GoDoc]](https://godoc.org/github.com/dikhan/terraform-provider-openapi)
* [kcli](https://github.com/cswank/kcli) **star:155** 用于检查kafka主题/分区/消息的命令行工具。   [![最近一年没有更新][Yellow]](https://github.com/cswank/kcli)   [![godoc][GoDoc]](https://godoc.org/github.com/cswank/kcli)
* [grapes](https://github.com/yaronsumel/grapes) **star:153** 旨在轻松地通过ssh分发命令的轻量级工具。   [![godoc][GoDoc]](https://godoc.org/github.com/yaronsumel/grapes)
* [winrm-cli](https://github.com/masterzen/winrm-cli) **star:122** 在Windows机器上远程执行命令的Cli工具。   [![最近一年没有更新][Yellow]](https://github.com/masterzen/winrm-cli)   [![godoc][GoDoc]](https://godoc.org/github.com/masterzen/winrm-cli)
* [Dockerfile-Generator](https://github.com/ozankasikci/dockerfile-generator) **star:112** 一个go库和一个可执行文件，它使用各种输入通道生成有效的Dockerfiles。   [![最近一年没有更新][Yellow]](https://github.com/ozankasikci/dockerfile-generator)   [![godoc][GoDoc]](https://godoc.org/github.com/ozankasikci/dockerfile-generator)
* [drone-scp](https://github.com/appleboy/drone-scp) **star:85** 通过 SSH 进行文件拷贝。其中 SSH 通过二进制文件、docker 或 Drone CI触发。   [![godoc][GoDoc]](https://godoc.org/github.com/appleboy/drone-scp)
* [go-furnace](https://github.com/go-furnace/go-furnace) **star:83** 用Go编写的托管解决方案，可轻松地在AWS、GCP或DigitalOcean上部署应用程序。   [![最近一年没有更新][Yellow]](https://github.com/go-furnace/go-furnace)   [![godoc][GoDoc]](https://godoc.org/github.com/go-furnace/go-furnace)
* [s3-proxy](https://github.com/oxyno-zeta/s3-proxy) **star:55** 具有GET、PUT和DELETE方法和身份验证(OpenID连接和基本身份验证)的S3代理。   [![最近一周有更新][Green]](https://github.com/oxyno-zeta/s3-proxy)   [![godoc][GoDoc]](https://godoc.org/github.com/oxyno-zeta/s3-proxy)
* [Dropship](https://github.com/chrismckenzie/dropship) **star:54** 通过 cdn 部署代码的工具。   [![最近一年没有更新][Yellow]](https://github.com/chrismckenzie/dropship)   [![godoc][GoDoc]](https://godoc.org/github.com/chrismckenzie/dropship)
* [drone-jenkins](https://github.com/appleboy/drone-jenkins) **star:32** 使用二进制文件、docker或 Drone CI 来触发下游Jenkins作业。   [![godoc][GoDoc]](https://godoc.org/github.com/appleboy/drone-jenkins)
* [Rodent](https://github.com/alouche/rodent) **star:31** 管理Go版本、项目和跟踪依赖项。   [![最近一年没有更新][Yellow]](https://github.com/alouche/rodent)
* [awsenv](https://github.com/soniah/awsenv) **star:27** 可以为 profile 加载Amazon (AWS)环境变量的轻量二进制文件。   [![最近一年没有更新][Yellow]](https://github.com/soniah/awsenv)   [![godoc][GoDoc]](https://godoc.org/github.com/soniah/awsenv)
* [lwc](https://github.com/timdp/lwc) **star:25** UNIX wc命令的实时更新版本。   [![最近一年没有更新][Yellow]](https://github.com/timdp/lwc)   [![godoc][GoDoc]](https://godoc.org/github.com/timdp/lwc)
* [DepCharge](https://github.com/centerorbit/depcharge) **star:18** Helps orchestrating the execution of commands across the many dependencies in larger projects.   [![最近一年没有更新][Yellow]](https://github.com/centerorbit/depcharge)   [![godoc][GoDoc]](https://godoc.org/github.com/centerorbit/depcharge)
* [docker-go-mingw](https://github.com/x1unix/docker-go-mingw) **star:17** 使用MinGW工具链在Windows上构建Go二进制文件的Docker图像。   [![godoc][GoDoc]](https://godoc.org/github.com/x1unix/docker-go-mingw)
* [httpref](https://github.com/dnnrly/httpref) **star:14** httpref是一个方便的CLI参考，用于HTTP方法、状态码、头以及TCP和UDP端口。   [![godoc][GoDoc]](https://godoc.org/github.com/dnnrly/httpref)
* [sg](https://github.com/ChristopherRabotin/sg) **star:6** 可测试一组HTTP极限(如ab)，可以在每个调用之间使用响应代码和数据，根据之前的响应来确定特定的服务器压力。   [![最近一年没有更新][Yellow]](https://github.com/ChristopherRabotin/sg)   [![godoc][GoDoc]](https://godoc.org/github.com/ChristopherRabotin/sg)
* [aptly](https://github.com/smira/aptly) **star:4** Debian存储库管理工具。   [![最近一年没有更新][Yellow]](https://github.com/smira/aptly)   [![godoc][GoDoc]](https://godoc.org/github.com/smira/aptly)

### 其他软件

* [croc](https://github.com/schollz/croc) **star:14729** 轻松、安全地将文件或文件夹从一台计算机发送到另一台计算机。   [![star > 2000][Awesome]](https://github.com/schollz/croc)   [![最近一周有更新][Green]](https://github.com/schollz/croc)   [![godoc][GoDoc]](https://godoc.org/github.com/schollz/croc)
* [Docker](http://www.docker.com/)  面向开发人员和系统管理员的分布式应用程序的开放平台。
* [Gor](https://github.com/buger/gor) **star:14518** Http 流量复制工具，用于实时回放从生产环境到阶段/开发环境的流量。   [![star > 2000][Awesome]](https://github.com/buger/gor)   [![最近一周有更新][Green]](https://github.com/buger/gor)   [![godoc][GoDoc]](https://godoc.org/github.com/buger/gor)
* [restic](https://github.com/restic/restic) **star:13415** 消除重复项备份程序。   [![star > 2000][Awesome]](https://github.com/restic/restic)   [![最近一周有更新][Green]](https://github.com/restic/restic)   [![godoc][GoDoc]](https://godoc.org/github.com/restic/restic)
* [Seaweed File System](https://github.com/chrislusf/seaweedfs) **star:12652** 快速、简单、可伸缩的分布式文件系统，采用了O(1)磁盘查找。   [![star > 2000][Awesome]](https://github.com/chrislusf/seaweedfs)   [![最近一周有更新][Green]](https://github.com/chrislusf/seaweedfs)   [![godoc][GoDoc]](https://godoc.org/github.com/chrislusf/seaweedfs)
* [confd](https://github.com/kelseyhightower/confd) **star:7565** 使用 etcd 或 consul 的模板和数据管理本地应用程序配置文件。   [![star > 2000][Awesome]](https://github.com/kelseyhightower/confd)   [![godoc][GoDoc]](https://godoc.org/github.com/kelseyhightower/confd)
* [Comcast](https://github.com/tylertreat/Comcast) **star:7532** 模拟坏的网络连接。   [![star > 2000][Awesome]](https://github.com/tylertreat/Comcast)   [![godoc][GoDoc]](https://godoc.org/github.com/tylertreat/Comcast)
* [LiteIDE](https://github.com/visualfc/liteide) **star:6543** 简单的、开源的、跨平台的Go IDE。   [![star > 2000][Awesome]](https://github.com/visualfc/liteide)   [![包含中文文档][CN]](https://github.com/visualfc/liteide)
* [drive](https://github.com/odeke-em/drive) **star:6112** 基于命令行的谷歌驱动器客户端。   [![star > 2000][Awesome]](https://github.com/odeke-em/drive)   [![godoc][GoDoc]](https://godoc.org/github.com/odeke-em/drive)
* [toxiproxy](https://github.com/shopify/toxiproxy) **star:5620** 为自动化测试模拟网络和系统条件的代理。   [![star > 2000][Awesome]](https://github.com/shopify/toxiproxy)   [![最近一周有更新][Green]](https://github.com/shopify/toxiproxy)   [![godoc][GoDoc]](https://godoc.org/github.com/shopify/toxiproxy)
* [tsuru](https://tsuru.io/)  Extensible and open source Platform as a Service software.
* [nes](https://github.com/fogleman/nes) **star:4854** 任天堂娱乐系统(NES)模拟器。   [![star > 2000][Awesome]](https://github.com/fogleman/nes)   [![godoc][GoDoc]](https://godoc.org/github.com/fogleman/nes)
* [Duplicacy](https://github.com/gilbertchen/duplicacy) **star:3770** 跨平台网络和云备份工具。   [![star > 2000][Awesome]](https://github.com/gilbertchen/duplicacy)   [![godoc][GoDoc]](https://godoc.org/github.com/gilbertchen/duplicacy)
* [scc](https://github.com/boyter/scc) **star:2686** 一个非常快速准确的代码计数器，采用了复杂的计算和 COCOMO 预估。   [![star > 2000][Awesome]](https://github.com/boyter/scc)   [![godoc][GoDoc]](https://godoc.org/github.com/boyter/scc)
* [myLG](https://github.com/mehrdadrad/mylg) **star:2499** 命令行网络诊断工具。   [![star > 2000][Awesome]](https://github.com/mehrdadrad/mylg)   [![最近一年没有更新][Yellow]](https://github.com/mehrdadrad/mylg)   [![godoc][GoDoc]](https://godoc.org/github.com/mehrdadrad/mylg)
* [GoBoy](https://github.com/Humpheh/goboy) **star:2377** 用 Go 编写的任天堂Game Boy彩色模拟器。   [![star > 2000][Awesome]](https://github.com/Humpheh/goboy)   [![最近一年没有更新][Yellow]](https://github.com/Humpheh/goboy)   [![godoc][GoDoc]](https://godoc.org/github.com/Humpheh/goboy)
* [Stack Up](https://github.com/pressly/sup) **star:2274** Stack Up 是一个超级简单的部署工具 — 只面向Unix。   [![star > 2000][Awesome]](https://github.com/pressly/sup)   [![godoc][GoDoc]](https://godoc.org/github.com/pressly/sup)
* [syncthing](https://syncthing.net/)  开放，分散的文件同步工具和协议。
* [lgo](https://github.com/yunabe/lgo) **star:2196** 与 Jupyter 可进行交互 Go 程序。它支持代码完成、代码检查以及与Go 100% 兼容性。   [![star > 2000][Awesome]](https://github.com/yunabe/lgo)   [![godoc][GoDoc]](https://godoc.org/github.com/yunabe/lgo)
* [limetext](https://limetext.github.io)  一个强大而优雅的文本编辑器。
* [Circuit](https://github.com/gocircuit/circuit) **star:1907** Circuit 是一个可编程平台即服务(PaaS)和/或基础设施即服务(IaaS)，用于管理、发现、同步和编排包含云应用程序的服务和主机。   [![最近一年没有更新][Yellow]](https://github.com/gocircuit/circuit)   [![godoc][GoDoc]](https://godoc.org/github.com/gocircuit/circuit)
* [snap](https://github.com/intelsdi-x/snap) **star:1793** 强大的遥测框架。   [![最近一年没有更新][Yellow]](https://github.com/intelsdi-x/snap)   [![godoc][GoDoc]](https://godoc.org/github.com/intelsdi-x/snap)
* [borg](https://github.com/crufter/borg) **star:1519** 基于终端的bash代码段搜索引擎。   [![最近一年没有更新][Yellow]](https://github.com/crufter/borg)   [![godoc][GoDoc]](https://godoc.org/github.com/crufter/borg)
* [Documize](https://github.com/documize/community) **star:1373** 集成了SaaS工具数据的现代wiki软件。   [![最近一周有更新][Green]](https://github.com/documize/community)
* [Go Package Store](https://github.com/shurcooL/Go-Package-Store) **star:886** App that displays updates for the Go packages in your GOPATH.   [![最近一年没有更新][Yellow]](https://github.com/shurcooL/Go-Package-Store)   [![godoc][GoDoc]](https://godoc.org/github.com/shurcooL/Go-Package-Store)
* [blocky](https://github.com/0xERR0R/blocky) **star:828** 快速和轻量级的DNS代理作为广告拦截器，为本地网络具有许多功能。   [![最近一周有更新][Green]](https://github.com/0xERR0R/blocky)   [![godoc][GoDoc]](https://godoc.org/github.com/0xERR0R/blocky)
* [vFlow](https://github.com/VerizonDigital/vflow) **star:820** 高性能、可伸缩和可靠的 IPFIX、sFlow和 Netflow 收集器。   [![godoc][GoDoc]](https://godoc.org/github.com/VerizonDigital/vflow)
* [peg](https://github.com/pointlander/peg) **star:807** 解析表达式语法，是Packrat解析器生成器的实现。   [![godoc][GoDoc]](https://godoc.org/github.com/pointlander/peg)
* [shell2http](https://github.com/msoap/shell2http) **star:798** 通过http服务器执行shell命令(用于原型或远程控制)。   [![godoc][GoDoc]](https://godoc.org/github.com/msoap/shell2http)
* [Leaps](https://github.com/jeffail/leaps) **star:706** 使用操作转换的成对编程服务。   [![godoc][GoDoc]](https://godoc.org/github.com/jeffail/leaps)
* [gfile](https://github.com/Antonito/gfile) **star:627** 通过WebRTC在两台计算机之间安全地传输文件，不需要任何第三方依赖。   [![godoc][GoDoc]](https://godoc.org/github.com/Antonito/gfile)
* [Gebug](https://github.com/moshebe/gebug) **star:548** 一个工具，通过启用调试器和热重新加载特性，使docker化的Go应用程序的调试非常容易，无缝。   [![最近一周有更新][Green]](https://github.com/moshebe/gebug)   [![godoc][GoDoc]](https://godoc.org/github.com/moshebe/gebug)
* [Guora](https://github.com/meloalright/guora) **star:546** 一个用Go编写的类似Quora的自托管web应用程序。   [![godoc][GoDoc]](https://godoc.org/github.com/meloalright/guora)   [![包含中文文档][CN]](https://github.com/meloalright/guora)
* [mockingjay](https://github.com/quii/mockingjay-server) **star:496** 一份配置文件中便可伪造HTTP服务器与用户之间的行为。您还可以使服务器随机宕机，以帮助进行更实际的性能测试。   [![godoc][GoDoc]](https://godoc.org/github.com/quii/mockingjay-server)
* [gocc](https://github.com/goccmack/gocc) **star:493** Gocc是一个用Go编写的编译器工具包。   [![godoc][GoDoc]](https://godoc.org/github.com/goccmack/gocc)
* [go-peerflix](https://github.com/Sioro-Neoku/go-peerflix) **star:434** 视频流 torrent 客户端。   [![godoc][GoDoc]](https://godoc.org/github.com/Sioro-Neoku/go-peerflix)
* [ipe](https://github.com/dimiro1/ipe) **star:328** Open source Pusher server implementation compatible with Pusher client libraries written in GO.   [![godoc][GoDoc]](https://godoc.org/github.com/dimiro1/ipe)
* [ide](https://github.com/thestrukture/ide) **star:318** 基于浏览器的IDE   [![godoc][GoDoc]](https://godoc.org/github.com/thestrukture/ide)
* [tcpprobe](https://github.com/mehrdadrad/tcpprobe) **star:301** 用于网络性能和路径监控的TCP工具，包括套接字统计信息。   [![godoc][GoDoc]](https://godoc.org/github.com/mehrdadrad/tcpprobe)
* [wellington](https://github.com/wellington/wellington) **star:298** Sass 项目管理工具，使用sprite函数(如Compass)扩展语言。   [![godoc][GoDoc]](https://godoc.org/github.com/wellington/wellington)
* [woke](https://github.com/get-woke/woke) **star:255** 检测源代码中不包含的语言。   [![最近一周有更新][Green]](https://github.com/get-woke/woke)   [![godoc][GoDoc]](https://godoc.org/github.com/get-woke/woke)
* [Cherry](https://github.com/rafael-santiago/cherry) **star:247** 微型网络聊天服务器。   [![最近一年没有更新][Yellow]](https://github.com/rafael-santiago/cherry)   [![godoc][GoDoc]](https://godoc.org/github.com/rafael-santiago/cherry)
* [joincap](https://github.com/assafmo/joincap) **star:167** 用于合并多个pcap文件的命令行实用程序。   [![godoc][GoDoc]](https://godoc.org/github.com/assafmo/joincap)
* [Juju](https://jujucharms.com/)  Cloud-agnostic的服务部署和编制 —— 支持EC2、Azure、Openstack、MAAS等。
* [Orbit](https://github.com/gulien/orbit) **star:153** 一个根据模板来运行命令和生成文件的简单小工具。   [![godoc][GoDoc]](https://godoc.org/github.com/gulien/orbit)
* [tcpdog](https://github.com/mehrdadrad/tcpdog) **star:150** 基于eBPF的TCP可观测性。   [![godoc][GoDoc]](https://godoc.org/github.com/mehrdadrad/tcpdog)
* [Better Go Playground](https://goplay.tools)  使用语法高亮显示、代码完成和其他功能。
* [vaku](https://github.com/lingrino/vaku) **star:119** 用于库中基于文件夹的函数(如复制、移动和搜索)的CLI和API。   [![godoc][GoDoc]](https://godoc.org/github.com/lingrino/vaku)
* [dp](https://github.com/scryinfo/dp) **star:82** 通过SDK与区块链进行数据交换，开发人员可以轻松访问DAPP开发。   [![godoc][GoDoc]](https://godoc.org/github.com/scryinfo/dp)
* [boxed](https://github.com/tejo/boxed) **star:75** 基于Dropbox的博客引擎。   [![最近一年没有更新][Yellow]](https://github.com/tejo/boxed)   [![godoc][GoDoc]](https://godoc.org/github.com/tejo/boxed)
* [naclpipe](https://github.com/unix4fun/naclpipe) **star:21** 基于加密管的简单的NaCL EC25519工具。   [![最近一年没有更新][Yellow]](https://github.com/unix4fun/naclpipe)   [![godoc][GoDoc]](https://godoc.org/github.com/unix4fun/naclpipe)
* [term-quiz](https://github.com/crazcalm/term-quiz) **star:18** 测试你的终端。   [![最近一年没有更新][Yellow]](https://github.com/crazcalm/term-quiz)   [![godoc][GoDoc]](https://godoc.org/github.com/crazcalm/term-quiz)
* [Snitch](https://github.com/lucasgomide/snitch) **star:15** 当有人通过 Tsuru 部署任何应用程序时，会通知您的团队以及其他工具。   [![最近一年没有更新][Yellow]](https://github.com/lucasgomide/snitch)   [![godoc][GoDoc]](https://godoc.org/github.com/lucasgomide/snitch)
* [GoDocTooltip](https://github.com/diankong/GoDocTooltip) **star:14** 包含了 Go 使用手册文档的 Chrome 扩展。
* [GoLand](https://jetbrains.com/go)  功能齐全的跨平台 Go IDE。
* [hoofli](https://github.com/dnnrly/hoofli) **star:1** 从Chrome或Firefox网络检查生成PlantUML图表。   [![godoc][GoDoc]](https://godoc.org/github.com/dnnrly/hoofli)
* [hugo](http://gohugo.io/)  快速、现代的静态网站引擎。

# 资源

*在哪里可以找到新的Go库。 (翻译出错了? 试试 [英文版](README_EN.md#resources) 吧~)*

## 基准

* [go-web-framework-benchmark](https://github.com/smallnest/go-web-framework-benchmark) **star:1525** web框架基准测试。   [![godoc][GoDoc]](https://godoc.org/github.com/smallnest/go-web-framework-benchmark)
* [go-http-routing-benchmark](https://github.com/julienschmidt/go-http-routing-benchmark) **star:1516** HTTP请求路由器基准测试和比较。   [![godoc][GoDoc]](https://godoc.org/github.com/julienschmidt/go-http-routing-benchmark)
* [go_serialization_benchmarks](https://github.com/alecthomas/go_serialization_benchmarks) **star:1187** Go序列化方法的基准测试。   [![godoc][GoDoc]](https://godoc.org/github.com/alecthomas/go_serialization_benchmarks)
* [skynet](https://github.com/atemerev/skynet) **star:990** 天网 1M 线程微基准测试。
* [speedtest-resize](https://github.com/fawick/speedtest-resize) **star:212** 对比各种图像大小调整算法性能。   [![godoc][GoDoc]](https://godoc.org/github.com/fawick/speedtest-resize)
* [go-benchmarks](https://github.com/tylertreat/go-benchmarks) **star:139** Few miscellaneous Go microbenchmarks. Compare some language features to alternative approaches   [![最近一年没有更新][Yellow]](https://github.com/tylertreat/go-benchmarks)   [![godoc][GoDoc]](https://godoc.org/github.com/tylertreat/go-benchmarks)
* [gospeed](https://github.com/feyeleanor/GoSpeed) **star:107** 计算语言结构的速度的微观基准测试。   [![godoc][GoDoc]](https://godoc.org/github.com/feyeleanor/GoSpeed)
* [autobench](https://github.com/davecheney/autobench) **star:91** 用来来比较不同Go版本之间的性能的框架。   [![最近一年没有更新][Yellow]](https://github.com/davecheney/autobench)   [![godoc][GoDoc]](https://godoc.org/github.com/davecheney/autobench)
* [golang-sql-benchmark](https://github.com/tyler-smith/golang-sql-benchmark) **star:59** 为流行的 Go 数据库/SQL实用程序收集基准测试。   [![最近一年没有更新][Yellow]](https://github.com/tyler-smith/golang-sql-benchmark)   [![godoc][GoDoc]](https://godoc.org/github.com/tyler-smith/golang-sql-benchmark)
* [gocostmodel](https://github.com/PuerkitoBio/gocostmodel) **star:57** Go语言常用基本操作的基准测试。   [![godoc][GoDoc]](https://godoc.org/github.com/PuerkitoBio/gocostmodel)
* [go-benchmark-app](https://github.com/mrLSD/go-benchmark-app) **star:21** 强大的HTTP基准测试工具，包含了Аb，Wrk，Siege工具。收集统计和各种参数指标，并比较相关结果。   [![最近一年没有更新][Yellow]](https://github.com/mrLSD/go-benchmark-app)   [![godoc][GoDoc]](https://godoc.org/github.com/mrLSD/go-benchmark-app)
* [kvbench](https://github.com/jimrobinson/kvbench) **star:21** K / V 类型数据库基准测试。   [![最近一年没有更新][Yellow]](https://github.com/jimrobinson/kvbench)   [![godoc][GoDoc]](https://godoc.org/github.com/jimrobinson/kvbench)
* [go-ml-benchmarks](https://github.com/nikolaydubina/go-ml-benchmarks) **star:16** 机器学习推理基准。   [![godoc][GoDoc]](https://godoc.org/github.com/nikolaydubina/go-ml-benchmarks)
* [go-json-benchmark](https://github.com/zerosnake0/go-json-benchmark) **star:5** JSON的基准。   [![godoc][GoDoc]](https://godoc.org/github.com/zerosnake0/go-json-benchmark)

## 会议

* [Capital Go](http://www.capitalgolang.com)  华盛顿特区。,美国。
* [dotGo](http://www.dotgo.eu)  巴黎,法国。
* [GoCon](http://gocon.connpass.com/)  东京,日本。
* [GoDays](https://www.godays.io/)  德国柏林。
* [GoLab](http://golab.io/)  佛罗伦萨,意大利。
* [GolangUK](http://golanguk.com/)  伦敦,英国。
* [GopherChina](http://gopherchina.org)  上海,中国。
* [GopherCon](http://www.gophercon.com/)  美国丹佛。
* [GopherCon Australia](https://gophercon.com.au/)  澳大利亚悉尼。
* [GopherCon Brazil](https://gopherconbr.org)  弗洛,BR。
* [GopherCon Europe](https://gophercon.is/)  德国柏林。
* [GopherCon India](https://www.gophercon.in/)  印度浦那。
* [GopherCon Israel](https://www.gophercon.org.il/)  特拉维夫,以色列。
* [GopherCon Russia](https://www.gophercon-russia.ru)  莫斯科,俄罗斯。
* [GopherCon Singapore](https://gophercon.sg)  新加坡枫树商贸城。
* [GopherCon Vietnam](https://gophercon.vn/)  越南胡志明市。
* [GothamGo](http://gothamgo.com/)  美国纽约市。
* [GoWayFest](https://goway.io/)  白俄罗斯明斯克。

## E-Books

* [A Go Developer's Notebook](https://leanpub.com/GoNotebook/read)
* [An Introduction to Programming in Go](http://www.golang-book.com/)
* [Build Web Application with Golang](https://www.gitbook.com/book/astaxie/build-web-application-with-golang/details)
* [Building Web Apps With Go](https://www.gitbook.com/book/codegangsta/building-web-apps-with-go/details)
* [For the Love of Go](https://bitfieldconsulting.com/books)  为golang初学者准备的一系列入门书籍。
* [Go 101](https://go101.org)  一本关注 Go 语法/语义和各种细节的书。
* [Go Bootcamp](http://golangbootcamp.com)
* [GoBooks](https://github.com/dariubs/GoBooks) **star:9891** 一份精选的 Go 书籍清单。   [![star > 2000][Awesome]](https://github.com/dariubs/GoBooks)
* [How To Code in Go eBook](https://www.digitalocean.com/community/books/how-to-code-in-go-ebook)  600页的Go介绍针对的是第一次开发人员。
* [Go Succinctly](https://github.com/thedevsir/gosuccinctly) **star:18** in Persian.   [![最近一年没有更新][Yellow]](https://github.com/thedevsir/gosuccinctly)   [![godoc][GoDoc]](https://godoc.org/github.com/thedevsir/gosuccinctly)
* [Learning Go](https://www.miek.nl/downloads/Go/Learning-Go-latest.pdf)
* [Network Programming With Go](https://jan.newmarch.name/go/)
* [Practical Go Lessons](https://www.practical-go-lessons.com/)
* [Spaceship Go A Journey to the Standard Library](https://blasrodri.github.io/spaceship-go-gh-pages/)
* [The Go Programming Language](http://www.gopl.io/)
* [The Golang Standard Library by Example (Chinese)](https://github.com/polaris1119/The-Golang-Standard-Library-by-Example)
* [Web Application with Go the Anti-Textbook](https://github.com/thewhitetulip/web-dev-golang-anti-textbook/)
* [Writing A Compiler In Go](https://compilerbook.com)
* [Writing An Interpreter In Go](https://interpreterbook.com)

## Gophers

* [Free Gophers Pack](https://github.com/MariaLetta/free-gophers-pack) **star:2284** 由 Maria Letta 提供的与 Gopher 有关的图片包，其中包含了插图,表情文字。   [![star > 2000][Awesome]](https://github.com/MariaLetta/free-gophers-pack)   [![最近一年没有更新][Yellow]](https://github.com/MariaLetta/free-gophers-pack)   [![godoc][GoDoc]](https://godoc.org/github.com/MariaLetta/free-gophers-pack)
* [gopher-logos](https://github.com/GolangUA/gopher-logos) **star:92** 可爱的 gopher 标识。
* [Go-gopher-Vector](https://github.com/keygx/Go-gopher-Vector) **star:39** 与 Go gopher 相关的媒介数据[。ai . svg)。   [![最近一年没有更新][Yellow]](https://github.com/keygx/Go-gopher-Vector)
* [gopher-stickers](https://github.com/tenntenn/gopher-stickers)
* [gopher-vector](https://github.com/golang-samples/gopher-vector)
* [gophericons](https://github.com/shalakhin/gophericons)
* [gophers](https://github.com/ashleymcnamara/gophers) **star:2485** 阿什莉·麦克纳马拉的歌斐艺术品。   [![star > 2000][Awesome]](https://github.com/ashleymcnamara/gophers)   [![最近一年没有更新][Yellow]](https://github.com/ashleymcnamara/gophers)   [![godoc][GoDoc]](https://godoc.org/github.com/ashleymcnamara/gophers)
* [gophers](https://github.com/egonelbre/gophers) **star:2441** Free gophers.   [![star > 2000][Awesome]](https://github.com/egonelbre/gophers)   [![最近一年没有更新][Yellow]](https://github.com/egonelbre/gophers)   [![godoc][GoDoc]](https://godoc.org/github.com/egonelbre/gophers)
* [gopherize.me](https://github.com/matryer/gopherize.me) **star:516** Gopherize自己。
* [gophers](https://github.com/sillecelik/go-gopher) **star:98** Gopher amigurumi玩具图案。   [![最近一周有更新][Green]](https://github.com/sillecelik/go-gopher)
* [gophers](https://github.com/rogeralsing/gophers) **star:54** 随机gopher图形。   [![最近一年没有更新][Yellow]](https://github.com/rogeralsing/gophers)

## 聚会

* [Basel Go Meetup](https://www.meetup.com/Basel-Go-Meetup/)
* [Belfast Gophers](https://www.meetup.com/Belfast-Gophers/)
* [Berlin Golang](https://www.meetup.com/golang-users-berlin/)
* [Brisbane Gophers](https://www.meetup.com/Brisbane-Golang-Meetup/)
* [Canberra Gophers](https://www.meetup.com/Canberra-Gophers/)
* [Go Language NYC](https://www.meetup.com/golanguagenewyork/)
* [Go London User Group](https://www.meetup.com/Go-London-User-Group/)
* [Go Remote Meetup](https://www.meetup.com/Go-Remote-Meetup/)
* [Go Toronto](https://www.meetup.com/go-toronto/)
* [Go User Group Atlanta](https://www.meetup.com/Go-Users-Group-Atlanta/)
* [GoBandung](https://www.meetup.com/GoBandung/)
* [GoBridge, San Francisco, CA](https://www.meetup.com/gobridge/)
* [GoCracow - Krakow, Poland](https://www.meetup.com/GoCracow/)
* [GoJakarta](https://www.meetup.com/GoJakarta/)
* [Golang Amsterdam](https://www.meetup.com/golang-amsterdam/)
* [Golang Argentina](https://www.meetup.com/Golang-Argentina/)
* [Golang Baltimore, MD](https://www.meetup.com/BaltimoreGolang/)
* [Golang Bangalore](https://www.meetup.com/Golang-Bangalore/)
* [Golang Belo Horizonte - Brazil](https://www.meetup.com/go-belo-horizonte/)
* [Golang Boston](https://www.meetup.com/bostongo/)
* [Golang Bulgaria](https://www.meetup.com/Golang-Bulgaria/)
* [Golang Cardiff, UK](https://www.meetup.com/Cardiff-Go-Meetup/)
* [Golang Copenhagen](https://www.meetup.com/Go-Cph/)
* [Golang Curitiba - Brazil](https://www.meetup.com/GolangCWB/)
* [Golang DC, Arlington, VA](https://www.meetup.com/Golang-DC/)
* [Golang Dorset, UK](https://www.meetup.com/golang-dorset/)
* [Golang Estonia](https://www.meetup.com/Golang-Estonia/)
* [Golang Gurgaon, India](https://www.meetup.com/Gurgaon-Go-Meetup/)
* [Golang Hamburg - Germany](https://www.meetup.com/Go-User-Group-Hamburg/)
* [Golang Israel](https://www.meetup.com/Go-Israel/)
* [Golang Joinville - Brazil](https://www.meetup.com/Joinville-Go-Meetup/)
* [Golang Kathmandu](https://www.meetup.com/Golang-Kathmandu/)
* [Golang Korea](https://www.meetup.com/GDG-Golang-Korea/)
* [Golang Lima - Peru](https://www.meetup.com/Golang-Peru/)
* [Golang Lyon](https://www.meetup.com/Golang-Lyon/)
* [Golang Marseille](https://www.meetup.com/fr-FR/Golang-Marseille/)
* [Golang Melbourne](https://www.meetup.com/golang-mel/)
* [Golang Mountain View](https://www.meetup.com/Golang-Mountain-View/)
* [Golang New York](https://www.meetup.com/nycgolang/)
* [Golang North East](https://www.meetup.com/en-AU/Golang-North-East/)
* [Golang Paris](https://www.meetup.com/Golang-Paris/)
* [Golang Poland](https://www.meetup.com/Golang-Poland/)
* [Golang Pune](https://www.meetup.com/Golang-Pune/)
* [Golang Singapore](https://www.meetup.com/golangsg/)
* [Golang Stockholm](https://www.meetup.com/Go-Stockholm/)
* [Golang Sydney, AU](https://www.meetup.com/golang-syd/)
* [Golang São Paulo - Brazil](https://www.meetup.com/golangbr/)
* [Golang Taipei](https://www.meetup.com/golang-taipei-meetup/)
* [Golang Turkey](https://kommunity.com/goturkiye)
* [Golang Vancouver, BC](https://www.meetup.com/golangvan/)
* [Golang Vienna, Austria](https://www.meetup.com/viennago/)
* [Golang Казань](https://www.meetup.com/GolangKazan/)
* [Golang Москва](https://www.meetup.com/Golang-Moscow/)
* [Golang Питер](https://www.meetup.com/Golang-Peter/)
* [GoSF - San Francisco, CA](https://www.meetup.com/golangsf)
* [Istanbul Golang](https://www.meetup.com/Istanbul-Golang/)
* [Seattle Go Programmers](https://www.meetup.com/golang/)
* [Ukrainian Golang User Groups](https://www.meetup.com/uagolang/)
* [Utah Go User Group](https://www.meetup.com/utahgophers/)
* [Women Who Go - San Francisco, CA](https://www.meetup.com/Women-Who-Go/)

*在这里添加您所在城市/国家的群组(发送**PR**) (翻译出错了? 试试 [英文版](README_EN.md#meetups) 吧~)*

## 风格指南

* [bahlo/go-styleguide](https://github.com/bahlo/go-styleguide)
* [CockroachDB](https://github.com/cockroachdb/cockroach/blob/master/docs/style.md)
* [GitLab](https://docs.gitlab.com/ee/development/go_guide/)
* [Hyperledger](https://github.com/hyperledger/fabric/blob/release-1.4/docs/source/style-guides/go-style.rst)
* [Magnetico](https://github.com/boramalper/magnetico/wiki/magnetico-Design-Specification)
* [Sourcegraph](https://about.sourcegraph.com/handbook/engineering/go_style_guide)
* [Thanos](https://thanos.io/tip/contributing/coding-style-guide.md/)
* [Uber](https://github.com/uber-go/guide/blob/master/style.md)

## 社交媒体
### Twitter

* [@golang](https://twitter.com/golang)
* [@golang_news](https://twitter.com/golang_news)
* [@golangch](https://twitter.com/golangch)
* [@golangflow](https://twitter.com/golangflow)
* [@golangweekly](https://twitter.com/golangweekly)

### Reddit
 * [r/golang](https://www.reddit.com/r/golang/)

## 网站

* [awesome-awesomeness](https://github.com/bayandin/awesome-awesomeness) **star:27899** 其他 awesome 系列的列表。   [![star > 2000][Awesome]](https://github.com/bayandin/awesome-awesomeness)
* [Awesome Remote Job](https://github.com/lukasz-madon/awesome-remote-job) **star:20824** Curated list of awesome remote jobs. A lot of them are looking for Go hackers.   [![star > 2000][Awesome]](https://github.com/lukasz-madon/awesome-remote-job)
* [golang-graphics](https://github.com/mholt/golang-graphics) **star:140** 收藏的 Go 图像，图形和艺术作品。   [![最近一年没有更新][Yellow]](https://github.com/mholt/golang-graphics)   [![归档项目][Archived]](https://github.com/mholt/golang-graphics)
* [golang-nuts](https://groups.google.com/forum/#!forum/golang-nuts)  Go 邮件列表。
* [Google Plus Community](https://plus.google.com/communities/114112804251407510571)  Google+社区 golang爱好者聚集地。
* [Gopher Community Chat](https://invite.slack.golangbridge.org)  加入我们为Gophers设立的全新Slack社区([了解它是如何产生的](https://blog.gopheracademy.com/gophers-slack-community/))。
* [Gophercises](https://gophercises.com/)  为 Go 初学者提供免费的代码训练。
* [gowalker.org](https://gowalker.org)   Go API 文档。
* [json2go](https://m-zajac.github.io/json2go)  高级JSON去结构转换-在线工具。
* [justforfunc](https://www.youtube.com/c/justforfunc)  致力于传授 Go 编程语言技巧和技巧的Youtube 频道，由Francesc Campoy [@francesc](https://twitter.com/francesc)主办。
* [Learn Go Programming](https://blog.learngoprogramming.com)  学习Go概念与插图。
* [Lille Gophers](https://lille-gophers.loscrackitos.codes/)  Golang在法国里尔谈论社区([@LilleGophers](https://twitter.com/LilleGophers))。
* [Awesome Go @LibHunt](https://go.libhunt.com)  属于你的 Go 工具箱。
* [gocryforhelp](https://github.com/ninedraft/gocryforhelp) **star:38** 专门收集需要帮助的Go项目，这是你开启开源之路的好去处。   [![最近一年没有更新][Yellow]](https://github.com/ninedraft/gocryforhelp)
* [godoc.org](https://godoc.org/)  开源 Go 包的文档。
* [Golang Developer Jobs](https://golangjob.xyz)  开发人员的工作专为Golang相关的角色。
* [Golang Flow](https://golangflow.io)  发布更新、新闻、包等等。
* [Golang News](https://golangnews.com)  关于 Go 编程的链接和新闻。
* [Golang Resources](https://golangresources.com)  一个最佳示范，包含文章，练习，讨论和视频学习。
* [awesome-go-extra](https://github.com/xwjdsh/awesome-go-extra) **star:16** 解析awesome-go README文件并生成一个新的README文件与repo信息。   [![最近一周有更新][Green]](https://github.com/xwjdsh/awesome-go-extra)   [![godoc][GoDoc]](https://godoc.org/github.com/xwjdsh/awesome-go-extra)   [![包含中文文档][CN]](https://github.com/xwjdsh/awesome-go-extra)
* [CodinGame](https://www.codingame.com/)  以小游戏互动完成任务的形式来学习 Go。
* [Go Blog](http://blog.golang.org)  官方 Go 博客。
* [Go Challenge](http://golang-challenge.org/)  通过解决问题并从 Go 专家那里得到反馈来学习 Go。
* [Go Code Club](https://www.youtube.com/watch?v=nvoIPQYdx9g&list=PLEcwzBXTPUE_YQR7R0BRtHBYJ0LN3Y0i3)  一群地鼠每周阅读和讨论一个不同的Go项目。
* [Go Community on Hashnode](https://hashnode.com/n/go)  Hashnode上的Go社区。
* [Go Forum](https://forum.golangbridge.org)  讨论 Go 的论坛。
* [Go In 5 Minutes](https://www.goin5minutes.com/)  5 minute screencasts focused on getting one thing done.
* [Go Projects](https://github.com/golang/go/wiki/Projects)  wiki上的 Go 社区项目列表。
* [Go Report Card](https://goreportcard.com)  为你的 Go 包生成一份报告单。
* [go.dev](https://go.dev/)  一个 go 开发者的中心。
* [Made with Golang](https://madewithgolang.com/?ref=awesome-go)
* [r/Golang](https://www.reddit.com/r/golang)  与 Go 有关的新闻。
* [studygolang](https://studygolang.com)  Go语言中文网
* [Trending Go repositories on GitHub today](https://github.com/trending?l=go)  寻找最新的 Go库 的好地方。
* [TutorialEdge - Golang](https://tutorialedge.net/course/golang/)

### 教程

* [Build web application with Golang](https://github.com/astaxie/build-web-application-with-golang) **star:38413** Golang电子书，主要讲述如何用 Golang 建立一个web应用程序。   [![star > 2000][Awesome]](https://github.com/astaxie/build-web-application-with-golang)   [![godoc][GoDoc]](https://godoc.org/github.com/astaxie/build-web-application-with-golang)   [![包含中文文档][CN]](https://github.com/astaxie/build-web-application-with-golang)
* [Building and Testing a REST API in Go with Gorilla Mux and PostgreSQL](https://semaphoreci.com/community/tutorials/building-and-testing-a-rest-api-in-go-with-gorilla-mux-and-postgresql)  我们会写一个API的帮助下强大的大猩猩Mux。
* [Building Go Web Applications and Microservices Using Gin](https://semaphoreci.com/community/tutorials/building-go-web-applications-and-microservices-using-gin)  Get familiar with Gin and find out how it can help you reduce boilerplate code and build a request handling pipeline.
* [Caching Slow Database Queries](https://medium.com/@rocketlaunchr.cloud/caching-slow-database-queries-1085d308a0c9)  如何缓存数据库的慢查询。
* [Canceling MySQL](https://medium.com/@rocketlaunchr.cloud/canceling-mysql-in-go-827ed8f83b30)  如何取消MySQL查询。
* [Debugged.it Go patterns](https://github.com/haveyoudebuggedit/go-patterns)  高级的Go模式和准备运行的示例。
* [Go Cheat Sheet](https://github.com/a8m/go-lang-cheat-sheet) **star:5732**  Go's reference card。   [![star > 2000][Awesome]](https://github.com/a8m/go-lang-cheat-sheet)
* [Go database/sql tutorial](http://go-database-sql.org/)  数据库概论/ sql。
* [Go Playground for iOS](https://codeplayground.app)  在你的移动设备上编辑你编辑和运行你的 Go 代码。
* [Ethereum Development with Go](https://github.com/miguelmota/ethereum-development-with-go-book) **star:898** 一本讲述如何用 Go 进行以太开发的小册。   [![godoc][GoDoc]](https://godoc.org/github.com/miguelmota/ethereum-development-with-go-book)   [![包含中文文档][CN]](https://github.com/miguelmota/ethereum-development-with-go-book)
* [Games With Go](http://gameswithgo.org/)  关于编程和游戏开发系列教学视频。
* [Go By Example](https://gobyexample.com/)  手把手教你 如何在 Go 应用程序中使用注释。
* [50 Shades of Go](http://devs.cloudimmunity.com/gotchas-and-common-mistakes-in-go-golang/)  Go 初学者经常遇到的陷阱、误区、错误
* [A Guide to Golang E-Commerce](https://snipcart.com/blog/golang-ecommerce-ponzu-cms-demo?utm_term=golang-ecommerce-ponzu-cms-demo)  教你如何用 Go 搭建一个电商平台 (包括demo)。
* [A Tour of Go](http://tour.golang.org/)  互动的 Go 之旅。
* [Design Patterns in Go](https://github.com/shubhamzanwar/design-patterns) **star:56** 在Go中实现的编程设计模式的集合。   [![godoc][GoDoc]](https://godoc.org/github.com/shubhamzanwar/design-patterns)
* [Go WebAssembly Tutorial - Building a Simple Calculator](https://tutorialedge.net/golang/go-webassembly-tutorial/)
* [go-patterns](https://github.com/tmrts/go-patterns) **star:16835** 策划的清单去设计模式，食谱和习惯用法。   [![star > 2000][Awesome]](https://github.com/tmrts/go-patterns)   [![godoc][GoDoc]](https://godoc.org/github.com/tmrts/go-patterns)
* [Learn Go with TDD](https://github.com/quii/learn-go-with-tests) **star:15155** 学习使用测试驱动开发。   [![star > 2000][Awesome]](https://github.com/quii/learn-go-with-tests)   [![godoc][GoDoc]](https://godoc.org/github.com/quii/learn-go-with-tests)   [![包含中文文档][CN]](https://github.com/quii/learn-go-with-tests)
* [Learning Golang - From zero to hero](https://milapneupane.com.np/2019/07/06/learning-golang-from-zero-to-hero/)  面向 Golang 初学者教程。
* [package main](https://www.youtube.com/packagemain)  关于 Go 编程的YouTube频道。
* [Programming with Google Go](https://www.coursera.org/specializations/google-golang)  Coursera的专业学习可以从零开始。
* [Learn Go with 1000+ Exercises](https://github.com/inancgumus/learngo) **star:10749** 通过成千上万的例子、练习和测验来学习Go。   [![star > 2000][Awesome]](https://github.com/inancgumus/learngo)   [![最近一周有更新][Green]](https://github.com/inancgumus/learngo)   [![godoc][GoDoc]](https://godoc.org/github.com/inancgumus/learngo)
* [Golang for Node.js Developers](https://github.com/miguelmota/golang-for-nodejs-developers) **star:2490** 引入示例讲述 Golang 与Node.js在学习上的差异。   [![star > 2000][Awesome]](https://github.com/miguelmota/golang-for-nodejs-developers)   [![godoc][GoDoc]](https://godoc.org/github.com/miguelmota/golang-for-nodejs-developers)
* [Golangbot](https://golangbot.com/learn-golang-series/)  Go 编程教程。
* [GolangCode](https://golangcode.com/)  收集代码片段和教程，以帮助处理日常问题。
* [GopherSnippets](https://gophersnippets.com/)  带有测试和可测试示例的代码片段，用于Go编程语言。
* [Hackr.io](https://hackr.io/tutorials/learn-golang)  Go社区投票选举出来的最好的在线 Go 教程。
* [How to Benchmark: dbq vs sqlx vs GORM](https://medium.com/@rocketlaunchr.cloud/how-to-benchmark-dbq-vs-sqlx-vs-gorm-e814caacecb5)  学习如何在Golang中进行基准测试。作为案例研究，我们将对dbq、sqlx和GORM进行基准测试。
* [How To Deploy a Go Web Application with Docker](https://semaphoreci.com/community/tutorials/how-to-deploy-a-go-web-application-with-docker)  学习如何使用Docker进行Go开发，以及如何构建Docker生产镜像。
* [How to Use Godog for Behavior-driven Development in Go](https://semaphoreci.com/community/tutorials/how-to-use-godog-for-behavior-driven-development-in-go)  快速使用Godog —— 一个行为驱动开发的构建和测试应用程序框架。
* [goapp](https://github.com/bnkamalesh/goapp) **star:272** 关于构建和开发Go web应用/服务的指南。   [![godoc][GoDoc]](https://godoc.org/github.com/bnkamalesh/goapp)
* [The world’s easiest introduction to WebAssembly with Golang](https://medium.com/@martinolsansky/webassembly-with-golang-is-fun-b243c0e34f02)
* [Working with Go](https://github.com/mkaz/working-with-go) **star:1160** 由一个经验丰富的Go程序员群体编写的一系列Go学习范例。   [![最近一年没有更新][Yellow]](https://github.com/mkaz/working-with-go)   [![归档项目][Archived]](https://github.com/mkaz/working-with-go)
* [Your basic Go](http://yourbasic.org/golang)  如何收集大量的教程。

